//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __ARTICLES_ADDTOTABLE.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


/*

Kod preuzimanja artikla iz ifarnika artikala u raun na stolu:

Postoje istovremeno otvorena dva prozora:

  prozor za restoranski sto kao query  ALIAS "STO"
  prozor za ifarnik artiala kao query ALIAS "ART"

sluaj 1
--------

iz otvorenog prozora za ifarnik artikala SELECT "ART" uzima se artikal
i dodaje se u TABLU x1 a zatim se iz te table preuzimaju podaci u QUERY
SELECT "STO" u otvoren prozor za restoranski sto:

  * solucija A
  * Ovde se podatak dodaje direktno u TABLU a ne u QUERY -------- YES

sluaj 2
--------

iz otvorenog prozora za restoranski sto SELECT "STO" menja se koliina
i menja se cena stavke-artikla i promena se upisuje u QUERY SELECT "STO"
a izlaskom iz i zatvaranjem stola sa CLOSE STO podatak se prenosi u
TABLU x1

  * solucija B
  * Ovde se podatak dodaje direktno u QUERY a ne u TABLU -------- YES



* ---



When retrieving an item from the item codebook to the account on the table:

There are two windows open at the same time:

   restaurant table window as query ALIAS "STO"
   artial codebook window as query  ALIAS "ART"

case 1
--------

the item is taken from the open window for the item codebook SELECT "ART".
and it is added to the TABLE x1 and then data is taken from that table to QUERY
SELECT "STO" in the open window for the restaurant table:

  * solution A
  * Here, data is added directly to TABLE and not to QUERY -------- YES

case 2
--------

from the open window for the SELECT "STO" restaurant table, the quantity changes
and the price of the item-article is changed and the change is entered in
QUERY SELECT "STO" and by exiting and closing the table with CLOSE STO,
the data is transferred to TABLE x1

  * solution B
  *  Here, data is added directly to QUERY and not to TABLE -------- YES

*/




* Ovo se izvrava iz SELECT "ART"
* FUNCTION preuzmi_naziv(nn)
*   FUNCTION stavku_dodaj_na_sto_YES()
*   FUNCTION stavku_dodaj_na_sto_NOT()

* Ovo se izvrava iz SELECT "STO"
* FUNCTION dialogue_for_entering_quantity(xROBS)
* FUNCTION dialogue_for_entering_price(xROBS)



#include "Xbtsys.ch"   // XbttoolsIII
#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "dll.ch"
#include "dcdialog.ch"



* ---
* POSLE IZBORA I PRENOSA ARTIKLA IZ IFARNIKA ARTIKALA U RAUN
* RESTORANSKOG STOLA, IFARNIK ARTIKALA EKA SLEDEI IZBOR I PRENOS
* (ZATVARA SE SAMO NA KOMANDU ZA ZATVARANJE: ESC, BUTTON, FINGER-TAP)
* ---
* AFTER SELECTING AND TRANSFERRING ARTICLE FROM ARTICLE CODE BOOK
* TO ACCOUNT OF RESTAURANT TABLE, CODE BOOK OF ARTICLES AWAITS NEXT
* SELECTION AND TRANSFER
* (CLOSES ONLY ON CLOSE COMMAND: ESC, BUTTON, FINGER-TAP)
*************************************************************************
FUNCTION take_article(nn)
*************************************************************************
LOCAL radno := SELECT()
LOCAL i:=0


* A  U R I R A N J E  R A  U N A  S T O L A  --- S T A R T

IF nn == 1 // article is taken

 // ako je artikal PREUZET (Enter, Mouse-LbDblClick, finger-tap, button)
 // proveri da li postoji otvoren restoranski sto - odnosno raun stola

 // if article is TAKEN (Enter, Mouse-LbDblClick, finger-tap, button)
 // check if there is an open restaurant table - that is, a table account

  FOR i=1 to 3

      IF alias(i)=="STO"
      // ako je otvoren bilo koji restoranski STO
      // artikal se UPISUJE u taj otvoreni sto
      // if any restaurant table is open
      // item is WRITE into that open table
         SELECT "STO"
         *************************
         stavku_dodaj_na_sto_YES()
         *************************
      ELSE
      // ako ne postoji otvoren restoranski sto
      // NE DEAVA SE NITA
      // if there is no open restaurant table
      // NOTHING HAPPENS
         ***
      ENDIF

  NEXT i

ELSE  // nn == 0  // article not taken

 // ako artikal NIJE PREUZET (ESC, button, [x])
 // proveri da li postoji otvoren restoranski sto

 // if article NOT TAKEN (ESC, button, [x] close)
 // check if there is an open restaurant table

  FOR i=1 to 3

      IF alias(i)=="STO"
      // ako je otvoren bilo koji restoranski STO
      // artikal se NE UPISUJE u taj otvoreni sto
      // if any restaurant table is open
      // the article is NOT WRITE into that open table
         SELECT "STO"
         *************************
         stavku_dodaj_na_sto_NOT()
         *************************
      ELSE
      // ako ne postoji otvoren restoranski sto
      // NE DEAVA SE NITA
      // if there is no open restaurant table
      // NOTHING HAPPENS
         ***
      ENDIF

  NEXT i


ENDIF // IF nn == 1


* A  U R I R A N J E  R A  U N A  S T O L A  --- E N D


SELECT(radno)
RETURN NIL
*** POSLE PRENOSA STAVKE ARTIKLA IZ IFARNIKA ARTIKALA U RAUN NE ZATVARA SE IFARNIK





*************************************************************************
FUNCTION stavku_dodaj_na_sto_YES()
*************************************************************************
LOCAL radno:=SELECT() // SELECT "ART"

*"-----------------------------
*" kompletna produkciona stavka
*" ----------------------------

/*
*********************************************************** YES-UPSIZE

     *************
     SELECT "STO"
     *************
     APPEND BLANK
     REK:=RECNO()

     REPLACE ;
      STO->UUID_ WITH UuidToChar(UuidCreate()) ,;
      STO->COK_  WITH .F. ,; // nije tampano
      STO->ROBS_ WITH ARTIKLI->ROBS_  ,;
      STO->ROBN_ WITH ARTIKLI->ROBN_  ,;
      STO->MERA_ WITH ARTIKLI->MERA_  ,;
      STO->KOLI_ WITH 1               ,;
      STO->CENA_MPR_ WITH ARTIKLI->CENA_MPR_  ,;
      STO->VRED_MPR_ WITH ARTIKLI->CENA_MPR_  ,;
      STO->PPUP_ WITH ARTIKLI->PPUP_

     PPOD := STO->VRED_MPR_  * (((100 * STO->PPUP_)/(100 + STO->PPUP_))/100)
     PPOD:=ROUND(PPOD,2)

     REPLACE STO->PPOD_ WITH PPOD ,;
             STO->VRED_VPR_ WITH STO->VRED_MPR_ - STO->PPOD_

     CENA_VPR := ROUND( STO->VRED_VPR_ / STO->KOLI_ ,2)

     REPLACE STO->CENA_VPR_ WITH CENA_VPR //,;
             // STO->VRED_NAB_ WITH STO->VRED_VPR_, STO->CENA_NAB_ WITH STO->CENA_VPR_


     // upisuje se u REGK artikla runo a u STO ovde:
     REPLACE ;
     STO->STAT_ WITH ARTIKLI->STAT_ ,; // P,R,U...
     STO->TARI_ WITH ARTIKLI->TARI_ ,; // R - roba, Prazno ili P - proizvodi
     STO->GRUP_ WITH ARTIKLI->GRUP_ ,; // H - hrana, P - Pie
     STO->DOBS_ WITH ARTIKLI->DOBS_ ,; // GRUPE ARTIKALA 1-14
     STO->FLAG_ WITH  "G"           ,; // "G" gotovina, "C" ek-bezgotovinski, "V" kartica banke
     STO->ZNAK_ WITH ARTIKLI->ZNAK_ ,; // slobodno
     STO->MAGS_ WITH ARTIKLI->MAGS_ ,; // magacin-prodavnica-kasa
     STO->DOBO_ WITH " " // slobodno

     // upisuje se u STO ovde automatski
     ***************************
     cKonobar := "66" // xKONOBARcbroj() // "05" KASA_BAZA.DLL
     ***************************
     REPLACE STO->OPST_ WITH cKonobar         // 05 - 20


     REPLACE VRE0_ WITH VAR2CHAR(REK)


     * Iz KASA_tach_buttons_stolovi.prg -> RACUN_NA_STOLU(o,GetList1)
     * ako je otvoren RAUN STOLA tada postoje i ove varijable:
     * PUBLIC oBrowse5
     * PUBLIC oDlgSto
     * PUBLIC GetListSto

******** novi nain rada ********  26-09-2023

SetAppFocus(oBrowse5)
obrowse5:refreshall()
oBrowse5:forceStable()
// --- tehnika: uvek-vidi-ceo-browser-spisak
 SELECT "STO"
 GO TOP                                               // na vrh spiska da se vidi ceo spisak
 PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5) // na kraj spiska a da se vidi ceo spisak
// --- tehnika: uvek-vidi-ceo-browser-spisak

// --- promena koliine u stavci rauna stola
// --- promena koliine u stavci rauna stola
IF FILE(gde_exe()+"\kasakolicina")
   // nema dijaloga za upis koliine
ELSE
 ykolicina()
 obrowse5:refreshCurrent()
ENDIF

******** novi nain rada ********  26-09-2023
*********************************************************** YES-UPSIZE
*/


*** OVO TREBA PRIMENITI I OVDE !!!  ---------------------------------------------------------> URADITI 10-11-2023
**************************************************************************** 4
***STATIC FUNCTION iz_dbf_verzije_programa___stavku_dodaj_na_sto_YES()
****************************************************************************
****" ovo se koristi u dbf verziji kase
***
***
***LOCAL radno :=SELECT()
*****************
**** SELECT "STO"
*****************
***
***
*** ***********************   *** funkcija preuzeta iz KASA_PRODAJA.EXE i preraena ia KASA_UGOSTITELJ.EXE
*** RACUN_FORMIRAJ_STAVKU()   ***__RACUN_FORMIRAJ_STAVKU.PRG
*** ***********************   *** stavka se formira u SELECT "STO" a ne u SELECT "RACUN"
***
***
**** --- START
**** Posle svake novododate stavke u raun stola nain plaanja se postavlja na GOTOVINA
***************
***kasa_kash() *** postavi nain plaanja celog RAUNA STOLA na GOTOVINA
***************
***SELECT(radno)
**** --- END
***
***
***
***     PUBLIC kolicinu_promeni := .T.  *** 14-07-2023 *** prikai dijalog za promenu koliine
***
***     oBrowse5:refreshall()      *** refresh browsera rauna na stolu STO
***     dc_getrefresh(GetListSto)  *** refresh browsera rauna na stolu STO
***     dc_setappfocus(oDlgSto)    *** fokus na browser rauna na stolu STO
***     PostAppEvent(xbeP_Keyboard,xbeK_TAB,,oDlgSto)  *** klik na TAB u browseru rauna na stolu STO
***     *** jedino ovaj klik na TAB i otvaranje dialoga za upis koliine ponovo daje fokus za browser
***     *** rauna stola - sve drugo to sam pokuao nije uspelo da vrati fokus na browser rauna
***
***     GO TOP
***
***SELECT(radno)
***RETURN NIL
**************************************************************************** 4
*** OVO TREBA PRIMENITI I OVDE !!!  ---------------------------------------------------------> URADITI 10-11-2023


*********************************************************** NOT-UPSIZE
SELECT(radno) // SELECT "ART"

      xUUID_     := UuidToChar(UuidCreate())
      xCOK_      := .F.                       // nije tampano
      xROBS_     := ART->ROBS_
      xROBN_     := ART->ROBN_
      xMERA_     := ART->MERA_
      xKOLI_     := 1
      xCENA_MPR_ := ART->CENA_MPR_
      xVRED_MPR_ := ART->CENA_MPR_
      xPPUP_     := ART->PPUP_

           xOBRSTOPA  := (((100 * xPPUP_)/(100 + xPPUP_))/100)
           xPPOD      := xVRED_MPR_ * xOBRSTOPA
           xPPOD      := ROUND(xPPOD,2)

      xPPOD_     := xPPOD
      xVRED_VPR_ := xVRED_MPR_ - xPPOD_

           IF xKOLI_ <> 0
              xCENA_VPR   := ROUND( xVRED_VPR_ / xKOLI_ ,2)
           ELSE
              xCENA_VPR   := 0
           ENDIF

      xCENA_VPR_ := xCENA_VPR


     // upisuje se u REGK artikla runo a u STO ovde:

     xSTAT_      := ART->STAT_  // P,R,U...
     xTARI_      := ART->TARI_  // R - roba, Prazno ili P - proizvodi
     xGRUP_      := ART->GRUP_  // H - hrana, P - Pie
     xDOBS_      := ART->DOBS_  // GRUPE ARTIKALA 1-14
     xFLAG_      :=  "G"            // "G" gotovina, "C" ek-bezgotovinski, "V" kartica banke
     xZNAK_      := ART->ZNAK_  // slobodno
     xMAGS_      := ART->MAGS_  // magacin-prodavnica-kasa
     xDOBO_      := " "               // slobodno

     // upisuje se u STO ovde automatski
     ***************************
     cKonobar := xKONOBARcbroj() // "05" to "20" __XKONOBAR_XKASIR.PRG
     ***************************
     xOPST_      := cKonobar        // 05 - 20 barman (alt)
     xKSIR_      := cKonobar        // 05 - 20 barman (new)


     xVRE0_      := var2char(__record)// VAR2CHAR(REK)
                                      // zbog sortiranja stavki u raunu restoranskog stola
                                      // po redosledu nastanka stavki
                                      // due to sorting the items in the restaurant table bill
                                      // in the order of occurrence of items

* ---
    cCOK_      :=      IIF(xCOK_=.T.,"TRUE","FALSE")
    cKOLI_     :=      var2char(xKOLI_)
    cCENA_MPR_ :=      var2char(xCENA_MPR_)
    cVRED_MPR_ :=      var2char(xVRED_MPR_)
    cPPUP_     :=      var2char(xPPUP_)
    cPPOD_     :=      var2char(xPPOD_)
    cVRED_VPR_ :=      var2char(xVRED_VPR_)
    cCENA_VPR_ :=      var2char(xCENA_VPR_)

* PUBLIC _shetab_ := "public.x1" // iz 4_KASA_tach_buttons_stolovi_racuni.prg

TEXT INTO cSQL WRAP
  INSERT INTO &_shetab_
  ( UUID_,
    COK_ ,
    ROBS_,
    ROBN_,
    MERA_,
    KOLI_,
    CENA_MPR_,
    VRED_MPR_,
    PPUP_,
    PPOD_,
    VRED_VPR_,
    CENA_VPR_,
    STAT_,
    TARI_,
    GRUP_,
    DOBS_,
    FLAG_,
    ZNAK_,
    MAGS_,
    DOBO_,
    OPST_,
    VRE0_,
    KSIR_
  )
  VALUES
  ('&xUUID_',
   '&cCOK_' ,
   '&xROBS_',
   '&xROBN_',
   '&xMERA_',
    &cKOLI_ ,
    &cCENA_MPR_,
    &cVRED_MPR_,
    &cPPUP_,
    &cPPOD_,
    &cVRED_VPR_,
    &cCENA_VPR_,
   '&xSTAT_',
   '&xTARI_',
   '&xGRUP_',
   '&xDOBS_',
   '&xFLAG_',
   '&xZNAK_',
   '&xMAGS_',
   '&xDOBO_',
   '&xOPST_',
   '&xVRE0_',
   '&xKSIR_'
   )
ENDTEXT
//dc_memoedit(cSQL);quit

  oStmt := DacSqlStatement():fromChar(cSQL)
  oStmt:build():execute()


* solucija A
* Ovde se podatak dodaje direktno u TABLU a ne u QUERY -------- YES
************************************* RELOADING BROWSER START
****************
* SELECT "STO";USE // CLOSE QUERY // WORK
  CLOSE STO        // CLOSE QUERY // WORK
****************
cSQL    := "SELECT * FROM "+_shetab_+" ORDER BY __record;"
oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"STO")
STO:=cAlias        // this is mandatory  !
*************
SELECT "STO"
*************
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)  // OK
// prikaz cele liste i skok na zadnju stavku u listi
// view entire list and jump to last item in the list
************************************* RELOADING BROWSER START





* solucija B
* Ovde se podatak dodaje direktno u QUERY a ne u TABLU -------- NO
* i zbog toga ovo ne funkcionie
* pa se solucija B ne moe koristiti umesto solucije A
/*
SELECT "STO"
oBrowse5:forceStable()
GO TOP
LOCATE FOR ROBS_==xROBS_
*/




IF FILE(gde_exe()+"\kasakolicina")
  // nema dijaloga za upis koliine
  // no dialog for entering quantity
ELSE
  // dijalog za upis koliine
  // dialog for entering quantity
  ***************************************
  dialogue_for_entering_quantity(xROBS_)
  ***************************************
ENDIF

*
* --- reloading the browser
* --- ponovno uitavanje browser-a ------------------ end

*********************************************************** NOT-UPSIZE

RETURN NIL // FUNCTION stavku_dodaj_na_sto()







************************************************************************* NOT-UPSIZE
FUNCTION stavku_dodaj_na_sto_NOT()
*************************************************************************

     *************
     SELECT "STO"
     *************

     * Iz KASA_tach_buttons_stolovi.prg -> RACUN_NA_STOLU(o,GetList1)
     * Ako je otvoren RAUN STOLA tada postoje i ove varijable:
     * If RESTAURANT TABLE ACCOUNT is open, then these variables also exist:
     * PUBLIC oBrowse5
     * PUBLIC oDlgSto
     * PUBLIC GetListSto

RETURN NIL // FUNCTION stavku_ne_dodaj_na_sto()






**************************************************************************** NOT-UPSIZE
FUNCTION dialogue_for_entering_quantity(xROBS)
****************************************************************************
* zamena za YES-UPSIZE funkciju ykolicina()

LOCAL radno:=SELECT()
PRIVATE kolicina // mora da bude private zbog /kolicina u funkciji EUPIS1()
************
SELECT "STO"
************
GO TOP
LOCATE FOR ROBS_==xROBS
************************************

   PRIVATE ;
    ROBS     :=      ROBS_       ,;
    KOLI     :=      KOLI_       ,;
    CENA_MPR :=      CENA_MPR_   ,;
    VRED_MPR :=      VRED_MPR_   ,;
    PPUP     :=      PPUP_       ,;
    PPOD     :=      PPOD_       ,;
    VRED_VPR :=      VRED_VPR_   ,;
    CENA_VPR :=      CENA_VPR_

*************************************

IF KOLI=NIL;KOLI:=1;ENDIF
kolicina := EUPIS1("KOLI","QUANTITY:")
IF kolicina > 99999 .or. kolicina < -9999
   C__GRESKA("Nedozvoljena koliina;Not allowed quantity","STOP",,"G1")
   RETURN NIL
ENDIF



************************************* OBRAUN-KALKULATION-START
KOLI := kolicina
*************************************
VRED_MPR := KOLI * CENA_MPR
kfc := ((100 * PPUP)/(100+PPUP))/100
pdv := VRED_MPR * kfc
pdv := round(pdv,2)
VRED_VPR := VRED_MPR - pdv
PPOD := pdv
IF KOLI<>0
  CENA_VPR := VRED_VPR/KOLI
ELSE
  CENA_VPR := 0
ENDIF
************************************* OBRAUN-KALKULATION-END


************************************* UPDATE START
************************** cSQL string START
// varijable za cSQL string:

    cROBS_     :=      ROBS
    cKOLI_     :=      var2char(KOLI)
    cCENA_MPR_ :=      var2char(CENA_MPR)
    cVRED_MPR_ :=      var2char(VRED_MPR)
    cPPUP_     :=      var2char(PPUP)
    cPPOD_     :=      var2char(PPOD)
    cVRED_VPR_ :=      var2char(VRED_VPR)
    cCENA_VPR_ :=      var2char(CENA_VPR)

* PUBLIC _shetab_ := "public.x1" // iz 4_KASA_tach_buttons_stolovi_racuni.prg

// UPDATE (REPLACE)
TEXT INTO cSQL WRAP
  UPDATE &_shetab_
  SET
    KOLI_=&cKOLI_,
    CENA_MPR_=&cCENA_MPR_,
    VRED_MPR_=&cVRED_MPR_,
    PPUP_=&cPPUP_,
    PPOD_=&cPPOD_,
    VRED_VPR_=&cVRED_VPR_,
    CENA_VPR_=&cCENA_VPR_
  WHERE
    ROBS_='&cROBS_'
ENDTEXT
************************** cSQL string END
// dc_memoedit(cSQL);quit
  oStmt := DacSqlStatement():fromChar(cSQL)
  oStmt:build():execute()
************************************* UPDATE END


* solucija A
* Ovde se podatak dodaje direktno u TABLU a ne u QUERY -------- NO
/*
************************************* RELOADING BROWSER START
****************
* SELECT "STO";USE // CLOSE QUERY // WORK
  CLOSE STO        // CLOSE QUERY // WORK
****************
cSQL    := "SELECT * FROM "+_shetab_+";"
oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"STO")
STO:=cAlias        // this is mandatory  !
*************
SELECT "STO"
*************
GO TOP
LOCATE FOR ROBS_==cROBS_

* kombinacija ove tri komande menja nain rada u oBrowse5
* CLEAR TYPEAHEAD
* PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
* CLEAR TYPEAHEAD
// prikaz cele liste i skok na zadnju stavku u listi
// view entire list and jump to last item in the list
************************************* RELOADING BROWSER END
*/

* solucija B
* Ovde se podatak dodaje direktno u QUERY a ne u TABLU -------- YES
* pa se solucija B moe koristiti umesto solucije A
SELECT "STO"
oBrowse5:forceStable()
GO TOP
LOCATE FOR ROBS_==cROBS_

RETURN NIL







**************************************************************************** NOT-UPSIZE
FUNCTION dialogue_for_entering_price(xROBS)
****************************************************************************
* zamena za YES-UPSIZE funkciju ykolicina()

LOCAL radno:=SELECT()
PRIVATE kolicina // mora da bude private zbog /kolicina u funkciji EUPIS1()
************
SELECT "STO"
************
GO TOP
LOCATE FOR ROBS_==xROBS
************************************

   PRIVATE ;
    ROBS     :=      ROBS_       ,;
    KOLI     :=      KOLI_       ,;
    CENA_MPR :=      CENA_MPR_   ,;
    VRED_MPR :=      VRED_MPR_   ,;
    PPUP     :=      PPUP_       ,;
    PPOD     :=      PPOD_       ,;
    VRED_VPR :=      VRED_VPR_   ,;
    CENA_VPR :=      CENA_VPR_

*************************************

IF CENA_MPR=NIL;CENA_MPR:=1;ENDIF
cena := EUPIS1("CENA_MPR","PRICE:")
IF cena > 999999 .or. cena < 0
   C__GRESKA("Nedozvoljena cena;Not allowed price","STOP",,"G1")
   RETURN NIL
ENDIF

************************************* OBRAUN-KALKULATION-START
CENA_MPR := cena
*************************************
VRED_MPR := KOLI * CENA_MPR
kfc := ((100 * PPUP)/(100+PPUP))/100
pdv := VRED_MPR * kfc
pdv := round(pdv,2)
VRED_VPR := VRED_MPR - pdv
PPOD := pdv
IF KOLI<>0
  CENA_VPR := VRED_VPR/KOLI
ELSE
  CENA_VPR := 0
ENDIF
************************************* OBRAUN-KALKULATION-END


************************************* UPDATE START
************************** cSQL string START
// varijable za cSQL string:

    cROBS_     :=      ROBS
    cKOLI_     :=      var2char(KOLI)
    cCENA_MPR_ :=      var2char(CENA_MPR)
    cVRED_MPR_ :=      var2char(VRED_MPR)
    cPPUP_     :=      var2char(PPUP)
    cPPOD_     :=      var2char(PPOD)
    cVRED_VPR_ :=      var2char(VRED_VPR)
    cCENA_VPR_ :=      var2char(CENA_VPR)

* PUBLIC _shetab_ := "public.x1" // iz 4_KASA_tach_buttons_stolovi_racuni.prg

// UPDATE (REPLACE)
TEXT INTO cSQL WRAP
  UPDATE &_shetab_
  SET
    KOLI_=&cKOLI_,
    CENA_MPR_=&cCENA_MPR_,
    VRED_MPR_=&cVRED_MPR_,
    PPUP_=&cPPUP_,
    PPOD_=&cPPOD_,
    VRED_VPR_=&cVRED_VPR_,
    CENA_VPR_=&cCENA_VPR_
  WHERE
    ROBS_='&cROBS_'
ENDTEXT
************************** cSQL string END
// dc_memoedit(cSQL);quit
  oStmt := DacSqlStatement():fromChar(cSQL)
  oStmt:build():execute()
************************************* UPDATE END


* solucija A
* Ovde se podatak dodaje direktno u TABLU a ne u QUERY -------- NO
/*
************************************* RELOADING BROWSER START
******************
* SELECT "STO";USE // CLOSE QUERY // WORK
  CLOSE STO        // CLOSE QUERY // WORK
******************
cSQL    := "SELECT * FROM "+_shetab_+";"
oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"STO")
STO:=cAlias        // this is mandatory  !
*************
SELECT "STO"
*************
GO TOP
LOCATE FOR ROBS_==cROBS_

* CLEAR TYPEAHEAD
* PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5) // DOES NOT WORK
* CLEAR TYPEAHEAD
// prikaz cele liste i skok na zadnju stavku u listi
// view entire list and jump to last item in the list
************************************* RELOADING BROWSER END
*/


* solucija B
* Ovde se podatak dodaje direktno u QUERY a ne u TABLU -------- YES
* pa se solucija B moe koristiti umesto solucije A
SELECT "STO"
oBrowse5:forceStable()
GO TOP
LOCATE FOR ROBS_==cROBS_

RETURN NIL













