//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __ARTICLES_CODEBOOK.PRG                                 SQL        //
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


/*
------------------------------------
  PACKAGE:
  __ARTICLES__MAIN.PRG      // MAIN FOR EXE APPLICATION

  __ARTICLES_GROUP.PRG      // ARTICLES CODEBOOK
                            // REGISTER OF ALL ARTICLES
                            // AND CODE BOOK OF GROUPS OF ARTICLES

  __ARTICLES_CODEBOOK.PRG   // ARTICLES GROUP FROM 1 TO 16
                            // ONLY LIST OF ARTICLES (FILTER)
                            // THAT HAVE A GIVEN GROUP

  __ARTICLES_SELECTION.PRG
  __ARTICLES_DESCRIPTION.PRG
  __ARTICLES_REGISTERCARD.PRG
  __ARTICLES_ADDTOTABLE.PRG
  __ARTICLES_INSERT_DELETE_SORT.PRG
------------------------------------


Note:

A.
Aplikacija moe da Koristi posgreSQL upsize table koje imaju upsize polja:

  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  __order_1_1 character(36),
  __order_2_2 character(16),
  CONSTRAINT kroba_11_pkey PRIMARY KEY (__record)

Ali aplikacija ne koristi ta polja i ona ovde nemaju nikakvu svrhu.
Takoe, ne koristi ni ostale elemente upsize maine:
 - ne koristi tablu "alaska-software.isam.orders"
 - ne koristi tablu "alaska-software.isam.tables"
 - ne koristi ISAM indekse
 - moe da koristi ali ne koristi SQL indekse
Koristi sve mogunosti PGDBE maine:
 - sve passtrough SQL komande i funkcije
 - samo neke od ISAM komandi i funkcija

B.
Aplikacija Moe da Koristi posgreSQL no-upsize table odnosno standardne
postgreSQL table, koje nemaju ova upsize polja.



Notes:

A.
An application can use posgreSQL upsize tables that have upsize fields:

   __deleted boolean NOT NULL DEFAULT false,
   __record serial NOT NULL,
   __rowversion integer NOT NULL DEFAULT 1,
   __keyversion integer NOT NULL DEFAULT 0,
   __lock_owner integer NOT NULL DEFAULT 0,
   __order_1_1 character(36),
   __order_2_2 character(16),
   CONSTRAINT kroba_11_pkey PRIMARY KEY (__record)

But the application doesn't use those fields and they have no purpose here.
Also, it does not use the other elements of the upsize engine:
  - don't use table "alaska-software.isam.orders"
  - do not use table "alaska-software.isam.tables"
  - does not use ISAM indexes
  - can use but not SQL indexes
It uses all the possibilities of the PGDBE machine:
  - all passthrough SQL commands and functions
  - just some of the ISAM commands and functions

B.
Can use posgreSQL no-upsize tables or standard ones
postgreSQL tables, which do not have these upsize fields.






 IFARNIK SVIH ARTIKALA I FILTER PO GRUPI ARTIKALA
 ===========================================================
 (FILTER PO GRUPA = DOBS_ = "1" do "16")
 BROWSER ARTIKALA - LISTA ARTIKALA
 ARTIKAL: DODAJ, OBRII, EDITUJ, NAI, POALJI U APLIKACIJU

 ret .T. article taken
 ret .F. article not taken
 formira fajl:  ARTIKAL.CFG = "articlecode/articlebarcode"
   artikal_CFG_upisi1( cfg_asifra, cfg_abarcod )
   arttikal_CFG_citaj1()
   __ARTICLES_REGISTERCARD.PRG

 CODE BOOK OF ALL ARTICLES AND FILTER BY GROUP OF ARTICLES
 ===========================================================
 (FILTER BY GROUP = DOBS_ = "1" to "16")
 BROWSER ARTICLES - LIST OF ARTICLES
 ITEM: ADD, DELETE, EDIT, FIND, SEND TO APPLICATION

 ret .T. article taken
 ret .F. article not taken
 create file:  ARTIKAL.CFG = "articlecode/articlebarcode"
   artikal_CFG_upisi1( cfg_asifra, cfg_abarcod )
   arttikal_CFG_citaj1()
   __ARTICLES_REGISTERCARD.PRG

 ===========================================================

 ARTICLES_CODEBOOK()

 STATIC FUNCTION take_article(nn)
 STATIC FUNCTION Maintitle(cTitle)
 STATIC FUNCTION vidi_help(cTitle)

 STATIC FUNCTION find_name(oBrowse)
 STATIC FUNCTION find_code()
 STATIC FUNCTION find_BarCod()
 STATIC FUNCTION find_cataloque()

 STATIC FUNCTION find_word(oBrowse,oDlg)
 STATIC FUNCTION find_supplier(oBrowse,oDlg)
 STATIC FUNCTION find_link(oBrowse,oDlg)


 STATIC FUNCTION ARTICLES_DESCRIPTION_(oBrowse)
 STATIC FUNCTION ARTICLES_REGISTERCARD_(lPar,GetList,oBrowse,GRUPA)
 STATIC FUNCTION WRITE_DATA_(oBrowse)

 STATIC FUNCTION DELETE_ARTICLE_(oBrowse,GetList)
 STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList)

 STATIC FUNCTION SORT_BY_NAME_(cschemename,ctablename,cgrupa,oBrowse)
 STATIC FUNCTION SORT_BY_CODE_(cschemename,ctablename,cgrupa,oBrowse)
 STATIC FUNCTION SORT_BY_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
 STATIC FUNCTION SORT_BY_TYPE_(cschemename,ctablename,cgrupa,oBrowse)

* koristi se samo ako postoji polje (kolona)  __record
* used only if field (column) __record exists
 STATIC FUNCTION RENUMBERATION_('scheme.table',obrowse,nn)  // for any upsize table
 STATIC FUNCTION RECONSTRUCTION_('scheme.table',obrowse,nn) // for any upsize table
 STATIC FUNCTION RENUMBER__record_(codebook,obrowse,nn)     // for any upsize table


*/


#include "Xbtsys.ch"   // XbttoolsIII
#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "dll.ch"
#include "dcdialog.ch"
* #include "appbrow.ch" // for test

*************************************************************************
* FUNCTION ARTICLES_CODEBOOK(GRUPA,NAME)
FUNCTION __sifarnik_artikala_GRUPE(GRUPA,NAME)
// vraa .T. ili .F. i formira DBF\ARTIKAL.CFG
*************************************************************************

* GRUPA = grupa artikala - a group of articles
* NAME  = naziv grupe - group name


LOCAL radno := SELECT() // na izlazu iz programa SELECT(radno)
                        // on program exit return SELECT(radno)

LOCAL GetList := {}, GetOptions, oDlg, oBrowse, oBrowBox, ;
      oToolBar, bBrojSlogova, bTitle, ;
      cTitle := "ARTICLES CODE BOOK"
      cTitleList := cTitle
      cTit:=" SQL TABLE "


*** STOP(cTablename,1)


DEFAULT GRUPA TO "", NAME TO ""
GRUPA := alltrim(GRUPA)
NAME  := alltrim(NAME)
PRIVATE xGRUPA := GRUPA, xNAME:=NAME

IF EMPTY(GRUPA)
   cTitleList := "ARTICLES CODE BOOK"
ELSE
   cTitleList := strtran(NAME,";"," ") // ARTICLES GROUP NAME
ENDIF











*********************************
PUBLIC lPreuzet_je_artikal := .F.  // the article has been taken
*********************************
// IZLAZ IZ FUNKCIJE SA ESC ili sa Close -> lPreuzet_je_artikal := .F.
// IZLAZ IZ FUNKCIJE SA ESC ili sa Close -> isprazni ARTIKAL.CFG
// EXIT THE FUNCTION WITH ESC or with Close -> lPreuzet_je_artikal := .F.
// EXIT THE FUNCTION WITH ESC or with Close -> empty ARTIKAL.CFG



    **********************************************************
       PRIVATE BMP_OK, BMP_HLP, BMP_ESC, aCUR

       aCUR := {"USER32.DLL",114}

       BMP_OK := XbpBitmap():new():create()
       BMP_OK:load( "BAZNE.DLL", 11041 )
       BMP_OK:transparentClr := BMP_OK:getDefaultBgColor()

       BMP_HLP := XbpBitmap():new():create()
       BMP_HLP:load( "BAZNE.DLL", 11043 )
       BMP_HLP:transparentClr := BMP_HLP:getDefaultBgColor()

       BMP_ESC := XbpBitmap():new():create()
       BMP_ESC:load("BAZNE.DLL",11042 )
       BMP_ESC:transparentClr := BMP_ESC:getDefaultBgColor()
    **********************************************************





//========================================================================  START
// T A B L E  N A M E S
//========================================================================


    PRIVATE ;
    MAG         := _MAG_ ,; // PUBLIC __pg__ini() C-PGDB.DLL
    KAS         := _KAS_ ,; // PUBLIC __pg__ini() C-PGDB.DLL
    cSchemeName := _she_ ,; // PUBLIC __pg__ini() C-PGDB.DLL
    cTablename  := "kroba_"+_MAG_ ,; // zbog kompatibilnosti
    codebook    := _she_+".kroba_"+_MAG_

    PRIVATE oSession    := DbSession()

    ***********************
    * _shetab_="public.x1" // 4_KASA_tach_buttons_stolovi_racuni.prg
    ***********************
    // PUBLIC _shetab_ = "public.x1" or ""
    // potrebno za prenos podataka na restoranski sto
    // needed to transfer data to the restaurant table
    IF TYPE("_shetab_")<>"C"
       _shetab_:=""
    ENDIF
    ***********************
    * STOP(;
    * "=="+GRUPA+"==",;
    * "=="+NAME+"==" ,;
    * "=="+_shetab_+"==",1)
    ***********************


//========================================================================
// T A B L E  N A M E S
//========================================================================  END



//========================================================================  START
// D C B R O W S E  C O N T E N T  F R O M  P O S T G R E S Q L  T A B L E
//========================================================================

*----------------------------
* bez indeksa
* without index
*----------------------------


* --- STEP 1 --- SQL FILTERS BY GROUP --- PGDBE SQL


IF EMPTY(GRUPA)

   *" NO FILTER

    cSQL    := "SELECT * FROM "+codebook+" ORDER BY robn_ ;"
    oStmt   := DacSqlStatement():fromChar(cSQL)
    cAlias  := oStmt:build():query(,"ART")

ELSE

   *" YES FILTER

    cSQL    := "SELECT * FROM "+codebook+" WHERE dobs_='"+GRUPA+"' ORDER BY robn_ ;"
    oStmt   := DacSqlStatement():fromChar(cSQL)
    cAlias  := oStmt:build():query(,"ART")

ENDIF


    ART:=cAlias
    SELECT "ART"         // this is mandatory  !
    svega:=reccount()    // this works correctly !
    * count all to svega // this works correctly !
    GO TOP


*------
* NOTE:
*------
*
*"OVO OVDE NE FUNKCIONIE - THIS DOESN'T WORK HERE:
* SELECT "ART"
* INDEX ON ROBN_ TO 1
* INDEX ON ROBS_ TO 2
* SET INDEX TO 1,2
* U aplikaciji se ne mogu koristiti ISAM komande:
*    SEEK, SET SOFTSEEK, SET ORDER...
* cannot be used in the application ISAM commands:
*    SEEK, SET SOFTSEEK, SET ORDER...
*"OVO OVDE NE FUNKCIONIE - THIS DOESN'T WORK HERE:
*
//========================================================================
// D C B R O W S E  C O N T E N T  F R O M  P O S T G R E S Q L  T A B L E
//========================================================================  END









//========================================================================  START
// DCBROWSE LISTA SA ISAM KOMANDAMA PREUZETA IZ STARE DBF-NTX APLIKACIJE
// DCBROWSE LIST WITH ISAM COMMANDS TAKEN FROM OLD DBF-NTX APPLICATION
//========================================================================


*****************
SELECT "ART"
*****************


of2  := Font_codepage(14,"Verdana Bold",238,.t.)
of3  := Font_codepage(12,"Archivo Narrow",238,.t.)
of4  := Font_codepage(11,"Consolas",238,.t.)

HOR := 62
VER := 15 + 8.8

PUBLIC preuzmi_naziv := 0

@  0,2 DCSAY cTitleList SAYFONT of2  SAYCOLOR GRA_CLR_DARKRED SAYSIZE 0
@  0,51 DCSAY cTit SAYFONT "10.Verdana Bold"  ;
SAYCOLOR GRA_CLR_WHITE,GraMakeRGBColor({156,139,18}) SAYSIZE 0

BROWSER_COLOR() // bazne.dll

@  1,2 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE HOR,VER ;
   OBJECT oBrowBox

@ .1,.5 DCBROWSE oBrowse PARENT oBrowBox ALIAS "ART" ;
   SIZE HOR-1,VER-0.4 ;
   CURSORMODE XBPBRW_CURSOR_ROW ;
   HEADLINES 2 ;
   ITEMSELECTED {|| take_article(1),;  // here
                    SetAppFocus(oBrowse) }  ;
   EVAL {|o|o:setfont(of3)}




//--------------------------------------------
// K O L O N E  S P I S K A  A R T I K A L A
// COLUMNS FOR THE LIST OF ITEMS
//--------------------------------------------



DCBROWSECOL FIELD ART->ROBN_ WIDTH 20 HEADER "ARTICLE NAME"   ;
            PARENT oBrowse  TOOLTIP " NAZIV ARTIKLA | ARTICLE NAME "

DCBROWSECOL FIELD ART->MERA_ WIDTH 3  HEADER "UOM" ;
            PARENT oBrowse TOOLTIP " JEDINICA MERE | UNIT OF MEASUREMENT "

DCBROWSECOL FIELD ART->ROBS_ WIDTH 4  HEADER "CODE" ;
            PARENT oBrowse TOOLTIP " IFRA ARTIKLA | ARTICLE CODE "


DCBROWSECOL FIELD ART->CENA_MPR_ ;
  WIDTH 7;
  HEADER "PRICE" PARENT oBrowse TOOLTIP " MALOPRODAJNA CENA | RETAIL PRICE "

DCBROWSECOL FIELD ART->ROBK_ ;
  WIDTH 15 ;
  HEADER "BARCOD" PARENT oBrowse TOOLTIP " BARCOD EAN13 | GTIN EAN13 "


DCBROWSECOL FIELD ART->GRUP_ ;
  WIDTH 4 ;
  HEADER "H-FOOD  ;P-DRINK" PARENT oBrowse TOOLTIP " H-HRANA P=PIE | H=FOOD P=DRINK "

DCBROWSECOL FIELD ART->DOBS_ ;
  WIDTH 4 ;
  HEADER "GRUPA;1-16" PARENT oBrowse TOOLTIP " GRUPA 1 DO 16 | GROUP 1 TO 16 "


DCBROWSECOL FIELD ART->ROBN_ WIDTH 20 HEADER "ARTICLE NAME"   ;
            PARENT oBrowse

//--------------------------------------------
// COLUMNS FOR THE LIST OF ITEMS
// K O L O N E  S P I S K A  A R T I K A L A
//--------------------------------------------



//-------------------------------------------------------------------------------------
// TOOLBAR COMMAND BUTTON:
//-------------------------------------------------------------------------------------

d_tol := HOR
d_bro := 6
d_duz := d_tol/d_bro

of3  := Font_codepage(11,"Archivo Narrow",238,.t.)

@ VER+2,2 DCTOOLBAR oToolBar SIZE d_tol,3 BUTTONSIZE d_duz,3 FONT of3



DCADDBUTTON CAPTION BMP_OK ;
   TOOLTIP "Preuzmi podatke artikla - Download item data" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| take_article(1),;  // here
   SetAppFocus(oBrowse)};
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Name;F2" ;
   ACCELKEY {xbeK_F2, asc("N"), asc("n")} ;
   TOOLTIP " Nai po Nazivu - Find by Name " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| find_name(oBrowse), ;  // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse)} ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Code;F3" ;
   ACCELKEY {xbeK_F3, asc("C"), asc("c")};
   TOOLTIP " Nai po ifri - Find by Code " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_code(oBrowse), ; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Word;F4" ;
   ACCELKEY {xbeK_F4, asc("W"), asc("w")};
   TOOLTIP " Nadji po rei sadranoj bilo gde u nazivu ;"+;
           " Find by word contained anywhere in the name " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_word(oBrowse,oDlg),; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Barcod;F5" ;
   ACCELKEY {xbeK_F5, asc("B"), asc("b")};
   TOOLTIP " Nai po Barcodu - Find by Barcode " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_barcod(oBrowse),;  // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Catalog;F6" ;
   ACCELKEY {xbeK_F6, asc("Q"), asc("q")};
   TOOLTIP " Nai po katalokom broju - Find by catalog number " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_cataloque(oBrowse),; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE


*---
@ VER+2+3,2 DCTOOLBAR oToolBar SIZE d_tol,3 BUTTONSIZE d_duz,3  FONT of3
*---


DCADDBUTTON CAPTION "Group;F7"  ;
   ACCELKEY {xbeK_F7, asc("S"), asc("s")};
   TOOLTIP " Filter po grupi - Filter by group " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_supplier(oBrowse,oDlg),; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Links;F8"  ;
   ACCELKEY {xbeK_F8, asc("L"), asc("l")};
   TOOLTIP " Filter po Vezi - Filter by links " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_link(oBrowse,oDlg),; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
ALIGNCAPTION BS_MULTILINE


***********************
PRIVATE RESTART := .F.
***********************

DCADDBUTTON CAPTION "Descript;F9" ;
   ACCELKEY {xbeK_F9, asc("D"), asc("d")};
   TOOLTIP " Opis artikla - description article " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| ARTICLES_DESCRIPTION_(oBrowse)} ; // here
   ALIGNCAPTION BS_MULTILINE

* Varijanta sa ponovnim kreiranjem browsera - update data
* Variant with re-creation of the browser   - update data
* ACTION {|| RESTART:=.F., ;
* ARTICLES_DESCRIPTION_(oBrowse),;  // --> RESTART:=.T. or .F.
* IIF( RESTART=.T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList), SetAppFocus(oBrowse) )}



DCADDBUTTON CAPTION "Article;F10" ;
   ACCELKEY {xbeK_F10, asc("A"), asc("a")} ;
   TOOLTIP "Registar kartica artikla - Article card register" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| ARTICLES_REGISTERCARD_(.F.,GetList,oBrowse,GRUPA) };  // here
   ALIGNCAPTION BS_MULTILINE

* Varijanta sa ponovnim kreiranjem browsera - update data
* Variant with re-creation of the browser   - update data
* ACTION {|| RESTART:=.F., ;
* ARTICLES_REGISTERCARD_(.F.,GetList,oBrowse,GRUPA),;  // --> RESTART:=.T. or .F.
* IIF( RESTART=.T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList), SetAppFocus(oBrowse) )}


// NO WINDOWSXP.MANIFEST jer BMP gubi transparentnost
// NO WINDOWSXP.MANIFEST because BMP it loses transparency
DCADDBUTTON CAPTION BMP_HLP;
   ACCELKEY xbeK_F1  ;
   TOOLTIP "Help;F1" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| vidi_help(cTitle, cTitleList),;
   DC_GetRefresh(GetList), SetAppFocus(oBrowse)} ;
ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION BMP_ESC ;
   ACCELKEY xbeK_ESC;
   TOOLTIP "Kraj;Esc" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| take_article(0), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
ALIGNCAPTION BS_MULTILINE


* STEALT BUTTONS
DCHOTKEY xbeK_ALT_F1 ACTION {|| xc_autor1() }


DCHOTKEY xbeK_ALT_DEL ACTION {|| RECONSTRUCTION_(cTableName,oBrowse,1),SetAppFocus(oBrowse) }  // here


DCHOTKEY xbeK_ALT_F2 ACTION {|| SORT_BY_NAME_GROUP_(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }  // here
DCHOTKEY xbeK_ALT_F3 ACTION {|| SORT_BY_CODE_GROUP_(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }  // here


IF GRUPA==""

   DCHOTKEY xbeK_INS ACTION {|| INSERT_ARTICLE_(oBrowse,GetList,"ROBN_"),;
   DC_GetRefresh(GetList), oBrowse:RefreshAll(), SetAppFocus(oBrowse) }
   // SELECT * FROM tablename ORDER BY ROBN_;
   *---
   DCHOTKEY xbeK_DEL ACTION {|| DELETE_ARTICLE_(oBrowse,GetList,"ROBN_"),;
   DC_GetRefresh(GetList), oBrowse:RefreshAll(), SetAppFocus(oBrowse) }
   // SELECT * FROM tablename ORDER BY ROBN_;

ELSE


   * Kada nisu uitani svi artikli ve samo grupa artikala, tada nie dozvoljeno
   * dodavanje novog artikla u ifarnik i brisanje artikla iz ifarnika
   *
   * When not all articles are loaded but only a group of articles, then it is not
   * allowed adding a new article to the codebook and deleting an article from the
   * codebook

   DCHOTKEY xbeK_INS ACTION {|| c__greska("ADDING ARTICLE TO GROUP"     +chr(59)+;
                                          "  IS NOT POSSIBLE"           +chr(59)+;
                                          "ADD ARTICLEE IS POSSIBLE IN" +chr(59)+;
                                          "  "+cTitle                   +chr(59)+;
                                          "","ADD ARTICLE",,"G3"),;
   SetAppFocus(oBrowse) }
   *---
   DCHOTKEY xbeK_DEL ACTION {|| c__greska("DELETING ARTICLE FROM GROUP"  +chr(59)+;
                                          "  IS NOT POSSIBLE"            +chr(59)+;
                                          "DELETE ARTICLE IS POSSIBLE IN"+chr(59)+;
                                          "  "+cTitle                    +chr(59)+;
                                          "","DELETE ARTICLE",,"G3"),;
   SetAppFocus(oBrowse) }
ENDIF
//----------------------------------------------------------------------------------------------


aahorver:=appdesktop():currentsize()
ahor:=aahorver[1]-(HOR*7)-40
aver:=aahorver[2]-(VER*20)-242



DCGETOPTIONS ICON 1;
   SAYCENTER ;
   AUTOFOCUS ;
   NOMAXBUTTON ;
   NOMINBUTTON ;
   NOESCAPEKEY ;
   WINDOWROW aver WINDOWCOL ahor  ;
   TOOLTIPCOLOR GRA_CLR_BLACK,GRA_CLR_YELLOW TOOLTIPFONT "10.Consolas"

 bTitle := {|| Maintitle(cTitle) }

 DCREAD GUI TITLE bTitle OPTIONS GetOptions ;
            FIT ;
            SETFOCUS @oBrowse ;
              PARENT @oDlg ;
              EVAL {|o|SetAppWindow(o) };
              MODAL

SELECT "ART"

IF RESTART==.T.

    //  stop(2,restart,alias(),1)
     SELECT "ART";USE;SELECT(radno)
     CLEAR TYPEAHEAD
     ******************************
     * ARTICLES_CODEBOOK(GRUPA,NAME)
      __sifarnik_artikala_GRUPE(GRUPA,NAME)
     ******************************
ELSE
     // stop(3,restart,alias(),1)
     SELECT "ART"
     USE
ENDIF


//  ************************************************ START
//  * PRENESI FOKUS NA RESTORANSKI STO
//  * TRANSFER FOCUS TO RESTAURANT TABLE
    IF TYPE('oooFocus')="O"
    // PRIVATE oooFocus:
    // 4_KASA_tach_buttons_stolovi_racuni.prg
       SetAppFocus(oooFocus)
    ENDIF
//  ************************************************ END
//  OR
//  ************************************************ START
//  * PRENESI FOKUS NA RESTORANSKI STO
//  * TRANSFER FOCUS TO RESTAURANT TABLE
//  * LOCAL i
//  FOR i=1 to 3
//
//      IF alias(i)=="STO"
//      // ako je otvoren bilo koji STO
//      // artikal se NE UPISUJE u taj otvoreni sto
//        **************
//         SELECT "STO"
//        **************
//         SetAppFocus(oBrowse5)
//      ELSE
//      // ako ne postoji otvoren sto
//      // NE DEAVA SE NITA
//         ***
//      ENDIF
//
//  NEXT i
//  ************************************************ END


SELECT(radno)
RETURN(lPreuzet_je_artikal)  // .T./.F. the article has been taken





















* STATIC FUNCTION take_article(nn)
* STATIC FUNCTION Maintitle(cTitle)
* STATIC FUNCTION vidi_help(cTitle)



*------------------------------------------------------------------------
* FUNCTION take_article() nalazi se u __ARTICLES_ADDTOTABLE.PRG
* kao specifina funkcija samo za ovu aplikaciju KASA-ARTIKLI.EXE
*------------------------------------------------------------------------
/*
*************************************************************************
STATIC FUNCTION take_article(nn)
*************************************************************************
LOCAL radno := SELECT()

IF nn=0  // article not taken
 **********************************
 artikal_CFG_upisi1( "", "" ) // ARTICLE_REGISTERCARD.PRG
 **********************************
   SELECT(radno)
   RETURN NIL
ENDIF

 // article is taken
 **********************************
 artikal_CFG_upisi1( ROBS_, ROBK_ ) // ARTICLE_REGISTERCARD.PRG
 **********************************
 * Auriran je fajl ARTIKAL.CFG
 * The ARTIKAL.CFG file has been updated
 * Aplikacija uzima artikal sa: artikal_CFG_citaj1()
 * The application takes the article from: article_CFG_citaj1()

c__procitaj(;
"ARTIKAL JE POSLAT U ARTIKAL.CFG FILE"  +chr(59)+;
"ARTICLE HAS SENT TO ARTIKAL.CFG FILE"  +chr(59)+;
"Code       "+ROBS_                     +chr(59)+;
"Name       "+ROBN_                     +chr(59)+;
"Barcod     "+ROBK_                     +chr(59)+;
"Group      "+DOBS_                     +chr(59)+;
"Type       "+GRUP_                     +chr(59)+;
"","SEND ARTICLE TO APPLICATION",,"G3")
SELECT(radno)
*"POSLE SLANJA STAVKE ARTIKLA U APLIKACIJU NE ZATVARA SE IFARNIK
*"AFTER SENDING ARTICLE INTO APPLICATION, CODEBOOK DOES NOT CLOSE
RETURN NIL
*/


*************************************************************************
STATIC FUNCTION Maintitle(cTitle)
*************************************************************************
// ispis naslova u TITLE BAR-u sa brojem slogova
// print title in TITLE BAR with number of records
  LOCAL cBrojac, cNaslov
  * svega = broj redova table sa poetka programa
  * svega = number of table rows from the beginning of the program

*" U OVOM IFARNIKU NEMA PRIKAZA IZMENE BROJA REDOVA
*" THIS CODE BOOK DOES NOT SHOW THE CHANGE OF THE NUMBER OF ROWS
* COUNT ALL TO cBrojac  // reccount() not works
* GO TOP

    cNaslov := ;
    APLIKACIJA+"  |  KASH-REGISTER "+MAG+"-"+KAS+"  |  ARTICLES" + "  " +;
    var2char(svega)

RETURN(cNaslov)



*************************************************************************
STATIC FUNCTION vidi_help(cTitle)
*************************************************************************
LOCAL cr := chr(59), ctxt

ctxt := ;
"Sa ovog SPISKA ARTIKALA"                      +cr+;
cTitleList                                     +cr+;
"vri se izbor artikla traenjem artikla"      +cr+;
"po nazivu, po ifri artikla, po barkodu,"     +cr+;
"po katalokom broju, po rei u nazivu..."     +cr+;
"i slanje izabranog artikla u Dokument,"       +cr+;
"u koji se upisuju podaci o artiklu:"          +cr+;
"ili duplim klikom na artikal ili sa Enter"    +cr+;
"_____________________________________________"+cr+;
" "                                            +cr+;
"From this LIST OF ARTICLES"                   +cr+;
cTitleList                                     +cr+;
"article selection is made by searching for"   +cr+;
"article by name, by code, by barcode, by  "   +cr+;
"catalog number, by word anywhere in name..."  +cr+;
"and sending selected article to Document"     +cr+;
"in which data about article is entered:"      +cr+;
"or double click on article or with Enter."    +cr+;
"_____________________________________________"+cr+;
" "                                            +cr+;
" Article is added to the List  [INSERT]"      +cr+;
" Article is deleted from List  [DELETE]"      +cr+;
" Reconstruction List           [ALT]+[DEL]"   +cr+;
" Sorting List by article name  [ALT]+[F2]"    +cr+;
" Sorting List by article code  [ALT]+[F3]"    +cr+;
" "

* alertbox(,ctxt,{"    OK    "},,cTitle,"10.Consolas") // bazne.dll
c__procitaj(ctxt,"ARTICLES CODE BOOK",,"10.Lucida Console")  // bazne.dll


CLEAR TYPEAHEAD
RETURN(nil)




************ __ARTICLES_INSERT_DELETE_SORT.PRG ****************** START

STATIC FUNCTION DELETE_ARTICLE_(oBrowse,GetList,_order_)
  DELETE_ARTICLE(oBrowse,GetList,_order_)
RETURN NIL
STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList,_order_)
  INSERT_ARTICLE(oBrowse,GetList,_order_)
RETURN NIL


STATIC FUNCTION SORT_BY_NAME_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_NAME(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_CODE_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_CODE(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_GROUP(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_TYPE_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_TYPE(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL

STATIC FUNCTION SORT_BY_NAME_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_NAME_GROUP(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_CODE_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_CODE_GROUP(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL


STATIC FUNCTION RENUMBERATION_(ccTablename,oBrowse,nn)
  RENUMBERATION(ccTablename,oBrowse,nn)
  * ccTablename = 'tablename' or 'schemename.tablename'
RETURN NIL
STATIC FUNCTION RECONSTRUCTION_(ccTablename,oBrowse,nn)
  RECONSTRUCTION(ccTablename,oBrowse,nn)
  * ccTablename = 'tablename' or 'schemename.tablename'
RETURN NIL
STATIC FUNCTION RENUMBER__record_(codebook,oBrowse,nn)
  RENUMBER__record(codebook,oBrowse,nn)
  * codebook='schemename.tablename'
RETURN NIL

************ __ARTICLES_INSERT_DELETE_SORT.PRG ****************** END


***************** __ARTICLES_DESCRIPTION.PRG ******************** START
STATIC FUNCTION ARTICLES_DESCRIPTION_(oBrowse)
   ARTICLES_DESCRIPTION(oBrowse)
RETURN NIL
***************** __ARTICLES_DESCRIPTION.PRG ******************** END


***************** __ARTICLES_REGISTERCARD.PRG ******************** START
STATIC FUNCTION ARTICLES_REGISTERCARD_(lPar,GetList,oBrowse,GRUPA)
* lPar =.F. editovanje zabranjeno | editing prohibited
   ARTICLES_REGISTERCARD(lpar,GetList,oBrowse,GRUPA)
RETURN NIL
STATIC FUNCTION WRITE_DATA_(oBrowse)
   WRITE_DATA(oBrowse)
RETURN NIL
***************** __ARTICLES_REGISTERCARD.PRG ******************** END










* STATIC FUNCTION find_name(oBrowse)
* STATIC FUNCTION find_code()
* STATIC FUNCTION find_word(oBrowse,oDlg)
* STATIC FUNCTION find_BarCod()
* STATIC FUNCTION find_cataloque()
* STATIC FUNCTION find_supplier(oBrowse,oDlg)
* STATIC FUNCTION find_link(oBrowse,oDlg)

*************************************************************************
STATIC FUNCTION find_name(oBrowse)
*************************************************************************

   xUpis := space(20)
   cUpis := Enter_key("Trai po nazivu","",xUpis,,"top")

   GO TOP
   LOCATE FOR ALLTRIM(ROBN_)=ALLTRIM(cUpis)
   IF FOUND()=.F.
      * confirmbox(setappwindow(),"Nije naeno",;
      * "Not Found",XBPMB_OK,XBPMB_CRITICAL)
      * c_poruka("NIJE NAENO","Not Found")
      * stop("NIJE NAENO",0)

      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_code()
*************************************************************************
   xUpis := space(5)
   cUpis := Enter_key("ifra","",xUpis,,"top")
   cUpis := STRZERO(VAL(cUpis),5)

   GO TOP
   LOCATE FOR ALLTRIM(ROBS_)=ALLTRIM(cUpis)
   IF FOUND()=.F.
      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_barcod()
*************************************************************************
LOCAL re := RecNo(), xUpis, cUpis, nUpis

   xUpis := space(13)
   cUpis := Enter_key("Trai po BarCodu","",xUpis,,"top")
   cUpis := ALLTRIM(cUpis)
   nUpis := LEN(cUpis)

   GO TOP
   LOCATE FOR SUBSTR(ROBK_,1,nUpis) == cUpis
   IF FOUND()=.F.
      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_cataloque()
*************************************************************************
LOCAL re := RecNo(), xUpis, cUpis, nUpis

   xUpis := space(25)
   cUpis := Enter_key("Trai po Katalokom broju","",xUpis,,"top")
   cUpis := ALLTRIM(cUpis)
   nUpis := LEN(cUpis)

   GO TOP
   LOCATE FOR SUBSTR(DOBK_,1,nUpis) == cUpis
   IF FOUND()=.F.
      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_word(oBrowse,oDlg)
*************************************************************************
// Otvorena radna tabla SELECT "ART" - Open working table SELECT "ART":
LOCAL radno:=SELECT()
LOCAL selekcija := Enter_key("Find by part of name","",space(20),,"top")
      selekcija := ALLTRIM(selekcija)
      * selekcija = PART OF NAME -> "ROBN_"
      **************************************************
      ARTICLES_SELECTION(selekcija,"ROBN_",oDlg,,xGRUPA)
      **************************************************
* ARTICLES_SELECTION.PRG
* formiraj listu svih artikla koji imaju re 'selekcija' u nazivu artikla
* create a list of all articles that have word 'selection' in article name
* No case-sensitive
SELECT(radno)
RETURN(nil)

*************************************************************************
STATIC FUNCTION find_supplier(oBrowse,oDlg)
*************************************************************************
// Otvorena radna tabla SELECT "ART" - Open working table SELECT "ART":
LOCAL radno:=SELECT()
LOCAL selekcija := ALLTRIM(DOBS_)
      * selekcija = SUPPLIER CODE -> "DOBS_"
      **************************************************
      ARTICLES_SELECTION(selekcija,"DOBS_",oDlg,,xGRUPA)
      **************************************************
* ARTICLES_SELECTION.PRG
* formiraj listu svih artikala koji imaju ifru dobavljaa = 'selekcija'
* create a list of all articles that have supplier code = 'selection'
SELECT(radno)
RETURN(nil)

*************************************************************************
STATIC FUNCTION find_link(oBrowse,oDlg)
*************************************************************************
// Otvorena radna tabla SELECT "ART" - Open working table SELECT "ART":
LOCAL radno:=SELECT()
LOCAL selekcija := ALLTRIM(VEZA_)
      * selekcija = LINK CODE -> "VEZA_"
      **************************************************
      ARTICLES_SELECTION(selekcija,"VEZA_",oDlg,,xGRUPA)
      **************************************************
* ARTICLES_SELECTION.PRG
* formiraj listu svih artikala koji imaju ifru veze = 'selekcija'
* create a list of all articles that have link code = 'selection'
SELECT(radno)
RETURN(nil)








//* FUNCTION DELETE_ARTICLE(oBrowse,GetList)
//* FUNCTION INSERT_ARTICLE(oBrowse,GetList)
//* STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList,cUpis)
//* FUNCTION RENUMBERATION()
//* FUNCTION RECONSTRUCTION()
//* FUNCTION RENUMBER__record()
//
//**************************************************************************
//FUNCTION DELETE_ARTICLE(oBrowse,GetList)
//**************************************************************************
//LOCAL radno:=SELECT()
//LOCAL xCode := robs_, yCode:=robs_, xName := robn_ , cRec
//*
//* --- tehnika:
//* uvijek-odaberi-susednu-stavku (nakon brisanja stavke iz browsera)
//* --- technique:
//* always-select-adjacent-item (after deleting the item from the browser)
//*
// SKIP 1
// IF EOF()
//     SKIP -1
//     SKIP -1
//     cRec:=robs_
//     // stop(ROBS_,"GORE",1)
//     SKIP 1
//     // stop(ROBS_,"DEL",1)
// ELSE
//     cRec:=robs_
//     // stop(ROBS_,"DOLE",1)
//     SKIP -1
//     // stop(ROBS_,"DEL",1)
// ENDIF
//// ISAM nee da uita __record
//// ISAM will not load __record
//* --- technique:
//* always-select-adjacent-item (after deleting the item from the browser)
//
//IF c__sifra(2,"password=22")=.F.
//   RETURN NIL
//ENDIF
//
//IF c__neda("Brie se iz registra-spiska artikala"  +chr(59)+;
//           "It is deleted from list of articles:"  +chr(59)+;
//           " "                                     +chr(59)+;
//           xCode+" "+xName                         +chr(59)+;
//           "","DELETION",,"G3")=.F.
//           CLEAR TYPEAHEAD
//           RETURN NIL
//ENDIF
//
//
//
//   SELECT(radno)
//  * DELETE  // now the __deleted column is set to TRUE // Error
//  * COMMIT                                             // Error
//
//
//   // remove from table ROW with column __deleted=TRUE
//     xCode := "'"+xCode+"'"
//
//     IF empty(yCode)
//       // ako nema ifre artikla - if no article code
//        cSQL := "DELETE FROM ONLY "+codebook+" WHERE robs_ IS NULL;"
//     ELSE
//        cSQL := "DELETE FROM ONLY "+codebook+" WHERE robs_="+xCode+";"
//     ENDIF
//     oStmt := DacSqlStatement():fromChar(cSQL)
//     oStmt:build():execute()
//    * ---
//     cSQL := "VACUUM FULL "+codebook+";"
//     oStmt := DacSqlStatement():fromChar(cSQL)
//     oStmt:build():execute()
//
//   SELECT(radno) // SELECT "ART"
//
//
//   * --- technique:
//   * always-select-adjacent-item (after deleting the item from the browser)
//   oBrowse:refreshall()
//    GO TOP
//    LOCATE FOR alltrim(robs_)=alltrim(cRec)
//    IF FOUND()==.F.
//       GO TOP
//    ENDIF
//   oBrowse:refreshall()
//   * --- technique:
//   * always-select-adjacent-item (after deleting the item from the browser)
//
//   c__poruka("DELETED","OK",,"G3")
//
//
//RETURN NIL
//
//
//
//
//**************************************************************************
//FUNCTION INSERT_ARTICLE(oBrowse,GetList)
//**************************************************************************
//LOCAL radno:=SELECT()
//
//   LOCAL xUpis := space(5)  // broj znakova za upis
//   LOCAL cUpis := Enter_key("New Code","",xUpis,,"top")
//   IF EMPTY(cUpis)
//      RETURN NIL
//   ENDIF
//   cUpis := STRZERO(VAL(cUpis),5)
//
//
//   GO TOP
//   LOCATE FOR ALLTRIM(ROBS_)=ALLTRIM(cUpis)
//   IF FOUND()
//      c__poruka("ARTICLE EXISTS","OK",,"G3")
//      CLEAR TYPEAHEAD
//      RETURN NIL
//   ENDIF
//
//
//**************************************
//INSERT_ARTICLE_(oBrowse,GetList,cUpis)
//**************************************
//
//RETURN NIL
//
//
//*************************************************************************
//STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList,cUpis)
//*************************************************************************
//LOCAL radno:=SELECT()
//PRIVATE ROBS, ROBN, DOBS,  cSQL, oStmt
//
//ROBS := cUPIS
//ROBN := " *** NEW NAME "+ROBS+" ***"
//DOBS := xGRUPA
//
//TEXT INTO cSQL WRAP
//INSERT INTO &codebook ( ROBS_, ROBN_, DOBS_ ) VALUES ('&ROBS', '&ROBN', '&DOBS' );
//ENDTEXT
//// dc_memoedit(cSQL)
//
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():execute()
//
//
//SELECT "ART"
//DBREFRESH()
//GO TOP
//LOCATE FOR ROBS_==ROBS
//DC_GetRefresh(GetList)
//oBrowse:RefreshAll()
//
//SELECT(radno)
//RETURN NIL
//
//
//
//
//
//
//* STATIC FUNCTION SORT_BY_NAME_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
//* STATIC FUNCTION SORT_BY_CODE_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
//
//**************************************************************************
//STATIC FUNCTION SORT_BY_NAME_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
//**************************************************************************
//  SORT_BY_NAME_GROUP(cschemename,ctablename,cgrupa,oBrowse)
//RETURN NIL
//**************************************************************************
//STATIC FUNCTION SORT_BY_CODE_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
//**************************************************************************
//  SORT_BY_CODE_GROUP(cschemename,ctablename,cgrupa,oBrowse)
//RETURN NIL
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//* FUNCTION RENUMBERATION()
//* FUNCTION RECONSTRUCTION()
//* FUNCTION RENUMBER__record()
//
//*************************************************************************
//FUNCTION RENUMBERATION(ccTablename,oBrowse,nn)
//*************************************************************************
//* ccTablename = 'tablename' or 'schemename.tablename'
//* Moe se koristiti za bilo koju upsize tablu koja ima __record kolonu
//* Can be used for any upsize table that has a __record column
//
//LOCAL radno:=SELECT()
//PRIVATE cTablename := ccTablename
//
//IF nn=1
//c__poruka("START RENUMBERATION","START",,"G3")
//ENDIF
//
//* --- PASS 1 START
//// Napravi se lista brojeva upisanih u __record za svaki red table
//// Create a list of numbers written in __record for each row of the table
//* ---
//cSQL := "SELECT __record FROM "+codebook+";"
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():query(, @xResult)
//SELECT QUERY
//aRow:={}
//DO WHILE .NOT. EOF()
//  AADD(aRow,__record)
//SKIP
//ENDDO
//CLOSE QUERY
//SELECT(radno) // SELECT "ART"
//* ---
//// Izvri se renumeracija svih redova u tabli u koloni __record Public Key
//// All rows in the table in the __record Public Key column are renumbered
//* ---
//cSQL:=""; ni:=0
//FOR ni=1 TO len(aRow)
//
// alt_No__record := var2char(aRow[ni])  // 1,2,3,5,6      // state after DELETE __record = 4
// new_No__record := var2char(-aRow[ni]) // -1,-2,-3,-5,-6 // state after renumberation pass 1
//
//TEXT INTO txt WRAP
//UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
//ENDTEXT
//
//cSQL:=cSQL+txt
//NEXT ni
//* ---
//* dc_memoedit(cSQL) // test
//// sve se to upie u sve redove table
//// everything is written in all the rows of table
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():execute()
//// DBREFRESH()
//* --- PASS 1 END
//
//
//
//* --- PASS 2 START
//// ponovo se uitaju svi aurirani redovi table sa negativnim __record
//// reload all updated table rows with negative __record
//cSQL := "SELECT __record FROM "+codebook+";"
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():query(, @xResult)
//SELECT QUERY
//aRow:={}
//DO WHILE .NOT. EOF()
//  AADD(aRow,__record)
//SKIP
//ENDDO
//CLOSE QUERY
//SELECT(radno) // SELECT "ART"
//* ---
//* ---
//cSQL:=""; ni:=0
//FOR ni=1 TO len(aRow)
//
// alt_No__record := var2char(aRow[ni]) // -1,-2,-3,-5,-6 // state after renumberation pass 1
// new_No__record := var2char(ni)       // 1,2,3,4,5      // state after renumberation pass 2
//
//TEXT INTO txt WRAP
//UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
//ENDTEXT
//
//cSQL:=cSQL+txt
//NEXT ni
//* ---
//* dc_memoedit(cSQL) // test
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():execute()
//// DBREFRESH()
//// APPEND BLANK e dodati novi __record = 6 poto on sada ne postoji i sve je OK
//// APPEND BLANK will add a new __record = 6 since it doesn't exist now and everything is OK
//* --- PASS 2 END
//
//
//* "--- alternative for PASS 2
//* RENUMBER__record(cTablename) // here
//* DBREFRESH()
//* oBrowse:Refreshall()
//* "--- alternative for PASS 2
//
//*------------------------------------------------------------------------
//* --- AFTER DELETING ROW FOLLOWS RESET COLUMN __record -------------- END
//*------------------------------------------------------------------------
//
//
//
//// rekonstrukcija formirane prazne i/ili napunjene table:
//  cSQL := "VACUUM FULL "+codebook+";"
//  oStmt := DacSqlStatement():fromChar(cSQL)
//  oStmt:build():execute()
//
//
//   SELECT(radno) // SELECT "ART"
//   DbRefresh()
//   oBrowse:refreshall()
//   GO TOP
//
//* ---
//IF nn=1
//c__poruka("END RENUMBERATION","END",,"G3")
//ENDIF
//RETURN NIL
//
//
//
//*************************************************************************
//FUNCTION RECONSTRUCTION(ccTablename,oBrowse,nn)
//*************************************************************************
//* ccTablename = 'tablename' or 'schemename.tablename'
//* Moe se koristiti za bilo koju upsize tablu koja ima __record kolonu
//* Can be used for any upsize table that has a __record column
//
//LOCAL radno:=SELECT()
//PRIVATE cTablename := ccTablename
//
//IF nn=1
//c__poruka("START RECONSTRUCTION","START",,"G3")
//ENDIF
//
//
//* ---
//  * specijalna operacija:
//  * APPEND BLANK kad se prekine sa error u tablu doda jedan prazan red
//  * koji nema ifru artikla i koji treba obrisati.
//  * Bie obrisani svi redovi koji imaju robs_ IS NULL (robs_="     ")
//  * special operation:
//  * APPEND BLANK, when terminated with an error, adds one blank row to the table
//  * which does not have an article code and which should be deleted
//  * All rows that have robs_ IS NULL (robs_="     ") will be deleted
//
//  cSQL := "DELETE FROM ONLY "+codebook+" WHERE robs_ IS NULL;"
//  oStmt := DacSqlStatement():fromChar(cSQL)
//  oStmt:build():execute()
//  SELECT(radno)
//  //DBREFRESH()
//* ---
//
//
//* --- PASS 1 START
//// Napravi se lista brojeva upisanih u __record za svaki red table
//// Create a list of numbers written in __record for each row of the table
//* ---
//cSQL := "SELECT __record FROM "+codebook+";"
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():query(, @xResult)
//SELECT QUERY
//aRow:={}
//DO WHILE .NOT. EOF()
//  AADD(aRow,__record)
//SKIP
//ENDDO
//CLOSE QUERY
//SELECT(radno) // SELECT "ART"
//* ---
//// Izvri se renumeracija svih redova u tabli u koloni __record Public Key
//// All rows in the table in the __record Public Key column are renumbered
//* ---
//cSQL:=""; ni:=0
//FOR ni=1 TO len(aRow)
//
// alt_No__record := var2char(aRow[ni])  // -1,-2,-3,-5,-6 state after accident
// new_No__record := var2char(-aRow[ni]-100000)
// // -100001,-200002,-300003,-500005,-600006  state after reconstructions pass 1
//
//TEXT INTO txt WRAP
//UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
//ENDTEXT
//
//cSQL:=cSQL+txt
//NEXT ni
//* ---
//* dc_memoedit(cSQL) // test
//// sve se to upie u sve redove table
//// everything is written in all the rows of the board
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():execute()
////DBREFRESH()
//* --- PASS 1 END
//
//
//* --- PASS 2 START
//// ponovo se uitaju svi aurirani redovi table sa negativnim __record
//// reload all updated table rows with negative __record
//cSQL := "SELECT __record FROM "+codebook+";"
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():query(, @xResult)
//SELECT QUERY
//aRow:={}
//DO WHILE .NOT. EOF()
//  AADD(aRow,__record)
//SKIP
//ENDDO
//CLOSE QUERY
//SELECT(radno) // SELECT "ART"
//* ---
//* ---
//cSQL:=""; ni:=0
//FOR ni=1 TO len(aRow)
//
//
// alt_No__record := var2char(aRow[ni])
// // -100001,-200002,-300003,x,-500005,-600006 state after reconstructions pass 1
// new_No__record := var2char(ni) // 1,2,3,4,5  state after reconstructions pass 2
//
//
//TEXT INTO txt WRAP
//UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
//ENDTEXT
//
//cSQL:=cSQL+txt
//NEXT ni
//* ---
//* dc_memoedit(cSQL) // test
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():execute()
//// DBREFRESH()
//// APPEND BLANK e dodati novi __record = 6 poto on sada ne postoji i sve je OK
//// APPEND BLANK will add a new __record = 6 since it doesn't exist now and everything is OK
//* --- SECTION 2 END
//
//*------------------------------------------------------------------------
//* --- AFTER DELETING ROW FOLLOWS RESET COLUMN __record -------------- END
//*------------------------------------------------------------------------
//
//
//// rekonstrukcija formirane prazne i/ili napunjene table:
//  cSQL := "VACUUM FULL "+codebook+";"
//  oStmt := DacSqlStatement():fromChar(cSQL)
//  oStmt:build():execute()
//
//
//SELECT(radno) // SELECT "ART"
//DbRefresh()
//oBrowse:refreshall()
//setappfocus(oBrowse)
//GO TOP  // ubije se program ???
//
//
//* ---
//IF nn=1
//c__poruka("END RECONSTRUCTION","END",,"G3")
//ENDIF
//
//
//RETURN NIL
//
//
//
//*************************************************************************
//FUNCTION RENUMBER__record(cTablename)
//*************************************************************************
//* ccTablename = 'tablename' or 'schemename.tablename'
//* Moe se koristiti za bilo koju upsize tablu koja ima __record kolonu
//* Can be used for any upsize table that has a __record column
//
//LOCAL radno:=SELECT()
//LOCAL cSQL,oStmt,nRows
//PRIVATE xTable := codebook
//*------------------------------------------------------------------ START
//* RENUMERACIJA kolone __record brojevima od 1 do n
//* RENUMBER of the __record column with numbers from 1 to n
//*------------------------------------------------------------------------
//* https://stackoverflow.com/questions/41346345/
//* how-can-i-update-all-rows-in-postgresql-from-1-to-n-where-n-number-of-rows
//* Example:
//* update kroba_11
//*   set __record = t.rn
//* from (
//*   select __record,
//*          row_number() over (order by __record) as rn
//*   from kroba_11
//* ) t
//* where t.__record = kroba_11.__record;
//* ---
//
//PRIVATE xTableRecord := xTable+".__record"
//
//TEXT INTO cSQL WRAP
//update &xTable
//  set __record = t.rn
//from (
//  select __record,
//         row_number() over (order by __record) as rn
//  from &xTable
//) t
//where t.__record = &xTablerecord;
//ENDTEXT
//
//* dc_memoedit("2"+chr(13)+chr(10)+cSQL) // test
//
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():execute()
//* ---
//
//* ---
//// Brojanje redova u tabli
//// Counting rows in the table
//cSQL:="SELECT COUNT(*) FROM "+xTable+";"
//oStmt := DacSqlStatement():fromChar(cSQL)
//oStmt:build():query()
//SELECT QUERY
//nRows:=count
//CLOSE QUERY
//c_poruka("NUMBER OF ROWS RENUMBERED "+var2char(nRows))
//*------------------------------------------------------------------------
//* RENUMERACIJA kolone __record brojevima od 1 do n
//* RENUMBER of the __record column with numbers from 1 to n
//*---------------------------------------------------------------------END
//
//SELECT(radno) // SELECT "ART"
//DbRefresh()
//
//RETURN NIL
//
//








//* --- PREUZIMANJE ARTIKLA PO IFRI U RAUN RESTORANSKOG STOLA -----------
//* Ako konobar zna ifru artikla ne mora da otvara ifarnik artikala.
//* Potrebno je da upie ifru artikla i taj artikal e biti dodat u
//* raun restoranskog stola.
//* --- TAKING OF ARTICLE BY CODE INTO ACCOUNT OF RESTAURANT TABLE --------
//* If the barman knows the article code, he does not have to open the
//* article code book. It is necessary to enter the code of the article
//* and that article will be added to restaurant table bill.
//* ---
//*" Funkcija se aktivira na komandni taster [S] iz otvorenog rauna stola
//*" dok je aktivan raun stola SELECT STO
//*" The function is activated on the command key [S] from the open account
//*" RESTAURANT TABLE while the SELECT STO account RESTAURANT TABLE is active
//*************************************************************************
//FUNCTION zadaj__sifru__artikla(ccfile)
//*************************************************************************
//* Zadaj ifru artikla u dialog boksu za ifru
//* Nai ifru artikla u kroba_11 tabli i preuzmi artikal u tablu
//* restoranskog stola x1, x2, x3...
//* Ova funkcija poziva se iz otvorenog rauna restoranskog stola SELECT "STO"
//* ---
//* Enter the article code in the code dialog box
//* Find article code in the kroba_11 table and download article to
//* table restaurant desk x1, x2, x3...
//* This function is called from the open account restaurant table SELECT "STO"
//* ---
//
//LOCAL radno:=SELECT() // SELECT "STO"
//LOCAL sifra := "     "
//
//sifra:=eUpis0(sifra,"Article code","Code:|from 1 to 99999")
//IF EMPTY(sifra)
//   CLEAR TYPEAHEAD
//   RETURN NIL
//ENDIF
//IF val(sifra)=0 .or. val(sifra)>99999
//   sifra:=strzero(val(sifra),5)
//   c_greska("Code "+sifra+" is not allowed")
//   CLEAR TYPEAHEAD
//   RETURN NIL
//ENDIF
//sifra:=strzero(val(sifra),5)
//
//*********************************
//codebook := _she_+".kroba_"+_MAG_
//*********************************
//
//
//
///*
//* BUG ???
//* kad se upotrebi ovaj kod u YES-UPSIZE on otvara samo onu grupu artikala
//* koja je bila zadnja otvorena u aplikaciji - kao lista artikala za grupu
//* odnosno kao ALIAS "ART" i na kraju je bila zatvorena sa USE,
//* a ne otvara sve redove table - sve artikle u tabli kako bi moralo biti !!!
//* ---
//* BUG ???
//* when this code is used in ZES-UPSIZE, it opens only that group of articles
//* that is was last opened in the application - as a list of items for the group
//* i.e. as ALIAS "ART" and was finally closed with USE,
//* and it does not open all rows of the board - all items in the board as it
//* should be !!!
//* ---
//DBREFRESH()
//SPISAK_ROBE:="kroba_11"
//USE (SPISAK_ROBE) NEW SHARED ALIAS "ART"
//count all to brojac
//GO TOP
//*****************
//SELECT "ART"
//*****************
//*/
//
//
//
//
//*
//* Ovo radi kako treba - otvara sve redove table:
//    cSQL    := "SELECT * FROM "+codebook+";"
//    oStmt   := DacSqlStatement():fromChar(cSQL)
//    cAlias  := oStmt:build():query(,"ART")
//
//    ARTIKLI:=cAlias
//    SELECT "ART"
//    GO TOP
//
//
//GO TOP
//LOCATE FOR alltrim(ROBS_) == alltrim(sifra)
//IF FOUND()==.F.
//   SELECT "ART";USE
//   SELECT(radno)  // SELECT "STO"
//   c_greska("ifra "+sifra+" nije naena")
//   CLEAR TYPEAHEAD
//   RETURN NIL
//ENDIF
//
//
//* A  U R I R A N J E  R A  U N A  S T O L A  --- S T A R T
//
//
// // ako je artikal PREUZET - ifra je naena
//
//      // artikal se UPISUJE u taj otvoreni sto
//      // i sto se aktivira sa TAB upis koliine
//         SELECT "STO"
//
//         * PUBLIC _shetab_ // scheme.table 'public.x1'
//         *********************************
//         stavku_dodaj_na_sto_YES(_shetab_)  // __ARTICLES_ADDTOTABLE.PRG
//         *********************************
//
//* A  U R I R A N J E  R A  U N A  S T O L A  --- E N D
//SELECT "ART";USE
//SELECT(radno)  // SELECT "STO"
//CLEAR TYPEAHEAD
//RETURN NIL
//








