//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __ARTICLES_DESCRIPTION.PRG                              SQL        //
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

/*

-------------------------------
  PACKAGE:
  __ARTICLES__MAIN.PRG
  __ARTICLES_CODEBOOK.PRG
  __ARTICLES_SELECTION.PRG
  __ARTICLES_DESCRIPTION.PRG
  __ARTICLES_REGISTERCARD.PRG
-------------------------------

  EDITOR TEKST STRINGA - MEMO POLJA  - U DBF/DBT FAJLU
  EDITOR TEKST STRINGA - TXT  KOLONE - U POSTGRESQL TABLI

  TEXT STRING EDITOR - MEMO FIELDS - IN DBF/DBT FILE
  TEXT STRING EDITOR - TXT COLUMNS - IN POSTGRESQL TABLE

-------------------------------
 FUNCTION ARTICLES_DESCRIPTION(oBrowse)
 FUNCTION _Editor_()
 STATIC FUNCTION mehlp()
 STATIC FUNCTION xxx(oDlg,x,y)  // test window position

*/

#include "Xbp.ch"
#include "AppEvent.ch"
#include "Common.ch"

#include "xbtsys.ch"
#include "dcdialog.ch"

#include "pgdbe.ch"

#include "std.ch"
#include "sql.ch"
#include "dac.ch"
#pragma library("adac20b.lib")

* koristi se za testiranje programa
*  #include "Appbrow.ch"
*  MEMVAR appObject





***********************************************************************************

FUNCTION ARTICLES_DESCRIPTION(oBrowse)  // Obrada text polja OPIS_ iz XbpMLE editora

***********************************************************************************
LOCAL radno := SELECT()  // SELECT "ART"

rec:=recno() // this works

PRIVATE ;
      sifra := ROBS_,; // string from table
      naziv := ROBN_,; // string from table
      cTxt  := ""   ,; // string
      txt   := gde_exe()+"\t.txt" // txt file

      // POSTUPAK:
      // UITAJ IZ TABLE TEKST OPIS_ U STRING cTxt
      // OBRISI TXT FAJL txt AKO POSTOJI
      // ZAPISI STRING cTxt U TXT FAJL txt
      // IZ EDITORA MLE UITAJ TEKST cTxt IZ TXT FAJLA txt
      // IZ EDITORA MLE EDITUJ TEKST cTxt
      // IZ EDITORA MLE ZAPII TEKST cTxt U TXT FAJL txt
      // UITAJ IZ TXT FAJLA txt STRING cTxt
      // ZAPII STRING cTxt U TABLU U OPIS_

       // PROCEDURE:
       // LOAD FROM TABLE TEXT OPIS_ INTO STRING cTxt
       // DELETE TXT FILE txt IF EXISTS
       // WRITE STRING cTxt TO TXT FILE txt
       // FROM MLE EDITOR LOAD TEXT cTxt FROM TXT FILE txt
       // FROM EDITOR MLE EDIT TEXT cTxt
       // FROM THE MLE EDITOR WRITE THE TEXT cTxt TO THE TXT FILE txt
       // LOAD FROM TXT FILE txt STRING cTxt
       // WRITE STRING cTxt IN TABLE IN OPIS_


      cTxt := OPIS_    // string from table - string from memo fields
      DELETE FILE (txt)
      MemoWrit(txt,cTxt)




 *********************************************************************
  IZMENA := ;
  _Editor_(txt,67,8,"centar","ARTICLE DESCRIPTION:",sifra+"  "+naziv)
 *********************************************************************


 IF IZMENA==.T. // samo ako je bilo izmena u tekstu
                // only if there were changes in the text


    // UCITAJ TEKST IZ TXT FAJLA txt U STRING
    // LOAD TEXT FROM TXT FILE txt INTO STRING
     cTxt := ALLTRIM( MemoRead(txt) )


    ************************************************************

     PRIVATE ztable:=cschemename+"."+ctablename
     // ne moe: &cschemename.&ctablename // taka se ne prikazuje u TEXT INTO
     // can't: &cschemename.&ctablename // dot doesn't show in TEXT INTO

     PRIVATE cSQL, cStmt
     TEXT INTO cSQL WRAP
     UPDATE &ztable SET OPIS_ = '&cTxt' WHERE ROBS_ = '&sifra'
     ENDTEXT
     // dc_memoedit(cSQL)

     oStmt := DacSqlStatement():fromChar(cSQL)
     oStmt:build():execute()


     SELECT (radno)// ovo je obavezno | this is mandatory
     DBREFRESH()
     oBrowse:refreshall() // ova komanda osveava browser sa novim podatkom
                          // this command refreshes the browser with new data
    *************************************************************


    *************************************************************
    * SELECT(radno)
    *
    *  IF DBRLOCK() // TABLE IS USE EXCLUSIVE
    *    REPLACE OPIS_ WITH cTxt  // this doesn't work
    *    * for table is:
    *    * "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY robn_ ;"
    *    * it is obtained:
    *    * error: * file is opened in read-only mode
    *  DBRUNLOCK()
    *  ENDIF
    *
    * DBREFRESH()
    * oBrowse:refreshall() // ova komanda osveava browser sa novim podatkom
    ************************************************************


 ENDIF // IF IZMENA==.T. // samo ako je bilo izmena u tekstu
                         // only if there were changes in the text
SELECT(radno)
RETURN(nil)




*************************************************************************
* Example: use CRT X=67,Y=8 not PIXEL X=600, Y=300
* eEditor1( txtfajl,67,8,"centar",f_i,P_NAZIV,;
*           "8.Helv Bold",GRA_CLR_DARKRED,"8.Helv",GRA_CLR_BLACK)

FUNCTION _Editor_( cFileName,x,y,pozicija,cnaslov1,cnaslov2,;
                   cFontnaslov2,cBojanaslov2,cFontTekst,cBojaTekst )

*************************************************************************
LOCAL GetList := {}, getoptions, oDlg,;
      oNaziv, size1, sTxt ,oEdit , lOpis := .F.

DEFAULT cFileName TO Gde_Exe()+"\t.txt"    ,;
        x         TO 67                    ,;
        y         TO 8                     ,;
        pozicija     TO "centar"           ,;
        cnaslov1     TO "COBA Systems "   ,;
        cnaslov2     TO "BELEKA"          ,;
        cFontNaslov2 TO "12.Consolas Bold" ,;
        cBojaNaslov2 TO GRA_CLR_DARKRED    ,;
        cFontTekst   TO "11.Consolas"      ,;
        cBojaTekst   TO GRA_CLR_DARKBLUE


      IF File(cFileName) = .F.
         MemoWrit(cFileName,cnaslov1)
      ENDIF


      aCUR      := {"USER32.DLL",114,XBPWINDOW_POINTERTYPE_POINTER}



                   BMP_DOC := XbpBitmap():new():create()
                   BMP_DOC:load( "BAZNE.DLL", 11021 )
                   BMP_DOC:transparentClr := BMP_DOC:getDefaultBgColor()

                   BMP_OK := XbpBitmap():new():create()
                   BMP_OK:load( "BAZNE.DLL", 11041 )
                   BMP_OK:transparentClr := BMP_OK:getDefaultBgColor()

                   BMP_ESC := XbpBitmap():new():create()
                   BMP_ESC:load("BAZNE.DLL",11042 )
                   BMP_ESC:transparentClr := BMP_ESC:getDefaultBgColor()

                   BMP_HLP := XbpBitmap():new():create()
                   BMP_HLP:load( "BAZNE.DLL", 11043 )
                   BMP_HLP:transparentClr := BMP_HLP:getDefaultBgColor()




   // --------------------- dialog top right
      aRefSize := SetAppWindow():currentSize()
      aRefPos  := SetAppWindow():currentPos()

         aSize := { x * 7.3, y * 33.4 } // prevoenje BAZNIH CRT u PIXELE
         aPos  := {0,0}

      IF pozicija == "goredesno"
         aPos  := GoreDesnoPos( aSize, aRefSize, aRefPos )   // Bazne.dll
      ENDIF
      IF pozicija == "gorelevo"
         aPos  := GoreLevoPos( aSize, aRefSize, aRefPos )   // Bazne.dll
      ENDIF
      IF pozicija == "doledesno"
         aPos  := DoleDesnoPos( aSize, aRefSize, aRefPos )   // Bazne.dll
      ENDIF
      IF pozicija == "dolelevo"
         aPos  := DoleLevoPos( aSize, aRefSize, aRefPos )   // Bazne.dll
      ENDIF

      IF pozicija == "centar"
         aRefSize := AppDesktop():currentSize()
         aPos  := CenterPos( aSize, aRefSize )
      ENDIF
   // --------------------- dialog top right


         sTxt := MemoRead(cFileName)
         sTxt := HardCR(sTxt)


   @ 0,0  DCSAY cnaslov2  SAYFONT cFontnaslov2 SAYCOLOR cBojanaslov2 SAYSIZE 0


   @ 2,0   DCMULTILINE sTxt ;
           SIZE x,y OBJECT oEdit ;
           FONT cFontTekst ;
           COLOR cBojaTekst, GRA_CLR_WHITE ;
           NOWORDWRAP

   ox := 2+y+1

tbr := 67
btt := tbr/3
dd := 7

@ ox,0 DCTOOLBAR oToolBar SIZE tbr,3 BUTTONSIZE btt,3

   *************
   IZMENA := .F.
   *************
   DCADDBUTTON CAPTION BMP_OK PARENT oToolBar SIZE dd WHEN {||.F.}
   DCADDBUTTON CAPTION "Save-Exit" PARENT oToolBar ;
   ACCELKEY { xbeK_TAB } ;
   TOOLTIP " [TAB] Snimi izmene i izlaz | Save changes and exit " ;
   ACTION {|| IZMENA:=.T. ,;
              MemoWrit( cFileName, sTxt ), tone(100),;
              c_poruka("SNIMLJENO | RECORDED"),;
              DC_GetRefresh(Getlist), SetAppFocus(oEdit),;
              DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
   CURSOR aCUR SIZE btt-dd


   DCADDBUTTON CAPTION BMP_HLP PARENT oToolBar SIZE dd WHEN {||.F.}
   DCADDBUTTON CAPTION "Help" PARENT oToolBar ;
   ACCELKEY { xbeK_F1 } ;
   TOOLTIP " [F1] Help " ;
   ACTION {|| mehlp(), DC_GetRefresh(Getlist), SetAppFocus(oEdit) } ;
   CURSOR aCUR SIZE btt-dd

   DCADDBUTTON CAPTION BMP_ESC PARENT oToolBar SIZE dd WHEN {||.F.}
   DCADDBUTTON CAPTION "Exit" PARENT oToolBar ;
   ACCELKEY { xbeK_ESC } ;
   TOOLTIP " [Esc] Izlaz " ;
   ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }  ;
   CURSOR aCUR SIZE btt-dd

   DCGETOPTIONS WINDOWROW aPos[2] WINDOWCOL aPos[1];
   NOESCAPEKEY NOMAXBUTTON NOMINBUTTON NOTASKLIST FONT "10.Arial Bold"

   DCREAD GUI FIT;
      TITLE cnaslov1 ;
      OPTIONS GetOptions ;
              PARENT @oDlg ;
              EVAL {||SetAppWindow(oDlg)} ;
              MODAL

RETURN IZMENA




*************************************************************************
STATIC FUNCTION mehlp()
*************************************************************************
c__poruka("Detaljniji opis artikla koji se uvek moe" + chr(59)+;
          "videti uz artikal, a tampa se na fakturi" + chr(59)+;
          " "                                         + chr(59)+;
          "Detailed description of article that can always"  + chr(59)+;
          "see with article, and it is printed on invoice."  + chr(59)+;
          "","Detaljni Opis artikla | Detailed description of article",,"G1")

RETURN NIL





STATIC FUNCTION xxx(oDlg,x,y)
 as := oDlg:currentsize()
 ap := odlg:currentpos()
  msgbox(var2char(as[1])+"x"+var2char(as[2])+chr(13)+;
  var2char(ap[1])+"x"+var2char(ap[2]),"size-pos: "+alltrim(str(x))+" "+alltrim(str(y)))
RETURN NIL















