//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __ARTICLES_GROUP.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

/*

------------------------------------
  PACKAGE:
  __ARTICLES__MAIN.PRG      // MAIN FOR EXE APPLICATION

  __ARTICLES_GROUP.PRG      // ARTICLES CODEBOOK
                            // REGISTER OF ALL ARTICLES
                            // AND CODE BOOK OF GROUPS OF ARTICLES

  __ARTICLES_CODEBOOK.PRG   // ARTICLES GROUP FROM 1 TO 16
                            // ONLY LIST OF ARTICLES (FILTER)
                            // THAT HAVE A GIVEN GROUP

  __ARTICLES_SELECTION.PRG
  __ARTICLES_DESCRIPTION.PRG
  __ARTICLES_REGISTERCARD.PRG
  __ARTICLES_ADDTOTABLE.PRG
  __ARTICLES_INSERT_DELETE_SORT.PRG
------------------------------------




 FUNCTION ARTICLES_GROUP()

 STATIC FUNCTION take_article(nn)
 STATIC FUNCTION Maintitle(cTitle)
 STATIC FUNCTION vidi_help(cTitle)

 STATIC FUNCTION find_name(oBrowse)
 STATIC FUNCTION find_code()
 STATIC FUNCTION find_BarCod()
 STATIC FUNCTION find_cataloque()

 STATIC FUNCTION find_word(oBrowse,oDlg)
 STATIC FUNCTION find_supplier(oBrowse,oDlg)
 STATIC FUNCTION find_link(oBrowse,oDlg)


 STATIC FUNCTION ARTICLES_DESCRIPTION_(oBrowse)
 STATIC FUNCTION ARTICLES_REGISTERCARD_(lPar,GetList,oBrowse,GRUPA)
 STATIC FUNCTION WRITE_DATA_(oBrowse)

 STATIC FUNCTION DELETE_ARTICLE_(oBrowse,GetList)
 STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList)

 STATIC FUNCTION SORT_BY_NAME_(cschemename,ctablename,cgrupa,oBrowse)
 STATIC FUNCTION SORT_BY_CODE_(cschemename,ctablename,cgrupa,oBrowse)
 STATIC FUNCTION SORT_BY_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
 STATIC FUNCTION SORT_BY_TYPE_(cschemename,ctablename,cgrupa,oBrowse)

* koristi se samo ako postoji polje (kolona)  __record
* used only if field (column) __record exists
 STATIC FUNCTION RENUMBERATION_('scheme.table',obrowse,nn)  // for any upsize table
 STATIC FUNCTION RECONSTRUCTION_('scheme.table',obrowse,nn) // for any upsize table
 STATIC FUNCTION RENUMBER__record_(codebook,obrowse,nn)     // for any upsize table

*/


#include "Xbtsys.ch"   // XbttoolsIII
#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "dll.ch"
#include "dcdialog.ch"
* #include "appbrow.ch" // for test

*************************************************************************
FUNCTION ARTICLES_GROUP(xakcija)
*************************************************************************
* xakcija = "group" // articles codebook for working with articles groups
* xakcija = "all"   // articles codebook for working with all articles

LOCAL radno := SELECT() // na izlazu iz programa SELECT(radno)
                        // on program exit return SELECT(radno)

LOCAL GetList := {}, GetOptions, oDlg, oBrowse, oBrowBox, ;
      oToolBar, bBrojSlogova, bTitle

PRIVATE akcija := xakcija

      if akcija="group"
         cTitle := "GROUPS OF ARTICLES"
      else
         cTitle := "ARTICLES CODE BOOK"
      endif
      cTitleList := cTitle
      cTit:=" SQL TABLE "



    **********************************************************
       PRIVATE BMP_OK, BMP_HLP, BMP_ESC, aCUR

       aCUR := {"USER32.DLL",114}

       BMP_OK := XbpBitmap():new():create()
       BMP_OK:load( "BAZNE.DLL", 11041 )
       BMP_OK:transparentClr := BMP_OK:getDefaultBgColor()

       BMP_HLP := XbpBitmap():new():create()
       BMP_HLP:load( "BAZNE.DLL", 11043 )
       BMP_HLP:transparentClr := BMP_HLP:getDefaultBgColor()

       BMP_ESC := XbpBitmap():new():create()
       BMP_ESC:load("BAZNE.DLL",11042 )
       BMP_ESC:transparentClr := BMP_ESC:getDefaultBgColor()
    **********************************************************


//========================================================================  START
// T A B L E  N A M E S
//========================================================================
    PUBLIC GRUPA := "" // slui za filter po grupama
                       // slui za sortiranje po grupama
    PRIVATE xGRUPA := GRUPA

    PRIVATE ;
    MAG         := _MAG_ ,; // PUBLIC __pg__ini() C-PGDB.DLL
    KAS         := _KAS_ ,; // PUBLIC __pg__ini() C-PGDB.DLL
    cSchemeName := _she_ ,; // PUBLIC __pg__ini() C-PGDB.DLL
    cTablename  := "kroba_"+_MAG_ ,; // zbog kompatibilnosti
    codebook    := _she_+".kroba_"+_MAG_

    PRIVATE oSession    := DbSession()


//========================================================================
// T A B L E  N A M E S
//========================================================================  END


DCMENUBAR oMenuBar
DCSUBMENU oMenu_1 PROMPT "Sorting" ;
           PARENT oMenuBar
   DCMENUITEM "Sort by name" ;
              PARENT oMenu_1 ;
              ACTION {|| SORT_BY_NAME(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }   // here
   DCMENUITEM "Sort by code" ;
              PARENT oMenu_1 ;
              ACTION {|| SORT_BY_CODE(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }   // here
   DCMENUITEM "Sort by type" ;
              PARENT oMenu_1 ;
              ACTION {|| SORT_BY_TYPE(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }  // here
   DCMENUITEM "Sort by group" ;
              PARENT oMenu_1 ;
              ACTION {|| SORT_BY_GROUP(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }  // here


DCSUBMENU oMenu_1 PROMPT "Filtering" ;
           PARENT oMenuBar
   DCMENUITEM "Filter by group code" ;
              PARENT oMenu_1 ;
              ACTION {|| find_supplier(oBrowse,oDlg) }   // here
   DCMENUITEM "Filter by link tag" ;
              PARENT oMenu_1 ;
              ACTION {|| find_link(oBrowse,oDlg) }       // here
   DCMENUITEM "Filter by word in name" ;
              PARENT oMenu_1 ;
              ACTION {|| find_word(oBrowse,oDlg) }       // here






//========================================================================  START
// D C B R O W S E  C O N T E N T  F R O M  P O S T G R E S Q L  T A B L E
//========================================================================

    IF akcija="group"
       cSQL    := "SELECT * FROM "+codebook+" ORDER BY DOBS_ ;"   // BY GROUP
    ELSE
       cSQL    := "SELECT * FROM "+codebook+" ORDER BY ROBN_ ;"   // BY NAME
    ENDIF
    oStmt   := DacSqlStatement():fromChar(cSQL)
    cAlias  := oStmt:build():query(,"ART")

    ART:=cAlias
    SELECT "ART"         // this is mandatory  !
    svega:=reccount()    // this works correctly !
    * count all to svega // this works correctly !
    GO TOP

//========================================================================
// D C B R O W S E  C O N T E N T  F R O M  P O S T G R E S Q L  T A B L E
//========================================================================  END









//========================================================================  START
// DCBROWSE LISTA SA ISAM KOMANDAMA PREUZETA IZ STARE DBF-NTX APLIKACIJE
// DCBROWSE LIST WITH ISAM COMMANDS TAKEN FROM OLD DBF-NTX APPLICATION
//========================================================================


*****************
SELECT "ART"
*****************


of2  := Font_codepage(14,"Verdana",238,.t.)
of3  := Font_codepage(11,"Archivo Narrow",238,.t.)
of4  := Font_codepage(11,"Consolas",238,.t.)

* replacement for Archivo Narrow
* of3  := Font_codepage(11,"Calibri Bold",238,.t.)





HOR := 62
VER := 15 + 8.8

PUBLIC preuzmi_naziv := 0

@  0,2 DCSAY cTitleList SAYFONT of2  SAYCOLOR GRA_CLR_DARKRED SAYSIZE 0
@  0,51 DCSAY cTit SAYFONT "10.Verdana Bold"  ;
SAYCOLOR GRA_CLR_WHITE,GraMakeRGBColor({156,139,18}) SAYSIZE 0

BROWSER_COLOR() // bazne.dll

@  1,2 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE HOR,VER ;
   OBJECT oBrowBox

@ .1,.5 DCBROWSE oBrowse PARENT oBrowBox ALIAS "ART" ;
   SIZE HOR-1,VER-0.4 ;
   CURSORMODE XBPBRW_CURSOR_ROW ;
   HEADLINES 2 ;
   ITEMSELECTED {|| WRITE_DATA_(oBrowse),;  // here
                    SetAppFocus(oBrowse) }  ;
   EVAL {|o|o:setfont(of3)}




//--------------------------------------------
// K O L O N E  S P I S K A  A R T I K A L A
// COLUMNS FOR THE LIST OF ITEMS
//--------------------------------------------


//--------------------------------------------
IF akcija = "group"
//--------------------------------------------

DCBROWSECOL FIELD ART->GRUP_ ;
  WIDTH 4 ;
  PARENT oBrowse ;
  HEADER "H-FOOD  ;P-DRINK";
  TOOLTIP " H-HRANA P=PIE | H=FOOD P=DRINK "

DCBROWSECOL FIELD ART->DOBS_ ;
  WIDTH 4 ;
  PARENT oBrowse ;
  HEADER "GROUP;1-16" ;
  TOOLTIP " GRUPA 1 DO 16 | GROUP 1 TO 16 "


DCBROWSECOL FIELD ART->ROBS_ ;
  WIDTH 4 ;
  PARENT oBrowse ;
  HEADER "CODE" ;
  TOOLTIP " IFRA ARTIKLA | ARTICLE CODE "


DCBROWSECOL FIELD ART->ROBN_ ;
  WIDTH 21 ;
  PARENT oBrowse;
  HEADER "ARTICLE NAME"   ;
  TOOLTIP " NAZIV ARTIKLA | ARTICLE NAME "

DCBROWSECOL FIELD ART->MERA_ ;
  WIDTH 3 ;
  PARENT oBrowse ;
  HEADER "UOM" ;
  TOOLTIP " JEDINICA MERE | UNIT OF MEASUREMENT "


DCBROWSECOL FIELD ART->CENA_MPR_ ;
  WIDTH 7;
  PARENT oBrowse ;
  HEADER "PRICE" ;
  TOOLTIP " MALOPRODAJNA CENA | RETAIL PRICE "

DCBROWSECOL FIELD ART->ROBK_ ;
  WIDTH 15 ;
  PARENT oBrowse ;
  HEADER "BARCOD" ;
  TOOLTIP " BARCOD EAN13 | GTIN EAN13 "


DCBROWSECOL FIELD ART->ZALI_ ;
  WIDTH 7;
  PARENT oBrowse ;
  HEADER "STOK" ;
  TOOLTIP " STOK | ZALIHE "


DCBROWSECOL FIELD ART->ROBN_ ;
  WIDTH 20 ;
  PARENT oBrowse ;
  HEADER "ARTICLE NAME"

//--------------------------------------------
ELSE
//--------------------------------------------

DCBROWSECOL FIELD ART->ROBN_ ;
  WIDTH 21 ;
  PARENT oBrowse;
  HEADER "ARTICLE NAME"   ;
  TOOLTIP " NAZIV ARTIKLA | ARTICLE NAME "

DCBROWSECOL FIELD ART->MERA_ ;
  WIDTH 3 ;
  PARENT oBrowse ;
  HEADER "UOM" ;
  TOOLTIP " JEDINICA MERE | UNIT OF MEASUREMENT "

DCBROWSECOL FIELD ART->ROBS_ ;
  WIDTH 3 ;
  PARENT oBrowse ;
  HEADER "CODE" ;
  TOOLTIP " IFRA ARTIKLA | ARTICLE CODE "

DCBROWSECOL FIELD ART->CENA_MPR_ ;
  WIDTH 7;
  PARENT oBrowse ;
  HEADER "PRICE" ;
  TOOLTIP " MALOPRODAJNA CENA | RETAIL PRICE "

DCBROWSECOL FIELD ART->ROBK_ ;
  WIDTH 15 ;
  PARENT oBrowse ;
  HEADER "BARCOD" ;
  TOOLTIP " BARCOD EAN13 | GTIN EAN13 "


DCBROWSECOL FIELD ART->GRUP_ ;
  WIDTH 4 ;
  PARENT oBrowse ;
  HEADER "H-FOOD  ;P-DRINK";
  TOOLTIP " H-HRANA P=PIE | H=FOOD P=DRINK "

DCBROWSECOL FIELD ART->DOBS_ ;
  WIDTH 4 ;
  PARENT oBrowse ;
  HEADER "GROUP;1-16" ;
  TOOLTIP " GRUPA 1 DO 16 | GROUP 1 TO 16 "


DCBROWSECOL FIELD ART->ZALI_ ;
  WIDTH 7;
  PARENT oBrowse ;
  HEADER "STOK" ;
  TOOLTIP " STOK | ZALIHE "

DCBROWSECOL FIELD ART->ROBN_ ;
  WIDTH 20 ;
  PARENT oBrowse ;
  HEADER "ARTICLE NAME"

//--------------------------------------------
ENDIF
//--------------------------------------------


//--------------------------------------------
// COLUMNS FOR THE LIST OF ITEMS
// K O L O N E  S P I S K A  A R T I K A L A
//--------------------------------------------



//-------------------------------------------------------------------------------------
// TOOLBAR COMMAND BUTTON:
//-------------------------------------------------------------------------------------

d_tol := HOR
d_bro := 6
d_duz := d_tol/d_bro



@ VER+2,2 DCTOOLBAR oToolBar SIZE d_tol,3 BUTTONSIZE d_duz,3 FONT of3



DCADDBUTTON CAPTION BMP_OK ;
   TOOLTIP " Brza izmena podataka - Quick change of data " ;
   ; // TOOLTIP "Preuzmi podatke artikla - Download item data" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| WRITE_DATA_(oBrowse) ,;
   ; // take_article(1),;  // here
   SetAppFocus(oBrowse)};
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Name;F2" ;
   ACCELKEY {xbeK_F2, asc("N"), asc("n")} ;
   TOOLTIP " Nai po Nazivu - Find by Name " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| find_name(oBrowse), ;  // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse)} ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Code;F3" ;
   ACCELKEY {xbeK_F3, asc("C"), asc("c")};
   TOOLTIP " Nai po ifri - Find by Code " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_code(oBrowse), ; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Word;F4" ;
   ACCELKEY {xbeK_F4, asc("W"), asc("w")};
   TOOLTIP " Nadji po rei sadranoj bilo gde u nazivu ;"+;
           " Find by word contained anywhere in the name " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_word(oBrowse,oDlg),; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Barcod;F5" ;
   ACCELKEY {xbeK_F5, asc("B"), asc("b")};
   TOOLTIP " Nai po Barcodu - Find by Barcode " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_barcod(oBrowse),;  // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "Catalog;F6" ;
   ACCELKEY {xbeK_F6, asc("Q"), asc("q")};
   TOOLTIP " Nai po katalokom broju - Find by catalog number " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {||find_cataloque(oBrowse),; // here
   DC_GetRefresh(GetList), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE


*---
@ VER+2+3,2 DCTOOLBAR oToolBar SIZE d_tol,3 BUTTONSIZE d_duz,3  FONT of3
*---


DCADDBUTTON CAPTION "ARTICLE;INSERT"  ;
   ACCELKEY xbeK_INS;
   TOOLTIP " Add new article in Articles codebook " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| IIF(akcija="group", INSERT_ARTICLE_(oBrowse,GetList,"DOBS_"),;
                                  INSERT_ARTICLE_(oBrowse,GetList,"ROBN_")),;
   DC_GetRefresh(GetList), oBrowse:RefreshAll(), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION "ARTICLE;DELETE"  ;
   ACCELKEY xbeK_DEL;
   TOOLTIP " Delete article from Articles codebook " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| IIF(akcija="group", DELETE_ARTICLE_(oBrowse,GetList,"DOBS_"),;
                                  DELETE_ARTICLE_(oBrowse,GetList,"ROBN_")),;
   DC_GetRefresh(GetList), oBrowse:RefreshAll(), SetAppFocus(oBrowse) } ;
   ALIGNCAPTION BS_MULTILINE


***********************
PRIVATE RESTART := .F.
***********************

DCADDBUTTON CAPTION "ARTICLE;DESCRIPT" ;
   ACCELKEY {xbeK_F9, asc("D"), asc("d")};
   TOOLTIP " Opis artikla - description article " ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| ARTICLES_DESCRIPTION_(oBrowse)} ; // here
   ALIGNCAPTION BS_MULTILINE

* Varijanta sa ponovnim kreiranjem browsera - update data
* Variant with re-creation of the browser   - update data
* ACTION {|| RESTART:=.F., ;
* ARTICLES_DESCRIPTION_(oBrowse),;  // --> RESTART:=.T. or .F.
* IIF( RESTART=.T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList), SetAppFocus(oBrowse) )}



DCADDBUTTON CAPTION "ARTICLE;CARD" ;
   ACCELKEY {xbeK_F10, asc("A"), asc("a")} ;
   TOOLTIP "Registar kartica artikla - Article card register" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| ARTICLES_REGISTERCARD_(.F.,GetList,oBrowse,GRUPA) };  // here
   ALIGNCAPTION BS_MULTILINE

* Varijanta sa ponovnim kreiranjem browsera - update data
* Variant with re-creation of the browser   - update data
* ACTION {|| RESTART:=.F., ;
* ARTICLES_REGISTERCARD_(.F.,GetList,oBrowse,GRUPA),;  // --> RESTART:=.T. or .F.
* IIF( RESTART=.T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList), SetAppFocus(oBrowse) )}


// NO WINDOWSXP.MANIFEST jer BMP gubi transparentnost
// NO WINDOWSXP.MANIFEST because BMP it loses transparency
DCADDBUTTON CAPTION BMP_HLP;
   ACCELKEY xbeK_F1  ;
   TOOLTIP "Help;F1" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| vidi_help(cTitle, cTitleList),;
   DC_GetRefresh(GetList), SetAppFocus(oBrowse)} ;
ALIGNCAPTION BS_MULTILINE

DCADDBUTTON CAPTION BMP_ESC ;
   ACCELKEY xbeK_ESC;
   TOOLTIP "Kraj;Esc" ;
   CURSOR aCUR PARENT oToolBar ;
   ACTION {|| take_article(0), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
ALIGNCAPTION BS_MULTILINE


* STEALT BUTTONS
DCHOTKEY xbeK_ALT_F1 ACTION {|| xc_autor1() }


DCHOTKEY xbeK_ALT_DEL ACTION {|| RECONSTRUCTION_(cTableName,oBrowse,1),SetAppFocus(oBrowse) }  // here


DCHOTKEY xbeK_ALT_F2 ACTION {|| SORT_BY_NAME_(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }   // here
DCHOTKEY xbeK_ALT_F3 ACTION {|| SORT_BY_CODE_(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }   // here
DCHOTKEY xbeK_ALT_F4 ACTION {|| SORT_BY_GROUP_(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }  // here
DCHOTKEY xbeK_ALT_F5 ACTION {|| SORT_BY_TYPE_(cschemename,ctablename,grupa,oBrowse),SetAppFocus(oBrowse) }  // here

   DCHOTKEY xbeK_INS ACTION {|| IIF(akcija="group", INSERT_ARTICLE_(oBrowse,GetList,"DOBS_"),;
                                                    INSERT_ARTICLE_(oBrowse,GetList,"ROBN_")),;
   DC_GetRefresh(GetList), oBrowse:RefreshAll(), SetAppFocus(oBrowse) }
   *---
   DCHOTKEY xbeK_DEL ACTION {|| IIF(akcija="group", DELETE_ARTICLE_(oBrowse,GetList,"DOBS_"),;
                                                    DELETE_ARTICLE_(oBrowse,GetList,"ROBN_")),;
   DC_GetRefresh(GetList), oBrowse:RefreshAll(), SetAppFocus(oBrowse) }

/*

   DCHOTKEY xbeK_INS ACTION {|| c__greska("ADDING ARTICLE TO GROUP"     +chr(59)+;
                                          "  IS NOT POSSIBLE"           +chr(59)+;
                                          "ADD ARTICLEE IS POSSIBLE IN" +chr(59)+;
                                          "  "+cTitle                   +chr(59)+;
                                          "","ADD ARTICLE",,"G3"),;
   SetAppFocus(oBrowse) }
   *---
   DCHOTKEY xbeK_DEL ACTION {|| c__greska("DELETING ARTICLE FROM GROUP"  +chr(59)+;
                                          "  IS NOT POSSIBLE"            +chr(59)+;
                                          "DELETE ARTICLE IS POSSIBLE IN"+chr(59)+;
                                          "  "+cTitle                    +chr(59)+;
                                          "","DELETE ARTICLE",,"G3"),;
   SetAppFocus(oBrowse) }

*/


  DCHOTKEY xbeK_ENTER ACTION {|| WRITE_DATA_(oBrowse) }

//----------------------------------------------------------------------------------------------


aahorver:=appdesktop():currentsize()
ahor:=aahorver[1]-(HOR*7)-40
aver:=aahorver[2]-(VER*20)-242



DCGETOPTIONS ICON 1;
   SAYCENTER ;
   AUTOFOCUS ;
   NOMAXBUTTON ;
   NOMINBUTTON ;
   NOESCAPEKEY ; // ; WINDOWROW aver WINDOWCOL ahor
   TOOLTIPCOLOR GRA_CLR_BLACK,GRA_CLR_YELLOW TOOLTIPFONT "10.Consolas"

 bTitle := {|| Maintitle(cTitle) }

 DCREAD GUI TITLE bTitle OPTIONS GetOptions ;
            FIT ;
            SETFOCUS @oBrowse ;
              PARENT @oDlg ;
              EVAL {|o|SetAppWindow(o) };
              MODAL

SELECT "ART"

IF RESTART==.T.

    //  stop(2,restart,alias(),1)
     SELECT "ART";USE;SELECT(radno)
     CLEAR TYPEAHEAD
     ******************************
     ARTICLES_GROUP()
     ******************************
ELSE
     // stop(3,restart,alias(),1)
     SELECT "ART"
     USE
ENDIF

SELECT(radno)
RETURN NIL




















* STATIC FUNCTION take_article(nn)
* STATIC FUNCTION Maintitle(cTitle)
* STATIC FUNCTION vidi_help(cTitle)



*------------------------------------------------------------------------
* FUNCTION take_article() nalazi se u __ARTICLES_ADDTOTABLE.PRG
* kao specifina funkcija samo za ovu aplikaciju KASA-ARTIKLI.EXE
*------------------------------------------------------------------------
/*
*************************************************************************
STATIC FUNCTION take_article(nn)
*************************************************************************
LOCAL radno := SELECT()

IF nn=0  // article not taken
 **********************************
 artikal_CFG_upisi1( "", "" ) // ARTICLE_REGISTERCARD.PRG
 **********************************
   SELECT(radno)
   RETURN NIL
ENDIF

 // article is taken
 **********************************
 artikal_CFG_upisi1( ROBS_, ROBK_ ) // ARTICLE_REGISTERCARD.PRG
 **********************************
 * Auriran je fajl ARTIKAL.CFG
 * The ARTIKAL.CFG file has been updated
 * Aplikacija uzima artikal sa: artikal_CFG_citaj1()
 * The application takes the article from: article_CFG_citaj1()

c__procitaj(;
"ARTIKAL JE POSLAT U ARTIKAL.CFG FILE"  +chr(59)+;
"ARTICLE HAS SENT TO ARTIKAL.CFG FILE"  +chr(59)+;
"Code       "+ROBS_                     +chr(59)+;
"Name       "+ROBN_                     +chr(59)+;
"Barcod     "+ROBK_                     +chr(59)+;
"Group      "+DOBS_                     +chr(59)+;
"Type       "+GRUP_                     +chr(59)+;
"","SEND ARTICLE TO APPLICATION",,"G3")
SELECT(radno)
*"POSLE SLANJA STAVKE ARTIKLA U APLIKACIJU NE ZATVARA SE IFARNIK
*"AFTER SENDING ARTICLE INTO APPLICATION, CODEBOOK DOES NOT CLOSE
RETURN NIL
*/


*************************************************************************
STATIC FUNCTION Maintitle(cTitle)
*************************************************************************
// ispis naslova u TITLE BAR-u sa brojem slogova
// print title in TITLE BAR with number of records
  LOCAL cBrojac, cNaslov
  * svega = broj redova table sa poetka programa
  * svega = number of table rows from the beginning of the program

*" U OVOM IFARNIKU NEMA PRIKAZA IZMENE BROJA REDOVA
*" THIS CODE BOOK DOES NOT SHOW THE CHANGE OF THE NUMBER OF ROWS
* COUNT ALL TO cBrojac  // reccount() not works
* GO TOP

    cNaslov := ;
    APLIKACIJA+"  |  KASH-REGISTER "+MAG+"-"+KAS+"  |  ARTICLES" + "  " +;
    var2char(svega)

RETURN(cNaslov)



*************************************************************************
STATIC FUNCTION vidi_help(cTitle)
*************************************************************************
LOCAL cr := chr(59), ctxt

IF akcija="group"
ctxt := ;
"Ovaj IFARNIK ARTIKALA"                      +cr+;
cTitleList                                    +cr+;
"slui za upravljanje artiklima i za brzu"    +cr+;
"izmenu GRUPE, CENE, KOLIINE i BARKODA"      +cr+;
"klikom na taster ENTER ili duplim klikom"    +cr+;
"mia na artikal ili na komandno dugme "      +cr+;
"_____________________________________________"+cr+;
" "                                            +cr+;
"This ARTICLES CODEBOOK"                       +cr+;
cTitleList                                     +cr+;
"uses for article management and quick"        +cr+;
"change GROUP, PRICE, QUANTITY and BARCODE"    +cr+;
"by clicking the ENTER key or double clicking" +cr+;
"mouse on article or command button "          +cr+;
"_____________________________________________"+cr+;
" "                                            +cr+;
" Article is added to the List  [INSERT]"      +cr+;
" Article is deleted from List  [DELETE]"      +cr+;
" Reconstruction List           [ALT]+[DEL]"   +cr+;
" Sorting List by article name  [ALT]+[F2]"    +cr+;
" Sorting List by article code  [ALT]+[F3]"    +cr+;
" "


ELSE


ctxt := ;
"Ovaj IFARNIK ARTIKALA"                      +cr+;
cTitleList                                    +cr+;
"slui za upravljanje artiklima, odnosno za"  +cr+;
"formiranje i odravanje ifarnika artikala"  +cr+;
"koji se koriste u ovoj poslovnoj aplikaciji" +cr+;
"Artikli su: HRANA i PIE u restoranu ili"    +cr+;
"ROBA, USLUGA, MATERIJAL i PROIZVOD"          +cr+;
"_____________________________________________"+cr+;
" "                                            +cr+;
"This ARTICLES CODEBOOK"                       +cr+;
cTitleList                                     +cr+;
"serves to manage articles, ie for formation"  +cr+;
"and maintenance of articles codebook used in" +cr+;
"this business application. Articles are:"     +cr+;
"FOOD and DRINKS in a restaurant or"           +cr+;
"GOODS, SERVICES, MATERIALS and PRODUCTS"      +cr+;
"_____________________________________________"+cr+;
" "                                            +cr+;
" Article is added to the List  [INSERT]"      +cr+;
" Article is deleted from List  [DELETE]"      +cr+;
" Reconstruction List           [ALT]+[DEL]"   +cr+;
" Sorting List by article name  [ALT]+[F2]"    +cr+;
" Sorting List by article code  [ALT]+[F3]"    +cr+;
" "
ENDIF


* alertbox(,ctxt,{"    OK    "},,cTitle,"10.Consolas") // bazne.dll
c__procitaj(ctxt,"ARTICLES CODE BOOK",,"10.Lucida Console")  // bazne.dll


CLEAR TYPEAHEAD
RETURN(nil)




************ __ARTICLES_INSERT_DELETE_SORT.PRG ****************** START

STATIC FUNCTION DELETE_ARTICLE_(oBrowse,GetList,_order_)
  DELETE_ARTICLE(oBrowse,GetList,_order_)
RETURN NIL
STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList,_order_)
  INSERT_ARTICLE(oBrowse,GetList,_order_)
RETURN NIL


STATIC FUNCTION SORT_BY_NAME_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_NAME(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_CODE_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_CODE(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_GROUP(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_TYPE_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_TYPE(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL

STATIC FUNCTION SORT_BY_NAME_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_NAME_GROUP(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL
STATIC FUNCTION SORT_BY_CODE_GROUP_(cschemename,ctablename,cgrupa,oBrowse)
  SORT_BY_CODE_GROUP(cschemename,ctablename,cgrupa,oBrowse)
RETURN NIL


STATIC FUNCTION RENUMBERATION_(ccTablename,oBrowse,nn)
  RENUMBERATION(ccTablename,oBrowse,nn)
  * ccTablename = 'tablename' or 'schemename.tablename'
RETURN NIL
STATIC FUNCTION RECONSTRUCTION_(ccTablename,oBrowse,nn)
  RECONSTRUCTION(ccTablename,oBrowse,nn)
  * ccTablename = 'tablename' or 'schemename.tablename'
RETURN NIL
STATIC FUNCTION RENUMBER__record_(codebook,oBrowse,nn)
  RENUMBER__record(codebook,oBrowse,nn)
  * codebook='schemename.tablename'
RETURN NIL

************ __ARTICLES_INSERT_DELETE_SORT.PRG ****************** END


***************** __ARTICLES_DESCRIPTION.PRG ******************** START
STATIC FUNCTION ARTICLES_DESCRIPTION_(oBrowse)
   ARTICLES_DESCRIPTION(oBrowse)
RETURN NIL
***************** __ARTICLES_DESCRIPTION.PRG ******************** END


***************** __ARTICLES_REGISTERCARD.PRG ******************** START
STATIC FUNCTION ARTICLES_REGISTERCARD_(lPar,GetList,oBrowse,GRUPA)
* lPar =.F. editovanje zabranjeno | editing prohibited
   ARTICLES_REGISTERCARD(lpar,GetList,oBrowse,GRUPA)
RETURN NIL
STATIC FUNCTION WRITE_DATA_(oBrowse)
   WRITE_DATA(oBrowse)
RETURN NIL
***************** __ARTICLES_REGISTERCARD.PRG ******************** END








* STATIC FUNCTION find_name(oBrowse)
* STATIC FUNCTION find_code()
* STATIC FUNCTION find_word(oBrowse,oDlg)
* STATIC FUNCTION find_BarCod()
* STATIC FUNCTION find_cataloque()
* STATIC FUNCTION find_supplier(oBrowse,oDlg)
* STATIC FUNCTION find_link(oBrowse,oDlg)

*************************************************************************
STATIC FUNCTION find_name(oBrowse)
*************************************************************************
   xUpis := space(20)
   cUpis := Enter_key("Trai po nazivu","",xUpis,,"top")

   GO TOP
   LOCATE FOR ALLTRIM(ROBN_)=ALLTRIM(cUpis)
   IF FOUND()=.F.
      * confirmbox(setappwindow(),"Nije naeno",;
      * "Not Found",XBPMB_OK,XBPMB_CRITICAL)
      * c_poruka("NIJE NAENO","Not Found")
      * stop("NIJE NAENO",0)

      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_code()
*************************************************************************
   xUpis := space(5)
   cUpis := Enter_key("ifra","",xUpis,,"top")
   cUpis := STRZERO(VAL(cUpis),5)

   GO TOP
   LOCATE FOR ALLTRIM(ROBS_)=ALLTRIM(cUpis)
   IF FOUND()=.F.
      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_barcod()
*************************************************************************
LOCAL re := RecNo(), xUpis, cUpis, nUpis

   xUpis := space(13)
   cUpis := Enter_key("Trai po BarCodu","",xUpis,,"top")
   cUpis := ALLTRIM(cUpis)
   nUpis := LEN(cUpis)

   GO TOP
   LOCATE FOR SUBSTR(ROBK_,1,nUpis) == cUpis
   IF FOUND()=.F.
      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_cataloque()
*************************************************************************
LOCAL re := RecNo(), xUpis, cUpis, nUpis

   xUpis := space(25)
   cUpis := Enter_key("Trai po Katalokom broju","",xUpis,,"top")
   cUpis := ALLTRIM(cUpis)
   nUpis := LEN(cUpis)

   GO TOP
   LOCATE FOR SUBSTR(DOBK_,1,nUpis) == cUpis
   IF FOUND()=.F.
      c__greska("NIJE NAENO","Not Found")
      GO TOP
   ENDIF

CLEAR TYPEAHEAD
RETURN NIL
*************************************************************************
STATIC FUNCTION find_word(oBrowse,oDlg)
*************************************************************************
// Otvorena radna tabla SELECT "ART" - Open working table SELECT "ART":
LOCAL radno:=SELECT()
LOCAL selekcija := Enter_key("Find by part of name","",space(20),,"top")
      selekcija := ALLTRIM(selekcija)
      * selekcija = PART OF NAME -> "ROBN_"
      **************************************************
      ARTICLES_SELECTION(selekcija,"ROBN_",oDlg,,xGRUPA)
      **************************************************
* ARTICLES_SELECTION.PRG
* formiraj listu svih artikla koji imaju re 'selekcija' u nazivu artikla
* create a list of all articles that have word 'selection' in article name
* No case-sensitive
SELECT(radno)
RETURN(nil)

*************************************************************************
STATIC FUNCTION find_supplier(oBrowse,oDlg)
*************************************************************************
// Otvorena radna tabla SELECT "ART" - Open working table SELECT "ART":
LOCAL radno:=SELECT()
LOCAL selekcija := ALLTRIM(DOBS_)
      * selekcija = SUPPLIER CODE -> "DOBS_"
      **************************************************
      ARTICLES_SELECTION(selekcija,"DOBS_",oDlg,,xGRUPA)
      **************************************************
* ARTICLES_SELECTION.PRG
* formiraj listu svih artikala koji imaju ifru dobavljaa = 'selekcija'
* create a list of all articles that have supplier code = 'selection'
SELECT(radno)
RETURN(nil)

*************************************************************************
STATIC FUNCTION find_link(oBrowse,oDlg)
*************************************************************************
// Otvorena radna tabla SELECT "ART" - Open working table SELECT "ART":
LOCAL radno:=SELECT()
LOCAL selekcija := ALLTRIM(VEZA_)
      * selekcija = LINK CODE -> "VEZA_"
      **************************************************
      ARTICLES_SELECTION(selekcija,"VEZA_",oDlg,,xGRUPA)
      **************************************************
* ARTICLES_SELECTION.PRG
* formiraj listu svih artikala koji imaju ifru veze = 'selekcija'
* create a list of all articles that have link code = 'selection'
SELECT(radno)
RETURN(nil)























