//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __ARTICLES_INSERT_DELETE_SORT.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


* FUNCTION DELETE_ARTICLE(oBrowse,GetList)
* FUNCTION INSERT_ARTICLE(oBrowse,GetList)
* STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList,cUpis)

* FUNCTION SORT_BY_NAME(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_CODE(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_GROUP(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_TYPE(cschemename,ctablename,cgrupa,oBrowse)

* FUNCTION SORT_BY_NAME_GROUP(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_CODE_GROUP(cschemename,ctablename,cgrupa,oBrowse)

* FUNCTION RENUMBERATION(ccTablename,oBrowse,nn)
* FUNCTION RECONSTRUCTION(ccTablename,oBrowse,nn)
* ccTablename = 'tablename' or 'schemename.tablename'
* FUNCTION RENUMBER__record(codebook,oBrowse,nn)
* codebook='schemename.tablename'


* FUNCTION zadaj__sifru__artikla()
*
*   IT DOES NOT OPEN ARTICLES CODEBOOK
*   Function is activated on the command key [S] from the open account
*   RESTAURANT TABLE while the SELECT STO account RESTAURANT TABLE is active
*   Zadaje se ifra artikla i artikal se preuzima iz table.
*   Ne otvara se ifarnik artikala za preuzimanje artikla.
*   Article code is set and the article is taken from the table.
*   Articles codebook does not open to download the article.




#include "Xbtsys.ch"   // XbttoolsIII
#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "dll.ch"
#include "dcdialog.ch"
* #include "appbrow.ch" // for test



**************************************************************************
FUNCTION DELETE_ARTICLE(oBrowse,GetList,_order_)
**************************************************************************
* _order_ = "NAME_" for reload table in browser
*           "SELECT * FROM "+codebook+" ORDER BY NAME_ ;"



LOCAL radno:=SELECT()
LOCAL xCode := robs_, yCode:=robs_, xName := robn_ , cRec

*
* --- tehnika:
* uvijek-odaberi-susednu-stavku (nakon brisanja stavke iz browsera)
* --- technique:
* always-select-adjacent-item (after deleting the item from the browser)
*
 SKIP 1
 IF EOF()
     SKIP -1
     SKIP -1
     cRec:=__record // robs_
     SKIP 1
 ELSE
     cRec:=__record // robs_
     SKIP -1
 ENDIF
* --- technique:
* always-select-adjacent-item (after deleting the item from the browser)

IF c__sifra(2,"password=22")=.F.
   RETURN NIL
ENDIF

IF c__neda("Brie se iz registra-spiska artikala"  +chr(59)+;
           "It is deleted from list of articles:"  +chr(59)+;
           " "                                     +chr(59)+;
           xCode+" "+xName                         +chr(59)+;
           "","DELETION",,"G3")=.F.
           CLEAR TYPEAHEAD
           RETURN NIL
ENDIF



   SELECT(radno)
  * DELETE  // now the __deleted column is set to TRUE // Error
  * COMMIT                                             // Error


   // remove from table ROW with column __deleted=TRUE
     xCode := "'"+xCode+"'"

     IF empty(yCode)
       // ako nema ifre artikla - if no article code
        cSQL := "DELETE FROM ONLY "+codebook+" WHERE robs_ IS NULL;"
     ELSE
        cSQL := "DELETE FROM ONLY "+codebook+" WHERE robs_="+xCode+";"
     ENDIF
     oStmt := DacSqlStatement():fromChar(cSQL)
     oStmt:build():execute()
    * ---
     cSQL := "VACUUM FULL "+codebook+";"
     oStmt := DacSqlStatement():fromChar(cSQL)
     oStmt:build():execute()


   *---------------------------- reload table in browser

   * Ovde treba ponovo uitati QUERY table inae u browser-u ostaju
   * prazne stavke od obrisanih artikala:
   * Here you need to reload the QUERY tables, otherwise they will
   * remain in the browser empty items from deleted items:

   * Moe i bez ovoga, ali bolje je sa ovim kod malih tabli
   * It can be done without this, but it is better with this for small boards:

    SELECT "ART"; CLOSE ART
    IF _order_=NIL .or. EMPTY(_order_)
       cSQL    := "SELECT * FROM "+codebook+" ;"
    ELSE
       cSQL    := "SELECT * FROM "+codebook+" ORDER BY "+_order_+" ;"
    ENDIF
    oStmt   := DacSqlStatement():fromChar(cSQL)
    cAlias  := oStmt:build():query(,"ART")
    ART:=cAlias
    SELECT "ART"         // this is mandatory  !
    svega:=reccount()    // this works correctly !
    * count all to svega // this works correctly !
    GO TOP

    *---------------------------- reload table in browser


   SELECT "ART"
   DBREFRESH()
   svega:=reccount()

   * --- technique:
   * always-select-adjacent-item (after deleting the item from the browser)
   oBrowse:refreshall()
    GO TOP
    // LOCATE FOR alltrim(robs_)=alltrim(cRec)
    LOCATE FOR __record = cRec
    IF FOUND()==.F.
       GO TOP
    ENDIF
   oBrowse:refreshall()
   * --- technique:
   * always-select-adjacent-item (after deleting the item from the browser)

   c__poruka("DELETED","OK",,"G3")


RETURN NIL




**************************************************************************
FUNCTION INSERT_ARTICLE(oBrowse,GetList,_order_)
**************************************************************************
* _order_ = "NAME_" for reload table in browser
*           "SELECT * FROM "+codebook+" ORDER BY NAME_ ;"

LOCAL radno:=SELECT()

   LOCAL xUpis := space(5)  // broj znakova za upis
   LOCAL cUpis := Enter_key("New Code","",xUpis,,"top")
   IF EMPTY(cUpis)
      RETURN NIL
   ENDIF
   cUpis := STRZERO(VAL(cUpis),5)


   GO TOP
   LOCATE FOR ALLTRIM(ROBS_)=ALLTRIM(cUpis)
   IF FOUND()
      c__poruka("ARTICLE EXISTS","OK",,"G3")
      CLEAR TYPEAHEAD
      RETURN NIL
   ENDIF


**********************************************
INSERT_ARTICLE_(oBrowse,GetList,cUpis,_order_)
**********************************************

RETURN NIL


*************************************************************************
STATIC FUNCTION INSERT_ARTICLE_(oBrowse,GetList,cUpis,_order_)
*************************************************************************
LOCAL radno:=SELECT()
PRIVATE ROBS, ROBN, DOBS,  cSQL, oStmt

ROBS := cUPIS
ROBN := " *** NEW NAME "+ROBS+" ***"
DOBS := xGRUPA

TEXT INTO cSQL WRAP
INSERT INTO &codebook ( ROBS_, ROBN_, DOBS_ ) VALUES ('&ROBS', '&ROBN', '&DOBS' );
ENDTEXT

oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()


   *---------------------------- reload table in browser

   * Ovde treba ponovo uitati QUERY table u Browser
   * Here you need to reload the QUERY tables in Browser

   * Moe i bez ovoga, ali bolje je sa ovim kod malih tabli
   * It can be done without this, but it is better with this for small boards:

    SELECT "ART"; CLOSE ART
    IF _order_=NIL .or. EMPTY(_order_)
       cSQL    := "SELECT * FROM "+codebook+" ;"
    ELSE
       cSQL    := "SELECT * FROM "+codebook+" ORDER BY "+_order_+" ;"
    ENDIF
    oStmt   := DacSqlStatement():fromChar(cSQL)
    cAlias  := oStmt:build():query(,"ART")
    ART:=cAlias
    SELECT "ART"         // this is mandatory  !
    svega:=reccount()    // this works correctly !
    * count all to svega // this works correctly !
    GO TOP

    *---------------------------- reload table in browser


SELECT "ART"
DBREFRESH()
svega:=reccount()
GO TOP
LOCATE FOR ROBS_==ROBS
DC_GetRefresh(GetList)
oBrowse:RefreshAll()

SELECT(radno)
RETURN NIL









* FUNCTION SORT_BY_NAME(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_CODE(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_GROUP(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_TYPE(cschemename,ctablename,cgrupa,oBrowse)

**************************************************************************
FUNCTION SORT_BY_NAME(cschemename,ctablename,cgrupa,oBrowse)
**************************************************************************
LOCAL radno:=SELECT() // SELECT "ART"
CLOSE ART

   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY robn_ ;"

oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"ART")
ART:=cAlias
SELECT "ART" // this is mandatory  !
GO TOP
oBrowse:Refreshall()
RETURN NIL
**************************************************************************
FUNCTION SORT_BY_CODE(cschemename,ctablename,cgrupa,oBrowse)
**************************************************************************
LOCAL radno:=SELECT()  // SELECT "ART"
CLOSE ART

   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY robs_ ;"

oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"ART")
ART:=cAlias
SELECT "ART" // this is mandatory  !
GO TOP
oBrowse:Refreshall()
RETURN NIL

**************************************************************************
FUNCTION SORT_BY_GROUP(cschemename,ctablename,cgrupa,oBrowse)
**************************************************************************
LOCAL radno:=SELECT()  // SELECT "ART"
CLOSE ART

   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY dobs_ ;"

oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"ART")
ART:=cAlias
SELECT "ART" // this is mandatory  !
GO TOP
oBrowse:Refreshall()
RETURN NIL


**************************************************************************
FUNCTION SORT_BY_TYPE(cschemename,ctablename,cgrupa,oBrowse)
**************************************************************************
LOCAL radno:=SELECT()  // SELECT "ART"
CLOSE ART

   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY grup_ ;"

oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"ART")
ART:=cAlias
SELECT "ART" // this is mandatory  !
GO TOP
oBrowse:Refreshall()
RETURN NIL



* FUNCTION SORT_BY_NAME_GROUP(cschemename,ctablename,cgrupa,oBrowse)
* FUNCTION SORT_BY_CODE_GROUP(cschemename,ctablename,cgrupa,oBrowse)

**************************************************************************
FUNCTION SORT_BY_NAME_GROUP(cschemename,ctablename,cgrupa,oBrowse)
**************************************************************************
LOCAL radno:=SELECT() // SELECT "ART"
CLOSE ART
cgrupa := padr(cgrupa,4)
IF EMPTY(xGRUPA)
   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY robn_ ;"
ELSE
   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" WHERE dobs_='"+cgrupa+"' ORDER BY robn_ ;"
ENDIF
oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"ART")
ART:=cAlias
SELECT "ART" // this is mandatory  !
GO TOP
oBrowse:Refreshall()
RETURN NIL
**************************************************************************
FUNCTION SORT_BY_CODE_GROUP(cschemename,ctablename,cgrupa,oBrowse)
**************************************************************************
LOCAL radno:=SELECT()  // SELECT "ART"
CLOSE ART
cgrupa := padr(cgrupa,4)
IF EMPTY(xGRUPA)
   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" ORDER BY robs_ ;"
ELSE
   cSQL := "SELECT * FROM "+cschemename+"."+ctablename+" WHERE dobs_='"+cgrupa+"' ORDER BY robs_ ;"
ENDIF
oStmt   := DacSqlStatement():fromChar(cSQL)
cAlias  := oStmt:build():query(,"ART")
ART:=cAlias
SELECT "ART" // this is mandatory  !
GO TOP
oBrowse:Refreshall()
RETURN NIL






* FUNCTION RENUMBERATION()
* FUNCTION RECONSTRUCTION()
* FUNCTION RENUMBER__record()

*************************************************************************
FUNCTION RENUMBERATION(ccTablename,oBrowse,nn)
*************************************************************************
* ccTablename = 'tablename' or 'schemename.tablename'
* Moe se koristiti za bilo koju upsize tablu koja ima __record kolonu
* Can be used for any upsize table that has a __record column

LOCAL radno:=SELECT()
PRIVATE cTablename := ccTablename

IF nn=1
c__poruka("START RENUMBERATION","START",,"G3")
ENDIF

* --- PASS 1 START
// Napravi se lista brojeva upisanih u __record za svaki red table
// Create a list of numbers written in __record for each row of the table
* ---
cSQL := "SELECT __record FROM "+codebook+";"
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():query(, @xResult)
SELECT QUERY
aRow:={}
DO WHILE .NOT. EOF()
  AADD(aRow,__record)
SKIP
ENDDO
CLOSE QUERY
SELECT(radno) // SELECT "ART"
* ---
// Izvri se renumeracija svih redova u tabli u koloni __record Public Key
// All rows in the table in the __record Public Key column are renumbered
* ---
cSQL:=""; ni:=0
FOR ni=1 TO len(aRow)

 alt_No__record := var2char(aRow[ni])  // 1,2,3,5,6      // state after DELETE __record = 4
 new_No__record := var2char(-aRow[ni]) // -1,-2,-3,-5,-6 // state after renumberation pass 1

TEXT INTO txt WRAP
UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
ENDTEXT

cSQL:=cSQL+txt
NEXT ni
* ---
* dc_memoedit(cSQL) // test
// sve se to upie u sve redove table
// everything is written in all the rows of table
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
// DBREFRESH()
* --- PASS 1 END



* --- PASS 2 START
// ponovo se uitaju svi aurirani redovi table sa negativnim __record
// reload all updated table rows with negative __record
cSQL := "SELECT __record FROM "+codebook+";"
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():query(, @xResult)
SELECT QUERY
aRow:={}
DO WHILE .NOT. EOF()
  AADD(aRow,__record)
SKIP
ENDDO
CLOSE QUERY
SELECT(radno) // SELECT "ART"
* ---
* ---
cSQL:=""; ni:=0
FOR ni=1 TO len(aRow)

 alt_No__record := var2char(aRow[ni]) // -1,-2,-3,-5,-6 // state after renumberation pass 1
 new_No__record := var2char(ni)       // 1,2,3,4,5      // state after renumberation pass 2

TEXT INTO txt WRAP
UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
ENDTEXT

cSQL:=cSQL+txt
NEXT ni
* ---
* dc_memoedit(cSQL) // test
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
// DBREFRESH()
// APPEND BLANK e dodati novi __record = 6 poto on sada ne postoji i sve je OK
// APPEND BLANK will add a new __record = 6 since it doesn't exist now and everything is OK
* --- PASS 2 END


* "--- alternative for PASS 2
* RENUMBER__record(cTablename) // here
* DBREFRESH()
* oBrowse:Refreshall()
* "--- alternative for PASS 2

*------------------------------------------------------------------------
* --- AFTER DELETING ROW FOLLOWS RESET COLUMN __record -------------- END
*------------------------------------------------------------------------



// rekonstrukcija formirane prazne i/ili napunjene table:
  cSQL := "VACUUM FULL "+codebook+";"
  oStmt := DacSqlStatement():fromChar(cSQL)
  oStmt:build():execute()


   SELECT(radno) // SELECT "ART"
   DbRefresh()
   oBrowse:refreshall()
   GO TOP

* ---
IF nn=1
c__poruka("END RENUMBERATION","END",,"G3")
ENDIF
RETURN NIL



*************************************************************************
FUNCTION RECONSTRUCTION(ccTablename,oBrowse,nn)
*************************************************************************
* ccTablename = 'tablename' or 'schemename.tablename'
* Moe se koristiti za bilo koju upsize tablu koja ima __record kolonu
* Can be used for any upsize table that has a __record column

LOCAL radno:=SELECT()
PRIVATE cTablename := ccTablename

IF nn=1
c__poruka("START RECONSTRUCTION","START",,"G3")
ENDIF


* ---
  * specijalna operacija:
  * APPEND BLANK kad se prekine sa error u tablu doda jedan prazan red
  * koji nema ifru artikla i koji treba obrisati.
  * Bie obrisani svi redovi koji imaju robs_ IS NULL (robs_="     ")
  * special operation:
  * APPEND BLANK, when terminated with an error, adds one blank row to the table
  * which does not have an article code and which should be deleted
  * All rows that have robs_ IS NULL (robs_="     ") will be deleted

  cSQL := "DELETE FROM ONLY "+codebook+" WHERE robs_ IS NULL;"
  oStmt := DacSqlStatement():fromChar(cSQL)
  oStmt:build():execute()
  SELECT(radno)
  //DBREFRESH()
* ---


* --- PASS 1 START
// Napravi se lista brojeva upisanih u __record za svaki red table
// Create a list of numbers written in __record for each row of the table
* ---
cSQL := "SELECT __record FROM "+codebook+";"
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():query(, @xResult)
SELECT QUERY
aRow:={}
DO WHILE .NOT. EOF()
  AADD(aRow,__record)
SKIP
ENDDO
CLOSE QUERY
SELECT(radno) // SELECT "ART"
* ---
// Izvri se renumeracija svih redova u tabli u koloni __record Public Key
// All rows in the table in the __record Public Key column are renumbered
* ---
cSQL:=""; ni:=0
FOR ni=1 TO len(aRow)

 alt_No__record := var2char(aRow[ni])  // -1,-2,-3,-5,-6 state after accident
 new_No__record := var2char(-aRow[ni]-100000)
 // -100001,-200002,-300003,-500005,-600006  state after reconstructions pass 1

TEXT INTO txt WRAP
UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
ENDTEXT

cSQL:=cSQL+txt
NEXT ni
* ---
* dc_memoedit(cSQL) // test
// sve se to upie u sve redove table
// everything is written in all the rows of the board
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
//DBREFRESH()
* --- PASS 1 END


* --- PASS 2 START
// ponovo se uitaju svi aurirani redovi table sa negativnim __record
// reload all updated table rows with negative __record
cSQL := "SELECT __record FROM "+codebook+";"
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():query(, @xResult)
SELECT QUERY
aRow:={}
DO WHILE .NOT. EOF()
  AADD(aRow,__record)
SKIP
ENDDO
CLOSE QUERY
SELECT(radno) // SELECT "ART"
* ---
* ---
cSQL:=""; ni:=0
FOR ni=1 TO len(aRow)


 alt_No__record := var2char(aRow[ni])
 // -100001,-200002,-300003,x,-500005,-600006 state after reconstructions pass 1
 new_No__record := var2char(ni) // 1,2,3,4,5  state after reconstructions pass 2


TEXT INTO txt WRAP
UPDATE &codebook SET __record = &new_No__record WHERE __record = &alt_No__record;
ENDTEXT

cSQL:=cSQL+txt
NEXT ni
* ---
* dc_memoedit(cSQL) // test
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
// DBREFRESH()
// APPEND BLANK e dodati novi __record = 6 poto on sada ne postoji i sve je OK
// APPEND BLANK will add a new __record = 6 since it doesn't exist now and everything is OK
* --- SECTION 2 END

*------------------------------------------------------------------------
* --- AFTER DELETING ROW FOLLOWS RESET COLUMN __record -------------- END
*------------------------------------------------------------------------


// rekonstrukcija formirane prazne i/ili napunjene table:
  cSQL := "VACUUM FULL "+codebook+";"
  oStmt := DacSqlStatement():fromChar(cSQL)
  oStmt:build():execute()


SELECT(radno) // SELECT "ART"
DbRefresh()
oBrowse:refreshall()
setappfocus(oBrowse)
GO TOP  // ubije se program ???


* ---
IF nn=1
c__poruka("END RECONSTRUCTION","END",,"G3")
ENDIF


RETURN NIL



*************************************************************************
FUNCTION RENUMBER__record(codebook,oBrowse,nn)
*************************************************************************
* Moe se koristiti za bilo koju upsize tablu koja ima __record kolonu
* Can be used for any upsize table that has a __record column

LOCAL radno:=SELECT()
LOCAL cSQL,oStmt,nRows
PRIVATE xTable := codebook // schemename.tablename
*------------------------------------------------------------------ START
* RENUMERACIJA kolone __record brojevima od 1 do n
* RENUMBER of the __record column with numbers from 1 to n
*------------------------------------------------------------------------
* https://stackoverflow.com/questions/41346345/
* how-can-i-update-all-rows-in-postgresql-from-1-to-n-where-n-number-of-rows
* Example:
* update kroba_11
*   set __record = t.rn
* from (
*   select __record,
*          row_number() over (order by __record) as rn
*   from kroba_11
* ) t
* where t.__record = kroba_11.__record;
* ---

PRIVATE xTableRecord := xTable+".__record"

TEXT INTO cSQL WRAP
update &xTable
  set __record = t.rn
from (
  select __record,
         row_number() over (order by __record) as rn
  from &xTable
) t
where t.__record = &xTablerecord;
ENDTEXT

* dc_memoedit("2"+chr(13)+chr(10)+cSQL) // test

oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
* ---

* ---
// Brojanje redova u tabli
// Counting rows in the table
cSQL:="SELECT COUNT(*) FROM "+xTable+";"
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():query()
SELECT QUERY
nRows:=count
CLOSE QUERY
c_poruka("NUMBER OF ROWS RENUMBERED "+var2char(nRows))
*------------------------------------------------------------------------
* RENUMERACIJA kolone __record brojevima od 1 do n
* RENUMBER of the __record column with numbers from 1 to n
*---------------------------------------------------------------------END

SELECT(radno) // SELECT "ART"
DbRefresh()

RETURN NIL








* P O S E B N A  O P E R A C I J A
* S P E C I A L  O P E R A T I O N
*
* --- NE OTVARA SE IFARNIK ARTIKALA VE SE IZ RAUNA RESTORANSKOG STOLA
* --- VRI PREUZIMANJE ARTIKLA PO ZADATOJ IFRI U RAUN RESTORANSKOG STOLA
* Ako konobar zna ifru artikla ne mora da otvara ifarnik artikala.
* Potrebno je da upie ifru artikla i taj artikal e biti dodat u
* raun restoranskog stola.
*
* --- IT DOES NOT OPEN ARTICLES CODEBOOK, BUT FROM RESTAURANT TABLE ACCOUNT
* --- PICK UP THE ARTICLE BY SPECIFIED CODE TO ACCOUNT OF RESTAURANT TABLE
* If the barman knows the article code, he does not have to open the
* article code book. It is necessary to enter the code of the article
* and that article will be added to restaurant table bill.
* ---
*" Funkcija se aktivira na komandni taster [S] iz otvorenog rauna stola
*" dok je aktivan raun stola SELECT STO
*" The function is activated on the command key [S] from the open account
*" RESTAURANT TABLE while the SELECT STO account RESTAURANT TABLE is active
*************************************************************************
FUNCTION zadaj__sifru__artikla()
*************************************************************************
* Zadaj ifru artikla u dialog boksu za ifru
* Nai ifru artikla u kroba_11 tabli i preuzmi artikal u tablu
* restoranskog stola x1, x2, x3...
* Ova funkcija poziva se iz otvorenog rauna restoranskog stola SELECT "STO"
* ---
* Enter the article code in the code dialog box
* Find article code in the kroba_11 table and download article to
* table restaurant desk x1, x2, x3...
* This function is called from the open account restaurant table SELECT "STO"
* ---
* use:
* PUBLIC _she_, _MAG_, _shetab_

LOCAL radno:=SELECT() // SELECT "STO"
LOCAL sifra := "     "

sifra:=eUpis0(sifra,"Article code","Code:|from 1 to 99999")
IF EMPTY(sifra)
   CLEAR TYPEAHEAD
   RETURN NIL
ENDIF
IF val(sifra)=0 .or. val(sifra)>99999
   sifra:=strzero(val(sifra),5)
   c_greska("Code "+sifra+" is not allowed")
   CLEAR TYPEAHEAD
   RETURN NIL
ENDIF
sifra:=strzero(val(sifra),5)

*********************************
codebook := _she_+".kroba_"+_MAG_
*********************************


    cSQL    := "SELECT * FROM "+codebook+";"
    oStmt   := DacSqlStatement():fromChar(cSQL)
    cAlias  := oStmt:build():query(,"ART")

    ARTIKLI:=cAlias
    SELECT "ART"
    GO TOP


GO TOP
LOCATE FOR alltrim(ROBS_) == alltrim(sifra)
IF FOUND()==.F.
   SELECT "ART";USE
   SELECT(radno)  // SELECT "STO"
   c_greska("ifra "+sifra+" nije naena")
   CLEAR TYPEAHEAD
   RETURN NIL
ENDIF


* A  U R I R A N J E  R A  U N A  S T O L A  --- S T A R T


 // ako je artikal PREUZET - ifra je naena
 // artikal se UPISUJE u taj otvoreni restoranski sto
 // if the article is TAKEN - the code is found
 // article is WRITE into that open restaurant table

         SELECT "STO"

         * PUBLIC _shetab_ // scheme.table = 'public.x1'
         *********************************
         stavku_dodaj_na_sto_YES(_shetab_)  // __ARTICLES_ADDTOTABLE.PRG
         *********************************

* A  U R I R A N J E  R A  U N A  S T O L A  --- E N D
SELECT "ART";USE
SELECT(radno)  // SELECT "STO"
CLEAR TYPEAHEAD
RETURN NIL












