//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __ARTICLES_SELECTION.PRG                                 SQL       //
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


/*

-------------------------------
  PACKAGE:
  __ARTICLES__MAIN.PRG
  __ARTICLES_CODEBOOK.PRG
  __ARTICLES_SELECTION.PRG
  __ARTICLES_DESCRIPTION.PRG
  __ARTICLES_REGISTERCARD.PRG
-------------------------------

IZDVAJANJE-SELEKCIJA ARTIKALA IZ SPISKA ARTIKALA NA POSEBNU FILTER LISTU
SISTEM SA OTVARANJEM OTVORENOG DBF SPISKA ARTIKLA U DRUGOJ INSTANCI
I SA FILTRIRANJEM SPISKA U DRUGOJ INSTANCI DA SE DOBIJE FILTER LISTA
SVE SE DESAVA DOK JE OTVOREN I AKTIVAN GLAVNI SPISAK ARTIKALA OBJEKTA

SELECTION-SELECTION OF ARTICLES FROM LIST OF ITEMS TO A SPECIAL FILTER LIST
SYSTEM WITH OPENING OF THE OPEN DBF LIST OF ARTICLES IN THE SECOND INSTANCE
AND WITH FILTERING THE LIST IN THE SECOND INSTANCE TO GET THE FILTER LIST
EVERYTHING HAPPENS WHILE THE OBJECT'S MAIN ITEM LIST IS OPEN AND ACTIVE

-------------------------------
FUNCTION ARTICLES_SELECTION( selekcija, vrsta, oDlgMain, xxsdbf, grupa )
STATIC FUNCTION si(oDlg)
STATIC FUNCTION selekcija_help()

*/


#include "Appevent.ch"
#include "Xbp.ch"
#include "common.ch"
#include "xbtsys.ch"
#include "dcdialog.ch"


***********************************************************************************
FUNCTION ARTICLES_SELECTION( selekcija, vrsta, oDlgMain, xxsdbf, grupa )
***********************************************************************************
* selekcija = string: "BEER"
* vrsta     = string: "ROBN_", "DOBS_", "VEZA_"
* oDlgMain  = object: setappwindow()
* xxsdbf    = string: 'tablename' or 'schemename.tablename'
*                     tabla iz koje se uzimaju podaci
*                     table from which the data is taken
* grupa     = string: group of articles "1","2","3"... "99"

LOCAL radno := SELECT()
LOCAL GetList := {}, oBrowse, oBrowBox , oToolBar, bTitle
LOCAL GetOptions , oDlg

LOCAL rek := RecNo(), xsvega  // aktuelni slog spiska artikala

LOCAL BMP_DOC,BMP_OK,BMP_ESC,BMP_HLP
LOCAL aCUR := {"user32.dll",114}
LOCAL oCUR := {"user32.dll",112}

DEFAULT selekcija TO "A", ;
        vrsta     TO "PARTOFNAME",;
        oDlgMain  TO SetAppWindow(),;
        xxsdbf    TO "",;
        grupa     TO ""

// stop(selekcija,vrsta,oDlgMain,xxsdbf,grupa,1)



        BMP_DOC := XbpBitmap():new():create()
        BMP_DOC:load( "BAZNE.DLL", 11021 )
        BMP_DOC:transparentClr := BMP_DOC:getDefaultBgColor()

        BMP_OK := XbpBitmap():new():create()
        BMP_OK:load( "BAZNE.DLL", 11041 )
        BMP_OK:transparentClr := BMP_OK:getDefaultBgColor()

        BMP_ESC := XbpBitmap():new():create()
        BMP_ESC:load("BAZNE.DLL",11042 )
        BMP_ESC:transparentClr := BMP_ESC:getDefaultBgColor()

        BMP_HLP := XbpBitmap():new():create()
        BMP_HLP:load( "BAZNE.DLL", 11043 )
        BMP_HLP:transparentClr := BMP_HLP:getDefaultBgColor()



PRIVATE title_selekcije := "ARTICLE"
IF vrsta = "ROBN_"
   title_selekcije := "ARTICLE NAME"
ENDIF
IF vrsta = "DOBS_"
   title_selekcije := "SUPPLIER CODE"
ENDIF
IF vrsta = "VEZA_"
   title_selekcije := "ARTICLE LINK"
ENDIF
PRIVATE opis_selekcije := 'contain word = "'+selekcija+'"'

PRIVATE cgrupa := grupa      // cgrupa NO LOCAL
PRIVATE txt    := selekcija  // ctxt NO LOCAL

*"----------------------------- start
*"table or schemename.tablename
*"-----------------------------
// varijabla ctable mora biti PRIVATE zbog komande TEXT INTO cSQL
// u kojoj se koristi kao &ctable
// the ctable variable must be PRIVATE because of the TEXT INTO cSQL
// command in which it is used as &ctable
PRIVATE ctable := xxsdbf  // tabla iz koje se uzimaju podaci
*                         // the table from which the data is taken
*       ctable := "public.kroba_11"
*       cTABLE := "kroba_11"
* or
*
PRIVATE ctable := cschemename+"."+ctablename
// command TEXT INTO cSQL
// ne sme da sadri - must not contain:
//     &cschemename.&ctablename
// taka se ne tampa u TEXT INTO - dot is not printed in TEXT INTO
*"-----------------------------
*"table or schemename.tablename
*"----------------------------- end

PRIVATE xAlias, cSQL, cStmt, LISTA




* -----------------
IF vrsta = "ROBN_"  // selekcija je string zadat od strane usera koji se trai u polju robn_ u tabli
* -----------------

  // daje sve nazive koji poinju sa rei: selekcija
  *  cSQL  := "SELECT * FROM "+cschemename+"."+ctablename+" WHERE robn_ LIKE '"+selekcija+"%' ORDER BY robn_ ;"

  // https://www.postgresql.org/docs/9.4/functions-string.html
  // pronai funkciju koja daje sve nazive koji sadre re: selekcija
  // strpos('COBA','OB')=2
  *  cSQL  := "SELECT * FROM "+cschemename+"."+ctablename+" WHERE strpos(robn_,'KOBAS')>0 ;"


    IF cgrupa == ""
       TEXT INTO cSQL WRAP
       SELECT * FROM &ctable WHERE strpos( upper(robn_) , upper('&txt') ) > 0 ;
       ENDTEXT
    ELSE
       TEXT INTO cSQL WRAP
       SELECT * FROM &ctable WHERE strpos( upper(robn_) , upper('&txt') ) > 0 AND dobs_ = '&cgrupa';
       ENDTEXT
    ENDIF

    oStmt := DacSqlStatement():fromChar(cSQL)
    xAlias  := oStmt:build():query(,"LISTA")
    LISTA:=xAlias
    SELECT "LISTA"
    xsvega:=reccount() // radi ispravno


* -----------------
ENDIF
* -----------------

* -----------------
IF vrsta = "VEZA_"  // selekcija je string preuzet iz polja veza_ u tabli koji se trai u polju veza_ u tabli
* -----------------

    cSQL  := "SELECT * FROM "+cschemename+"."+ctablename+" WHERE veza_= '"+selekcija+"' ORDER BY robn_ ;"
    oStmt := DacSqlStatement():fromChar(cSQL)
    xAlias  := oStmt:build():query(,"LISTA")

    LISTA:=xAlias
    SELECT "LISTA"
    xsvega:=reccount() // radi ispravno
* -----------------
ENDIF
* -----------------

* -----------------
IF vrsta = "DOBS_"  // selekcija je string preuzet iz polja dobs_ u tabli  koji se trai u polju dobs_ u tabli
* -----------------

    cSQL  := "SELECT * FROM "+cschemename+"."+ctablename+" WHERE dobs_='"+selekcija+"' ORDER BY robn_ ;"
    oStmt := DacSqlStatement():fromChar(cSQL)
    xAlias  := oStmt:build():query(,"LISTA")

    LISTA:=xAlias
    SELECT "LISTA"
    xsvega:=reccount() // radi ispravno
* -----------------
ENDIF
* -----------------


    ******************************
     PRIVATE sifra_artikla := ""
     // ovde se smeta sifra izabranog artikla
     // here is the code of the selected article
    ******************************


@  0,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP PIXEL SIZE 22,22 CAPTION BMP_DOC PARENT BrowBox
@  0,6 DCSAY title_selekcije SAYSIZE 0 PARENT BrowBox
@  1,6 DCSAY opis_selekcije+" = "+var2char(xsvega) SAYSIZE 0 PARENT BrowBox


@  2,0             DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 45,11.2 OBJECT oBrowBox
@  0+0.2,0+0.2     DCBROWSE oBrowse PARENT oBrowBox ALIAS "LISTA" ;
                   SIZE 45-0.4,11.2-0.4 ;
                   CURSORMODE XBPBRW_CURSOR_ROW ;
                   ITEMSELECTED {|| sifra_artikla := ROBS_ ,;
                   DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }; // FONT "6.Helv"


   DCBROWSECOL FIELD LISTA->ROBN_     WIDTH 20 HEADER "ARTICLE NAME" PARENT oBrowse
   DCBROWSECOL FIELD LISTA->ROBS_     WIDTH 3  HEADER "CODE"         PARENT oBrowse

   DCBROWSECOL FIELD LISTA->CENA_MPR_ WIDTH 6  HEADER "PRICE"        PARENT oBrowse

   DCBROWSECOL FIELD LISTA->ROBK_     WIDTH 8  HEADER "BARCOD"       PARENT oBrowse
   DCBROWSECOL FIELD LISTA->MERA_     WIDTH 2  HEADER "UNIT"         PARENT oBrowse
                                               * MEASUREMENT UNIT
   DCBROWSECOL FIELD LISTA->DOBS_     WIDTH 4  HEADER "SUPP"         PARENT oBrowse
   DCBROWSECOL FIELD LISTA->VEZA_     WIDTH 15 HEADER "LINK"         PARENT oBrowse


tbr := 45
btt := tbr/3

@ 13.6,0 DCTOOLBAR oToolBar SIZE tbr,3 BUTTONSIZE btt,3

//---------------------------------------------------------------------------
DCADDBUTTON CAPTION BMP_OK PARENT oToolBar SIZE 5 WHEN {||.F.}
DCADDBUTTON CAPTION "&Take it" PARENT oToolBar ACCELKEY xbeK_ENTER ;
   ACTION {|| sifra_artikla := ROBS_ ,DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
   TOOLTIP "[Enter] Uzmi artikal - Take it article" ;
   CURSOR aCUR SIZE btt-5

DCADDBUTTON CAPTION BMP_HLP PARENT oToolBar SIZE 5 WHEN {||.F.}
DCADDBUTTON CAPTION "&Help" PARENT oToolBar ACCELKEY xbeK_F1 ;
   ACTION {|| selekcija_help(),  DC_GetRefresh(GetList), SetAppFocus(oBrowse)} ;
   TOOLTIP "[F1] Help" ;
   CURSOR aCUR SIZE btt-5

DCADDBUTTON CAPTION BMP_ESC PARENT oToolBar SIZE 5 WHEN {||.F.}
DCADDBUTTON CAPTION "&Exit" PARENT oToolBar ACCELKEY xbeK_ESC;
   ACTION {|| sifra_artikla := "", DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
   TOOLTIP "[Esc] Odustani od uzimanja - Stop taking it" ;
   CURSOR aCUR  SIZE btt-5

//---------------------------------------------------------------------------


   // --------------------- Prozor gore desno u AppWindow() -----------------

   // Funkcija si(oDlg)
   // daje aSize aktuelnog oDlg prozora, posle njegovog formiranja

      PRIVATE aSize    := {345,354} // aktuelni oDlg GUI prozor ovog programa
      PRIVATE aRefSize := SetAppWindow():currentSize()
      PRIVATE aRefPos  := SetAppWindow():currentPos()
      PRIVATE aPos     := GoreDesnoPos( aSize, aRefSize, aRefPos )   // xBazne.prg

         //MsgBox(str(aRefPos[1])+" "+str(aRefPos[2])+chr(13)+;
         //       str(aPos[1])   +" "+str(aPos[2]),"Pos oDlg")

   // --------------------- Prozor gore desno u AppWindow() -----------------


DCGETOPTIONS ICON 1 ;
   AUTOFOCUS ;
   WINDOWCOL  aPos[1]  WINDOWROW  aPos[2] ;
   NORESIZE ;
   NOMAXBUTTON ;
   NOMINBUTTON ;
   NOESCAPEKEY ;
   FONT "11.Archivo Narrow Bold"


 DCREAD GUI TITLE "LIST FROM OBJECT ("+MAG+")" ;
            OPTIONS GetOptions ;
            FIT ;
            SETFOCUS @oBrowse ;
              PARENT @oDlg ;
              EVAL {||SetAppWindow(oDlg)} ;
              MODAL

SELECT "LISTA"
USE
SELECT(radno)


IF EMPTY(sifra_artikla)=.F.  // samo ako je sifra artikla preuzeta iz liste
   GO TOP
   LOCATE FOR alltrim(ROBS_) == alltrim(sifra_artikla)
ELSE
   // GO TOP --> NO
   // vrati se na aktuelni record spiska artikala
   // return to the current item list record
ENDIF

CLEAR TYPEAHEAD  // vraa fokus na objekat sa koga je fokus prenet ovde
RETURN NIL

***********************************************************************************
STATIC FUNCTION si(oDlg)
***********************************************************************************
// Pomocna funkcija - alat za programera
// Da bi se utvrdile dimenzije FIT aktivnog oDlg prozora, mora se, tek posle
// njegovog kreiranja sa DCREAD GUI FIT, pozvati ova funkcija da ga "izmeri".
// ove dimenzije se koriste kao gotove fiksne vrednosti npr. aSize := {300,400}
// u funkciji:
//   aPos := GoreDesnoPos( aSize, aRefSize, aRefPos )   // xBazne.prg
     LOCAL aSize  :=  oDlg:currentSize()                // dimenzije prozora
     MsgBox(str(aSize[1])+" "+str(aSize[2]),"oDlg Prozor")

RETURN(nil)
***********************************************************************************
STATIC FUNCTION selekcija_help()
***********************************************************************************
LOCAL cr := chr(59), cTxt := ;
"Izabere se artikal na filter listi artikala:"+cr+;
" "                                           +cr+;
" - Dupli klik miem na izabrani artikal "    +cr+;
" - ENTER na izabrani artikal"                +cr+;
" - Klik na command button [ Take it ]"       +cr+;
" "                                           +cr+;
"i izabrani artikal bie pronaen u ifarniku"+cr+;
"artikala(select za preuzimanje u aplikaciju)"+cr+;
" "                                           +cr+;
"An article is selected in item filter list:" +cr+;
" "                                           +cr+;
" - Double mouse click on the selected item " +cr+;
" - ENTER to selected item"                   +cr+;
" - Click on the command button [ Take it ]"  +cr+;
" "                                           +cr+;
"and selected item will be found in codebook" +cr+;
"article (select to download to application)" +cr+;
" "
c__procitaj(cTxt,"POSEBNA SELEKCIJA | SPECIAL SELECTION",,"H")
CLEAR TYPEAHEAD// vraa fokus na objekat sa koga je fokus prenet ovde
RETURN(nil)




