//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __KASA_INI.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////



#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "xbtsys.ch"

#INCLUDE "DCDIALOG.CH"




********************************************************

* [COBA Systems]
* inifile=Y:\EZIR\(EZIR)\KASA.INI

* [COMPANY]
* tin=101950010
* businessName=SPAJI DOO NEGOTIN
* locationName=.
* address=KOROGLAKA 13
* district=19300 NEGOTIN

* [KASA_CFG]

* cLokacija_Prijema=Y:\EZIR\(EZIR)\FIRME\FIRMA-01\2001
* cLokacija_Slanja=Y:\EZIR\(EZIR)\FIRME\FIRMA-01\2001

* cObjekat_Kase=11
* cBroj_Kase=11

* cModZaliha=dozvola prodaje robe bez zaliha
* cRadSaKupcima=rad sa kupcima iskljucen
* cModRada=trgovacki mod rada
* cUpis_Kolicine=ima upisa kolicine posle skenera

* KASA=NOTOUCH

* cStampaRacunaUgostitelja=0
* kasa_racunar=0
// DELETE FILE (gde_sam()+"\kasaracunar")
// preuzimanje Dokumenata iz knjigovodstva firme

* [EPSON_CFG]

* cPreskok_Redova=0 - preskok redova za EPSON TM
* cTipStampe=40 znakova CONDENSED za EPSON TM
* cTipRacuna=jedna roba JEDAN RED za EPSON TM
* cFiokaPin=5 - otvaranje na PIN za EPSON TM

* [PRINTER_CFG]

* cPrinter_duzinareda=40
* cFP=POST
* cFiskalni_Printer=POS printer termalni

* DIALOG_ARHIVA_KASABLOK=0
* DIALOG_ARHIVA_NEFISKALNI=0
* ARHIVA_NEFISKALNI=0
* ZABRANI_BRISANJE=0

* [DOKUMENTA]

* dok_podesi=0
// NE moe se aktivirati operacija menija
// [Podesi rad sa Dokumentima]

* [BI]

* total_po_artiklu=0

********************************************************



//#########################################################################################################//
//
//                                           KASA_INI.PRG
//                radi samo sa klasom u modulu INIFILE.PRG koja sadri ist Xbase++ kod
//
//                                      Formira KASA.INI fajl
//
//#########################################################################################################//


* Ni jedna funkcija od ovih ne obraa se LPFR-u (fiskalnom printeru) 19-01-2022


* FUNCTION KASA_INIT_INI() // poziv sa starta MAIN PROCEDURE
* FUNCTION KASA_INI_KREIRAJ(poruka)  // Postavljanje sistema na default
* FUNCTION KASA_INI_UCITAJ(poruka) // Uutavanje parametara iz KASA.INI

* FUNCTION INI_otvori() // KASA.INI za citanje i upis
* STATIC FUNCTION c_procitaj(poruka,naslov) // centrira tekst bez ikone
* STATIC FUNCTION c_greska(poruka,naslov)



* FUNCTION PRODAJA_ARTIKALA_BEZ_ZALIHA()
* FUNCTION RAD_SA_EVIDENCIJOM_KUPACA()
* FUNCTION UPIS_KOLICINE_POSLE_SKENERA()
* FUNCTION MOD_PRODAJE_RACUNARA_KASE()


* FUNCTION ZABRANI_BRISANJE()
* FUNCTION DIALOG_ARHIVA_NEFISKALNI()
* FUNCTION DIALOG_ARHIVA_KASABLOK()
* FUNCTION ARHIVA_NEFISKALNI()
* FUNCTION STAMPA_RACUNA_UGOSTITELJA()

* FUNCTION KASA_RACUNAR()           // dokumenta
* FUNCTION KASA_DOKUMENTA_CFG()     // dokumenta


* FUNCTION KASA_TOUCH_MOD()
* FUNCTION COMPANY_LABELS()   // 18-01-2022












***************************************************************************
FUNCTION KASA_INIT_INI() // poziv sa starta MAIN PROCEDURE
***************************************************************************
/*


 VANO:

 GLAVNA FUNKCIJA ZA INICIJALIZACIJU PARAMETARA KASE
 AKO JE NEMA KREIRA KASA.INI I AUTOMATSKI KREIRA KASA.DBF
 I PUNI IH SA DEFAULT VREDNOSTIMA
 AKO JE IMA UITAVA IZ NJE PARAMETRE I STAVLJA IH U PUBLIC VARIJABLE


 * __KASA_INI.PRG:
 *******************
  KASA_INIT_INI()
 *******************
 * Iz fajla KASA.INI i COMPORT.INI uitavaju se parametri za rad kase
 * (ako INI fajlova nema oni se automatski kreiraju iz iste funkcije)
  PUBLIC MAG := cObjekat_Kase
  PUBLIC KAS := cBroj_Kase
  * PUBLIC fp = fiskalni printer: "GP550","GP350"... default "GP550"





*/


  PRIVATE KasaIni := gde_exe() + "\KASA.INI"

  * 1. ako nema fajla KASA.INI napravi ga
  * ----------------------------------------------------
  IF FILE(KasaIni) == .F.
     KASA_INI_KREIRAJ() // postavljanje default parametara za kasu - ovde
  ENDIF


  * 2. ako postoji KASA.INI uitaj
  * ------------------------------------------------------------------
  IF KASA_INI_UCITAJ() = .F. // UITAJ PARAMETRE KASE U PUBLIC VARIJABLE - KASA_INI.PRG
    QUIT_QUIT() // bazne.dll // AKO NEMA KASA.INI FAJLA ILI NE MOE DA SE OTVORI - PREKINI PROGRAM
  ENDIF


RETURN nil









******************************************************************************** 10-01-2022
FUNCTION KASA_INI_KREIRAJ(poruka)  // Postavljanje sistema na default
********************************************************************************
/*
    Upotreba:

    IF FILE(gde_exe()+"\KASA.INI") = .F.
       KASA_INI_KREIRAJ()
    ENDIF




        KREIRA KASA.INI I AUTOMATSKI KREIRA KASA.DBF I PUNI IH SA DEFAULT VREDNOSTIMA
        NE UITAVA IZ NJE PARAMETRE I NE STAVLJA IH U PUBLIC VARIJABLE
        KORISTI: CR_KASA()  - KREIRAJ KASA.DBF I NAPUNI JE SA IDENTINIM VREDNOSTIMA KAO U KASA.INI

*/

DEFAULT poruka TO 0
IF poruka = 1
   IF ConfirmBox(,;
           "Postavljanje Sistema Programa, odnosno parametara"+chr(13)+chr(10)+;
           "rada programa kao i pojedinih operacija programa,"+chr(13)+chr(10)+;
           'na default vrednosti - na "Fabriko Podeavanje",'+chr(13)+chr(10)+;
           "ime e biti ponitena sva dosadanja setovanja.",;
           "Postavljanje Sistema na Default",XBPMB_YESNO,XBPMB_QUESTION,)=XBPMB_RET_NO
           RETURN(.F.)
   ENDIF
ENDIF






*********************************************************************** 10-01-2022
INI := gde_exe()+"\KASA.INI"
IF TYPE("DB_adresa")=="C"
   knjigovodstvo := DB_adresa // raunar SERVER centralna baza podataka knjigovodstva
ELSE
   knjigovodstvo := "C:\CSYSTEMS\FIRME\FIRMA-01\2001"
ENDIF


* --- 18-01-2022

* Preuzmi iz XCoba.SYS Company labels:
PUBLIC ;
tin          := "102432867 | 55667977"      // P_PORRN,;
businessName := "COBA Systems Software PR"  // P_NAZIV,;
locationName := "www.cobasystems.com"       // P_LICE ,;
address      := "Srbe Jovanovia 1/10"      // P_ADR  ,;
district     := "19300 NEGOTIN"             // P_MESTO

INI_WRITE("C","COMPANY", "tin"           , tin            ,INI )
INI_WRITE("C","COMPANY", "businessName"  , businessName   ,INI )
INI_WRITE("C","COMPANY", "locationName"  , locationName   ,INI )
INI_WRITE("C","COMPANY", "address"       , address        ,INI )
INI_WRITE("C","COMPANY", "district"      , district       ,INI )

* --- 18-01-2022


INI_WRITE("C","KASA_CFG", "cLokacija_Prijema"    , knjigovodstvo ,INI )     // podaci se u kasu primaju sa lokacije
INI_WRITE("C","KASA_CFG", "cLokacija_Slanja"     , knjigovodstvo ,INI )     // podaci iz kase alju se na lokaciju
INI_WRITE("C","KASA_CFG", "cObjekat_Kase"        , "11" ,INI )     // ifra maloprodajnog/veleprodajnog objekta koji prima podatke
INI_WRITE("C","KASA_CFG", "cBroj_Kase"           , "11" ,INI )     // Broj kase u objektu

INI_WRITE("C","KASA_CFG", "cModZaliha"           , "dozvola prodaje robe bez zaliha",INI )     // "zabrana prodaje robe bez zaliha"
INI_WRITE("C","KASA_CFG", "cRadSaKupcima"        , "rad sa kupcima iskljucen",INI )            // "rad sa kupcima ukljucen"
INI_WRITE("C","KASA_CFG", "cModRada"             , "trgovacki mod rada",INI )                   // "restoranski mod rada"
INI_WRITE("C","KASA_CFG", "cUpis_Kolicine"       , "ima upisa kolicine posle skenera",INI )     // "nema upisa kolicine posle skenera"

INI_WRITE("C","EPSON_CFG", "cPreskok_Redova"     , "0 - preskok redova za EPSON TM"  ,INI )     // "2 - preskok redova za EPSON TM"...
INI_WRITE("C","EPSON_CFG", "cTipStampe"          , "40 znakova CONDENSED za EPSON TM",INI )     // "40 znakova DRAFT za EPSON TM"
INI_WRITE("C","EPSON_CFG", "cTipRacuna"          , "jedna roba JEDAN RED za EPSON TM",INI )     // "jedna roba DVA REDA za EPSON TM"
INI_WRITE("C","EPSON_CFG", "cFiokaPin"           , "5 - otvaranje na PIN za EPSON TM",INI )     // "2 - otvaranje na PIN za EPSON TM"



* ---
   // ovo se ne moe menjati osim iz editora
INI_WRITE("N","PRINTER_CFG", "cPrinter_duzinareda", 40 ,INI )   // 40 karaktera 19-01-2022
* ---
   // ovo se ne moe menjati osim iz editora
INI_WRITE("C","PRINTER_CFG", "cFP",               "POST",INI )    // 25-08-2015
INI_WRITE("C","PRINTER_CFG", "cFiskalni_Printer", "POS printer termalni",INI )    // sledi spisak:
*
* NOVO OD 25-08-2015 // sledi spisak:
* PUBLIC cFiskalniPrinter                            fp
*        "Printer A4 laserski"                = "0"  POSM
*        "POS printer termalni"               = "1"  POST
* ---



IF poruka = 1

   MsgBox( ;
   "Sistem rada programa postavljen je na default vrednosti"+chr(13)+chr(10)+;
   "ime su resetovana i ponitena sva dosadanja setovanja.",;
   "Postavljanje Sistema na Default")

ENDIF
*********************************************************************** 10-01-2022

RETURN(.T.)
















******************************************************************************** 10-01-2022
FUNCTION KASA_INI_UCITAJ(poruka) // Uutavanje parametara iz KASA.INI
********************************************************************************
/*
  Upotreba:

  KASA_INI_UCITAJ()


  UITAVA PARAMETRE IZ KASA.INI I STAVLJA IH U PUBLIC VARIJABLE ZA UPOTREBU IZ APLIKACIJE
  POSLE TOGA TE PARAMETRE ZAPISUJE U KASA.DBF I STAVLJA IH U STARE PUBLIC VARIJABLE ZA
  UPOTREBU IZ STARIH VERZIJA APLIKACIJE (AUTOMATSKI AURIRA KASA.DBF)

  AKO JE PORUKA=1
  PRIKAZUJE ALERTBOX SA IZLISTANIM PARAMETRIMA I DOZVOLJAVA RESET PARAMETARA NA DEFAULT
  IZ FUNKCIJE KASA_INI_KREIRAJ() i KASA_MAG()


*/


    //------------------------------------------------------
      LOCAL radno := SELECT()

      LOCAL INI := gde_exe()+"\KASA.INI"

      IF FILE(INI) = .F.
         c_greska("INI fajl"+chr(13)+chr(10)+;
                  INI +chr(13)+chr(10)+;
                  "NE POSTOJI.","KASA.INI")
         RETURN(.F.)
      ENDIF
    //------------------------------------------------------

DEFAULT poruka TO 0


  // ovi parametri su ostavljeni u aplikaciji kao PUBLIC zbog kompatibilnosti sa
  // starim programom, ali svuda ih treba koristiti tako to ih u proceduri treba
  // definisati kao LOCAL ili PRIVATE i treba ih pozvati sa komandama INI-KOMANDE

  PUBLIC ;
         clokacija_prijema ,;
         clokacija_slanja  ,;
         cObjekat_kase     ,;
         cBroj_Kase


  // Ovi parametri se u aplikaciji dobijaju sa komandama INI-KOMANDE

  PUBLIC ;
         cLokacija_Prijema  ,;
         cLokacija_Slanja   ,;
         cObjekat_Kase      ,;
         cBroj_Kase
  PUBLIC ;
         cModFP             ,;
         cModZaliha         ,;
         cRadSaKupcima      ,;
         cModRada           ,;
         cUpis_Kolicine
  PUBLIC ;
         cPreskok_Redova    ,;
         cTipStampe         ,;
         cTipRacuna         ,;
         cFiokaPin
 PUBLIC ;
         cFiskalni_Printer, fp, cStampaRacunaKupcu  // 26-08-2015





   *******************************************************************************  19-01-2022
   * INI-KOMANDE (upotrebljavaju se iz aplikacije za uitavanje parametara)

    * --- 18-01-2022

    PUBLIC ;
    tin          := INI_READ("C","COMPANY", "tin"           ,INI ) ,;
    businessName := INI_READ("C","COMPANY", "businessName"  ,INI ) ,;
    locationName := INI_READ("C","COMPANY", "locationName"  ,INI ) ,;
    address      := INI_READ("C","COMPANY", "address"       ,INI ) ,;
    district     := INI_READ("C","COMPANY", "district"      ,INI )

    * --- 18-01-2022


    // Ucitaj vrednosti za CFG parametre iz KASA.INI fajla:

    cLokacija_Prijema := INI_READ("C","KASA_CFG", "cLokacija_Prijema",INI)
    cLokacija_Slanja  := INI_READ("C","KASA_CFG", "cLokacija_Slanja" ,INI)
    cObjekat_Kase     := INI_READ("C","KASA_CFG", "cObjekat_Kase"    ,INI)
    cBroj_Kase        := INI_READ("C","KASA_CFG", "cBroj_Kase"       ,INI)


    cModZaliha        := INI_READ("C","KASA_CFG", "cModZaliha"       ,INI)
    cRadSaKupcima     := INI_READ("C","KASA_CFG", "cRadSaKupcima"    ,INI)
    cModRada          := INI_READ("C","KASA_CFG", "cModRada"         ,INI)
    cUpis_Kolicine    := INI_READ("C","KASA_CFG", "cUpis_Kolicine"   ,INI)

    cPreskok_Redova   := INI_READ("C","EPSON_CFG", "cPreskok_Redova" ,INI)
    cTipStampe        := INI_READ("C","EPSON_CFG", "cTipStampe"      ,INI)
    cTipRacuna        := INI_READ("C","EPSON_CFG", "cTipRacuna"      ,INI)
    cFiokaPin         := INI_READ("C","EPSON_CFG", "cFiokaPin"       ,INI)



* ---

    // ovo se ne moe menjati osim iz editora
    PUBLIC cPrinter_duzinareda := INI_READ("N","PRINTER_CFG", "cPrinter_duzinareda",INI )   // 40 karaktera 19-01-2022
    * "default 40 karaktera - vai samo za termalne POS printere
    IF EMPTY(cPrinter_duzinareda)
           cPrinter_duzinareda := 40
           INI_WRITE("N","PRINTER_CFG", "cPrinter_duzinareda",cPrinter_duzinareda,INI)
    ENDIF

* ---

   // ovo se ne moe menjati osim iz editora
    cFiskalni_Printer := INI_READ("C","PRINTER_CFG", "cFiskalni_Printer",INI)
    fp                := INI_READ("C","PRINTER_CFG", "cFP",INI) // 25-08-2015

* ---

   *******************************************************************************  19-01-2022


  //=========================================================================================
  // PREVOENJE CFG PARAMETARA U PUBLIC VARIJABLE RADI KOMPATIBILNOSTI SA STARIM PROGRAMOM
  //=========================================================================================

  //  inicijalizuj PUBLIC zbog kompatibilnosti sa starim programom:

  PUBLIC ;
         Fiskalni_Printer ,;
         Preskok_redova   ,;
         Upis_Kolicine    ,;
         TipStampe        ,;
         TipRacuna        ,;
         FiokaPin         ,;
         ModRada

  PUBLIC ;
         ModFP            ,;
         ModZaliha        ,;
         Radsaracunom     ,;
         Radsakupcima





     IF cModZaliha == "dozvola prodaje robe bez zaliha"
         ModZaliha := 0
     ELSE         //  "zabrana prodaje robe bez zaliha"
         ModZaliha := 1
     ENDIF

     IF cRadSaKupcima == "rad sa kupcima iskljucen"
         Radsakupcima := 0
     ELSE            //  "rad sa kupcima ukljucen"
         Radsakupcima := 1
     ENDIF

     IF cUpis_Kolicine == "ima upisa kolicine posle skenera"
         Upis_Kolicine := 1
     ELSE            //   "nema upisa kolicine posle skenera"
         Upis_Kolicine := 0
     ENDIF

     IF cModRada == "trgovacki mod rada"
         ModRada := "1"
     ELSE      //   "restoranski mod rada"
         ModRada := "2"
     ENDIF



* novo od 25-08-2015

   IF     cFiskalni_Printer == "Printer A4 laserski"
       Fiskalni_Printer := "0"
   ELSEIF cFiskalni_Printer == "POS printer termalni"
       Fiskalni_Printer := "1"
   ELSE
       Fiskalni_Printer := "1"  // "POS printer termalni"
   ENDIF



        Preskok_Redova := VAL(SUBSTR(cPreskok_Redova,1,1)) // "0,1,2,3... string je "0 - preskok redova za EPSON TM"
        FiokaPin       := SUBSTR(cFiokaPin,1,1)            // "5" ili "2" string je "5 - otvaranje na PIN za EPSON TM


     IF cTipStampe == "40 znakova CONDENSED za EPSON TM"
         TipStampe := "1"
     ELSE        //   "40 znakova DRAFT za EPSON TM"
         TipStampe := "2"
     ENDIF
     IF cTipRacuna == "jedna roba JEDAN RED za EPSON TM"
         TipRacuna := "1"
     ELSE        //   "jedna roba DVA REDA za EPSON TM"
         TipRacuna := "2"
     ENDIF


  //=========================================================================================
  // PREVOENJE CFG PARAMETARA U PUBLIC VARIJABLE RADI KOMPATIBILNOSTI SA STARIM PROGRAMOM
  //=========================================================================================






  //=========================================================================================  START
  // ESIR KASA OD 2022 GODINE
  //=========================================================================================

    PRIVATE printer_name := ""

    PRIVATE PRN := INI_READ("C","KASABLOK","printer_kasablok",ini) // POS,WIN
    * PRN := "POS", "WIN"

    IF PRN=="POS"
       printer_name := INI_READ("C","KASABLOK","POS_printer_name",ini)
    ELSEIF PRN=="WIN"
       printer_name := INI_READ("C","KASABLOK","WIN_printer_name",ini)
    ENDIF

    PUBLIC fp := PRN
    PUBLIC cFiskalni_Printer := printer_name


    PUBLIC ;
    POS_printer_name := INI_READ("C","KASABLOK","POS_printer_name",ini) ,;
    WIN_printer_name := INI_READ("C","KASABLOK","WIN_printer_name",ini) ,;
    FAK_printer_name := INI_READ("C","KASABLOK","FAK_printer_name",ini) ,;
    KBL_printer_name := INI_READ("C","KASABLOK","KBL_printer_name",ini) ,;
    NAL_printer_name := INI_READ("C","KASABLOK","NAL_printer_name",ini)

    PUBLIC ROLNAPAPIRA := INI_READ("N","KASABLOK","RolnaPapira",ini)
    * ROLNAPAPIRA := 58, 80




    PUBLIC ;
    KASA_LPFR    := INI_READ("C","COMPANY", "KASA_LPFR" ,gde_exe()+"\KASAPFR.INI" ) ,; // HTTP ENDPOINT LOKACIJA
    KASA_VPFR    := INI_READ("C","COMPANY", "KASA_VPFR" ,gde_exe()+"\KASAPFR.INI" ) ,; // HTTP ENDPOINT LOKACIJA
    KASA_TEST    := INI_READ("C","COMPANY", "KASA_TEST" ,gde_exe()+"\KASAPFR.INI" ) ,; // TESTNO OKRUENJE LOKACIJA
    KASA_PAC     := INI_READ("C","COMPANY", "KASA_PAC"  ,gde_exe()+"\KASAPFR.INI" ) ,; // PAC: BCCMTH Detalji pfx sertifikata:
    KASA_PIN     := INI_READ("C","COMPANY", "KASA_PIN"  ,gde_exe()+"\KASAPFR.INI" )    // PIN ZA LPFR: 1234


    PUBLIC LPFR_TEST := INI_READ("L","KASA","LPFR_TEST" ,gde_exe()+"\KASAPFR.INI")
  * LPFR_TEST = TESTNO OKRUENJE .T. ili .F.


    PUBLIC LPFR_VPFR := INI_READ("C","KASA","LPFR_VPFR" ,gde_exe()+"\KASAPFR.INI")
  * LPFR_VPFR = "LPFR" ili "VPFR"

    IF LPFR_TEST==.T.
       cPFR_okruzenje := "TESTNO OKRUENJE"
       cPFR_endpoint  := KASA_TEST
    ELSE
       IF LPFR_VPFR = "LPFR"
          cPFR_okruzenje := "L-PFR"
          cPFR_endpoint  := KASA_LPFR
       ELSE
          cPFR_okruzenje := "V-PFR"
          cPFR_endpoint  := KASA_VPFR
       ENDIF
    ENDIF

    cPFR_endpoint1 := substr(cPFR_endpoint,1,36)
    cPFR_endpoint2 := substr(cPFR_endpoint,37,36)
    cPFR_endpoint3 := substr(cPFR_endpoint,73,36)

    cLokacija_Prijema1 := substr(cLokacija_Prijema,1,36)
    cLokacija_Prijema2 := substr(cLokacija_Prijema,37,36)

  //=========================================================================================
  // ESIR KASA OD 2022 GODINE
  //=========================================================================================  END




IF poruka = 1
 //  NOVI KASA.INI PARAMETRI        STARI KASA.DBF PARAMETRI

   IF TYPE("DB_adresa")=="C"
      DB_adresa__ := DB_adresa
   ELSE
      DB_adresa__ := "NEMA KNJIGOVODSTVA"
   ENDIF




   PRIVATE nStampaRacunaUgostitelja := ;
   INI_READ("N","KASA_CFG","cStampaRacunaUgostitelja",GDE_EXE()+"\KASA.INI")





   ch := ";"
   cTxt := ;
     "T R E N U T N O  S T A N J E  K O N F I G U R A C I J E  K A S E"                   +ch +;
     "_____________________________________________________________________"              +ch +;
     PADR("KASA RADI SA PFR PROCESOROM  : "+cPFR_okruzenje   ,68)              +" "+ " "   +ch +;
     PADR("PFR URL ADRESA I ENDPOINT    : "+cPFR_endpoint1   ,68)              +" "+ " "   +ch +;
     PADR("                               "+cPFR_endpoint2   ,68)              +" "+ " "   +ch +;
     PADR("                               "+cPFR_endpoint3   ,68)              +" "+ " "   +ch +;
     PADR("PAC kod (za rad sa V-PFR)    : "+KASA_PAC         ,68)              +" "+ " "   +ch +;
     PADR("PIN kod                      : "+KASA_PIN         ,68)              +" "+ " "   +ch +;
     "_____________________________________________________________________"              +ch +;
     " "                                                                                  +ch +;
     PADR("KASA RADI SA PRINTEROM      : "+cFiskalni_Printer,65)              +" "+ " "   +ch +;
     PADR("OZNAKA I TIP PRINTERA       : "+fp               ,65)              +" "+ " "   +ch +;
     PADR("IRINA ROLNE PAPIRA         : "+var2char(ROLNAPAPIRA)+" mm",65)    +" "+ " "   +ch +;
     " "                                                                                  +ch +;
     PADR("PRINTER ZA KASABLOKOVE      : "+KBL_printer_name ,65)              +" "+ " "   +ch +;
     PADR("PRINTER ZA NALOG ANKU      : "+NAL_printer_name ,65)              +" "+ " "   +ch +;
     PADR("PRINTER ZA NALOG KUHINJI    : "+NAL_printer_name ,65)              +" "+ " "   +ch +;
     PADR("PRINTER ZA FAKTURU KUPCU    : "+FAK_printer_name ,65)              +" "+ " "   +ch +;
     " "                                                                                  +ch +;
     PADR("MOD PRODAJE RAUNARA KASE   : "+cModRada         ,65)              +" "+ "DA"  +ch +;
     PADR("PRODAJA ARTIKALA BEZ ZALIHA : "+cModZaliha       ,65)              +" "+ "DA"  +ch +;
     PADR("UPIS KOLIINE POSLE SKENERA : "+cUpis_Kolicine   ,65)              +" "+ "DA"  +ch +;
     PADR("RAD SA EVIDENCIJOM KUPACA   : "+cRadSaKupcima    ,65)              +" "+ "DA"  +ch +;
     " "                                                                                  +ch +;
     PADR("LOKACIJA BAZE PODATAKA KASE : FIRMA-POSLOVNA-GODINA-PRODAJNIOBJEKAT  ",68)                   +ch +;
     PADR("_____________________________________________________________________",68)                   +ch +;
     PADR("LOKACIJA PRODAJNOG OBJEKTA  : "+cLokacija_Prijema1,68)                                        +ch +;
     PADR("                              "+cLokacija_Prijema2,68)                                        +ch +;
     PADR("GODINA PRODAJNOG OBJEKTA    : "+right(cLokacija_Prijema,4)+" (koristiti 2001 godinu)",68)    +ch +;
     PADR("IFRA PRODAJNOG OBJEKTA     : "+cObjekat_Kase    ,68)                                        +ch +;
     PADR("REDNI BROJ KASE U OBJEKTU   : "+cBroj_Kase       ,68)                                        +ch +;
     PADR("_____________________________________________________________________",68)                   +ch +;
     "  "

  * privremeno iskljueno, ali ne brisati ga odavde !!!

  * PADR("RAUN SE TAMPA PUN/ZBIRNO  : "+"Pun raun - svi artikli",65)      +" "+ IIF(nStampaRacunaUgostitelja=0,"DA","NE")+ ch +;
  * Ovaj upit postaviti posle klika na dugme za tampu rauna ugostitelja !!!

  *   " "                                                                                                + ch +;
  *   PADR("RAZMAK IZMEU DVA KASABLOKA : "+cPreskok_Redova  ,65)        +" "+ STR(Preskok_Redova,1,0)   + ch +;
  *   PADR("OTVARANJE FIOKE ZA NOVAC    : "+cFiokaPin        ,65)        +" "+ FiokaPin                  + ch +;
  *   PADR("TAMPANJE RAUNA-KASABLOKA  : "+cTipStampe       ,65)        +" "+ TipStampe                 + ch +;
  *   PADR("TAMPANJE RAUNA-KASABLOKA  : "+cTipRacuna       ,65)        +" "+ TipRacuna                 + ch +;
  *   "  "                                                                                               + ch +;


AlertBox(,cTxt,{"   OK   "},,;
"KASA::KONFIGURACIJA I PODEAVANJE KASE ZA RAD","V","B",,1)




ENDIF // IF poruka = 1

RETURN(nil)











*************************************************************
FUNCTION INI_otvori() // KASA.INI za citanje i upis
*************************************************************
    //------------------------------------------------------
      LOCAL aFileName := gde_exe()+"\KASA.INI"
      IF FILE(aFileName) = .F.
         c_greska("INI fajl"+chr(13)+chr(10)+;
                  aFileName +chr(13)+chr(10)+;
                  "NE POSTOJI.","CSYSTEMS.INI")
         RETURN(.F.)
      ENDIF
      IniFile := TIniFile():New(aFileName)  // INIFILES.PRG
    //------------------------------------------------------
RETURN(.T.)

*===================================================================================*
STATIC FUNCTION c_procitaj(poruka,naslov) // centrira tekst bez ikone
*===================================================================================*
DEFAULT naslov TO "PROCITAJ" ,;
        poruka TO "Pre starta operacije obavezno procitaj"+chr(13)+chr(10)+;
                  "______________________________________"
 confirmbox(,poruka,naslov,XBPMB_OK,;
 XBPMB_NOICON+XBPMB_APPMODAL+XBPMB_MOVEABLE)
RETURN(0)
*===================================================================================*
// KOMPATIBILNO SA CLIPPER 87 i BAZNE.LIB
STATIC FUNCTION c_greska(poruka,naslov)
*===================================================================================*
DEFAULT naslov TO "GRESKA" ,;
        poruka TO "Operacija nije uspela"
 confirmbox(,poruka,naslov,XBPMB_OK,;
 XBPMB_CRITICAL+XBPMB_APPMODAL+XBPMB_MOVEABLE)
RETURN(0)





















*######################################################################################################

FUNCTION RAD_SA_EVIDENCIJOM_KUPACA()

    * IF cRadSaKupcima == "rad sa kupcima iskljucen"
    *     Radsakupcima := 0
    * ELSE            //  "rad sa kupcima ukljucen"
    *     Radsakupcima := 1
    * ENDIF
*######################################################################################################

     LOCAL GetList := {}, oDlg, nT := 1 , aktivno := .F.
     PRIVATE IniFile // objekat
     IF INI_otvori(@IniFile) = .F.
        RETURN(.F.)
     ENDIF
     //----------------------------------------------------------------------------
        cRadSaKupcima := IniFile:ReadString("KASA_CFG", "cRadSaKupcima" )
     //----------------------------------------------------------------------------
     IF cRadSaKupcima == "rad sa kupcima iskljucen"
         nT := 1
     ELSE            //  "rad sa kupcima ukljucen"
         nT := 2
     ENDIF
     //----------------------------------------------------------------------------
       @ 0,1 DCSAY "RAD SA EVIDENCIJOM KUPACA"
       @ 1,1 DCSAY "Evidencija kupaca: Spisak svih Kupaca i Finansijski Raun za svakog Kupca"  SAYSIZE 0

       @ 2,1 DCRADIO nT PROMPT "&1. Voenje Evidencije i finansijske analitike Kupaca - iskljueno";
             VALUE 1 GROUP "RADIO1" ACCELKEY xbeK_ALT_1 GOTFOCUS {||TONE(2000)} WHEN {||.T.}
       @ 3,1 DCRADIO nT PROMPT "&2. Voenje Evidencije i finansijske analitike Kupaca - ukljueno";
             VALUE 2 GROUP "RADIO1" ACCELKEY xbeK_ALT_2 GOTFOCUS {||TONE(2000)} WHEN {||.T.}
     //----------------------------------------------------------------------------
       @ 5,01 DCPUSHBUTTON CAPTION "&Uputstvo" ACCELKEY xbeK_F1 ;
              SIZE 10,1.2 ACTION {||hlp_RadSaKupcima(),SetAppFocus(oDlg)}

       @ 5,11 DCPUSHBUTTON CAPTION "OK" ACCELKEY xbeK_ESC ;
              SIZE 10,1.2 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
     //----------------------------------------------------------------------------
     tone(100)
     DCGETOPTIONS NOMAXBUTTON NOMINBUTTON noescapekey
     DCREAD GUI OPTIONS GetOptions ENTEREXIT PARENT @oDlg MODAL ;
     FIT TITLE "PODEAVANJE KASE"

     IF nT = 1
      cRadSaKupcima := "rad sa kupcima iskljucen"
     ENDIF
     IF nT = 2
      cRadSaKupcima := "rad sa kupcima ukljucen"
     ENDIF
     //----------------------------------------------------------------------------
         IniFile:WriteString("KASA_CFG", "cRadSaKupcima", cRadSaKupcima )
         KASA_INI_UCITAJ()
     //----------------------------------------------------------------------------
     tone(100)
RETURN(.T.)
*******************************************************************************************************
STATIC FUNCTION hlp_RadSaKupcima()
*******************************************************************************************************
LOCAL ch := chr(59), cTxt
cTxt := ;
"RAD SA EVIDENCIJOM KUPACA" + ch +;
" "                           + ch +;
"Kupci se u raunarskoj kasi mogu voditi kao posebna evidencija to podrazumeva"+ ch +;
"formiranje REGISTRA KUPACA sa SPISKOM KUPACA i MATINIM PODACIMA kupaca,"      + ch +;
"zatim sa FINANSIJSKOM ANALITIKOM KARTICOM - RAUNOM za svakog kupca."         + ch +;
"Na ovaj nain moe se fiskalni iseak dat kupcu automatski knjiiti na raun"  + ch +;
"kupca, a uplata kupca moe se u bilo koje vreme runo upisati na isti raun,"  + ch +;
"ime se daje mogunost praenja rauna kupaca u sluaju prodaje sa odloenim"  + ch +;
"plaanjem ili prodaje 'na svesku' na odloene ekove i slino."                + ch +;
" "                           + ch +;
"Iz ove operacije ukljuuje se program kojim se moe formirati i odravati"  + ch +;
"opisana EVIDENCIJA KUPACA"    + ch +;
" "
c__procitaj(cTxt,"RAD SA EVIDENCIJOM KUPACA" )
CLEAR TYPEAHEAD
RETURN(nil)













*######################################################################################################

FUNCTION MOD_PRODAJE_RACUNARA_KASE()

     *IF cModRada == "trgovacki mod rada"
     *    ModRada := "1"
     *ELSE      //   "restoranski mod rada"
     *    ModRada := "2"
     *ENDIF
*######################################################################################################

     LOCAL GetList := {}, oDlg, nT := 1
     PRIVATE IniFile // objekat
     IF INI_otvori(@IniFile) = .F.
        RETURN(.F.)
     ENDIF
     //----------------------------------------------------------------------------
        cModRada := IniFile:ReadString("KASA_CFG", "cModRada" )
     //----------------------------------------------------------------------------
     IF cModRada == "trgovacki mod rada"
         nT := 1
     ELSE            //  "nema upisa kolicine posle skenera"
         nT := 2
     ENDIF
     //----------------------------------------------------------------------------
       izmena := .T.
       @ 0,1 DCSAY "MOD PRODAJE RAUNARA KASE"
       @ 1,1 DCSAY "Kasa radi na dva razliita naina, u dva moda rada:"  SAYSIZE 0

       @ 2,1 DCRADIO nT PROMPT "&1. Kasa radi u Trgovakom modu rada";
             VALUE 1 GROUP "RADIO1" ACCELKEY xbeK_ALT_1 GOTFOCUS {||TONE(2000)} EDITPROTECT {||!izmena}
       @ 3,1 DCRADIO nT PROMPT "&2. Kasa radi u Restoranskom modu rada";
             VALUE 2 GROUP "RADIO1" ACCELKEY xbeK_ALT_2 GOTFOCUS {||TONE(2000)} EDITPROTECT {||!izmena}
     //----------------------------------------------------------------------------
       @ 5,01 DCPUSHBUTTON CAPTION "&Uputstvo" ACCELKEY xbeK_F1 ;
              SIZE 10,1.2 ACTION {||hlp_ModRada(),SetAppFocus(oDlg)}

       @ 5,11 DCPUSHBUTTON CAPTION "OK" ACCELKEY xbeK_ESC ;
              SIZE 10,1.2 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
     //----------------------------------------------------------------------------
     tone(100)
     DCGETOPTIONS NOMAXBUTTON NOMINBUTTON noescapekey
     DCREAD GUI OPTIONS GetOptions ENTEREXIT PARENT @oDlg MODAL ;
     FIT TITLE "PODEAVANJE KASE"

     IF nT = 1
      cModRada := "trgovacki mod rada"
     ENDIF
     IF nT = 2
      cModRada := "restoranski mod rada"
     ENDIF
     //----------------------------------------------------------------------------
        IniFile:WriteString("KASA_CFG", "cModRada", cModRada )
        KASA_INI_UCITAJ()
     //----------------------------------------------------------------------------

RETURN(.T.)
*******************************************************************************************************
STATIC FUNCTION hlp_ModRada()
*******************************************************************************************************
LOCAL ch := chr(59), cTxt

izmena := .T.
//    tone(1000)
//    HDD    := PADR(VolSerial(),20)
//    sifra  := eUPIS0(HDD,"4. ifra za izmenu:")
//    nsifra := (VAL(substr(HDD,1,1)) + VAL(substr(HDD,2,1)) + VAL(substr(HDD,3,1)) + VAL(substr(HDD,4,1)))*4
//    csifra := ALLTRIM(STR(nsifra))
//    IF ALLTRIM(sifra)==ALLTRIM(csifra) .or. ALLTRIM(sifra) == "o"  //alt+1
//       izmena := .T.
//       tone(1000)
//    ELSE
//       izmena := .F.
//    ENDIF

cTxt := ;
"MOD PRODAJE RAUNARA KASE"   + ch +;
" "                           + ch +;
"Kod standardne prodaje artikala i usluga kupac na kasi dobija fiskalni iseak,"      + ch +;
"plati njegov iznos i izlazi iz prodajnog objekta. Ovaj nain rada ili mod rada"      + ch +;
"kase naziva se trgovaki mod rada."                                                  + ch +;
" "                                                                                   + ch +;
"Kod specifine prodaje, kao to je prodaja ugostiteljskih usluga u ugostiteljskom"   + ch +;
"objektu, kupac narui pie ili hranu, dobije to za svoj sto, uz to takoe dobije"    + ch +;
"nefiskalni iseak (privremeni raun). U kasi se formira broj stola tog kupca gde"    + ch +;
"se vri uvanje tog privremenog rauna kupca. Ovaj postupak moe se ponavljati a"    + ch +;
"svaka narudbina odnosno privremeni raun se registruju i uvaju na broju stola."    + ch +;
"Istovremeno posle svakog privremenog rauna moe se kao nefiskalni iseak tampati"  + ch +;
"NALOG KUHINJI i NALOG ANKU to raunar automatski deli prema artiklima upisanim"    + ch +;
"u nefiskalni iseak (privremeni raun). Nefiskalni iseci tampaju se na Windows"    + ch +;
"ili POS printeru."                                                                   + ch +;
"  "                                                                                  + ch +;
"Kada kupac (Gost) zatrai finalni raun, tada se iz fiskalnog ureaja, a iz podataka"+ ch +;
"sa broja stola kupca, tampa zbirni fiskalni iseak, a pre toga se moe tampati i"  + ch +;
"Raun-Faktura za kupca uz koju se prilae fiskalni iseak."                          + ch +;
"  "                                                                                  + ch +;
"Privremeni rauni za kupca mogu se neogranieno dugo uvati i aurirati na broju"    + ch +;
"stola kupca. Tek posle tampe zbirnog finalnog fiskalnog iseka, mogu se obrisati sa"+ ch +;
"broja stola, ime se ovaj broj stola oslobaa, ili se mogu prebaciti na bilo koji"   + ch +;
"drugi broj stola (od 1-100) i spojiti sa ve postojeim raunima na tom stolu, ime" + ch +;
"se dotad zauzeti broj stola oslobaa za rad, a raun kupca se moe dalje uvati. "   + ch +;
"  "                                                                                  + ch +;
"Ukljuivanje/Iskljuivanje Restoranskog i Trgovakog moda rada je iz ove operacije." + ch +;
" "
c__procitaj(cTxt,"MOD PRODAJE RAUNARA KASE" )
CLEAR TYPEAHEAD
RETURN(nil)








* 14-04-2016
*######################################################################################################

FUNCTION KASA_RACUNAR()

*######################################################################################################
/*
Koristi se samo iz programa kasa_dokumenta.exe
Ako u raunaru kasi u folderu baze podataka kase
postoji fajl:
               Kasaracunar

mogu se preuzeti Dokumenti iz knjigovodstva firme:
kalkulacije, nivelacije, interni rauni (prenosnice)
i mogu se ti Dokumenti prebaciti u raunar kasu.
Program kasa:dokumenta.exe na osnovu tog fajla zna da
se radi o raunaru kasi koji sme da preuzme dokumenta,
a ne o raunaru knjigovodstva koji ne sme da preuzme
dokumenta.
*/

     LOCAL GetList := {}, oDlg, nT := 1
     PRIVATE IniFile := gde_exe()+"\KASA.INI"
     //----------------------------------------------------------------------------
       DELETE FILE (gde_sam()+"\kasaracunar")

       nKasa_racunar := ;
       INI_READ("N","KASA_CFG","kasa_racunar",inifile)


     //----------------------------------------------------------------------------
     IF nKasa_racunar == 0
         nT := 0    // ne preuzimaj podatke iz knjigovodstva u kasu
     ELSE
         nT := 1    // preuzimaj podatke iz knjigovodstva u kasu
     ENDIF
     //----------------------------------------------------------------------------

       @ 0,1 DCSAY "PREUZIMANJE PODATAKA IZ KNJIGOVODSTVA U KASU"
       @ 1,1 DCSAY "Samo raunar kasa moe da preuzme podatke iz knjigovodstva"  SAYSIZE 0

       @ 2,1 DCRADIO nT PROMPT "&1. Ne preuzimaj podatke iz knjigovodstva u kasu";
             VALUE 0 GROUP "RADIO1" ACCELKEY xbeK_ALT_1 GOTFOCUS {||TONE(2000)}
       @ 3,1 DCRADIO nT PROMPT "&2. Preuzimaj podatke iz knjigovodstva u kasu" ;
             VALUE 1 GROUP "RADIO1" ACCELKEY xbeK_ALT_2 GOTFOCUS {||TONE(2000)}
     //----------------------------------------------------------------------------
       @ 5,01 DCPUSHBUTTON CAPTION "&Uputstvo" ACCELKEY xbeK_F1 ;
              SIZE 10,1.2 ACTION {||;
      c__procitaj(;
                  "Koristi se samo iz programa                          ;"+;
                  "               kasa_dokumenta.exe                    ;"+;
                  "kojim se vodi puno robno knjigovodstvo prodajnog     ;"+;
                  "objekta u kome je registar kasa, a koji podatke o    ;"+;
                  "artiklima preuzima iz raunara i iz programa za      ;"+;
                  "knjigovodstvo firme.                                 ;"+;
                  "Ako u raunaru kasi u folderu baze podataka kase     ;"+;
                  "postoji fajl:                                        ;"+;
                  "               Kasaracunar                           ;"+;
                  "mogu se preuzeti Dokumenti iz knjigovodstva firme:   ;"+;
                  "kalkulacije, nivelacije, interni rauni (prenosnice) ;"+;
                  "i mogu se ti Dokumenti prebaciti u raunar kasu.     ;"+;
                  "Program kasa_dokumenta.exe na osnovu tog fajla zna da;"+;
                  "se radi o raunaru kasi koji sme da preuzme dokumenta;"+;
                  "a ne o raunaru knjigovodstva koji ne sme da preuzme ;"+;
                  "dokumenta. Ovaj program formira ili brie taj fajl.  ",;
                  "PREUZIMANJE PODATAKA IZ KNJIGOVODSTVA U KASU",,"H","B")}

       @ 5,11 DCPUSHBUTTON CAPTION "OK" ACCELKEY xbeK_ESC ;
              SIZE 10,1.2 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
     //----------------------------------------------------------------------------
     tone(100)
     DCGETOPTIONS NOMAXBUTTON NOMINBUTTON noescapekey
     DCREAD GUI OPTIONS GetOptions ENTEREXIT PARENT @oDlg MODAL ;
     FIT TITLE "PREUZIMANJE PODATAKA IZ KNJIGOVODSTVA U KASU"

     IF nT = 0
      nKasa_racunar := 0
      DELETE FILE (gde_sam()+"\kasaracunar")
     ENDIF
     IF nT = 1
      nKasa_racunar := 1
      memowrit(gde_sam()+"\kasaracunar",dtoc(date())+" "+appname(.t.))
     ENDIF
     //----------------------------------------------------------------------------
        INI_WRITE("N","KASA_CFG", "kasa_racunar", nkasa_racunar ,IniFile )
        KASA_INI_UCITAJ()
     //----------------------------------------------------------------------------
RETURN(.T.)






* 14-04-2016
*######################################################################################################

FUNCTION KASA_DOKUMENTA_CFG()

*######################################################################################################
/*
  Ako u raunaru kasi u folderu programa u fajlu KASA.INI postoji
      [DOKUMENTA]
      dok_podesi=1
  tada se moe iz operacije menija [Podesi rad sa Dokumentima]
  izvriti podeavanje rada sa Dokumentima. Inae je to onemogueno.
*/


     LOCAL GetList := {}, oDlg, nT := 1
     PRIVATE IniFile := gde_exe()+"\KASA.INI"
     //----------------------------------------------------------------------------

       nDok_podesi := ;
       INI_READ("N","DOKUMENTA","dok_podesi",inifile)


     //----------------------------------------------------------------------------
     IF nDok_podesi == 0
         nT := 0    // ne mogu se podeavati opcije rada KASA_DOKUMENTA.EXE
     ELSE
         nT := 1    // mogu se podeavati opcije rada KASA_DOKUMENTA.EXE
     ENDIF
     //----------------------------------------------------------------------------

       @ 0,1 DCSAY "PODEAVANJE RADA SA DOKUMENTIMA KASE"
       @ 1,1 DCSAY "Operacija [Podesi rad sa dokumentima] je ukljuena/iskljuena"  SAYSIZE 0

       @ 2,1 DCRADIO nT PROMPT "&1. Iskljuena operacija: Podesi rad sa dokumentima kase";
             VALUE 0 GROUP "RADIO1" ACCELKEY xbeK_ALT_1 GOTFOCUS {||TONE(2000)}
       @ 3,1 DCRADIO nT PROMPT "&2. Ukljuena operacija: Podesi rad sa dokumentima kase" ;
             VALUE 1 GROUP "RADIO1" ACCELKEY xbeK_ALT_2 GOTFOCUS {||TONE(2000)}
     //----------------------------------------------------------------------------
       @ 5,01 DCPUSHBUTTON CAPTION "&Uputstvo" ACCELKEY xbeK_F1 ;
              SIZE 10,1.2 ACTION {||;
      c__procitaj(;
                  "Koristi se samo iz programa                          ;"+;
                  "               kasa_dokumenta.exe                    ;"+;
                  "kojim se vodi puno robno knjigovodstvo prodajnog     ;"+;
                  "objekta u kome je registar kasa, a koji podatke o    ;"+;
                  "artiklima preuzima iz raunara i iz programa za      ;"+;
                  "knjigovodstvo firme.                                 ;"+;
                  "                                                     ;"+;
                  "Rad sa dokumentima kase moe se podesiti na mod rada ;"+;
                  "koji je korisniku potreban, i u toku cele poslovne   ;"+;
                  "godine taj mod rada se ne sme menjati.               ;"+;
                  "                                                     ;"+;
                  "Iz tog razloga podeavanje rada sa dokumentima mora  ;"+;
                  "se obaviti paljivo i samo jednom. Ova operacija e  ;"+;
                  "ukljuiti mogunost za podeavanje, a posle izvrenog;"+;
                  "podeavanja treba tu mogunost ponovo iskljuiti.    ;"+;
                  "                                                     ",;
                  "PODEAVANJE RADA SA DOKUMENTIMA KASE",,"H","B")}

       @ 5,11 DCPUSHBUTTON CAPTION "OK" ACCELKEY xbeK_ESC ;
              SIZE 10,1.2 ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
     //----------------------------------------------------------------------------
     tone(100)
     DCGETOPTIONS NOMAXBUTTON NOMINBUTTON noescapekey
     DCREAD GUI OPTIONS GetOptions ENTEREXIT PARENT @oDlg MODAL ;
     FIT TITLE "PODEAVANJE RADA SA DOKUMENTIMA KASE"

     IF nT = 0
      nDok_podesi := 0

     ENDIF
     IF nT = 1
      nDok_podesi := 1

     ENDIF
     //----------------------------------------------------------------------------
        INI_WRITE("N","DOKUMENTA", "dok_podesi", nDok_podesi ,IniFile )
        KASA_INI_UCITAJ()
     //----------------------------------------------------------------------------
RETURN(.T.)









*** OVO JO UVEK KORISTE NEKI PROGRAMI, pa sam morao da ga preuzmem ovde
*** i ostavim samo jedan fajl: pattt := gde_tmp("4")   // 17-02-2022
#include "common.ch"
****************************************************************************

FUNCTION paket_fajl(bbbb) // samo formira PUBLIC nazive TMP fajlova

****************************************************************************

 * Deo programa iz modula FP2GALEB.PRG
 * Formira folder u kome se generisu fiskalni fajlovi:
 * BON_0000.DBF, TXT_0000.DBF, ART_0000.DBF, ART_0000.TXT
 * i path nazive ovih fajlova

     *************************************************************
     * UPOTREBA:
     // inicijalizuj paket - FORMIRAJ NAZIVE FISKALNIH FAJLOVA:
     // PUBLIC TO_FP := Gde_EXE()+"\FISKALNI"
     // PUBLIC paket := DB_adresa+"\"+NetName+"\"+ART_0000.DBF"
     // PUBLIC patxt := DB_adresa+"\"+NetName+"\"+ART_0000.TXT"
     // PUBLIC pabon := DB_adresa+"\"+NetName+"\"+BON_0000.DBF"
     // PUBLIC pattt := DB_adresa+"\"+NetName+"\"+TXT_0000.DBF"
     *************************************************************
     *  paket_fajl()
     *************************************************************


LOCAL nn, cccc

DEFAULT bbbb to 0   // broj fajla

//PUBLIC TO_FP := Gde_EXE()+"\FISKALNI",;  // zadrano zbog kompatibilnosti
//       paket, patxt, pabon, pattt
//



//     ** NOVI SISTEM U KLIJENTOVOM TMP FOLDERU NA SERVERU
//
//     cccc := STRZERO(bbbb,4)
//
//     paket := gde_tmp("1") // C:\CSYSTEMS\FIRME\FIRMA-01\2001\    KLIJENT1\__123456.TMP"
//     nn    := AT("\",paket)
//     paket := SUBSTR(paket,1,nn)+"ART_"+cccc+".DBF"        && "KLIJENT1\ART_0000.DBF
//
//     patxt := gde_tmp("2") // C:\CSYSTEMS\FIRME\FIRMA-01\2001\    KLIJENT1\__123456.TMP"
//     nn    := AT("\",patxt)
//     patxt := SUBSTR(patxt,1,nn)+"ART_"+cccc+".TXT"        && "KLIJENT1\ART_0000.TXT
//
//     pabon := gde_tmp("3") // C:\CSYSTEMS\FIRME\FIRMA-01\2001\    KLIJENT1\__123456.TMP"
//     nn    := AT("\",pabon)
//     pabon := SUBSTR(pabon,1,nn)+"BON_"+cccc+".DBF"        && "KLIJENT1\BON_0000.DBF
//
//     pattt := gde_tmp("4") // C:\CSYSTEMS\FIRME\FIRMA-01\2001\    KLIJENT1\__123456.TMP"
//     nn    := AT("\",pattt)
//     pattt := SUBSTR(pattt,1,nn)+"TXT_"+cccc+".DBF"        && "KLIJENT1\TXT_0000.DBF


  ********************************
    PUBLIC pattt := gde_tmp("4")      // 17-02-2022
  ********************************


   *  memowrit(pattt,"PATTT")
   *  msgbox(GDE_SAM()+"\"+paket+chr(13)+;
   *         GDE_SAM()+"\"+patxt+chr(13)+;
   *         GDE_SAM()+"\"+pabon+chr(13)+;
   *         GDE_SAM()+"\"+pattt+chr(13)+;
   *         "","test")



RETURN NIL


