//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __PLACANJE_NACIN_KUSUR.PRG
//                                                                      //
//   12-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////



/*

 __PLACANJE_NACIN_KUSUR.PRG

 30-05-2022 // izmenjeni nazivi naina plaanja
 28-01-2022
 14-01-2022

 ==================================================
 Program: __PLACANJE_NACIN_KUSUR.PRG
 KOMBINOVANO PLAANJE JEDNOG FISKALNOG RAUNA:
 GOTOVINA, EK, KARTICA, VAUER


 UREENJE RAUNA ZA PREGLED-TAMPU
 ---------------------------------
 FUNCTION zatvori_racun()
 poziv iz aplikacije - na poetku svake funkcije
 za pregled/tampu rauna


 VIESTRUKO (KOMBINOVANO) PLAANJE
 ---------------------------------
 FUNCTION visestruko_placanje()
 poziv iz aplikacije - komandno dugme

   FUNCTION uplate_obradi(GetList)
      FUNCTION TEST_VARIJABLI_PLACANJA(tit)
      FUNCTION OBRADA_VARIJABLI_PLACANJA()
   FUNCTION uplate_napravi(GetList)
   FUNCTION uplate_ponisti(GetList)
   FUNCTION uplate_vidi(1)


 JEDNOSTRUKO (PROSTO) PLAANJE
 --------------------------------------
 FUNCTION gotovinska___uplata()   // alt 1
 FUNCTION cekovna___uplata()      // alt 2
 FUNCTION kartica___uplata()      // alt 3
 FUNCTION virman___uplata()       // alt 4
 FUNCTION instant___uplata()      // alt 5
 FUNCTION vaucer___uplata()       // alt 6
 FUNCTION bezgotovine___uplata()  // alt 7

 ==================================================
 tekst mora biti izmeu dve crte od 50 znakova '='

*/



#include "Appevent.ch"
#include "Common.ch"
#include "xbp.ch"
#INCLUDE "DCDIALOG.CH"
#include "XBTSYS.CH"

// #include "Appbrow.ch"


*######################################################################## START
*
*             P L A  A N J E  V I  E S T R U K O
*         RAUN SE PLAA SA VIE RAZLIITIH NAINA PLAANJA
*         ZADAVANJE NAINA PLAANJA KOMANDNIM DUGMADIMA
*
*########################################################################



* [KOMANDNO DUGME]
* Poziva se iz programa PRODAJA_KOMANDNI_EKRAN.PRG
* DIALOG-BOX ZA IZBOR NAINA PLAANJA FISKALNOG RAUNA



*[KUPAC DAO IZNOSE] komandno dugme
***************************************************************************
*** FUNCTION visestruko_placanje() // napuni dbf polja
FUNCTION __placanje_nacin_kusur()
***************************************************************************
/*
  Poziva se iz programa PRODAJA_KOMANDNI_EKRAN.PRG
  Formira KARTICU-LISTU UPLATA za upis naina plaanja i uplaenih iznosa
  po upisanim nainima plaanja, za izraunavanje i prikaz kusura/doplate
  i za upis svih upisanih i sraunatih podataka u DBF za fiskalni raun.

* D O K U M E N T A C I J A
*
* IZNOSI ZA PLAANJE (koliina x cena) po stavkama rauna: VRED_MPR_
* IZNOSI POREZA na iznos VRED_MPR_ po stavkama rauna: PPOD_
* moraju da postoje pre ulaska u ovu funkciju kao iznosi upisani u DBF
* fiskalnog rauna i ovde se ti iznosi ne mogu menjati.
*
* Kupac moe svoj raun da plati sa vie naina na primer:
* GOTOVINA + EK + KARTICA i slino.
*
* viestruko plaanje moe se vriti upotrebom svih naina plaanja:
*
*                          GOTOVINA         G
*                          KARTICA          V
*                          EK              C
*                          VIRMAN - NALOG   N
*                          INSTANT          I
*                          VAUER           U
*                          BEZGOTOVINSKO    B
*                          AVANS            A
*
* Posle obrauna svih upisanih uplata koje je kupac dao mogu se desiti
* tri sluaja:
*                 - kupac je svojim uplatama zatvorio svoj raun
*                 - kupac je platio vie  - pa kasa ima povraaj KUSURA
*                 - kupac je platio manje - pa ima obavezu DOPLATE kasi
*
* Ovi sluajevi se prikazuju na kartici-listi uplata kao informacija kasiru
* kako bi mogao da na osnovu toga izvri eventualne korekcije uplata
*
* Napomena:
* Kasnije u postupku pripreme fiskalnog rauna za tampanje, svaka DOPLATA
* kupca (negativan iznos KUSURA) prepisuje se u polje za GOTOVINU: GOT_
* ime se uveava postojei iznos tog polja za iznos DOPLATA.
* Dakle na fiskalnom raunu moe se tampati naziv KUSUR i iznos kusura
* ali se nikada nee tampati naziv DOPLATA i iznos doplate. Ovaj naziv i
* iznos prikazuju se samo na kartici-listi uplata - za potrebe kasira
*
*/





   LOCAL radno := SELECT()
   LOCAL GetList := {},  GetOptions
   LOCAL lExit := .F., fokus := SetAppFocus(setAppWindow())
   LOCAL xx, mas

*================================================================
 LOCAL co0,co1,co2,co3,co4,of1,of2,of3,of4,aCUR,oCUR
 I2018(@co0,@co1,@co2,@co3,@co4,@of1,@of2,@of3,@of4,@aCUR,@oCUR)
*================================================================


* ---
* PRODAJA_KOMANDNI_EKRAN.PRG
IF da_li_racun_postoji()==.F.
   RETURN NIL
ENDIF
* ---



*------------------------------------------------ START
* V A R I J A B L E  P L A  A N J A:
*------------------------------------------------
PRIVATE    nRACUN,nPLATIO,nKUSUR,nDOPLATA,xFLAG
PRIVATE    nGOT,nCEK,nKAR,nNAL,nINS,nVAU,nBOT
STORE 0 TO nRACUN,nPLATIO,nKUSUR,nDOPLATA
STORE 0 TO nGOT,nCEK,nKAR,nNAL,nINS,nVAU,nBOT


// Preuzmi podatke iz fiskalnog rauna
SELECT "RACUN"
// VARIJABLE PLACANJA --- KOJE SE NE MOGU MENJATI (FIKSNE)
SUM ALL ;
    VRED_MPR_,;
    PPOD_ ;
    TO ;
    nRACUN,;// zbir rauna
    nPOREZ  // zbir poreza

GO TOP

// VARIJABLE PLACANJA --- KOJE SE MENJAJU U OVOJ FUNKCIJI

   nGOT   := GOT_   // gotovina
   nKAR   := KAR_   // kartica
   nCEK   := CEK_   // ek
   nNAL   := NAL_   // virman
   nVAU   := VAU_   // vauer
   nINS   := INS_   // instant
   nBOT   := BOT_   // bezgotovinski

   nAVA   := AVA_   // avans
   nAVP   := AVP_   // PDV na avans

   nUPLATA  := UPLATA_  // iznos koji kupac daje na kasi
   nKUSUR   := KUSUR_   // povraaj gotovine kupcu ili doplata kupca (minus)
   nDOPLATA := 0

   xFLAG := FLAG_ // G,V,C,N,U,I,B,A  // nain plaanja postavljen tasterom
                                     // pre ulaska u ovu funkciju. Default=G

   PRIVATE cKUSUR := "POVRAAJ:"

SELECT(radno)
***************************
OBRADA_VARIJABLI_PLACANJA()
***************************

                ***TEST_VARIJABLI_PLACANJA("ulaz u program")  // --- TEST
                ***CLEAR TYPEAHEAD

SELECT(radno)

*------------------------------------------------
* V A R I J A B L E  P L A  A N J A:
*------------------------------------------------ END









*********************************************** KARTICA-LISTA UPLATA *************************************************
mas := "9999999999.99"
xx:=1

   @ xx,1 DCSAY "RAUN"          SAYSIZE 0 SAYFONT of3 SAYCOLOR GRA_CLR_RED
   @ xx,15 DCGET nRACUN PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" EDITPROTECT {||.T.}

*---
jj:=0.3
xx:=xx+2.0
   @ xx+jj,1 DCSAY "Gotovina"      SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nGOT PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"G",o) }
xx:=xx+1.5
   @ xx+jj,1 DCSAY "Platna kartica"       SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nKAR PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"V",o) } ;
   WHEN {|| !tasteri_za_nacin_placanja }
xx:=xx+1.5
   @ xx+jj,1 DCSAY "ek"           SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nCEK PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"C",o) } ;
   WHEN {|| !tasteri_za_nacin_placanja }

xx:=xx+1.5
   @ xx+jj,1 DCSAY "Instant plaanje"       SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nINS PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"I",o) } ;
   WHEN {|| !tasteri_za_nacin_placanja }

xx:=xx+1.5
   @ xx+jj,1 DCSAY "Vauer"        SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nVAU PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"U",o) }

xx:=xx+1.5
  @ xx+jj,1 DCSAY "Prenos na raun"   SAYSIZE 0 SAYFONT of3
  @ xx,15 DCGET nNAL PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"N",o) }

xx:=xx+1.5
   @ xx+jj-0.6  ,1 DCSAY "Drugo"         SAYSIZE 0 SAYFONT of3
   @ xx+jj+0.2  ,1 DCSAY "bezgotovinsko" SAYSIZE 0 SAYFONT of3
   @ xx+jj+1    ,1 DCSAY "plaanje"      SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nBOT PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"B",o) }





xx:=xx+1.5 + 1
   @ xx+jj,1 DCSAY "AVANS"   SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nAVA PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"B",o) }

xx:=xx+1.5
   @ xx+jj,1 DCSAY "PDV NA AVANS"   SAYSIZE 0 SAYFONT of3
   @ xx,15 DCGET nAVP PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" LOSTFOCUS {|a,b,o| uplate_obradi(GetList,"B",o) }

*---

xx:=xx+2
   @ xx,1 DCSAY {|| cKUSUR }  SAYSIZE 10 SAYFONT of3 SAYCOLOR GRA_CLR_RED
   @ xx,15 DCGET nKUSUR PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" EDITPROTECT {||.T.}
xx:=xx+2



//xx:=xx+2
//   @ xx,1 DCSAY "KUSUR"          SAYSIZE 0 SAYFONT of3 SAYCOLOR GRA_CLR_RED
//   @ xx,15 DCGET nKUSUR PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" EDITPROTECT {||.T.}
//xx:=xx+1.5
//   @ xx,1 DCSAY "DOPLATA"        SAYSIZE 0 SAYFONT of3 SAYCOLOR GRA_CLR_RED
//   @ xx,15 DCGET nDOPLATA PICTURE mas GETSIZE 25,1.5 GETFONT "13.Verdana Bold" EDITPROTECT {||.T.}
//xx:=xx+2
*********************************************** KARTICA-LISTA UPLATA *************************************************






   @ xx,1 DCTOOLBAR oToolBar SIZE 40,3 BUTTONSIZE 40/3,3 FONT of3

   DCADDBUTTONXP CAPTION "OK;PRIHVATI" ;
               ACTION {|| uplate_napravi(GetList),;
                          DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ; // izlaz iz programa
               PARENT oToolBar ;
               CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 ;
               TOOLTIP ;
               "                                ;"+;
               " UPII U FISKALNI RAUN I IZAI ;"+;
               "                                 "
   DCADDBUTTONXP CAPTION "DEL;OBRII" ;   // VRAA NA ULAZNE PODATKE A OSTAJE U PROGRAMU
               ACCELKEY {xbeK_DEL} ;
               ACTION {|| uplate_ponisti(GetList)};
               PARENT oToolBar ;
               CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 ;
               TOOLTIP ;
               "                                  ;"+;
               " Obrii izmene i vrati na poetak ;"+;
               " pa nastavi sa izmenama podataka  ;"+;
               "                                   "


   DCADDBUTTONXP CAPTION "ESC;IZLAZ" ;    // VRAA NA ULAZNE PODATKE I IZLAZI IZ PROGRAMA
               ACCELKEY {xbeK_ESC} ;
               ACTION {|| uplate_napravi(GetList),;
               DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;  // izlaz iz programa
               PARENT oToolBar ;
               CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 ;
               TOOLTIP " Izlaz "
   /*
   DCADDBUTTONXP CAPTION "ESC;IZLAZ" ;    // VRAA NA ULAZNE PODATKE I IZLAZI IZ PROGRAMA
               ACCELKEY {xbeK_ESC} ;
               ACTION {|| uplate_ponisti(GetList), DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
               PARENT oToolBar ;
               CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 ;
               TOOLTIP ;
               "                                  ;"+;
               " Obrii izmene i vrati na poetak ;"+;
               " UPII U FISKALNI RAUN I IZAI   ;"+;
               "                                   "
    */



   DCGETOPTIONS NOTASKLIST GETFONT "10.Courier Bold" COLORGETS {{GRA_CLR_BLACK,GRA_CLR_YELLOW}} ;
   NOESCAPEKEY ;
   TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_YELLOW TOOLTIPFONT "10.Arial"

   DCREAD GUI ;
      TITLE "NAIN PLAANJA RAUNA" ;
      FIT ;
      MODAL ; //  ENTEREXIT ;
      OPTIONS GetOptions


* PRIVATE cKUSUR i nKUSUR dobijene ovde gore
 PUBLIC cccKUSUR := cKUSUR, nnnKUSUR := nKUSUR // ove dve varijable postavljaju se iz:
                                               // PRODAJA_KOMANDNI_EKRAN.PRG -> PUBLIC oPlatiObj



// zbog dve prostorije u restoranu
// mora da postoje dve aplikacije koje mogu istovremeno raditi
//                     C:\KASA1\KASA_UGOSTITELJ1.EXE ili KASA_U1.EXE
//                     C:\KASA2\KASA_UGOSTITELJ2.EXE ili KASA_U2.EXE
// svaka sa svojom bazom podataka
//                     C:\KASA1\FIRME\FIRMA-01\2001
//                     C:\KASA2\FIRME\FIRMA-01\2001


* IF APPNAME()="KASA_TOUCH.EXE" .OR. APPNAME()=="KASA_UGOSTITELJ.EXE"
IF APPNAME()="KASA_TOUCH.EXE" .OR. LEFT(APPNAME(),6)=="KASA_U"
   ****
ELSE
  DC_GetRefresh(oPlatiObj)
* oPlatiObj:setcaption(cKUSUR+"  "+var2char(nKUSUR))
ENDIF

SetAppFocus(fokus)
*** uplate_vidi(1)  // test
RETURN NIL

***************************************
FUNCTION TEST_VARIJABLI_PLACANJA(tit)
***************************************
/*

  Poziva se iz funkcija za kartice-liste uplata
  sa DCHOTKEY xbeK_F12 ili postavljanjem poziva
  ovoj funkciji u test takama prekida programa

  PRIKAZUJE TRENUTNO STANJE VARIJABLI PLAANJA
  KORISTI SE SAMO U TOKU RAZVOJA PROGRAMA
  KAO TEST ZA KONTROLU ISPRAVNOSTI RADA PROGRAMA

*/
msgbox(;
tit                            +chr(13)+;
" "                            +chr(13)+;
"gotovina = 	"	+var2char(nGOT)+chr(13)+;
"kartica  = 	"	+var2char(nKAR)+chr(13)+;
"ek      = 	"	+var2char(nCEK)+chr(13)+;
"virman   = 	"	+var2char(nNAL)+chr(13)+;
"instant  = 	"	+var2char(nINS)+chr(13)+;
"vauer   = 	"	+var2char(nVAU)+chr(13)+;
"bez got  = 	"	+var2char(nBOT)+chr(13)+;
"Avans    =     "       +var2char(nAVA)+chr(13)+;
"PDV Avans=     "       +var2char(nAVP)+chr(13)+;
"RAUN    = 	"	+var2char(nRACUN)+chr(13)+;
"UPLATA   = 	"	+var2char(nUPLATA)+chr(13)+;
"KUSUR    = 	"	+var2char(nKUSUR)+chr(13)+;
"",1)

CLEAR TYPEAHEAD
RETURN NIL

***************************************
FUNCTION OBRADA_VARIJABLI_PLACANJA()
***************************************
/*

  Poziva se iz funkcija za kartice-liste uplata:

  vri sraunavanje iznosa iz VARIJABLI PLAANJA
  i upis tih iznosa u VARIJABLE PLAANJA

*/

*---
* nRACUN := ABS(nRACUN)
* nPOREZ := ABS(nPOREZ)

* nGOT := ABS(nGOT)
* nKAR := ABS(nKAR)
* nCEK := ABS(nCEK)

* nNAL := ABS(nNAL)
* nINS := ABS(nINS)
* nVAU := ABS(nVAU)
* nBOT := ABS(nBOT)

* nAVA := ABS(nAVA)
* nAVP := ABS(nAVP)

* moda zbog povraaja koji treba da bude minus ?
* ne treba ii na ABS() funkciju. Videti to kasnije!
* ---

   nUPLATA := nGOT + nCEK + nKAR + nNAL + nINS + nVAU + nBOT //+ nAVA

   nKUSUR   := nRACUN - nUPLATA
   nDOPLATA := 0
   cKUSUR   := "POVRAAJ"
   IF nKUSUR > 0
     // nDOPLATA:=ABS(nKUSUR) // ne treba koristiti ovu varijablu !!!
     // treba koristiti nKUSUR sa znakom minus kod prikaza KUSR-DOPLATA
     // nKUSUR:=0  // nKUSUR SE NE SME STAVLJATI NA=0 AKO JE NEGATIVAN !!!
     cKUSUR := "DOPLATA"
   ENDIF

RETURN NIL


*[ GET LOSTFOCUS ]
***************************************************************************
STATIC FUNCTION uplate_obradi(GetList)
***************************************************************************
/*

  Poziva se iz kartice-liste uplata iz GET polja :
  vri sraunavanje iznosa iz VARIJABLI PLAANJA
  i upis tih iznosa u VARIJABLE PLAANJA

  VRI OSVEAVANJE PRIKAZA VARIJABLI PLAANJA U KARTICI-LISTI UPLATA

*/
LOCAL radno := SELECT()

***************************
OBRADA_VARIJABLI_PLACANJA()
***************************
Dc_GetRefresh(GetList)


 ***TEST_VARIJABLI_PLACANJA("uplate_obradi()") // --- TEST
 ***CLEAR TYPEAHEAD

SELECT(radno)
RETURN NIL  // ------ POVRATAK U PROGRAM I PRIKAZ REZULTATA






* [OK]
***************************************************************************
STATIC FUNCTION uplate_napravi(GetList)
***************************************************************************
LOCAL radno:=SELECT()
/*

  Poziva se iz kartice-liste uplata :

  U kartici-listi uplata vri se upis uplata i sraunavanje kusura/doplate
  samo u VARIJABLAMA PLAANJA koje se na kraju posla na izlazu iz ove
  kartice-liste upisuju u sve stavke fiskalnog rauna iz ove funkcije

*/
 ***TEST_VARIJABLI_PLACANJA("uplate_napravi()")
 ***CLEAR TYPEAHEAD

***************
SELECT "RACUN"
***************
SUM ALL VRED_MPR_ TO VRED_MPR
GO TOP
DO WHILE .NOT. EOF()

   REPLACE ;
   RACUN_  WITH VRED_MPR // nRACUN

   REPLACE ;
   GOT_ WITH nGOT ,;
   KAR_ WITH nKAR ,;
   CEK_ WITH nCEK ,;
   NAL_ WITH nNAL ,;
   INS_ WITH nINS ,;
   VAU_ WITH nVAU ,;
   BOT_ WITH nBOT ,;
   AVA_ WITH nAVA ,;
   AVP_ WITH nAVP ,;
   UPLATA_ WITH nGOT+nKAR+nCEK+nNAL+nINS+nVAU+nBOT,; // nUPLATA
   KUSUR_  WITH RACUN_ - UPLATA_ // nKUSUR

SKIP
ENDDO
GO TOP
**************
SELECT(radno)
**************

//Dc_GetRefresh(GetList)

RETURN NIL // ------ IZLAZ IZ PROGRAMA











***************************************************************************
STATIC FUNCTION uplate_ponisti(GetList)
***************************************************************************
/*

  Poziva se iz kartice-liste uplata:

  Da se ne bi u kartici-listi uplata brisala jedna-po-jedna uplata
  ovde se automatski ponitavaju sve upisane uplate.

  Ponitavaju se sve upisane uplate u karticu-listu uplata
  i postavlja se ZADATA uplata u sa kojom se ulo u ovu funkciju
                          GOTOVINA         G
                          KARTICA          V
                          EK              C
                          VIRMAN - NALOG   N
                          INSTANT          I
                          VAUER           U
                          BEZGOTOVINSKO    B
                          AVANS            A
  bez kusura i bez doplate

  Posle poziva ovoj funkciji iz funkcije visestruko_placanje():

   - sa tasterom DEL: sve upisano se poniti - postavi se ZADATA uplata
                      program se vraa u karticu-listu i nastavlja rad

   - sa tasterom ESC: sve upisano se poniti - postavi se ZADATA uplata
                      program izlazi iz kartice-liste i nastavlja rad

*/

LOCAL radno := SELECT()

// postavi VARIJABLE PLAANJA na = 0
STORE 0 TO nUPLATA, nKUSUR, nDOPLATA
STORE 0 TO nGOT, nCEK, nKAR, nNAL, nINS, nVAU, nBOT , nAVA, nAVP


* FUNCTION gotovinska___uplata()   // alt 1
* FUNCTION cekovna___uplata()      // alt 2
* FUNCTION kartica___uplata()      // alt 3
* FUNCTION virman___uplata()       // alt 4
* FUNCTION instant___uplata()      // alt 5
* FUNCTION vaucer___uplata()       // alt 6
* FUNCTION bezgotovine___uplata()  // alt 7
* FUNCTION avansna___uplata()  // alt 7


IF xFLAG="G"
// zadaj uplatu u GOTOVINI
**********************
gotovinska___uplata()  // alt 1
**********************
ENDIF
IF xFLAG="V"
**********************
kartica___uplata()     // alt 1
**********************
ENDIF
IF xFLAG="C"
**********************
cekovna___uplata()     // alt 1
**********************
ENDIF
IF xFLAG="N"
**********************
virman___uplata()      // alt 1
**********************
ENDIF
IF xFLAG="U"
**********************
vaucer___uplata()      // alt 1
**********************
ENDIF
IF xFLAG="I"
**********************
instant___uplata()     // alt 1
**********************
ENDIF
IF xFLAG="B"
**********************
bezgotovine___uplata() // alt 1
**********************
ENDIF
IF xFLAG="A"
**********************
avansna___uplata() // alt 1
**********************
ENDIF

IF AT(xFLAG,"G,V,C,N,U,I,B,A")==0  // ako je oteen FLAG_
// zadaj uplatu u GOTOVINI
**********************
gotovinska___uplata()  // alt 1
**********************
ENDIF



*************** ponaamo se kao na startu programa
// Preuzmi podatke iz fiskalnog rauna
SELECT "RACUN"
// VARIJABLE PLACANJA --- KOJE SE NE MOGU MENJATI (FIKSNE)
SUM ALL ;
    VRED_MPR_,;
    PPOD_ ;
    TO ;
    nRACUN,;// zbir rauna
    nPOREZ  // zbir poreza

GO TOP
SELECT(radno)

// VARIJABLE PLACANJA --- KOJE SE MENJAJU U OVOJ FUNKCIJI

   nGOT   := GOT_   // gotovina
   nKAR   := KAR_   // kartica
   nCEK   := CEK_   // ek
   nNAL   := NAL_   // virman
   nVAU   := VAU_   // vauer
   nINS   := INS_   // instant
   nBOT   := BOT_   // bezgotovinski

   nAVA   := AVA_   // avans
   nAVP   := AVP_   // porez na avans


   nUPLATA  := UPLATA_  // iznos koji kupac daje na kasi
   nKUSUR   := KUSUR_   // povraaj gotovine kupcu ili doplata kupca (minus)
   nDOPLATA := 0

****************************
OBRADA_VARIJABLI_PLACANJA()
****************************

*************** ponaamo se kao na startu programa

Dc_GetRefresh(GetList)


SELECT(radno)
RETURN NIL // ------ POVRATAK U PROGRAM I PRIKAZ REZULTATA















*[SPACE] taster na tastaturi
***************************************************************************
FUNCTION uplate_vidi(nn)
***************************************************************************
* nn=0 nema prikaza izvetaja, ili nn=1 prikaz izvetaja

// Poziv iz aplikacije: PRODAJA_KOMANDNI_EKRAN.PRG
//
// uitavanje uplata iz fiskalnog rauna u niz, vraanje niza
// u program i ako je parametar nn=1 prikaz uplata u dialog box-u

LOCAL radno:=SELECT()
LOCAL naziv_fajla := "", maska := "999,999,999,999.99"
LOCAL;
  nGOT := 0 ,;
  nCEK := 0 ,;
  nKAR := 0 ,;
  nNAL := 0 ,;
  nINS := 0 ,;
  nVAU := 0 ,;
  nBOT := 0 ,;
  nAVA := 0 ,;
  nAVP := 0 ,;
  nRACUN  := 0 ,;
  nUPLATA := 0 ,;
  nKUSUR  := 0

LOCAL;
MAGS := "" ,;   // MAGS_ ,; // broj prodajnog objekta
OPST := "" ,;   // OPST_    // broj kase u firmi
BRJ0 := "" ,;
DAT0 := CTOD("  .  .  ")


DEFAULT nn TO 0


***************
zatvori_racun()  // uredi raun i zatvori raun za slanje u tampu // ovde
***************




// uzmi broj fiskalnog iseka iz otvorenog rauna za kupca RACUN
***************
SELECT "RACUN"
***************
GO TOP
  nGOT := GOT_
  nCEK := CEK_
  nKAR := KAR_
  nNAL := NAL_
  nINS := INS_
  nVAU := VAU_
  nBOT := BOT_
  nAVA := AVA_
  nAVP := AVP_
  nRACUN  := RACUN_
  nUPLATA := UPLATA_
  nKUSUR  := KUSUR_


  KSIR := alltrim(KSIR_)    // ifra kasira
  MAGS := MAG // alltrim(MAGS_)    // broj prodajnog objekta  // PUBLIC MAG  KASA.INI
  OPST := KAS // alltrim(OPST_)    // broj kase u firmi       // PUBLIC KAS  KASA.INI
  BRJ0 := BRJ0_
  DAT0 := DAT0_

  OKK := MAGS+"-"+OPST+"-"+KSIR

  cKUSUR := "Povraaj kupcu....."+transform(ABS(nKUSUR),maska)
  IF nKUSUR > 0
  cKUSUR := "Doplata kupca......"+transform(ABS(nKUSUR),maska)
  ENDIF


SELECT(radno)



IF nn==1


   c__procitaj(;
   "Objekat/Kasa/Kasir "+PADR(OKK,18)              +chr(59)+;
   "Broj kasabloka....."+BRJ0                      +chr(59)+;
   "-------------------"+"------------------"      +chr(59)+;
   "Gotovina CASH......"+transform(nGOT,maska)     +chr(59)+;
   "ek CHECK.........."+transform(nCEK,maska)     +chr(59)+;
   "Kartica CARD......."+transform(nKAR,maska)     +chr(59)+;
   "Virman............."+transform(nNAL,maska)     +chr(59)+;
   "Instant............"+transform(nINS,maska)     +chr(59)+;
   "Vauer............."+transform(nVAU,maska)     +chr(59)+;
   "Bezgotovinski......"+transform(nBOT,maska)     +chr(59)+;
   "Avans.............."+transform(nAVA,maska)     +chr(59)+;
   "PDV za avans......."+transform(nAVP,maska)     +chr(59)+;
   "-------------------"+"------------------"      +chr(59)+;
   "Iznos Rauna......."+transform(nRACUN,maska)   +chr(59)+;
   "Ukupno plaeno....."+transform(nUPLATA,maska)  +chr(59)+;
   cKUSUR                                          +chr(59)+;
   "","NAIN PLAANJA RAUNA",,"V","R")

ENDIF


*** RETURN {OPST,BRJ0,nRACUN,nGOT,nCEK,nKAR,nNAL,nINS,nVAU,nBOT} // STARO
RETURN {MAGS,OPST,BRJ0,DAT0,nRACUN,nUPLATA,nKUSUR,nGOT,nCEK,nKAR,nNAL,nINS,nVAU,nBOT}








***************************************************************************
FUNCTION zatvori_racun()
***************************************************************************
/*

   OVA FUNKCIJA SE OBAVEZNO POZIVA IZ APLIKACIJE UVEK PRE NEGO TO SE
   ==================================================================
   FISKALNI RAUN POALJE NA PREGLED ILI NA TAMPU
   ==================================================================

   kada se otvori nov fiskalni raun, kada se doda prva stavka u raun
   iz funkcije: RACUN_FORMIRAJ_STAVKU(nKolicina,GetList)
   iz programa: __RACUN_FORMIRAJ_STAVKU.PRG

   inicijalno se prva stavka oznai kao FLAG_="G" GOTOVINA
   ali se ukupan iznos gotovine plaen po raunu ne upie u polje GOT_
   jer se stavke MORAJU SABRATI SAMO NA ZAVRETKU RAUNA ime se
   dobije zbirni iznos svih stavki - iznos gotovine za raun: za polje GOT_

   Upis druge, tree, etvrte... stavke u raun takoe nee zbir rauna
   upisati u GOT_ i druga polja za druge zbirove NEE upisati u POLJA ZA
   ZBIROVE kod svake stavke - to se mora uraditi !!!
   Bie samo u svaku stavku rauna upisani iznosi:

                     VRED_MPR_
                     PPOD_

   Takav fiskalni raun (DBF fajl) nije upotrebljiv za tampu rauna

   Da bi se raun ispravno tampao iz funkcija za pripremu tampe i tampu:

     __napravi_fiskalniracun_zastampu.prg
     __napravi_fiskalniracun_zastampu_txt.prg

   on mora da ima sve potrebne podatke upisane u POLJA ZA ZBIROVE :

   GOT_
   KAR_
   CEK_
   NAL_
   VAU_
   INS_
   BOT_

   AVA_
   AVP_

   RACUN_
   UPLATA_
   KUSUR_
   POREZ_

   Dakle, pre svake tampe rauna, a to se smatra ZAVRETKOM RAUNA,
   vri se provera rauna i ako raun nema upisane ove podatke,
   to znai da nije prethodno aktivirana ni jedna od funkcija
   za jednostruko plaanje:

              FUNCTION gotovinska___uplata()   // alt 1
              FUNCTION cekovna___uplata()      // alt 2
              FUNCTION kartica___uplata()      // alt 3
              FUNCTION virman___uplata()       // alt 4
              FUNCTION instant___uplata()      // alt 5
              FUNCTION vaucer___uplata()       // alt 6
              FUNCTION bezgotovine___uplata()  // alt 7

              FUNCTION avansna___uplata()        // alt 7

   ili nije aktivirana funkcija za viestruko plaanje:

              __placanje_nacin_kusur()   // __PLACANJE_NACIN_KUSUR.PRG

   pa ovi iznosi nisu upisani, jer iz tih funkcija se upisuju
   svi gore navedeni iznosi u navedena zbirna polja za raun,
   vri se tada upis ovih podataka u DBF rauna iz ove funkcije
   tako to se podaci postavljaju na default PLAANJE GOTOVINOM
   za IZNOS RAUNA bez KUSURA i bez DOPLATE

   Ovo se moe proveriti (testirati) funkcijom

              uplate_vidi(1)  // __PLACANJE_NACIN_KUSUR.PRG

   posle dodavanja tri do etiri stavke u novi raun

*/



LOCAL radno:=SELECT()

SELECT "RACUN"
GO TOP

   nRACUN := RACUN_

   nGOT   := GOT_   // gotovina
   nKAR   := KAR_   // kartica
   nCEK   := CEK_   // ek
   nNAL   := NAL_   // virman
   nVAU   := VAU_   // vauer
   nINS   := INS_   // instant
   nBOT   := BOT_   // bezgotovinski


   nAVA   := AVA_   // avans
   nAVP   := AVP_   // porez na avans

   nUPLATA  := UPLATA_  // iznos koji kupac daje na kasi
   nKUSUR   := KUSUR_   // povraaj gotovine kupcu ili doplata kupca (minus)
   nDOPLATA := 0



SELECT(radno)


   // VARIJABLE PLAANJA
   nUPLATA := nGOT + nCEK + nKAR + nNAL + nINS + nVAU + nBOT // + nAVA

   IF nUPLATA == 0

        // nisu upisane VARIJABLE PLAANJA
        // postavi plaanje na default GOTOVINA
        // kao da si kliknuo na dugme GOTOVINA

        **********************
        gotovinska___uplata()   // alt 1
        **********************

   ENDIF


   // U ovoj taki programa imamo:
   // Upisane su sve VARIJABLE PLAANJA
   // ali ako je neka oteena ponovi njihov obraun
   // i upis u DBF fiskalnog rauna


   // VARIJABLE PLACANJA --- KOJE SE NE MOGU MENJATI (FIKSNE)
   SELECT "RACUN"
   SUM ALL ;
       VRED_MPR_,;
       PPOD_ ;
       TO ;
       nRACUN,;// zbir rauna
       nPOREZ  // zbir poreza

   GO TOP

//--------------------------------- obraun
   nKUSUR   := nRACUN - nUPLATA
// OVDE OVO NE TREBA - OVO TREBA SAMO ZBOG PRIKAZA KUSR-DOPLATA
// nKUSUR SE NE SME STAVLJATI NA = 0 !!!
//   nDOPLATA := 0
//   IF nKUSUR > 0
//      nDOPLATA:=ABS(nKUSUR)
//      nKUSUR:=0
//   ENDIF
//--------------------------------- obraun

   GO TOP
   DO WHILE .NOT. EOF()
      REPLACE RACUN_  WITH nRACUN  ,;
              UPLATA_ WITH nUPLATA ,;
              KUSUR_  WITH nKUSUR
          *** POREZ_  WITH nPOREZ // ne postoji polje POREZ_

   SKIP
   ENDDO
   SELECT(radno)


RETURN NIL


*########################################################################
*
*             P L A  A N J E  V I  E S T R U K O
*         RAUN SE PLAA SA VIE RAZLIITIH NAINA PLAANJA
*         ZADAVANJE NAINA PLAANJA KOMANDNIM DUGMADIMA
*
*########################################################################  END








* 27-01-2022
*########################################################################  START
*
*             P L A  A N J E  J E D N O S T R U K O
*         RAUN SE PLAA SAMO SA JEDNIM NAINOM PLAANJA
*         ZADAVANJE NAINA PLAANJA KOMANDNIM DUGMADIMA
*
*########################################################################
* D O K U M E N T A C I J A
*
* FUNCTION gotovinska___uplata()   // alt 1
* FUNCTION cekovna___uplata()      // alt 2
* FUNCTION kartica___uplata()      // alt 3
* FUNCTION virman___uplata()       // alt 4
* FUNCTION instant___uplata()      // alt 5
* FUNCTION vaucer___uplata()       // alt 6
* FUNCTION bezgotovine___uplata()  // alt 7
* FUNCTION avansna___uplata()      // alt 7
*
* Ove funkcije pozivaju se iz PRODAJA_KOMANDNI_EKRAN.PRG
*
* ZADAVANJE NAINA PLAANJA KOMANDNIM DUGMETOM IZ MODA PRODAJE
* PROMENA ISPISA ZA NAIN PLAANJA I KUSUR NA DISPLEJU KASE
*
* Zadaje se jedan od naina plaanja koji vai za ceo fiskalni raun:
*--------------------------------------------------------------------
* Naziv naina     DBF polje  DBF Polje
* plaanja         FLAG_      KBON_xx.DBF
*
* GOTOVINA    ------ G ------ GOT_
* KARTICA     ------ V ------ KAR_
* EK         ------ C ------ CEK_
* VIRMAN      ------ N ------ NAL_
* VAUER      ------ U ------ VAU_
* INSTANT     ------ I ------ INS_
* BEZGOTOVINE ------ B ------ BOT_
*
*
* R E Z U L T A T:
*-------------------
* Ako se klikne na [KARTICA]
* - izvri se sabiranje VRED_MPR_ i PPOD_ za ceo fiskalni raun
* - u sve stavke na fiskalnom raunu sa REPLACE ALL upiu se polja:
*
*   FLAG_   WITH "V",;    //------ uplata karticom
*   RACUN_  WITH nRACUN,; //------ iznos fiskalnog rauna
*   UPLATA_ WITH nRACUN,; //------ iznos koji je kupac dao kasiru
*   KUSUR_  WITH 0,;      //------ povraaj kusura kupcu
*   GOT_ WITH 0,;
*   KAR_ WITH nRACUN,;    //------- iznos koji je kupac uplatio karticom
*   CEK_ WITH 0,;         //        SVI OSTALI IZNOSI STAVLJAJU SE NA = 0
*   NAL_ WITH 0,;
*   VAU_ WITH 0,;
*   INS  WITH 0,;
*   BOT_ WITH 0,;
*   AVA_ WITH 0,;
*   AVP_ WITH 0
*
* Sve isto se deava kada se klikne na bilo koje komandno dugme:
* GOTOVINA, KARTICA, EK, VIRMAN, VAUER, INSTANT, BEZ GOTOVINE
*
* Odmah se u fiskalni raun upisuje da je kupac platio ukupan iznos
* rauna tim nainom plaanja da nema ni kusur ni doplatu, pa se
* taj raun moe odmah tampati bez upisa dodatnih podataka o plaanju
*


*{ "FLAG_"     ,"C",    1, 0},;  //  oznaka za nain plaanja G,C,V,N,I,U,B
*{ "FLAG_IME_" ,"C",   30, 0},;  //  naziv za nain plaanja GOTOVINA,CEK,KARTICA,VIRMAN,INSTANT,VAUER,BEZ GOTOVINE


*[GOTOVINA] PRODAJA_KOMANDNI_EKRAN.PRG
***************************************************************************
FUNCTION gotovinska___uplata() // alt 1
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='G',
FLAG_IME_='GOTOVINA',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=&cRACUN,
KAR_=0,
CEK_=0,
NAL_=0,
VAU_=0,
INS_=0,
BOT_=0,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL



*[EK] PRODAJA_KOMANDNI_EKRAN.PRG
***************************************************************************
FUNCTION cekovna___uplata() // alt 2
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='C',
FLAG_IME_='EK',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=0,
CEK_=&cRACUN,
NAL_=0,
VAU_=0,
INS_=0,
BOT_=0,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL






*[KARTICA] PRODAJA_KOMANDNI_EKRAN.PRG
***************************************************************************
FUNCTION kartica___uplata()  // alt 3
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='V',
FLAG_IME_='KARTICA',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=&cRACUN,
CEK_=0,
NAL_=0,
VAU_=0,
INS_=0,
BOT_=0,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL









*[VIRMAN] PRODAJA_KOMANDNI_EKRAN.PRG
*************************************************************************** 13-01-2022
FUNCTION virman___uplata()  // alt 4
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='N',
FLAG_IME_='PRENOS NA RAUN',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=0,
CEK_=0,
NAL_=&cRACUN,
VAU_=0,
INS_=0,
BOT_=0,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL





*[INSTANT] PRODAJA_KOMANDNI_EKRAN.PRG
*************************************************************************** 13-01-2022
FUNCTION instant___uplata()  // alt 5
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='I',
FLAG_IME_='INSTANT',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=0,
CEK_=0,
NAL_=0,
VAU_=0,
INS_=&cRACUN,
BOT_=0,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL








*[VAUER] PRODAJA_KOMANDNI_EKRAN.PRG
*************************************************************************** 13-01-2022
FUNCTION vaucer___uplata()  // alt 6
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='U',
FLAG_IME_='VAUER',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=0,
CEK_=0,
NAL_=0,
VAU_=&cRACUN,
INS_=0,
BOT_=0,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL





*[BEZGOTOVINE] PRODAJA_KOMANDNI_EKRAN.PRG
*************************************************************************** 13-01-2022
FUNCTION bezgotovine___uplata()  // alt 7
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='B',
FLAG_IME_='BEZGOTOVINSKI',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=0,
CEK_=0,
NAL_=0,
VAU_=0,
INS_=0,
BOT_=&cRACUN,
AVA_=0,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL






*[AVANSNA] PRODAJA_KOMANDNI_EKRAN.PRG
*************************************************************************** 13-01-2022
FUNCTION avansna___uplata()  // alt 7
***************************************************************************
LOCAL radno:=SELECT()
*************
SELECT "STO"
*************
IF reccount()=0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   return nil
ENDIF
PRIVATE nRACUN,nPOREZ,cRACUN,cPOREZ,cSQL,oStmt
SUM ALL VRED_MPR_, PPOD_  TO nRACUN, nPOREZ
cRACUN:=var2char(nRACUN)
cPOREZ:=var2char(nPOREZ)
TEXT INTO cSQL WRAP
UPDATE &_shetab_
SET
FLAG_='A',
FLAG_IME_='AVANS',
RACUN_=&cRACUN,
UPLATA_=&cRACUN,
KUSUR_=0,
GOT_=0,
KAR_=0,
CEK_=0,
NAL_=0,
VAU_=0,
INS_=0,
BOT_=0,
AVA_=&cRACUN,
AVP_=0;
ENDTEXT
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
* oBrowse5:refreshall()
GO TOP
PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5)
SELECT(radno)
RETURN NIL




*************************************************************************
FUNCTION da_li_racun_postoji()
*************************************************************************
* koristi se pre poziva svake funkcije koja menja sadraj rauna
*     FUNCTION Vrsta_Racuna_Transakcija()
*     FUNCTION Kasir_Kupac_Veza()
*     FUNCTION __placanje_nacin_kusur()
* FUNCTION gotovinska___uplata()   // alt 1
* FUNCTION cekovna___uplata()      // alt 2
* FUNCTION kartica___uplata()      // alt 3
* FUNCTION virman___uplata()       // alt 4
* FUNCTION instant___uplata()      // alt 5
* FUNCTION vaucer___uplata()       // alt 6
* FUNCTION bezgotovine___uplata()  // alt 7
* FUNCTION avansna___uplata()      // alt 7
*
* Upotreba:
* IF da_li_racun_postoji()==.F.
*    RETURN NIL
* ENDIF

LOCAL radno:=SELECT() // SELECT "RACUN"
LOCAL bb:=0, lRet := .F. , brojac:=0
* ---
* Ako je raun za kupca KASA_BON SELECT "RACUN" prazan (nema slogove)
* ne mogu se postaviti podaci KASA-KUPAC-VEZA jer se nemaju gde upisati


/*
* --- 26-07-2023 EXTRA BUG
*
* Kada se ova funkcija pozivala iz KASA_UGOSTITELJ.EXE preko funkcija:
*     RACUN_TO_FISKALNI(oBrowse5) - 4_KASA_tach_buttons_stolovi_racuni.prg
*        __BON_FISKALNI_PRINTERI_IZBOR("FISKALNI") - 4_KASA_tach_buttons_stolovi_racuni_stampe.prg
*              FISKALNI__1() - FISKALNI_1.PRG
*                da_li_racun_postoji()  - 11_KASA__PRODAJA\KASA_VRSTA_UPLATE\__PLACANJE_NACIN_KUSUR.PRG
* OVAJ KOD DOLE NIJE FUNKCIONISAO JER DBF SELECT "STO" JE UVEK BIO RECCOUNT()=0 ???
* I APPBROWSE DAJE PRAZAN DBF FAJL ???  I AKO BI PO SVIM PRAVILIMA MORAO DA IMA RECCOUNT()>0
* NISAM USPEO DA REIM REBUS ALI OVAJ KOD I NE TREBA JER OVDE SE UVEK ULAZI SAMO IZ SELECT "RACUN"
* Ova funkcija ne poziva se nigde iz KASA_UGOSTITELJ.EXE ve se poziva preko gore datih funkcija.
* pokuaj reavanja je ovde na kraju u test_()
*                                      -------
* stop(1,c_dbfname(),ALIAS(),brojac,5)
* IF LEFT(APPNAME(),6)=="KASA_U"
*   SELECT "STO"
* ELSE
*   SELECT "RACUN"
* ENDIF
* brojac:=reccount()
* APPBROWSE
* APPDISPLAY
* stop(2,c_dbfname(),ALIAS(),brojac,5)
*
* Ovo se i sada moe testirati u programu KASA_UGOSTITELJ.EXE
* aktivni selektovani sto SELECT "STO" i pored toga to ima stavke rauna
* ovde e prijaviti reccount()=0 i appbrowse bez stavki rauna ???
*
* --- 26-07-2023 EXTRA BUG
*/


brojac:=reccount()
GO TOP // idi na prvi slog
SELECT(radno)
* ---
IF brojac==0
   C__GRESKA("Prvo dodaj artikal u RAUN za kupca" + chr(59)+;
             "First add article to BILL for buyer","1.STOP",,"G3")
   RETURN .F.
ENDIF
* ---
RETURN .T.

*########################################################################
*
*             P L A  A N J E  J E D N O S T R U K O
*         RAUN SE PLAA SAMO SA JEDNIM NAINOM PLAANJA
*         ZADAVANJE NAINA PLAANJA KOMANDNIM DUGMADIMA
*
*########################################################################  END




/*
* --- 26-07-2023 EXTRA BUG
* na startu main() pozovi uvu funkciju
* test_()
* quit
**************************************************************************
FUNCTION test_()
**************************************************************************
   LOCAL radno:=SELECT()

   dbfsto:=gde_sam()+"\STOLOVI\X24.STO"
   dbfracun:=gde_sam()+"\RACUN.DBF"
   USE (dbfsto) new exclusive alias "STO"
   COPY ALL TO (dbfracun)
   USE (dbfracun) new exclusive alias "RACUN"
   GO TOP
      test_test_()
   SELECT "RACUN"
   USE
   SELECT "STO"
   USE

   SELECT(radno)
RETURN NIL

FUNCTION test_test_()
   test_test_test_()
RETURN NIL

FUNCTION test_test_test_()

   IF LEFT(APPNAME(),6)=="KASA_U"
      SELECT "STO"
   ELSE
      SELECT "RACUN"
   ENDIF

   GO TOP
   APPBROWSE
   APPDISPLAY
   brojac:=reccount()
   stop(2,c_dbfname(),ALIAS(),brojac,5)

*" OVO OVDE RADI A GORE NIJE HTELO ??? GDE JE BUG U APLIKACIJI ???  26-07-2023
RETURN NIL
* --- 26-07-2023 EXTRA BUG
*/
