/*

 __PORESKEGRUPE.PRG

 24-01-2022  // dodata funkcija Slovo__za_poresku_grupu_latinica(ccGrupa)
 06-11-2015  // nije bilo izmena - samo je napisano objanjenje
 29-08-2015
 13-01-2015

  COBA Systems Software
 BAST Open Source Project
 Business Account Software Technology
 www.cobasystems.com
 Program: Alaska Xbase++ 1.90.355 sl1
          XbTools, ADSDBE, eXpress++


 pdvstopegrupe iz fajla: Gde_Exe()+"\kasa_pdvgrupa.txt"
 prebaene u fajl      : Gde_Exe()+"\KASA.INI"



* __PORESKEGRUPE.PRG
* Slovo__za_poresku_grupu("3")  --> ""
* Slovo__za_poresku_grupu("03") --> ""
* Slovo__iz_poreske_grupe("")  --> "3"
* PDV_stopeugrupe(20,ROBS,ROBN) --> "03"
* PDV_stopeugrupe(20)           --> "03"
* PDV_grupeustope("3")          --> 20%
* PDV_grupeustope("03")         --> 20%






*/

*#############################################################################################
*
*
*                                    PORESKEGRUPE.PRG
*
*                       FISKALNI UREAJI - BILO KOJI
*
*                       koristi se aplikacija za formiranje fajla:
*
*                                    kasa_pdvgrupa.txt
*
*                       koji uva tabelu fiskalnih PDV grupa i pripadajuih PDV stopa
*                       i na osnovu zadate PDV stope iz ove tabele oitava PDV grupu,
*                       ili na osnovu zadate PDV grupe iz ove tabele oitava PDV stopu
*
*#############################################################################################


/*


   *** 12-03-2008 ***  ugraditi u sve kase

   PDV GRUPE I PDV STOPE

   SISTEM POSTAVLJANJA PDV FISKALNIH GRUPA: 00,01,02,03,04,05,06,07,08
   KOJE SE ODREUJU DINAMIKI IZ TXT FAJLA: kasa_pdvgrupa.txt
   NA OSNOVU UZ ARTIKAL UPISANIH PDV STOPA: 0,8,18,...


   Poreska PDV stopa moe biti broj od 0 % - 99 %
   PDV stopa se upisuje u string u fajl: kasa_pdvgrupa.txt
   String ima dva znaka za jednu stopu i ukupno 18 znakova,
   da bi mogao da primi 9 PDV stopa:

   A  G  D    E    I  J  K   slovo
   00 01 02 03 04 05 06 07 08  PDV grupa
   00 00 00 18 08 00 00 00 00  PDV stopa -> string u kasa_pdvgrupa.txt fajlu

   000000180800000000 -> string u kasa_pdvgrupa.txt fajlu je bez blankova

   PDV stope u string, a naspram odgovarajuih PDV grupa, upisuje korisnik.

   Ako je PDV stopa, koja je upisana uz artikal, jednaka nuli
   nita se ne proverava ve joj se automatski dodeljuje PDV grupa "00"
   Na ovaj nain fiskalnu kasu koriste oni koji nisu u sistemu PDV.

   Oni koji su u sistemu PDV moraju da imaju PDV stopu upisanu uz artikal.
   Samo ako je PDV stopa, koja je upisana uz artikal, vea od nule
   vri se provera kojoj stopi upisanoj u string u fajlu kasa_pdvgrupa.txt
   odgovara ova stopa.

   Ako ne odgovara ni jednoj PDV stopi iz stringa, tada se izdaje poruka
   da je PDV stopa artikla nedozvoljena, a PDV grupa se postavlja na "00"

   Ako odgovara jednoj od PDV stopa iz stringa, tada se uzima PDV grupa te
   stope kao PDV grupa za fiskalni iseak.


   koriste se funkcije:

   FUNCTION PDV_stope_grupe() // GUI dialog za Upis PDV stopa naspram PDV grupa
                              // i za upis stringa u fajl Gde_Exe()+"\kasa_pdvgrupa.txt"

   FUNCTION PDV_stopeugrupe(nStopa,ROBS,ROBN) // PDV grupu formiraj prema PDV stopi artikla
                                              // i vrati je kao string
                                              // 00,01,02,03,04,05,06,07,08


   FUNCTION PDV_grupeustope(grupa) // PDV stopu formiraj prema PDV grupi artikla iz fiskalne kase
                                   // da bi podatke preuzete iz fiskalnog ureaja upisao u DBF


   primena:
   PDVgrupa := PDV_stopeugrupe(nStopa,cSifra,cNaziv) --> string  "00","01","02"... "08"
   PDVstopa := PDV_grupeustope(cGrupa)               --> numerik 0,8,18...

*/



#include "Appevent.ch"
#include "Common.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "Setcurs.ch"

#include "xbtdisk.ch"

#INCLUDE "DCDIALOG.CH"
#INCLUDE "DCGRA.CH"
//#INCLUDE "KASA_BAZA.CH" // koristi BMP poreskegrupe.bmp



***************************************************************************
FUNCTION PDV_stope_grupe_kontrola()
***************************************************************************
/*

  * 29-08-2015
  Ova funkcija proverava da li su PDV stopa opta i posebna upisane u
  tabelu PDV stopa i grupa. Ne dozvoljava da ove dve stope budu = 0
  Ako je korisnik kase van sistema PDV-a i tada moraju biti upisane obe
  stope opta i posebna, ali e korisnik uz svaki artikal upisati i stopu
  nula, a program e uvek prihvatiti nulu kao ispravnu stopu. Kod ovih
  korisnika u samom FP je kao aktivna oznaena samo stopa=0, a opta i
  posebna stopa nisu upisane u FP. U tim sluajevima ovaj program e
  dopustiti upis u fiskalni printer artikla sa optom ili posebnom stopom
  (jer te dve stope ima u tabeli) ali te artikle printer nee tampati na
  fiskalnom iseku (tako se ponaa GP550).

  * 29-08-2015
  takoe, ova funkcija formira i vraa:
      string_za_izmenu_fiskalnih_stopa := ;
      "02,010110000,00,00,00,20,10,00,00,00,00"
  koji se koristi samo od strane funkcije:
      FUNCTION FP550_pdvstope(xflag)
*/


   * NAIN OZNAAVANJA
   *
   *   A  G  D    E    I  J  K  grupa
   *   0  1  2  3  4  5  6  7  8  grupa
   * "00 00 00 20 10 00 00 00 00" stopa
   *   0  1  0  1  1  0  0  0  0  flag   // 1-stopa aktivirana, 0-nije aktivirana 29-08-2015

LOCAL string_za_izmenu_fiskalnih_stopa, string_stopa, string_flaga, fajl
LOCAL upis, upis0, upis1, upis2, upis3, upis4, upis5, upis6, upis7, upis8, flag




  // uitaj string PDVstopa i string PDVflagova

   fajl := Gde_Exe()+"\KASA.INI"
   upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
   flag := alltrim(INI_Read("C", "PDV", "PDVflag",fajl))

 // ako bilo koji string ne postoji
 // formiraj oba stringa kao default i ponovo ih uitaj

   IF EMPTY(upis) .or. EMPTY(flag)
      INI_Write("C", "PDV", "PDVgrupe","000000201000000000",fajl)
      INI_Write("C", "PDV", "PDVflag" ,"010110000",fajl)
      upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
      flag := alltrim(INI_Read("C", "PDV", "PDVflag",fajl))
      c_poruka("Aurirane PDV stope i grupe","KASA.INI")
   ENDIF

 // Iz sringa PDVstopa izdvoji svih 9 PDVstopa numerika:

   upis0 := VAL(substr(upis,1,2))     //A
   upis1 := VAL(substr(upis,3,2))     //G
   upis2 := VAL(substr(upis,5,2))     //D
   upis3 := VAL(substr(upis,7,2))     // 20 %
   upis4 := VAL(substr(upis,9,2))     //E 10 %
   upis5 := VAL(substr(upis,11,2))    //
   upis6 := VAL(substr(upis,13,2))    //I
   upis7 := VAL(substr(upis,15,2))    //J
   upis8 := VAL(substr(upis,17,2))    //K

 ***************************************************************
 * 06-11-2015
 * Pregled PDV stopa u FP i izmena PDV stopa u FP vre se iz:
 * FUNCTION FP550_pdvstope(xflag)
 // 53h (83) FP_PDV_DTOPE.PRG -> KASA_COBA.DLL
 // xflag=0 vidi PDV stope u FP
 // xflag=1 upii PDV stope u FP
 * Funkcije FP550_pdvstope(flag) poziva:
 * podaci := PDV_stope_grupe_kontrola()
 * Dobijeni string: "podaci", alje se preko protokola u FP za
 * izmenu stopa u fiskalnom printeru. String "podaci" se formira
 * ovde iz tri dela:
 * decimalna mesta = "02"     // ovo je uvek = "2" ili "02"
 * string_flaga = "010110000" // fiskalizovane su stope GE
 *                 AGDEIJK  // (iz KASA.INI)
 * string_stopa = "00,00,00,20,10,00,00,00,00" // upisane stope E
 *                 A  G  D    E    I  J  K   // (iz KASA.INI)
 *
 // koristi se iz KASA.INI uitani string_flaga
   string_flaga := flag  // 1-poreska stopa je aktivirana,
                         // 0-poreska stopa nije aktivirana

 // iz PDVstopa numerika napravi se string_stopa:
   string_stopa := ;
   var2char(upis0)+","+var2char(upis1)+","+var2char(upis2)+","+;
   var2char(upis3)+","+var2char(upis4)+","+var2char(upis5)+","+;
   var2char(upis6)+","+var2char(upis7)+","+var2char(upis8)

 // string podaci: string_za_izmenu_fiskalnih_stopa napravi se:
   string_za_izmenu_fiskalnih_stopa := ;
      "02"+","+string_flaga+","+string_stopa
   *  "02,010110000,00,00,00,20,10,00,00,00,00"
   *  "02" broj decimalnih mesta - fiksirano
 // Ova funkcija vraa: string_za_izmenu_fiskalnih_stopa
 // koji se jo moe koristiti za kontrolu ispravnosti PDV stope
 // upisane uz artikal prilikom slanja artikla u FP, ali za sad
 // se ne koristi nigde vie.
 * 06-11-2015
 ***************************************************************



IF upis0+upis1+upis2+upis3+upis4+upis5+upis6+upis7+upis8 < 30

      c__greska(;
      "GEKA: "                                  +chr(59)+;
      "OPTA PDV STOPA I/ILI POSEBNA PDV STOPA," +chr(59)+;
      "NISU ISPRAVNO UPISANE U TABELU PDV STOPA" +chr(59)+;
      " "                                        +chr(59)+;
      "Iz operacije programa: [ Konfiguracija ]" +chr(59)+;
      "pa zatim iz operacije [PDV stope i grupe]"+chr(59)+;
      "upiite ispravne obe PDV stope, i takoe" +chr(59)+;
      "ispravno ekirajte stope koje su upisane" +chr(59)+;
      "(fiskalizovane) u va fiskalni printer,"  +chr(59)+;
      "ili koje e te upisati u fiskalni printer"+chr(59)+;
      " ",;
      "STOP::PDV stope su neispravne",,"CB","R")




      RETURN " "

ENDIF




/* staro reenje
   IF upis3==0
      c_greska(;
      "GEKA: OPTA PDV STOPA = 0"          +chr(13)+;
      "Iz operacije programa Konfiguracija" +chr(13)+;
      "pa iz operacije PDV stope i grupe"   +chr(13)+;
      "upiite ispravnu optu PDV stopu","STOP")
   ENDIF
   IF upis4==0
      c_greska(;
      "GEKA: POSEBNA PDV STOPA = 0"        +chr(13)+;
      "Iz operacije programa Konfiguracija" +chr(13)+;
      "pa iz operacije PDV stope i grupe"   +chr(13)+;
      "upiite ispravnu posebnu PDV stopu","STOP")
   ENDIF
*/



RETURN string_za_izmenu_fiskalnih_stopa



* 29-08-2015
* #include "(res)\test.ch"
**********************************************************************************************
FUNCTION PDV_stope_grupe() // Upis PDV stopa naspram PDV grupa
**********************************************************************************************
   LOCAL GetList := {}, GetOptions, oo
   LOCAL upis, upis0, upis1, upis2, upis3, upis4, upis5, upis6, upis7, upis8, flag
   LOCAL fajl, x , aCUR := {"user32.dll",114}


        nDll := DllLoad("KASA_BAZA.DLL")    // KORISTI BITMAPU 506 IZ KASA_BAZA.DLL ???
        BMP1 := XbpBitmap():new():create()
        BMP1:load( nDll, 506 )

     *    BMP1 := 506 // iz test.ch


//----------------------------- izmena 29-08-2015  -------------------------
   * LOCAL fajl, upis, flag
   fajl := Gde_Exe()+"\KASA.INI"

   upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
   flag := alltrim(INI_Read("C", "PDV", "PDVflag",fajl))
   IF EMPTY(upis) .or. EMPTY(flag)
      INI_Write("C", "PDV", "PDVgrupe","000000201000000000",fajl)
      INI_Write("C", "PDV", "PDVflag" ,"010110000",fajl)
      upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
      flag := alltrim(INI_Read("C", "PDV", "PDVflag",fajl))
      c_poruka("Aurirane PDV stope i grupe","KASA.INI")
   ENDIF



   upis0 := VAL(substr(upis,1,2))     //A
   upis1 := VAL(substr(upis,3,2))     //G
   upis2 := VAL(substr(upis,5,2))     //D
   upis3 := VAL(substr(upis,7,2))     // 20 %
   upis4 := VAL(substr(upis,9,2))     //E 10 %
   upis5 := VAL(substr(upis,11,2))    //
   upis6 := VAL(substr(upis,13,2))    //I
   upis7 := VAL(substr(upis,15,2))    //J
   upis8 := VAL(substr(upis,17,2))    //K

   lG0   := IIF(substr(flag,1,1)$"0",.F.,.T.)
   lG1   := IIF(substr(flag,2,1)$"0",.F.,.T.)
   lG2   := IIF(substr(flag,3,1)$"0",.F.,.T.)
   lG3   := IIF(substr(flag,4,1)$"0",.F.,.T.)
   lG4   := IIF(substr(flag,5,1)$"0",.F.,.T.)
   lG5   := IIF(substr(flag,6,1)$"0",.F.,.T.)
   lG6   := IIF(substr(flag,7,1)$"0",.F.,.T.)
   lG7   := IIF(substr(flag,8,1)$"0",.F.,.T.)
   lG8   := IIF(substr(flag,9,1)$"0",.F.,.T.)


  @ 10,10 DCSTATIC TYPE XBPSTATIC_TYPE_GROUPBOX PIXEL OBJECT oOkvir ;
  SIZE 220,490  ;
  CAPTION "PDV Grupe i Stope"

  @ 20,10 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP PIXEL SIZE 200,400 CAPTION BMP1 PARENT oOkvir

 PRIVATE lakcija := .F.

 x := 21
   @ 5,   x DCGET upis0 picture "99" PARENT oOkvir  when {||lakcija } GETOBJECT prvi
   @ 6.8, x DCGET upis1 picture "99" PARENT oOkvir  when {||lakcija }
   @ 8.6, x DCGET upis2 picture "99" PARENT oOkvir  when {||lakcija }
   @ 10.4,x DCGET upis3 picture "99" PARENT oOkvir  when {||lakcija }
   @ 12.3,x DCGET upis4 picture "99" PARENT oOkvir  when {||lakcija }
   @ 14.0,x DCGET upis5 picture "99" PARENT oOkvir  when {||lakcija }
   @ 15.8,x DCGET upis6 picture "99" PARENT oOkvir  when {||lakcija }
   @ 17.6,x DCGET upis7 picture "99" PARENT oOkvir  when {||lakcija }
   @ 19.5,x DCGET upis8 picture "99" PARENT oOkvir  when {||lakcija }

   aBojat := {GRA_CLR_RED,GRA_CLR_WHITE}
   aBojaf := {GRA_CLR_PALEGRAY,GRA_CLR_WHITE}

 x := 25.6
   @ 5,   x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG0 =.f.,aBojaf,aBojat) }
   @ 6.8, x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG1 =.f.,aBojaf,aBojat) }
   @ 8.6, x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG2 =.f.,aBojaf,aBojat) }
   @ 10.4,x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG3 =.f.,aBojaf,aBojat) }
   @ 12.3,x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG4 =.f.,aBojaf,aBojat) }
   @ 14.0,x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG5 =.f.,aBojaf,aBojat) }
   @ 15.8,x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG6 =.f.,aBojaf,aBojat) }
   @ 17.6,x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG7 =.f.,aBojaf,aBojat) }
   @ 19.5,x dcsay "%" PARENT oOkvir SAYSIZE 0 SAYCOLOR {|| iif(lG8 =.f.,aBojaf,aBojat) }


 x := 25.6 + 2.5
   @ 5,   x DCCHECKBOX lG0  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 6.8, x DCCHECKBOX lG1  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 8.6, x DCCHECKBOX lG2  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 10.4,x DCCHECKBOX lG3  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 12.3,x DCCHECKBOX lG4  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 14.0,x DCCHECKBOX lG5  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 15.8,x DCCHECKBOX lG6  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 17.6,x DCCHECKBOX lG7  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }
   @ 19.5,x DCCHECKBOX lG8  PROMPT "" PARENT oOkvir ACTION {||DC_GetRefresh(GetList)} when {||lakcija }




th := 29
dh := th/3
dv := 2

@ 22,1 DCTOOLBAR oToolBar SIZE th,dv BUTTONSIZE dh,dv ;
PAREN ookvir COLOR GRA_CLR_PALEGRAY, GRA_CLR_PALEGRAY




DCADDBUTTON CAPTION "Key" ;
       ACTION {|a,b,o| ovlas(GetList,prvi), Dc_GetRefresh(GetList), setappfocus(prvi) };
       PARENT oToolBar CURSOR aCUR  ;

DCADDBUTTON CAPTION "Help" ;
       ACCELKEY xbeK_ESC;
       ACTION {|a,b,o| hellp(), SetAppFocus(o) };
       PARENT oToolBar CURSOR aCUR

DCADDBUTTON CAPTION "Exit"; //"&Kraj" ;
       ACCELKEY xbeK_ESC;
       ACTION {|| c_poruka("PROGRAM NA DALJE RADI SA OVIM STOPAMA","OK"),;
       DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) };
       PARENT oToolBar CURSOR aCUR


   DCGETOPTIONS NOMAXBUTTON NOMINBUTTON ;
   WINDOWHEIGHT 430+60+20+30 WINDOWWIDTH 200+20+30 NOESCAPEKEY;
   COLORGETS {{GRA_CLR_WHITE,GRA_CLR_RED}} ;
   GETFONT "12.Courier Bold" ;
   SAYFONT "12.Courier Bold" SAYWIDTH 30


   DCREAD GUI ;
      TITLE "PDV Grupe i Stope fiskalne kase" ;
      MODAL ;
      OPTIONS GetOptions

      upis := STRZERO(upis0,2)+STRZERO(upis1,2)+STRZERO(upis2,2)+STRZERO(upis3,2)+;
              STRZERO(upis4,2)+STRZERO(upis5,2)+STRZERO(upis6,2)+STRZERO(upis7,2)+STRZERO(upis8,2)


      *** MemoWrit(fajl,upis) *** staro
      *** SetFattr(fajl,FA_READONLY+FA_SYSTEM)  // "xbtdisk.ch"  *** staro

      INI_Write("C", "PDV", "PDVgrupe",upis,fajl)


      pdvflag := var2char(lG0)+var2char(lG1)+var2char(lG2)+var2char(lG3)+var2char(lG4)+;
                 var2char(lG5)+var2char(lG6)+var2char(lG7)+var2char(lG8)
      pdvflag := UPPER(pdvflag)
      pdvflag := STRTRAN(pdvflag,".")
      pdvflag := STRTRAN(pdvflag,"T","1")
      pdvflag := STRTRAN(pdvflag,"F","0")

      INI_Write("C", "PDV", "PDVflag",pdvflag,fajl)

CLEAR TYPEAHEAD
RETURN nil

//----------------------------- izmena 29-08-2015  -------------------------

*****************************************************************************************
STATIC FUNCTION ovlas(GetList,prvi)
*****************************************************************************************
 IF lakcija=.F.
    lakcija := .T.
    *setappfocus(prvi)

    c_poruka("Otkljuano za izmene","Otkljuano")
    RETURN .T.
 ENDIF
 IF lakcija=.T.
    lakcija := .F.
    c_greska("Zakljuano za izmene","Zakljuano")
    RETURN .F.
 ENDIF
RETURN NIL
*****************************************************************************************
STATIC FUNCTION hellp()
*****************************************************************************************

   C__PROCITAJ(;
   "Va Fiskalni ureaj je fiskalizovan i u njega su u tom postupku"   +CHR(59)+;
   "upisane PDV grupe i odgovarajue PDV stope sa kojima ureaj moe"  +CHR(59)+;
   "da radi. Ako se proba rad sa drugim PDV grupama i stopama, tada"   +CHR(59)+;
   "e doi do blokade ureaja i nee se tampati fiskalni iseak."    +CHR(59)+;
   " "                                                                 +CHR(59)+;
   "Iz tog razloga uz svaki artikal u aplikaciji - u raunaru, treba"  +CHR(59)+;
   "upisati te dozvoljene PDV grupe i PDV stope, a posebno u ovu"      +CHR(59)+;
   "Tabelu PDV grupa treba uz svaku grupu upisati i odgovarajuu PDV"  +CHR(59)+;
   "stopu identino kako je to upisano programirano u fiskalni ureaj."+CHR(59)+;
   " "                                                                 +CHR(59)+;
   "POSEBNO VANO: "                                                   +CHR(59)+;
   "Komanda za upis ili promenu PDV stopa u fiskalnom ureaju uitava" +CHR(59)+;
   "PDV grupe i stope iz ove tabele. Pre starta te komande obavezno se"+CHR(59)+;
   "mora ekirati svaka PDV stopa koju treba upisati u fiskalni ureaj"+CHR(59)+;
   "Samo ekirane PDV stope-grupe bie u fiskalnom ureaju prihvaene" +CHR(59)+;
   "kao aktivne (programirane).",;
   "PDV GRUPE I PDV STOPE FISKALNOG UREAJA I APLIKACIJE")

CLEAR TYPEAHEAD
RETURN NIL

**********************************************************************************************
FUNCTION PDV_stopeugrupe(stopa,ROBS,ROBN) // PDV grupu formiraj prema PDV stopi artikla
**********************************************************************************************
/*

 PDV stopa se preuzima iz kartice artikla iz baze podataka artikala raunarske aplikacije
 gde je ona uvek numerik sa decimalima: 0.0, 8.0, 18.0 i td. U memoriju fiskalne kase ne
 upisuje se PDV stopa ve PDV grupa kojoj pripada ta PDV stopa.

 Na osnovu podataka iz tabele PDV GRUPE FISKALNE KASE treba preuzeti PDV grupu koja odgovara
 ovoj PDV stopi, kako bi se ta poreska grupa upisala uz artikal u PLU bazu podataka u fiskalnom
 ureaju, gde se grupa uvek upisuje kodirana  kao string sa dva karaktera i to:
                   00,01,02,03,04,05,06,07,08

*/

   LOCAL upis, upis0, upis1,;
   upis2, upis3, upis4, upis5, upis6, upis7, upis8, fajl, x , pdvgrupa

   DEFAULT stopa TO 0 , ROBS TO "00000", ROBN TO "XXXXXXXXXXXXXXXXXXXXXXXXX"

   stopa := ROUND(stopa,0) // obavezno postavi na nula decimala !!!

   ***fajl := Gde_Exe()+"\kasa_pdvgrupa.txt" *** staro
   ***IF FILE(fajl)=.F.                      *** staro
   ***   MemoWrit(fajl,"000000180800000000") *** staro
   ***ENDIF                                  *** staro
   ***upis := ALLTRIM(MemoRead(fajl))        *** staro


   fajl := Gde_Exe()+"\KASA.INI"
   IF FILE(fajl) == .F.
      INI_Write("C", "PDV", "PDVgrupe","000000201000000000",fajl)
   ENDIF
   upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
   IF EMPTY(upis)
      INI_Write("C", "PDV", "PDVgrupe","000000201000000000",fajl)
      upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
      c_poruka("Aurirane PDV stope i grupe","KASA.INI")
   ENDIF


   upis0 := VAL(substr(upis,1,2))     //A
   upis1 := VAL(substr(upis,3,2))     //G
   upis2 := VAL(substr(upis,5,2))     //D
   upis3 := VAL(substr(upis,7,2))     // 18 %
   upis4 := VAL(substr(upis,9,2))     //E  8 %
   upis5 := VAL(substr(upis,11,2))    //
   upis6 := VAL(substr(upis,13,2))    //I
   upis7 := VAL(substr(upis,15,2))    //J
   upis8 := VAL(substr(upis,17,2))    //K

   pdvgrupa := "00"

   IF stopa > 0  // samo ako stopa nije nula

      IF stopa = upis0
         pdvgrupa := "00"  // ili STRZERO(upis0,2)

      ELSEIF stopa = upis1
         pdvgrupa := "01"

      ELSEIF stopa = upis2
         pdvgrupa := "02"

      ELSEIF stopa = upis3
         pdvgrupa := "03"

      ELSEIF stopa = upis4
         pdvgrupa := "04"

      ELSEIF stopa = upis5
         pdvgrupa := "05"

      ELSEIF stopa = upis6
         pdvgrupa := "06"

      ELSEIF stopa = upis7
         pdvgrupa := "07"

      ELSEIF stopa = upis8
         pdvgrupa := "08"

      ELSE
         tone(4000)
         c_greska("PDV stopa  "+ALLTRIM(str(stopa))+" %  nije dozvoljena,"  + chr(13) +;
                  "nije upisana u tabelu:"                     + chr(13) +;
                  "KASA - PDV GRUPE FISKALNE KASE"             + chr(13) +;
                  "iz operacije:"                              + chr(13) +;
                  "PDV stope i PDV grupe Fiskalne kase"        + chr(13) +;
                  " "                                          + chr(13) +;
                  "ifra i naziv artikla: "+ROBS               + chr(13) +;
                  ROBN ,;
                  "STOP")

            stopa := 20
            pdvgrupa := "03"

      ENDIF

   ELSE
       // poreska stopa je nula - nije u PDV u
   ENDIF

RETURN pdvgrupa // "00","01","02","03","04","05","06","07","08"
**********************************************************************************************
FUNCTION TESTPDVGRUPA()
 Msgbox("PDV grupa = "+PDV_stopeugrupe(18),"Stopa = 18")
 Msgbox("PDV grupa = "+PDV_stopeugrupe( 8),"Stopa =  8")
 Msgbox("PDV grupa = "+PDV_stopeugrupe( 0),"Stopa =  0")
 Msgbox("PDV grupa = "+PDV_stopeugrupe(20),"Stopa = 20")
 Msgbox("PDV grupa = "+PDV_stopeugrupe( 5),"Stopa =  5")
RETURN nil
**********************************************************************************************






**********************************************************************************************
FUNCTION PDV_grupeustope(grupa) // PDV stopu formiraj prema PDV grupi artikla iz fiskalne kase
**********************************************************************************************
/*

 PDV grupa se preuzima iz TXT fajla ili drugog fajla formiranog iz podataka o artiklu uzetih
 iz fiskalne kase gde je ona uvek kodirana kao string sa dva karaktera i to:
                   00,01,02,03,04,05,06,07,08
 Na osnovu podataka iz tabele PDV GRUPE FISKALNE KASE treba preuzeti PDV stopu koja odgovara
 ovoj PDV grupi, kako bi se ta poreska stopa upisala uz artikal u bazu podataka u raunaru
 u aplikaciji, poto za raunarsku knjigovodstvenu aplikaciju PDV grupa nema upotrebnu vrednost.

*/
   LOCAL upis, upis0, upis1,;
   upis2, upis3, upis4, upis5, upis6, upis7, upis8, fajl, x , pdvgrupa , stopa := 0

   DEFAULT grupa TO "00"

   stopa := ROUND(stopa,0) // obavezno postavi na nula decimala !!!

   *** fajl := Gde_Exe()+"\kasa_pdvgrupa.txt"  *** staro
   *** IF FILE(fajl)=.F.                       *** staro
   ***    MemoWrit(fajl,"000000180800000000")  *** staro
   *** ENDIF                                   *** staro
   *** upis := ALLTRIM(MemoRead(fajl))         *** staro

   fajl := Gde_Exe()+"\KASA.INI"
   IF FILE(fajl) == .F.
      INI_Write("C", "PDV", "PDVgrupe","000000201000000000",fajl)
   ENDIF
   upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
   IF EMPTY(upis)
      INI_Write("C", "PDV", "PDVgrupe","000000201000000000",fajl)
      upis := alltrim(INI_Read("C", "PDV", "PDVgrupe",fajl))
      c_poruka("Aurirane PDV stope i grupe","KASA.INI")
   ENDIF




// upisane u tabelu PDV grupa i PDV stopa i dozvoljene stope u %
   upis0 := VAL(substr(upis,1,2))     //A
   upis1 := VAL(substr(upis,3,2))     //G
   upis2 := VAL(substr(upis,5,2))     //D
   upis3 := VAL(substr(upis,7,2))     // 18 %
   upis4 := VAL(substr(upis,9,2))     //E  8 %
   upis5 := VAL(substr(upis,11,2))    //
   upis6 := VAL(substr(upis,13,2))    //I
   upis7 := VAL(substr(upis,15,2))    //J
   upis8 := VAL(substr(upis,17,2))    //K

// imamo dobijen podatak: PDV grupa := "00","01","02","03","04","05","06","07","08"
// zadatak je da se nae: PDV stopa koja odgovara toj PDV grupi

//   IF grupa     == "00"
//      stopa = upis0
//   ELSEIF grupa == "01"
//      stopa = upis1
//   ELSEIF grupa == "02"
//      stopa = upis2
//   ELSEIF grupa == "03"
//      stopa = upis3
//   ELSEIF grupa == "04"
//      stopa = upis4
//   ELSEIF grupa == "05"
//      stopa = upis5
//   ELSEIF grupa == "06"
//      stopa = upis6
//   ELSEIF grupa == "07"
//      stopa = upis7
//   ELSEIF grupa == "08"
//      stopa = upis8
//   ELSE
//      stopa = upis0
//
//         tone(4000)
//         c_greska("PDV grupa  "+grupa+"  nije dozvoljena,"    + chr(13) +;
//                  "nije predviena u fiskalnim ureajima."    + chr(13) +;
//                  "Desilo se pogreno uitavanje podataka"    + chr(13) +;
//                  "iz memorije fiskalnog ureaja."            + chr(13) +;
//                  " "                                         + chr(13) +;
//                  "PDV stopa za artikal stavlja se na nulu"   + chr(13) +;
//                  "TARIFA za artikal stavlja se na znak X"    ,;
//                  "STOP")
//
//   ENDIF


   IF val(grupa)     == 0     // ovde grupa moe da bude i "0" i "00"
      stopa = upis0
   ELSEIF val(grupa) == 1
      stopa = upis1
   ELSEIF val(grupa) == 2
      stopa = upis2
   ELSEIF val(grupa) == 3
      stopa = upis3
   ELSEIF val(grupa) == 4
      stopa = upis4
   ELSEIF val(grupa) == 5
      stopa = upis5
   ELSEIF val(grupa) == 6
      stopa = upis6
   ELSEIF val(grupa) == 7
      stopa = upis7
   ELSEIF val(grupa) == 8
      stopa = upis8
   ELSE
      stopa = upis0

         tone(4000)
         c_greska("PDV grupa  "+grupa+"  nije dozvoljena,"    + chr(13) +;
                  "nije predviena u fiskalnim ureajima."    + chr(13) +;
                  "Desilo se pogreno uitavanje podataka"    + chr(13) +;
                  "iz memorije fiskalnog ureaja."            + chr(13) +;
                  " "                                         + chr(13) +;
                  "PDV stopa za artikal stavlja se na nulu"   + chr(13) +;
                  "TARIFA za artikal stavlja se na znak X"    ,;
                  "STOP")

   ENDIF




RETURN stopa // numerik ceo broj bez decimala
**********************************************************************************************
FUNCTION TESTPDVSTOPA()
 Msgbox("PDV stopa = "+PADL(PDV_grupeustope("03"),2),"Grupa = 03")
 Msgbox("PDV stopa = "+PADL(PDV_grupeustope("04"),2),"Grupa = 04")
 Msgbox("PDV stopa = "+PADL(PDV_grupeustope("00"),2),"Grupa = 00")
 Msgbox("PDV stopa = "+PADL(PDV_grupeustope("09"),2),"Grupa = 09")
 Msgbox("PDV stopa = "+PADL(PDV_grupeustope("33"),2),"Grupa = 33")
RETURN nil
**********************************************************************************************











*******************************************************************************************
* 01-09-2015  korigovana greka na slovu E
// prima iz DBF podataka    ASCII karakter: cifru od 0-8 poresku grupu
// vraca u fiskalni printer ASCII karakter: Veliko slovo cirilice A,G,D,DJ,E,Za,I,J,K
FUNCTION Slovo__za_poresku_grupu(wznak)
//FUNCTION grupa_u_slovo(wznak)
*******************************************************************************************

* Slovo_za_poresku_grupu("3") --> ""

***********************************************************
* Karakteri po kodnoj strani 1251 (Windows Cyrillic Slavic)
* Velika slova irilice za poreske grupe:
*
*   CYRILLIC DEC  HEX  UNICODE
*   A_1251 = 192  C0   0410  // 0     - ne koristi se
*   G_1251 = 195  C3   0413  // 1     - nije u PDV stopa=0
*   D_1251 = 196  C4   0414  // 2     - ne koristi se
*   _1251 = 128  80   0402  // 3 () - osnovna stopa
*   E_1251 = 197  C5   0415  // 4 (E) - posebna stopa
*   _1251 = 198  C6   0416  // 5 () - ne koristi se
*   I_1251 = 200  C8   0418  // 6     - ne koristi se
*   J_1251 = 163  A3   0408  // 7     - ne koristi se
*   K_1251 = 202  CA   041A  // 8     - ne koristi se
*
***********************************************************

* wznak := "0","1","2","3","4","5","6","7","8"
* wznak := "00","01","02","03","04","05","06","07","08"

 LOCAL wslovo := chr(128)


 IF val(wznak) == 0
    wslovo := CHR(192)
 ENDIF
 IF val(wznak) == 1
    wslovo := CHR(195) // G
 ENDIF
 IF val(wznak) == 2
    wslovo := CHR(196)
 ENDIF
 IF val(wznak) == 3
    wslovo := CHR(128) // 
 ENDIF
 IF val(wznak) == 4
    wslovo := CHR(197) // E
 ENDIF
 IF val(wznak) == 5
    wslovo := CHR(198)
 ENDIF
 IF val(wznak) == 6
    wslovo := CHR(200)
 ENDIF
 IF val(wznak) == 7
    wslovo := CHR(163)
 ENDIF
 IF val(wznak) == 8
    wslovo := CHR(202)
 ENDIF


RETURN wslovo




*******************************************************************************************
FUNCTION Slovo__za_poresku_grupu_latinica(wznak)
*******************************************************************************************

* Slovo_za_poresku_grupu("3") --> ""

* wznak := "0","1","2","3","4","5","6","7","8"
* wznak := "00","01","02","03","04","05","06","07","08"
* wslovo:= ""
* wslovo:= "00,00,00,20,10,00,00,00,00" // upisane stope E
* wslovo:=  A  G  D    E    I  J  K   // (iz KASA.INI)


 LOCAL wslovo := chr(208) // 


 IF val(wznak) == 0
    wslovo := "A"  // chr(65)
 ENDIF
 IF val(wznak) == 1
    wslovo := "G"   // chr(71)
 ENDIF
 IF val(wznak) == 2
    wslovo := "D"  // chr(68)
 ENDIF
 IF val(wznak) == 3
    wslovo := ""  // chr(208)
 ENDIF
 IF val(wznak) == 4
    wslovo := "E"  // chr(69)
 ENDIF
 IF val(wznak) == 5
    wslovo := ""  // chr(142)
 ENDIF
 IF val(wznak) == 6
    wslovo := "I"  // chr(73)
 ENDIF
 IF val(wznak) == 7
    wslovo := "J"  // chr(74)
 ENDIF
 IF val(wznak) == 8
    wslovo := "K"  // chr(75)
 ENDIF


RETURN wslovo



*******************************************************************************************
* 01-09-2015  korigovana greka na slovu E
// prima iz fiskalnog printera   ASCII karakter: Veliko slovo cirilice A,G,D,DJ,E,Za,I,J,K
// vraca u DBF bazu podataka     ASCII karakter: cifru od 0-8 poresku grupu
FUNCTION Slovo__iz_poreske_grupe(wslovo)
*******************************************************************************************

* Slovo_iz_poreske_grupe("") -> "3"
* Slovo_iz_poreske_grupe( chr(128) ) -> "3"

***********************************************************
* Karakteri po kodnoj strani 1251 (Windows Cyrillic Slavic)
* Velika slova irilice za poreske grupe:
*
*   CYRILLIC DEC  HEX  UNICODE
*   A_1251 = 192  C0   0410  // 0     - ne koristi se
*   G_1251 = 195  C3   0413  // 1     - nije u PDV stopa=0
*   D_1251 = 196  C4   0414  // 2     - ne koristi se
*   _1251 = 128  80   0402  // 3 () - osnovna stopa
*   E_1251 = 197  C5   0415  // 4 (E) - posebna stopa
*   _1251 = 198  C6   0416  // 5 () - ne koristi se
*   I_1251 = 200  C8   0418  // 6     - ne koristi se
*   J_1251 = 163  A3   0408  // 7     - ne koristi se
*   K_1251 = 202  CA   041A  // 8     - ne koristi se
*
***********************************************************

 LOCAL wznak := "3"    // poreska grupa za robu sa porezom

 IF ASC(wslovo) == 192
    wznak := "00"
 ENDIF
 IF ASC(wslovo) == 195  // G
    wznak := "01"
 ENDIF
 IF ASC(wslovo) == 196
    wznak := "02"
 ENDIF
 IF ASC(wslovo) == 128 // 
    wznak := "03"
 ENDIF
 IF ASC(wslovo) == 197 // E
    wznak := "04"
 ENDIF
 IF ASC(wslovo) == 198
    wznak := "05"
 ENDIF
 IF ASC(wslovo) == 200
    wznak := "06"
 ENDIF
 IF ASC(wslovo) == 163
    wznak := "07"
 ENDIF
 IF ASC(wslovo) == 202
    wznak := "08"
 ENDIF

RETURN(wznak)
