

//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   1_KASA_STOLOVI_GLAVNI.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////






*-----------------------------------
* Xbase++
#include "Xbp.ch"
#include "AppEvent.ch"
#include "Common.ch"
*-----------------------------------
* XbToolIII++
#include "xbtsys.ch"
*-----------------------------------
* eXpress++
#include "dcdialog.ch"
*-----------------------------------
* Xbase++ PGDBE
#include "pgdbe.ch"
#include "std.ch"
#include "sql.ch"
#include "dac.ch"
#pragma library("adac20b.lib")
*-----------------------------------
* Xbase++ APPBROWSE, APPDISPLAY
* for testing the program:
  #include "Appbrow.ch"
  MEMVAR appObject
*-----------------------------------


*************************************************************************
PROCEDURE AppSys()
*************************************************************************
 // prvo se poziva:
 // init() pa appsys() pa dbesys() pa main()
 // first call:
 // init() then appsys() then dbesys() then main()

 SET DATE GERMAN
 SET CENTURY ON
 SET CHARSET TO ANSI

 PUBLIC APLIKACIJA := "SQL"

* --- 1. sprei drugu instancu

* ako je ova aplikacija ve startovana i u memoriji je
* a sada se startuje druga instanca - ovde se prekida sa QUIT

* if this application has already been started and is in memory
* and now the second instance is started - here it is terminated with QUIT

 *************
  xRUN_STOP() // BAZNE.DLL
 *************

* --- 1. sprei drugu instancu



RETURN
*************************************************************************
PROCEDURE dbesys()
*************************************************************************

   DbeLoad("pgdbe")
   DbeSetDefault("pgdbe")

RETURN
*************************************************************************
PROCEDURE MAIN()
*************************************************************************

  nOldIcon := DC_ICONDEFAULT(1) /* postavi ikonu programa */
  SETCANCEL(.F.)      /* Iskljui prekid aplikacije sa Alt+C */
  DC_DotHotKey(180)   /* taster Alt+D, koji startuje DOT Prompt, prebaci na 180 */


  *=================================================================== START
  * CONTROL APP DATABASE - CONNECT-CONTROL-DISCONNECT
  *===================================================================

  ************
  __pg__ini()  // C-PGDB.DLL
  ************
  *  daje databases PUBLIC variables iz "C-PGDB.INI"
  * _server_,_uid_,_pwd_,_db_,_she_,_tab_,_oSession_,
  * _dblist_,_shelist_,_tablist_,lAlert,lMsg,_lDBcontrol_
  * _MAG_,_KAS_,
  * _version_, _cConnStr_, cConnStrTest_ , _cdbc_

  // uva se zbog kompatibilnosti sa starom verzijom programa
  // zamenjuje funkcije KASA() i KASA_INIT_INI()
  // kept for compatibility with old version of the program
  // replaces KASA() and KASA_INIT_INI() functions:
  PUBLIC MAG:=_MAG_, KAS:=_KAS_, FPR:="PRINTER"



    IF _lDBcontrol_=.T. // C-PGDB.INI
      // vri se kontrola PgSQL database
      // kontrola database or create database if not exists
        *************************
        qq := __pg__connect_app() // C-PGDB.DLL
        *************************
        * qq=.T. or qq=.F.
        _c_poruka:=" | PostgreSQL database is controlled | OK"
    ELSE
      // ne vri se kontrola PgSQL database
        qq:=.T.
        *" N A S T A V A K  P R O G R A M A
        *" DATABAZA JE OK SVE TABLE SU OK
        *" CONTINUE PROGRAM
        *" DATABASE IS OK ALL TABLES IS OK
        _c_poruka:=" | PostgreSQL database is not controlled"
    ENDIF

    IF qq==.F.
       ***************
       __pg__appquit() // C-PGDB.DLL
       ***************
       *" P R E K I D  P R O G R A M A
       *" NEDOSTAJU TABLE U DATABAZI
       *" STOP PROGRAM
       *" TABLES IN DATABASE ARE MISSING
    ENDIF

  *===================================================================
  * CONTROL APP DATABASE - CONNECT-CONTROL-DISCONNECT
  *=================================================================== END


  *=================================================================== START
  * D A T A B A S E  N A M E  -  SCHEME NAME  -  TABLE NAME
  *===================================================================

  * TERMS USED IN THIS PROJECT

  * ---
  * FISKALNA REGISTAR KASA (CASHREGISTER)
  *   Samostalni elektronski ureaj ili raunarski softver u raunaru,
  *   koji formira raun za kupca za kupljene artikle, fiskalizuje
  *   raun preko web servisa (restful servis), tampa raun za kupca
  *   i arhivira raun.
  *
  * FISCAL CASH REGISTER (CASHREGISTER)
  *   An independent electronic device or computer software in a computer,
  *   who creates an invoice for the customer for purchased articles,
  *   fiscalizes the invoice via the web service (restful service), prints
  *   an invoice for the customer and archives the invoice.
  * ---
  * REGISTAR ARTIKALA  (CODEBOOK)
  *   Registar artikala ili ifarnik artikala sadri sve artikle
  *   koji se prodaju kupcima preko fiskalne kase: robu, proizvode,
  *   usluge, materijal, komisionu robu, gotova jela i pia za
  *   restorane
  *
  * ARTICLES CODEBOOK  (CODEBOOK)
  *   Article register or article codebook contains all articles
  *   which are sold to customers through the fiscal register: goods,
  *   products, services, material, commission goods, ready meals and
  *   drinks for restaurants
  * ---
  * AKTIVNI KASA RAUN (BILL)
  *   RAUN ZA KUPCA koji se formira u kasi
  *   ovaj raun se fiskalizuje i tampa kao fiskalni
  *   raun a zatim se arhivira i brie, ili
  *   ovaj raun se ne fiskalizuje i tampa se kao
  *   nefiskalni raun a zatim se arhivira i brie
  *
  * ACTIVE CASH BILL (BILL)
  *   BILL FOR CUSTOMER that is created at cash register
  *   this bill is fiscalized and printed as fiscal
  *   the bill is then archived and deleted, or
  *   this bill is not fiscalized and is printed as
  *   non-fiscal bill and then archived and deleted
  * ---
  * AKTIVNI KASA RAUN - PODACI ZA FAKTURU (BUYER)
  *   Raun za kupca koji se formira u kasi, moe se tampati i kao
  *   faktura za kupca, poto mu se dodaju svi podaci potrebni za
  *   fakturu koji se upisuju u ovu tablu
  *
  * ACTIVE CASH BILL - INVOICE DATA  (BUYER)
  *   Bill for the customer, which is created at the cash register,
  *   can also be printed as an invoice for the customer, since all
  *   the necessary information is added to it the invoice to be
  *   entered in this table
  * ---
  * ARHIVA FISKALIZOVANIH RAUNA  (ARCHIVE1)
  *  Raun za kupca se posle fiskalizacije tampa i izdaje se kupcu
  *  a zatim se arhivira u arhivu koja sadri sve izdate fiskalne
  *  raune
  *
  * ARCHIVE OF FISCALIZED BILLS  (ARCHIVE1)
  *   After fiscalization, the bill for the customer is printed and
  *   issued to the customer and then it is archived in an archive
  *   that contains all issued fiscals bills
  * ---
  * ARHIVA NEFISKALIZOVANIH RAUNA  (ARCHIVE2)
  *   Raun za kupca se ne fiskalizuje ve se tampa i izdaje se kupcu
  *   a zatim se arhivira u arhivu koja sadri sve izdate nefiskalne
  *   raune
  *
  * ARCHIVE OF NON-FISCALIZED BILLS  (ARCHIVE2)
  *   Bill for customer is not fiscalized, but is printed and issued
  *   to the customer and then it is archived in an archive that
  *   contains all issued non-fiscal ones bills
  * ---
  * RAUN VEZAN ZA STO U RESTORANU (ACCOUNT)
  *   U restoranu svaki sto ima svoj raun koji je ili prazan ili pun.
  *   Ovaj raun se otvara kada gosti zauzmu sto a zatvara se i prazni
  *   se kada gosti plate i oslobode sto. Kod plaanja, ovaj raun se
  *   prebacuje u AKTIVNI KASA RAUN koji se fiskalizuje (ili ne),
  *   tampa se, daje se gostu i arhivira se.
  *
  * ACCOUNT LINKED TO A RESTAURANT TABLE (ACCOUNT)
  *   In restaurant, each table has its own account, which is either empty
  *   or full. This account is opened when the guests occupy the table and
  *   is closed and emptied when the guests pay and free the table. When
  *   paying, this account is transfers to an ACTIVE CASH BILL that is
  *   fiscalized (or not), is printed, given to the guest and archived.
  * ---
  * PRODAJNI OBJEKAT I FISKALNE KASE U PRODAJNOM OBJEKTU (SALESOBJECT)
  *   Kompanija moe imati vie Prodajnih objekata (maloprodaja)
  *   koji se na nivou kompanije oznaavaju iframa od 01 do 99
  *   a svaki prodajni objekat moe imati vie fiskalnih registar kasa
  *   koje se na nivou kompanije oznaavaju iframa od 01 do 99
  *
  * SALES OBJECT AND FISCAL CASH REGISTER IN THE SALES OBJECT (SALESOBJECT)
  *   A company can have more Sales objects (retail)
  *   which are indicated at the company level with codes from 01 to 99
  *   and each sales object can have several fiscal cash registers
  *   which are indicated at the company level with codes from 01 to 99
  * ---
  * DNEVNI PAZAR I PAZAR ZA PERIOD  (SALE-FOR-DAY) (SALE-FOR-PERIOD)
  *   Dnevni pazar je Zbir svih fiskalnih rauna za jedan datum
  *   Pazar za period je Zbir svih fiskalnih rauna za period od datuma1 do
  *   datuma2 (ukljueni su i datum1 i datum2)
  *
  * SALE-FOR-DAY AND SALE-FOR-PERIOD (SALE-FOR-DAY) (SALE-FOR-PERIOD)
  *   Sale-for-day is sum of all fiscal bills for one date
  *   Sale-for-period is sum of all fiscal bills for the period from date1
  *   to date2 (both date1 and date2 are included)
  * ---




  * PUBLIC:
  *
  * _db_  = "kasa"    // example: database name // C-PGDB.INI
  * _she_ = "public"  // example: scheme name   // C-PGDB.INI
  *
  * _MAG_ = "11"      // example: code for sales object  // KASA.INI
  * _KAS_ = "22"      // example: code for cash register // KASA.INI
  *


  * T A B L E  N A M E


   // REGISTAR ARTIKALA
   // ARTICLES CODEBOOK
   PUBLIC SPISAK_ROBE  := "kroba_" +_MAG_
   PUBLIC _SPISAK_ROBE := _she_+"."+SPISAK_ROBE

   // AKTIVNI KASA RAUN
   // ACTIVE CASH BILL
   PUBLIC KASA_BON     := "kbon_"  +_KAS_
   PUBLIC _KASA_BON    := _she_+"."+KASA_BON

   // AKTIVNI KASA RAUN - PODACI ZA FAKTURU
   // ACTIVE CASH BILL - INVOICE DATA
   PUBLIC KASA_BLOK    := "kblok_" +_KAS_
   PUBLIC _KASA_BLOK   := _she_+"."+KASA_BLOK

   // ARHIVA FISKALIZOVANIH RAUNA
   // ARCHIVE OF FISCALIZED BILLS
   PUBLIC KASA_STAV    := "kasa_"  +_KAS_
   PUBLIC _KASA_STAV   := _she_+"."+KASA_STAV

   // ARHIVA NEFISKALIZOVANIH RAUNA
   // ARCHIVE OF NON-FISCALIZED BILLS
   PUBLIC KASA_DEL    := "kaso_"  +_KAS_
   PUBLIC _KASA_DEL   := _she_+"."+KASA_DEL

   // RAUN VEZAN ZA STO U RESTORANU
   // ACCOUNT LINKED TO A RESTAURANT TABLE
   * Postoje stolovi od 1 do 100:
   * There are tables from 1 to 100:
   * "x1","x2","x3"... "x100"
   * _she_+"."+"x1", _she_+"."+"x2"...

  *===================================================================
  * D A T A B A S E  N A M E  -  SCHEME NAME  -  TABLE NAME
  *=================================================================== END



*" C O N N E C T
*" uspostavi konekciju na ulazu u main()
* lRet:=SQL_connection(.T.) // connect // PG_DATABASE_CONNECT.PRG
***********************
lRet := __pg__connect()     // connect // C-PGDB.DLL
***********************


* STOP("P R O G R A M  W O R K I N G",0)


      **********************
      _KASA_stolovi_screen()
      **********************


*" D I S C O N N E C T
*" prekini konekciju na izlazu iz main()
* lRet:=SQL_connection(.F.) // disconnect // PG_DATABASE_CONNECT.PRG
**************************
lRet := __pg__disconnect()  // disconnect // C-PGDB.DLL
**************************



****************
 __pg__AppQuit() // disconnect all sessions // C-PGDB.DLL
****************
RETURN










*************************************************************************
FUNCTION EXIT_PRG()
*************************************************************************
IF C__NEDA("END OF PROGRAM","KRAJ PROGRAMA",3333,"G3")==.T.
   TMP_ISPRAZNI()
   QUIT_QUIT()
ELSE
   CLEAR TYPEAHEAD
   // PostAppEvent(xbeP_Keyboard,xbeK_ESC,,ooDlg)
ENDIF
RETURN NIL










***************************************************************************
FUNCTION DEMO_TXT_HLP()
***************************************************************************
LOCAL txt := "", cr := chr(13)+chr(10)


demo:="| DOKUMENTATION | DEMO APPLIKATION | "+appname()+" | "+gde_ver()
data:=strtran(upper(appname()),".EXE","-DATABASE.EXE")

TEXT INTO txt WRAP cr //TRIMMED

  &demo

  BAST BUSINESS ACCOUNT SOFTWARE TECHNOLOGY
  BAST OPEN SOURCE PROJECT
  COBA Systems, www.cobasystems.com

  ---

  Ova aplikacija je redukovana poslovna aplikacija za elektronsku fiskalnu
  registar kasu u restoranu. Kasa upravlja prodajom hrane i pia i izdaje
  fiskalne raune gostima restorana (kupcima).

  This application is a reduced business application for electronic fiscal
  cash register in a restaurant. The cash register manages food and drink
  sales and issues fiscal bills for restaurant guests (customers).

  ---

  Ova aplikacija pisana je u Alaska Xbase++ 2.0 i eXpress++ 2.0 programskom
  jeziku i radi sa PostgreSQL serverom baze podataka preko PGDBE.DLL maine.
  Ne koristi PGDBE UPSIZE tehnologiju ve koristi samo PGDBE tehnologiju.
  Korien je PostgreSQL server verzija 9.4 i sve novije verzije.

  This application is written in Alaska Xbase++ 2.0 and eXpress++ 2.0
  programming language and works with the PostgreSQL database server
  through the PGDBE.DLL engine.
  It does not use PGDBE UPSIZE technology but only uses PGDBE technology.
  PostgreSQL server version 9.4 and all newer versions were used.

  ---

  Program za kreiranje i odravanje postgreSQL baze podataka priloen je
  kao eksterna EXE aplikacija pod nazivom:
  &data

  A program for creating and maintaining a postgreSQL database is attached
  as an external EXE application named:
  &data

  ---

  Program za dizajn i raspored stolova u objektu restorana nije priloen
  Program for design and arrangement of tables in restaurant is not attached

  ---


  Iz aplikacije je izostavljen deo koji se bavi formiranjem fiskalnog rauna
  i slanjem fiskalnog rauna na restful web servis poreske uprave koja vri
  fiskalizaciju rauna i vraanje fiskalizovanog rauna nazad u fiskalnu
  registar kasu odakle se on tampa i izdaje kupcu.
  Ovaj deo nije univerzalan i zavisi od postojeih propisa u svakoj dravi.
  Zavisi i od restful web servisa (softver) koji su svida razliiti

  The part dealing with creation of a fiscal bill has been omitted from
  application and by sending fiscal bill to the restful web service of
  tax administration that performs fiscalization of bill and returning the
  fiscalized bill back to the fiscal one cash register from where it is
  printed and issued to the customer.
  This part is not universal and depends on existing regulations in each
  country.
  It also depends on restful web services (software), which are all different

  ---

  Izostavljen je i deo koda za tampanje fiskalnog i nefiskalnog rauna.
  Izostavljen je i deo koda za tampanje naloga kuhinji i naloga anku.

  Ostavljen je samo interfejs za formiranje rauna za gosta restorana sve
  do faze pred slanje tog rauna na restful web servis na fiskalizaciju.

  ---

  Part of code for printing fiscal and non-fiscal bills has also been omitted.
  Part of code for printing orders to kitchen and orders to bar was also omitted.

  Only the interface for creating an bill for the guest of the restaurant is left
  to the stage before sending that bill to restful web service for fiscalization.

  ---

  Izostavljen je sav kod za izdavanje izvetaja o prodaji za dan i za period.
  Izostavljen je sav kod za konfiguraciju i podeavanje rada kase preko INI
  fajlova

  All code for issuing sales reports for the day and for the period is omitted.
  All the code for configuring and setting up the cash register via INI files
  has been omitted

  ---

  Coba, 2023-11-11

ENDTEXT
* c__procitaj(txt,naslov,,"H","B")
* CLEAR TYPEAHEAD
  * Kada je txt = string u memoriji
  TxtFile:=cTxt()
  MEMOWRIT(TxtFile,txt)
  *******************************************
  off := Font_codepage(10,"Consolas",238,.f.)
  C_EDIT(TxtFile,demo,demo,,,,,,off) // baznex.dll
  *******************************************
   CLEAR TYPEAHEAD

RETURN NIL
