//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   1_KASA_stolovi_screen.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////



/*


 PROGRAM ZA RESTORAN SA STOLOVIMA
 KOMANDNI EKRAN ZA PRODAJU PREKO STOLOVA X1.STO do X100.STO
 PROGRAM FOR A RESTAURANT WITH TABLES
 COMMAND SCREEN FOR SALE OVER TABLES X1.STO to X100.STO
 ==========================================================

 Prikazuje dva reda komandnih dugmadi za grupe artikala u toolbaru (gore)
 Prikazuje sliku prostorije ugostiteljskog objekta na koju su postavljeni
 stolovi kao DCPUSHBUTTONS (command buttons)

 Shows two rows of command buttons for groups of items in the toolbar (top)
 Shows a picture of the room of the catering facility where they are placed
 TABLEs as DCPUSHBUTTONS (command buttons)


 ===================================================
 RAD SA POZICIONIRANIM STOLOVIMA U OBJEKTU RESTORANA
 WORKING WITH POSITIONED TABLES IN A RESTAURANT FACILITY
 ===================================================

 - Broj i lokacija stolova (koordinate) se uitavaju iz KASA_RESTORAN.INI
   i na te kordinate postavlja se DCPUSHBUTTON sa brojem i ikonom stola

 - Number and location of tables (coordinates) are loaded from KASA_RESTORAN.INI
   and a DCPUSHBUTTON with a number and a TABLE icon is placed on those coordinates

 - pozadinska slika ili crte objekta restorana je bitmapa:
 - the background image or drawing of the restaurant object is a bitmap:

       objekat.gif

   dimenzija 958 x 680 pixela

 Koristi DBF fajlove stolova: X1.STO,X2.STO,X3.STO... X100.STO
 Koristi ikone   sto1.ico, sto2.ico  32 x 32 pixela
 Koristi bitmape sto1.bmp, sto2.bmp  32 x 32 pixela

  Uses DBF table files: X1.STO,X2.STO,X3.STO... X100.STO
  In this program Uses postgreSQL tables: x1,x2,x3... x100
  Use icons sto1.ico, sto2.ico 32 x 32 pixels
  It uses bitmaps sto1.bmp, sto2.bmp 32 x 32 pixels

 Poseban EXE program sadri GUI sistem za premetanje stolova
 sa pozicije na poziciju i upis lokacije pozicije svakog stola
 u KASA_RESTORAN.INI
 Proitaj help u funkciji: FUNCTION helpxx(oDlg)

  A separate EXE program contains a GUI system for moving TABLEs
  from position to position and recording the location of the position of each table
  in KASA_RESTORAN.INI
  Read the help in the function: FUNCTION helpxx(oDlg)


 EMA RADA
 WORK SCHEME
 ---------

 inicijalizuj bazu podataka kase: | initialize the checkout database:
 KASA()  // KASA, ROBA, KUPCI, KASA_BAZA.PRG

 uitaj: cModRada iz KASA_CFG,INI | load: cModRada from KASA_CFG,INI
 postavi PUBLIC FOLDER_STOLA
 RESTORANSKI___MOD()

 bez ovoga nema stolova kada se startuje program
 without this there are no tables when the program is started
 KASA_STOLOVI_DEFAULT()
 KASA_STOLOVI(oo)


  * msgbox(var2char(oDlg:drawingarea:currentsize()))}
  * veliina bitmape - background slike - plan prostorije restorana
  * bitmap size - background images - restaurant room plan



  RAD SA RAUNIMA STOLOVA
  -----------------------

  Od moguih 100 stolova (X1.STO do X100.STO) mogu biti aktivirani svi
  ili samo deo stolova i svaki aktivirani sto ima svoje komandno dugme
  na kome je ikona stola i broj stola.

   WORKING WITH TABLE ACCOUNTS
   ---------------------------

   Of the possible 100 TABLEs (X1.STO to X100.STO) all can be activated
   or only part of the TABLEss and each activated TABLE has its own command button
   which has the TABLE icon and the TABLE number.

  (1)

  Levim klikom mia na ikonu stola ili sa tap prstom kod touch-screen
  -------------------------------------------------------------------
  monitora, aktivira se dbf browser za izabrani sto od broja 1 do 100
  odnosno otvara se RAUN STOLA 1,2,3... 100
  koji sadri stavke artikala isporuene gostu, kao i komandnu dugmad
  i komandne tastere za operacije koje se mogu izvriti na RAUNU STOLA:

   - formiranje odnosno obrada rauna,
     (dodavanje ili brisanje ili ekiranje/deekiranje stavki artikala),
   - pregled rauna u tekst editoru,
   - tampa rauna kao kasa bloka (bez pdv stope i pdv iznosa),
     (tampaju se samo neekirane stavke sa rauna)
   - tampa rauna kao fiskalnog rauna (sa pdv stopama i pdv iznosima),
     (tampaju se samo neekirane stavke sa rauna)
   - tampa rauna kao fakture za kupca (bez pdv stopa i pdv iznosa),
     (tampaju se samo neekirane stavke sa rauna)
   - tampa rauna kao naloga anku,
     (tampaju se samo neekirane stavke sa rauna ija grupa je P Pie)
   - tampa rauna kao naloga kuhinji,
     (tampaju se samo neekirane stavke sa rauna ija grupa je H hrana)
   - brisanje rauna,
     (briu se sve stavke iz rauna - raun se prazni)
   - prenos rauna ili dela rauna (samo neekirane stavke) na drugi sto


  (1)

   With a left click of the mouse on the TABLE icon or with a finger tap on the touch-screen
   -------------------------------------------------- -----------------
   monitor, the dbf browser is activated for the selected TABLE from number 1 to 100
   i.e. TABLE ACCOUNT 1,2,3... 100 is opened
   which contains item items delivered to the guest as well as command buttons
   and command keys for operations that can be performed on the DESK ACCOUNT:

    - formation or processing of accounts,
      (adding or deleting or checking/unchecking item items),
    - account overview in the text editor,
    - printing of the invoice as a cash register block (without VAT rate and VAT amount),
      (only unchecked invoice items are printed)
    - printing of the invoice as a fiscal invoice (with VAT rates and VAT amounts),
      (only unchecked invoice items are printed)
    - printing of invoices as invoices for the customer (without VAT rates and VAT amounts),
      (only unchecked invoice items are printed)
    - print the bill as an order to the bar,
      (only unchecked items from accounts whose group is P Beverages are printed)
    - print the bill as an order to the kitchen,
      (only unchecked items from accounts whose group is H food are printed)
    - account deletion,
      (all items from the account are deleted - the account is emptied)
    - transfer of the bill or part of the bill (only unchecked items) to another TABLE


  (2)

  Desnim klikom mia na ikonu stola ili sa tap prstom kod touch-screen
  --------------------------------------------------------------------
  otvara se i prikazuje se RAUN STOLA u tekst editoru NOTEPAD
  za brzi uvid u stanje rauna.
  Prikazuju se samo stavke artikala koje nisu ekirane u raunu stola,
  njihova ifra, naziv, mera, koliina, cena i vrednost kao i ukupan iznos
  rauna, zatim broj kase i kasira i nain plaanja.


  (2)

   By right-clicking the mouse on the TABLE icon or by tapping with your finger on the touch-screen
   -------------------------------------------------- ------------------
   opens and shows the TABLE CALCULATION in the NOTEPAD text editor
   for a quick overview of the account balance.
   Only item items that have not been checked into the TABLE account are displayed,
   their code, name, measure, quantity, price and value as well as the total amount
   of the account, then the number of the cash register and the cashier and the method of payment.


*/



// make sure to link the correct libraries
#pragma Library( "XppUI2.LIB" )
#pragma Library( "Adac20b.lib" )

#include "Appevent.ch"
#include "Common.ch"
//#include "Font.ch"
//#include "Gra.ch"
#include "Xbp.ch"


#INCLUDE "DCDIALOG.CH"
#INCLUDE "DCGRA.CH"
#INCLUDE "(KASA-STOLOVI-RESOURCE)\KASA-STOLOVI.CH"

#include "xbtsys.ch"







/*

* --- BLIND FUNCTIONS ---
* --- Functions that must exist for the program to work but are not used here :

FUNCTION  __BON_FISKALNI_PRINTERI_IZBOR   ; stop(1,1) ; RETURN NIL
FUNCTION  VRSTA_RACUNA_TRANSAKCIJA        ; stop(1,1) ; RETURN NIL
FUNCTION  KASIR_KUPAC_VEZA                ; stop(1,1) ; RETURN NIL
FUNCTION  KUSUR                           ; stop(1,1) ; RETURN NIL
FUNCTION  STAMPAJ_NEFISKALNI_ISECAK       ; stop(1,1) ; RETURN NIL
FUNCTION  KUPCI_STAMPAJ_RACUN             ; stop(1,1) ; RETURN NIL
FUNCTION  XVIDIGA_TXT                     ; stop(1,1) ; RETURN NIL
FUNCTION  TXT_HLP                         ; stop(1,1) ; RETURN NIL
FUNCTION  DCHOTKEY_TASTERS                ; stop(1,1) ; RETURN NIL
FUNCTION  KASA_POPIS_RACUNA               ; stop(1,1) ; RETURN NIL
FUNCTION  SEF_TEST_PRODUCTION             ; stop(1,1) ; RETURN NIL
FUNCTION  VIDI_RACUN_STOLA                ; stop(1,1) ; RETURN NIL
FUNCTION  KASA                            ; stop(1,1) ; RETURN NIL
* --- BLIND FUNCTIONS ---
*/



















*" THIS CASHIER WORKS WITH PostgreSQL SERVER "*
*" OVA KASA RADI SA PostgreSQL SERVEROM "*
***************************************************************************
FUNCTION _KASA_stolovi_screen()
***************************************************************************
SET DATE GERMAN
SET CENTURY ON
SET CHARSET TO ANSI


PUBLIC testtest:=.F. // radi testiranja _dcxbutt.prg



// Postavlja se iz LICENCA_PROGRAMA() __LICENCA_PROGRAMA.PRG KASA_BAZA.DLL
// i slui za ograniavanje upotrebe nekih operacija ako je proguran datumi_stop()
   PUBLIC dozvola_za_rad := .T.
   PUBLIC mmm            := 2 // distancer
   PUBLIC EXEnaziv       := "COBA KASA STOLOVI"
   PUBLIC CUR            := { "USER32.DLL", 114 }
   PUBLIC RESTART        := .F.
   PUBLIC KASAIME        := EXEnaziv

   PUBLIC nOldIcon := DC_ICONDEFAULT(1) // eXpress++
   DC_DotHotKey(180)    // Prebaci DotPrompt sa Alt+D na 180 // eXpress++
   SetCancel(.F.)       // turn off Alt+C




// --- initialize the cash register database and PUBLIC cash register:
// --- inicijalizuj bazu podataka kase i PUBLIC kase:

  *  __pg__ini()  // C-PGDB.DLL,C-PGDB.INI // 0_KASA_STOLOVI_GLAVNI.PRG
  *  STOP(_MAG_,_KAS_,MAG,KAS,cObjekat_kase,cBroj_kase,1) // TEST


   ********** // __XKONOBAR_XKASIR.PRG
   xKONOBAR() // ITANJE I PRIKAZ KASIRA NA DISPLAY TITLEBAR-a
   ********** // PROMENA NASLOVA NA TITLEBARU APP PROZORA
              // Formira: PUBLIC KASANASLOV
              // STOP(KASANASLOV)

// --- initialize the cash register database and PUBLIC cash register:

   // use command button for invisible tables in
   // 3_KASA_tach_buttons_stolovi.prg:
   PUBLIC o_for_stealt_table := nil

   *********
   STOLOVI()  // here
   *********

RETURN NIL









*************************************************************************
FUNCTION STOLOVI()
*************************************************************************

LOCAL Getlist := {}, GetOptions,  oDlg,  cZBIR, oZBIR
LOCAL oButton, lOk := .t., nEvent, mp1, mp2, oXbp
LOCAL radno := SELECT()
LOCAL x1,x2,y2,bb

PUBLIC Get_List := NIL , ooDlg := NIL

PUBLIC EXEnaziv := KASAIME
PUBLIC oBrowse1, oBrowse2, oCena
PUBLIC MAG1, MAG2, svega, spisak1, spisak2
PUBLIC cSifBar := space(13)  // inicijalno ifra ili barkod
PUBLIC kljuc := "X" // "R" raun je aktivan, "S" spisak artikala je aktivan,
                    // "X" upis ifre barkoda i koliine je aktivan
                    // odreuje koja e dugmad da budu WHEN disable/enable


PUBLIC SIFRA_KASIRA := "00"
//***  SIFRA_KASIRA := Upis_Sifre_Kasira()
PUBLIC CUR := { "USER32.DLL", 114 }

PUBLIC XPRESTART := .F.; RESTART := .F.



////***********************************
////STEALT_BUTTONS_UGOSTITELJ1(GetList) // STEALT_BUTTONS_UGOSTITELJ.PRG
////***********************************



//---podaci za funkciju stampaj_racun()
// stampaj_kasa_bon()
PUBLIC trazi, obrisi, kes, cek, kar
obrisi       := 0       // 0 - samo stampaj,
                        // 1 - posle stampanja arhiviraj i obrisi racun
kes          := "0.00"  // kupac platio u kesu      Placanje_kes()
cek          := "0.00"  // u cekovima               Placanje_cek()
kar          := "0.00"  // u preko kreditne kartice Placanje_kar()
cKusur       := "0.00"  // kusur za kupca

dbf1 := "ARTIKLI->"  // alias->ROBS_
dbf2 := "RACUN->"    // alias->ROBS_
dbf3 := "ARHIVA->"   // alias->ROBS_
//---podaci za funkciju stampaj_racun()


*************************************************************************  START
*
*                           D A T A B A S E
*
*************************************************************************
// THE DBFNTX DATABASE IS NOT USED HERE
// POSTGRESQL DATABASE IS USED

//---DBF ZA ARHIVU FISKALNIH BONOVA
 *   USE (KASA_STAV) NEW EXCLUSIVE ALIAS "ARHIVA"
 *    INDEX ON BRJ0_ TO (KASA_STAV_BROJ)
 *    INDEX ON DAT0_ TO (KASA_STAV_DATUM)
//---DBF ZA ARHIVU FISKALNIH BONOVA
*************************************************************************
*
*                           D A T A B A S E
*
*************************************************************************  END





*** ec_p("START")

************************************************************************* START
*                          "GORNJI TOOLBAR" - "TOP TOOLBAR"
*************************************************************************

   ******************************************
   KASA_tach_buttons_gornji_toolbar(GetList)   // 2_KASA_tach_buttons_gornji_toolbar.prg
   ******************************************

*************************************************************************
*                          "GORNJI TOOLBAR"
************************************************************************* END



***************************************************************************  START
*                           "S T O L O V I"   "TABLES"
***************************************************************************

   // GUI prikaz TSBC slika STOLOVA na ekranu
   // 3_KASA_tach_buttons_stolovi.prg
   // Startuje se tek posle DC READ GUI

   // GUI display of TSBC images of TABLES on the screen
   // 3_KASA_tach_buttons_stolovi.prg
   // Starts only after DC READ GUI

   ************************************
   KASA_tach_buttons_stolovi(GetList)   // 3_KASA_tach_buttons_stolovi.prg
   ************************************



***************************************************************************
*                           "S T O L O V I"
***************************************************************************  END




***************************************************************************  START 06-11-2023
*                           " DONJI TOOLBAR"  "BOTTOM TOOLBAR"
***************************************************************************

PRIVATE nx:=38, ny:= 123 // 0.2 + 10

PRIVATE nx:=31.6, ny:= 122.6 // 0.2 + 10


 @ nx,ny ;
 DCSTATIC TYPE XBPSTATIC_TYPE_RAISEDBOX CAPTION "ToolBar";
                              SIZE 14, 2.6 ;
                              OBJECT ToolOkvir ;
                              COLOR GRA_CLR_DARKGREEN,GRA_CLR_DARKGREEN PARENT OkvirBmp


   * [CTRL][A]
   @ 0.5,1 DCPUSHBUTTON CAPTION "A" SIZE 3,1.6 ;
     CURSOR CUR PARENT ToolOkvir ACCELKEY xbeK_CTRL_A;
     TOOLTIP " ARTICLES "  FONT "14.Verdana Bold" ;
     ACTION {|a,b,o| ARTICLES_GROUP("all") } // __ARTICLES_GROUP.PRG
     * artikli_u_kasi()

   * [CTRL][G]
   @ 0.5,1+3 DCPUSHBUTTON CAPTION "G" SIZE 3,1.6 ;
     CURSOR CUR PARENT ToolOkvir ACCELKEY xbeK_CTRL_G;
     TOOLTIP " GROUPS "  FONT "14.Verdana Bold" ;
     ACTION {|a,b,o| ARTICLES_GROUP("group") } // __ARTICLES_GROUP.PRG


   * [CTRL][H]
   @ 0.5,1+3+3 DCPUSHBUTTON CAPTION "H" SIZE 3,1.6 ;
     CURSOR CUR PARENT ToolOkvir ACCELKEY xbeK_CTRL_H;
     TOOLTIP " HELP "  FONT "14.Verdana Bold" ;
     ACTION {|a,b,o| help__kasa_stolovi_screen() }


   * [CTRL][X]
   @ 0.5,1+3+3+3 DCPUSHBUTTON CAPTION "X" SIZE 3,1.6 ;
     CURSOR CUR PARENT ToolOkvir ACCELKEY xbeK_CTRL_X;
     TOOLTIP " EXIT "  FONT "14.Verdana Bold" ;
     ; // ACTION {||exit__prg()}                        // off in test mode
     ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} // on in test mode

***************************************************************************
*                           " DONJI TOOLBAR"
*************************************************************************** END


PUBLIC HIDE:=.F.
oLOGO(GetList)  // SHOW



*************************************************************************** START
*                           "STEALT BUTTONS"
***************************************************************************
* Blokiran je pristup funkcijama zbog testiranja baznog interfejsa programa
* Access to functions is blocked due to testing the basic interface of the program

* [CTRL]+[F3] DODATNE OPERACIJE U KASI (MENI)
*-------------------------------------------------
  DCHOTKEY xbeK_CTRL_F3 ;
  ACTION {|| meni_dodatne_operacije(oDlg,GetList) }



* [SHIFT]+[F1] PRIKAZ LOKACIJE PROGRAMA I DATABASE
*-------------------------------------------------
  DCHOTKEY xbeK_SH_F1 ;
  ACTION {|| lokacija_prg_dbe() }


* [SHIFT]+[F2] POSTAVI OZNAKU [X] NA SVAKI STO KOJI IMA STAVKE RAUNA
*--------------------------------------------------------------------
  DCHOTKEY xbeK_SH_F2 ;
  ACTION {|| markiraj_zauzete_stolove() ,;
             RESTART:=.T.,;
             DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }


* [SHIFT]+[F3] POPIS RAUNA IZ AKTUELNOG DNEVNOG PAZARA
*---------------------------------------------------------------
  DCHOTKEY xbeK_SH_F3 ;
  ACTION {|| popis_racuna_iz_dnevnog_pazara() }


* [SHIFT]+[F4] POPIS RAUNA IZ ZADATOG PERIODA
*---------------------------------------------------------------
  DCHOTKEY xbeK_SH_F4 ;
  ACTION {|| popis_racuna_iz_perioda_pazara() }


* [SHIFT]+[F5] UKLJUI VIRTUELNU TASTATURU
*-------------------------------------------------
  DCHOTKEY xbeK_SH_F5 ;
  ACTION {|| aktiviraj_virtuelnu_tastaturu() }


* [SHIFT]+[F6] Use of stealth accounts (stealth tables)
*-------------------------------------------------
  DCHOTKEY xbeK_SH_F6 ;
  ACTION {|| aktiviraj_stealt_account_table(NIL,GetList,okvirbmp) }  // here



* svi programi za kasu - all cash register programs
* [CTRL][F1]
* Help 1048608   -  there is command button
*=====================================================
DCHOTKEY xbeK_CTRL_F1 ;
ACTION {|| STEALT_BUTTONS_UGOSTITELJ1(GetList) } // command_buttons_and_tasters.prg

* svi programi za kasu
* [CTRL][F2]
* Dokumentacija i Uputstva za rad sa programom
* Documentation and Instructions for working with the program
*=======================================================
DCHOTKEY xbeK_CTRL_F2 ;
ACTION {|| documentation_and_instruction() }  // command_buttons_and_tasters.prg

* svi programi za kasu
* [CTRL][P]
* Promena kasira ili konobara
* Change of cashier or waiter
*=======================================
 DCHOTKEY xbeK_CTRL_P  ;
 ACTION {|| promena_kasira_konobara() }  // command_buttons_and_tasters.prg

* svi programi za kasu
* [CTRL][F12]
* FISKALNI RAUN IZ ARHIVE RAUNA PO ZADATOM REDNOM BROJU
* SA SVIM PODACIMA O RAUNU U C_EDIT() ZA PDF/LASER TAMPU
* ---
* FISCAL ACCOUNT FROM THE ACCOUNT ARCHIVE ACCORDING TO THE
* SPECIFIED SERIAL NUMBER WITH ALL INVOICE DATA IN C_EDIT()
* FOR PDF/LASER PRINTING
*======================================================================
  DCHOTKEY xbeK_CTRL_F12 ; //  [CTRL][F12] ;
  ACTION {|| print_archived_fiscal_bill() }
  // command_buttons_and_tasters.prg
  // poziva funkciju:  _ARHIVA_FISKALNIH_RACUNA_2022() koja je ovde




// ----- added 12-11-2023 ----- // Masking technique  //---------------- start
//
// LOGO slika koja pokriva sliku restorana i restoranskih stolova
// Na startu programa LOGO slika maskira sporo iscrtavanje restoranskih
// stolova na ekranu monitora - to deluje runo i neprofesionalno
//
// LOGO image that covers the image of the restaurant and restaurant tables
// At the start of the program, LOGO image masks the slow drawing of the
// restaurants tables on monitor screen - which looks ugly and unprofessional



DCHOTKEY ASC("+") ACTION {|| ;  // FULL SCREEN
INI_WRITE("L","KASA","window",.T.,gde_exe()+"\KASA.INI") ,;
RESTART:=.T.,;
DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCHOTKEY ASC("-") ACTION {|| ;  // DEFAULT SCREEN
INI_WRITE("L","KASA","window",.F.,gde_exe()+"\KASA.INI") ,;
RESTART:=.T.,;
DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }


PUBLIC HIDE:=.F.
PRIVATE oLOGO := NIL // object
oLOGO(GetList)  // here

DCHOTKEY 46 ; // START APPLICATION AND START LOGO IMAGE
ACTION {|| _oLOGO() }  // here


// ----- added 12-11-2023 ----- // Masking technique //------------------- end

***************************************************************************
*                           "STEALT BUTTONS"
*************************************************************************** END


*** ec_k("END")








* #######################################################################
*
*                            DCREAD GUI
*
* #######################################################################


cTitle := APLIKACIJA+" | "+KASANASLOV+" | "+FPR+" | " // koriguj ovo sa: naslovpromeni()  // kasa_baza.dll

bHandler := {|a,b,c,d,e,f,g,h|MyHandler(a,b,c,d,e,f,@g,h)}

window := INI_READ("L","KASA","window",gde_exe()+"\KASA.INI")
* window =.T.   // FULL SCREEN
* window =.F.   // DEFAULT SCREEN


 DCGETOPTIONS NOESCAPEKEY ;   // COLOR GraMakeRGBColor({5,61,5})
 WINDOWWIDTH 985 WINDOWHEIGHT 860 ;
 MINSIZE 985,860 ;
 AUTORESIZE ;
 TOOLTIPCOLOR GRA_CLR_BLACK,GRA_CLR_YELLOW TOOLTIPFONT "10.Consolas" ;
 HIDE // o:show()



 DCREAD GUI HANDLERBLOCK bHandler  ;
 TITLE cTitle ;
 OPTIONS GetOptions ;
 SETFOCUS @oDlg ;
 PARENT @oDlg ;
 MODAL ;
 EVAL {|o| SetAppWindow(o) ,;
 Get_List := GetList       ,;
 ooDlg    := o             ,;
 IIF(window=.T., o:setFrameState(XBPDLG_FRAMESTAT_MAXIMIZED), NIL) ,;
 START_STOP_KASE(1) ,;  // start-stop kase i upis u log fajl
 naslovpromeni()    ,;
 o:show()}



SELECT(radno)



 IF RESTART = .T.
    qq := RunShell("",AppName(.T.))
 ENDIF
 IF XPRESTART = .T.
    qq := RunShell("",AppName(.T.))
    // XPmanifest.PRG  za manifest - mora ovaj restart
 ENDIF

 START_STOP_KASE(0)  // here

 *** TMP_ISPRAZNI() // bazne.dll // Delete all auxiliary temporary files

RETURN (NIL)





***************************************************************************
STATIC FUNCTION MyHandler(nEvent,mp1,mp2,oXbp,oDlg,aGetlist,aRef,lOk )
***************************************************************************

                            //------------------------
IF nEvent == xbeM_RbClick   // OK samo desni klik mia
                            //------------------------


    * STOP(oXbp:cargo,1)
    IF oXbp:cargo == NIL
        RETURN NIL
    ENDIF

     /*
      txt := ;
      " 1. nEvent   - The event type.                                  " + var2char(nEvent)           +chr(59)+;
      " 2. mp1      - The first event parameter.                       " + var2char(mp1)              +chr(59)+;
      " 3. mp2      - The second event parameter.                      " + var2char(mp2)              +chr(59)+;
      " 4. oXbp     - A pointer to the object creating the event.      " + var2char(oXbp)             +chr(59)+;
      " 5. oDlg     - A pointer to the main dialogue object.           " + var2char(oDlg)             +chr(59)+;
      " 6. aGetlist - A pointer to the GetList array.                  " + var2char("x")              +chr(59)+;
      " 7. aRef     - A pointer to an optional Reference array that    "                              +chr(59)+;
      "               was passed to DC_ReadGets().                     " + var2char(aRef)             +chr(59)+;
      " 8. lOk      - A logical value that is .TRUE. if the OK button  "                              +chr(59)+;
      "               was clicked and .FALSE. if CANCEL was clicked.   " + var2char(lOk)              +chr(59)+;
      " "
     c__procitaj(txt,"TEST FUNKCIJE")
     */


     /*
      *******************
      aa := oXbp:cargo[3]
      *******************
      txt := ;
      "broj  : "+var2char(aa[1]) +chr(59)+;
      "ifra : "+var2char(aa[2]) +chr(59)+;
      "Naziv : "+var2char(aa[3]) +chr(59)+;
      "Exten : "+var2char(aa[4]) +chr(59)+;
      "BMP   : "+var2char(aa[5]) +chr(59)+;
      "CAPT  : "+var2char(aa[6]) +chr(59)+;
      " "
     c__procitaj(txt,"DCBUTTON CARGO")
     */

     aSadrzaj:=oXbp:cargo[3] // TSCB taster ima Array kao CARGO varijablu
                             // TSCB key has Array as CARGO variable

     IF TYPE("aSadrzaj")$"A" // ako je Array tada moe biti dugme grupe ili dugme stola
                             // grupa ima tri lana, a sto ima dva lana u aSadrzaj nizu
                             // if Array then can be group button or table button
                             // the group has three members, and the table has two members in the aSadrzaj array


//        ***************************
//        IZMENI_BUTTON_ARTIKAL(oXbp)
//        ***************************

        IF LEN(aSadrzaj)==3 // OVO JE GRUPA  | THIS IS A GROUP  | GROUP NAME CHANGE

         grupa_cname := aSadrzaj[1]
         grupa_nbroj := aSadrzaj[2]
         grupa_cznak := aSadrzaj[3]


            * IF c__sifra(1,"Password","ifra za promenu naziva grupe")==.T.

                 upis:=eUpis0(PADR(grupa_cname,30),"IZMENA")
                 upis:=alltrim(upis)
                 IF EMPTY(upis)==.F.
                  * INI_WRITE("C","GRUPE","1","PIVO;RAKIJA",GDE_EXE()+"\KASA.INI")
                    INI_WRITE("C","GRUPE",var2char(grupa_nbroj),upis,GDE_EXE()+"\KASA.INI")
                    oXbp:setcaption(upis)
                 ENDIF

            * ENDIF // c__sifra()

        ELSE   // OVO JE STO  | THIS IS A TABLE  | BILL ON THE TABLE

              cFileStola:=asadrzaj[1] // "X100.STO"
              *******************************
              vidi_racun_na_stolu(cFileStola)  // command_buttons_and_tasters.prg
              *******************************

        ENDIF


     ENDIF



                                   //------------------------
ENDIF // IF nEvent == xbeM_RbClick // OK samo desni klik mia
                                   //------------------------


RETURN DCGUI_NONE







*************************************************************************** 12-03-2020
STATIC FUNCTION START_STOP_KASE(nn)
***************************************************************************
LOCAL radno:=SELECT(), log:=""
            // OFF
 RETURN NIL // ISKLJUENO DOK SE PROGRAM TESTIRA - DA NE ODUZIMA VREME
            // OFF WHILE THE PROGRAM IS BEING TESTED - NOT TO TAKE UP TIME
IF nn==1
   C__PORUKA(DTOC(DATE())+chr(59)+TIME(),"KASA START",,"A")
   log := alltrim(MEMOREAD("START_STOP_KASE.LOG"))
   log := log + "1. KASA START "+DTOC(DATE())+" "+TIME() +chr(13)+chr(10)
   MEMOWRIT("START_STOP_KASE.LOG",log)
ELSE
   C__PORUKA(DTOC(DATE())+chr(59)+TIME(),"KASA STOP",,"A")
   log := alltrim(MEMOREAD("START_STOP_KASE.LOG"))
   log := log + "2. KASA STOP  "+DTOC(DATE())+" "+TIME() +chr(13)+chr(10)
   MEMOWRIT("START_STOP_KASE.LOG",log)
ENDIF
SELECT(radno)
RETURN NIL


*************************************************************************
FUNCTION tastatura() // WINDOWS VIRTUELNA TASTATURA
*************************************************************************
/*
stop("tastatura")
* PostAppEvent(xbeP_Keyboard,xbeK_WIN,,ooDlg) // ne postoji
* PostAppEvent(xbeP_Keyboard,196721,,ooDlg) // xbeK_SH_F2 SHIFT+F2 = 196721  ovo radi
* PostAppEvent(xbeP_Keyboard,93,,ooDlg)  // WINDOWS KEY ovo ne radi
* PostAppEvent(xbeP_Keyboard,93+15,,ooDlg)  // WINDOWS KEY ovo ne radi
* WINDOWS KEY ili WINDOWS LOGO KEY taster nema ASC kod ali ima kljune kodove 91,92,93
return nil
*/

/*
 * OSK.EXE se ne moe aktivirati na ovaj nain:
 stari:=gde_sam()
 curdir("C:\Windows\System32")
     runshell("/C OSK.EXE",,.T.,.T.)
 curdir(stari)
 RETURN NIL
*/

tas:=gde_exe()+"\FreeVK.exe"
IF FILE(tas)=.F.
   c_greska(tas,"Nema virtuelne tastature")
   RETURN NIL
ENDIF

    prg:="/C "+gde_exe()+"\FreeVK.exe"  // ne radi
    prg:="/C FreeVK.exe" // radi
    stari:=gde_sam()
    CURDIR(gde_exe())
      runshell(prg,,.T.,.T.)        // ovo radi
    * runshell("/C FreeVK.exe",,.T.,.T.) // ovo radi
    CURDIR(stari)

* Windows OSK tastatura:
* On-Screen-Keyboard OSK tastatura
* Miem birate slova za kucanje. Jezik tastature menjate klikom na ALT + SHIFT.
* https://gate2home.com   //  izbor jezika za OSK tastaturu
* WIN+CTRL+O

RETURN nil



* [SHIFT]+[F6] Use of stealth accounts (stealth tables)
*************************************************************************
STATIC FUNCTION aktiviraj_stealt_account_table()
*************************************************************************

 RACUN_NA_STOLU_ZADAJ()
 * 4_KASA_tach_buttons_stolovi_racuni.prg

RETURN NIL




***************************************************************************
FUNCTION podesi_browser(xx)  // 0-ponisti aBrowPres 1-formiraj aBrowPres
***************************************************************************
BROWSER_COLOR()  // baznex.dll
RETURN NIL





************************
STATIC FUNCTION _oLOGO()
************************
IF HIDE==.F.
   HIDE:=.T.
   oLOGO:HIDE()
   RETURN NIL
ENDIF
IF HIDE==.T.
   HIDE:=.F.
   oLOGO:SHOW()
   oLOGO:ToFront()
   RETURN NIL
ENDIF
RETURN NIL


*************************************************************************
FUNCTION oLOGO(GetList)  // LOGO IMAGE FOR MAIN-APP-WINDOW
*************************************************************************

LOCAL b1 := GraMakeRGBColor({100,30,50}) // CRNO VINO    // RED WINE
LOCAL b2 := GraMakeRGBColor({5,61,5})    // ZELENA TRAVA // GREEN GRASS
LOCAL oCUR:={"user32.dll",114}

LOCAL Dhor,Dver,Whor,Wver,Ohor,Over,Xhor,Xver

//---DESKTOP
aSize:=appdesktop():currentsize()
Dhor  := aSize[1] ; Dver := aSize[2]  // CURRENT DESKTOP DIMENSION
//---DESKTOP

// OVO JE DEFAULT APP PROZOR 985 x 860  U KOME JE DUGME 985 x 860
//---PROGRAMMED DEFAULT APP WINDOW
Whor  := 985      ; Wver := 860       // DEFAULT APP WINDOW DIMENSION
//---PROGRAMMED DEFAULT APP WINDOW

// OVO JE RESIZE FULLSCREN APP PROZOR NA 1600 x 900 U KOME JE DUGME 985 x 860
//---DESKTOP-FULLSCREEN APP WINDOW  (resize object)
Ohor  := whor     ; Over := Wver      //
//---DESKTOP-FULLSCREEN APP WINDOW  (resize object)


//
// CHOICE FOR APP WINDOW TO CREATE
//
Xhor  := 0    ; Xver  := 0  //  APP WINDOW DIMENSION

window := INI_READ("L","KASA","window",gde_exe()+"\KASA.INI")

IF window==.F.   //---DESKTOP FULLSCREEN
   Xhor  := Whor
   Xver  := Wver
ELSE             //---PROGRAMMED DEFAULT
   Xhor  := Ohor
   Xver  := Over
ENDIF
//
// CHOICE FOR APP WINDOW TO CREATE
//

// CONTROL RESULT CREATED APP WINDOW
* Chor  := 0    , Cver := 0   // CREATED APP WINDOW DIMENSION
* aSize := o:currentsize()
* LOCAL Chor  := aSize[1] , Cver := aSize[2]   // CREATED APP WINDOW DIMENSION
// CONTROL RESULT CREATED APP WINDOW


PUBLIC oLOGO := NIL , HIDE := .F.

/*
//------------------------------ VARIJANTA A ----------------------------
// RESIZE BMP NO STRETCH

@ 0,0 ; // Xhorp, Xverp ;
DCPUSHBUTTON CAPTION 1001 ;
OBJECT oLOGO   ;   // PARENT ooDlg
PIXEL          ;
SIZE Xhor,Xver ACCELKEY ASC(".") ;
CURSOR oCUR  TOOLTIP " Logo OFF/ON click on key (dot) ; (+) and (-) Full Screen ON/OFF " ;
ACTION {|a,b,o|  oLOGO:=o  ,;
                 o:HIDE()     ,;
                 HIDE :=.T.   ,;
                 ; // DC_GetRefresh(GetList),;
                 NIL}
//------------------------------ VARIJANTA A ----------------------------
*/



*
//------------------------------ VARIJANTA B ----------------------------
// RESIZE BMP STRETCH

@ 0,0 ;
DCPUSHBUTTONXP BITMAP 1001 ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ;
OBJECT oLOGO   ;
PIXEL          ;
SIZE Xhor,Xver ACCELKEY ASC(".") ;
CURSOR oCUR TOOLTIP " Logo OFF/ON click on key (dot) ; (+) and (-) Full Screen ON/OFF " ;
     COLOR b2,b2 ;
CLICKCOLOR b2,b2 ;
MOUSECOLOR b2,b2 ;
ACTION {|a,b,o|  oLOGO:=o  ,;
                 o:HIDE()  ,;
                 HIDE :=.T.,;
                 ; // DC_GetRefresh(GetList),;
                 NIL}
//------------------------------ VARIJANTA A ----------------------------
*/


RETURN NIL











//*
//*   *********************************
//*   FileIni := gde_exe()+"\KASA.INI"
//*   *********************************
//*   PUBLIC windows_size := INI_Read ("C","SCREEN","SIZE", FileIni)      // donji_toolbar
//*   * PUBLIC windows_size := "MAX" ili "MIN"  // prodajni ekran
//*
//
//***************************************************************************
// FUNCTION winsize_start()
//***************************************************************************
//   LOCAL FileIni := gde_exe()+"\KASA.INI"
//   LOCAL SIZE := INI_Read ("C","SCREEN","SIZE", FileIni)
//    IF SIZE = "MIN"
//       winsize_min()
//    ELSE
//       winsize_max()
//    ENDIF
//
//RETURN NIL
//***************************************************************************
// FUNCTION winsize_max()
//***************************************************************************
//     LOCAL FileIni := gde_exe()+"\KASA.INI"
//
//     *oDlg:setFrameState(XBPDLG_FRAMESTAT_MAXIMIZED)
//     setappwindow():setFrameState(XBPDLG_FRAMESTAT_MAXIMIZED)
//     IF TYPE("oSifBar")$"O"
//     setappfocus(oSifBar)
//     ENDIF
//     INI_Write ("C","SCREEN","SIZE","MAX",FileIni)
//     PostAppEvent(xbeP_Keyboard,xbeK_ESC,,ooDlg)
//     //klik31()
//     PUBLIC windows_size := "MAX" // "MIN" ili "MAX"
//RETURN NIL
//***************************************************************************
// FUNCTION winsize_min()
//***************************************************************************
//     LOCAL FileIni := gde_exe()+"\KASA.INI"
//
//     *oDlg:setFrameState(XBPDLG_FRAMESTAT_NORMALIZED)
//     setappwindow():setFrameState(XBPDLG_FRAMESTAT_NORMALIZED)
//     IF TYPE("oSifBar")$"O"
//     setappfocus(oSifBar)
//     ENDIF
//     INI_Write ("C","SCREEN","SIZE","MIN",FileIni)
//     PostAppEvent(xbeP_Keyboard,xbeK_ESC,,ooDlg)
//     //klik31()
//     PUBLIC windows_size := "MIN" // "MIN" ili "MAX"
//RETURN NIL
//***************************************************************************
// FUNCTION winsize_replace()
//***************************************************************************
//    IF windows_size = "MIN"
//       winsize_max()
//    ELSE
//       winsize_min()
//    ENDIF
//RETURN NIL
//
//***************************************************************************
// FUNCTION kolicina_on_off_replace(oDlg)
//***************************************************************************
//   LOCAL FileIni := gde_exe()+"\KASA.INI"
//   PUBLIC kolicina_on := INI_Read ("L","TOUCH","KOLICINA_ON", FileIni)
//    IF kolicina_on = .T.
//       kolicina_on := .F.
//       INI_Write ("L","TOUCH","KOLICINA_ON",kolicina_on,FileIni)
//       RETURN NIL
//    ENDIF
//    IF kolicina_on = .F.
//       kolicina_on := .T.
//       INI_Write ("L","TOUCH","KOLICINA_ON",kolicina_on,FileIni)
//       RETURN NIL
//    ENDIF
//RETURN NIL
//
//
//
//
//function aaa()
//STOP("BLOCKED",0)
//return .f.
//










