
//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   3_KASA_tach_buttons_stolovi.prg
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   SAP --- Advantage Database Server ADS      version 10.10.0.49      //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "xbtsys.ch"

#INCLUDE "DCDIALOG.CH"
#INCLUDE "DCGRA.CH"
#INCLUDE "(KASA-STOLOVI-RESOURCE)\KASA-STOLOVI.CH"
  * B_STO1        =  501 "toolbar_ico\STO1.BMP"  // slobodno - free
  * B_STO2        =  502 "toolbar_ico\STO2.BMP"  // zauzeto [x] - busy




FUNCTION meni()
stop(1,1)
RETURN NIL

***************************************************************************
FUNCTION KASA_tach_buttons_stolovi(GetList) // GUI prikaz TSBC na ekranu
***************************************************************************
*   Formira grupu BUTTONS tastera koji predstavljaju stolove
*   i prikazuje BUTTONS tastere na ekranu


***************************************************************************
*     "B U T T O N S  S T O L O V I  -  BUTTONS TABLES
***************************************************************************
 LOCAL ;
 bb := 5-0.2 ,;
 du := 15-0.3,;
 x1 := 0.6   ,;
 y1 := 0.6   ,;
 aa := 15

* BAZNEX.DLL
  LOCAL of5 := Font_codepage(14,"Verdana",238,.t.)
  LOCAL co0,co1,co2,co3,co4,of1,of2,of3,of4,aCUR,oCUR
  I2018(@co0,@co1,@co2,@co3,@co4,@of1,@of2,@of3,@of4,@aCUR,@oCUR)
* DCPUSHBUTTONXP:
* CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2


PUBLIC fo1 := Font_codepage(12,"Archivo Narrow",238,.t.)

co7 := GraMakeRGBColor({10,181,57})   // TRAVA-ZELENA
co17 := GraMakeRGBColor({208,82,92})   // WIN10 CRVENA
co23 := GRA_CLR_PALEGRAY


* PUBLIC ini := strtran(appname(.t.),appname(),"KASA_RESTORAN.INI")
PUBLIC ini    := gde_exe()+"\KASA_RESTORAN.INI"
PUBLIC bmpico := INI_READ("L","DESIGN","bmpico",ini)
// koji se resursi koriste za sliku stola na Buttons stola:
// bmpico = .F. // koriste se STO1.ICO->I_STO1 i STO2.ICO->I_STO2 (DEFAULT)
// bmpico = .T. // koriste se STO1.BMP->B_STO1 i STO2.BMP->B_STO2
PUBLIC cap := INI_READ("L","DESIGN","caption",ini)
// .F. broj stola 11 i (x) slika - zauzeto
// .T. broj stola 11 u zagradama (11) - zauzeto
cap := .T.  // fiksirano

/*
[DESIGN]
bmpico=0
caption=1
[X100]
row=153
col=150
hor=46
ver=46
hide=0
free=0
name=COBIN STO
[X99]
row=153
col=150
hor=46
ver=46
hide=0
free=0
name=STO JE SLOBODAN
[X12]
row=363
col=570
hor=46
ver=46
hide=0
free=1
name=STO JE ZAUZET
*/

            * B I T M A P E  Z A  K O M A N D N U  D U G M A D
            // ako se koriste BMP bitmape ne moraju da budu objekti
             PUBLIC II_STO1 := XbpBitmap():new():create()
                    II_STO1:Load(NIL,601)
                    II_STO1:transparentClr := II_STO1:getDefaultBgColor()
             PUBLIC II_STO2 := XbpBitmap():new():create()
                    II_STO2:Load(NIL,602)
                    II_STO2:transparentClr := II_STO2:getDefaultBgColor()
             // na fullscreen - BMP se ne razvlae

            * B I T M A P E  Z A  K O M A N D N U  D U G M A D
            // ako se koriste BMP bitmape ne moraju da budu objekti
            // uzimaju se iz RES fajla ugraenog u EXE preko id broja
            // i mnemonika:
            //  501 = B_STO1
            //  502 = B_STO2
            // na fullscreen - BMP se ne razvlae



*****************************************************************
PUBLIC xrow,xcol,xhor,xver,xhide,xfree,xname
PUBLIC obj,sto, ok:=.T.

PUBLIC ooo := NIL
// objekat drugog stola na koji je prebaen raun sa prvog stola
// formira se iz FUNCTION RACUN_TO_DRUGISTO(oBrowse5)
// 4_KASA_tach_buttons_stolovi_racuni_stampe.prg
//---
// the object of the second table to which the account from the first table was transferred
// formed from FUNCTION CALCULATION_TO_OTHER(oBrowse5)
// 4_KASA_tach_buttons_stolovi_racuni_stampe.prg
*****************************************************************


***************************************************************** START
                   FOR i=100 TO 1 STEP -1
*****************************************************************


    PUBLIC xo   := nil
    *** xsto := "X"+alltrim(str(i))+".STO"  // "X1.STO","X2.STO","X3.STO"...
    *********************************
    xsto := "X"+alltrim(str(i))  // "X1","X2","X3"...  // T A B L E N A M E
    *********************************

    broj  := alltrim(str(i)) // -----------"1"
    marka := "X"+broj        // ---------- "X1" do "X100"
    xrow  := INI_READ("N",marka,"row",ini)
    xcol  := INI_READ("N",marka,"col",ini)
    xhor  := INI_READ("N",marka,"hor",ini)
    xver  := INI_READ("N",marka,"ver",ini)
    xhide := INI_READ("L",marka,"hide",ini)
    PUBLIC xfree := INI_READ("L",marka,"free",ini)
    xname := INI_READ("C",marka,"name",ini)


    PUBLIC oxo := "oX"+broj  // naziv varijable OBJECT svakog dugmeta oX1... oX100
    PUBLIC oxi := "oX"+broj

    PUBLIC cbrojstola:=broj
    PUBLIC cfajlstola:=xsto  // T A B L E N A M E

   * stop({xrow,xcol,xhor,xver}) //153,150, 46,46
   * stop(bmpico,1)


  // xfree = .F. sto je slobodan
  // xfree = .T. sto je zauzet
  // public obj := '"'+(marka)+'"'


 *-----------------------------------------------------------
 *" Ne uitavaj stolove koji su u magacinu na poziciji 15,15
 *" Do not load tables that are in the warehouse at position 15,15
 IF xrow = 15 .and. xcol = 15
    * Ne uitavaj stolove koji su na poziciji 15,15
 ELSE
 *-----------------------------------------------------------


              @ xrow,xcol ;
              DCPUSHBUTTON CAPTION IIF(xfree=.T.,B_STO2,B_STO1); // vano2:
              SIZE xhor, xver ;
              CURSOR aCUR PIXEL PARENT OkvirBmp ;
              FONT "10.Verdana Bold" ;
              OBJECT i ;
              ID oxi ;
              CARGO {xsto,i} ;  // T A B L E N A M E
              ACTION {|a,b,o| racun_na_stolu(o,GetList,okvirbmp),;    //  4_KASA_tach_buttons_stolovi_racuni.prg
                              otvoridrugisto() }                      //  3_KASA_tach_buttons_stolovi.prg


              * umesto TOOLTIP koristi se:
              * --- 11-07-2023
              * AKTIVAN JE PRIKAZ IKONA STOLOVA U PROSTORIJI UGOSTITELJSKOG OBJEKTA
              * [DESNI KLIK MIEM NA IKONU STOLA]
              *
              * klik na dugme u -> 3_KASA_tach_buttons_stolovi.prg
              * aktivira se     -> MyHandler()  iz 1_KASA_stolovi_screen.prg
              * funkcija        -> MyHendler()
              *     poziva      -> vidi_racun_stola()       iz KASA_RESTORAN_STOLOVI.PRG
              *                      vidi_racun_stola1()    prebacuje stavke sa "STO" u "RACUN"
              *                                             tampa txt raun za sto u notepad iz "RACUN"
              * --- 11-07-2023



              @ 0,26; // (gore-levo 0,0; dole-levo 26,0; dole-desno 26,26; gore-desno 0,26)
              DCPUSHBUTTONXP CAPTION broj;
              SIZE 20,20 ;
              PARENT i ;
              FONT "8.Verdana Bold" ;
              PIXEL ;
              CARGO {xsto,i};
              ACTION {|a,b,oo| vidi_zbir_racuna_stola(oo,cbrojstola,GetList) }

              // vano2:
              //
              // CAPTION ne sme da bude codeblock i ICO.
              // Mora da bude bitmapa BMP. Ako je CodeBlock,
              // tada aktivira samo postavku za zadnje
              // i=1 CAPTION: {|| IIF(xfree,B_STO2,B_STO1) }
              // i prikazuje sve stolove sa tom bitmapom !
              //
              // Bitmapa na stolu menja se na izlazu iz rauna stola u programu
              //   4_KASA_tach_buttons_stolovi_racuni.prg
              //        STATIC FUNCTION slobodan_sto(o,cRacun,cFile,GetList1)
              //        STATIC FUNCTION zauzet_sto(o,cRacun,cFile,GetList1)
              //
               // important2:
               //
               // CAPTION must not be codeblock and ICO.
               // Must be a BMP bitmap. If CodeBlock,
               // then only activates the last setting
               // i=1 CAPTION: {|| IIF(xfree,B_STO2,B_STO1) }
               // and display all tables with that bitmap !
               //
               // The bitmap on the table is changed at the exit from the table calculation in the program
               // 4_KASA_tach_buttons_stolovi_racuni.prg
               // STATIC FUNCTION free_table(o,cAccount,cFile,GetList1)
               // STATIC FUNCTION busy_table(o,cAccount,cFile,GetList1)
               //
             *-------------------------------------------------------------



 *-----------------------------------------------------------
 *" Ne uitavaj stolove koji su u magacinu na poziciji 15,15
 *" Do not load tables that are in the warehouse at position 15,15
 ENDIF // IF xrow = 15 .and. xcol = 15
 *-----------------------------------------------------------


*****************************************************************
                              NEXT i
*****************************************************************  END

 * USE INVISIBLE RESTAURANT TABLE
 * Start rauna restoranskog stola kada sto nema ikonu
 * Start restaurant table account when table has no icon
 * Restoranski sto nije upisan u KASA_RESTORAN.INI
 * Restaurant table is not entered in KASA_RESTORAN.INI

 * From main(): PUBLIC o_for_stealt_table := nil
   @ 10,0 ;
   DCPUSHBUTTON CAPTION "     " SIZE 36,40 ;
   PIXEL PARENT OkvirBmp ;
   OBJECT o_for_stealt_table ; // PUBLIC
   FONT "8.Arial Bold" ;
   CURSOR aCUR TOOLTIP " Use invisible restaurant table " ;
   ACTION {|| RACUN_NA_STOLU_ZADAJ() }
   // 4_KASA_tach_buttons_stolovi_racuni.prg


RETURN NIL



***************************************************************************
FUNCTION tobak(o)
***************************************************************************
o:toback() // .T. ili .F.
RETURN .F.










***************************************************************************
FUNCTION otvoridrugisto()
***************************************************************************
* PUBLIC ooo = drugi__OBJ iz RACUN_TO_DRUGISTO(oBrowse5) -> 4_KASA_tach_buttons_stolovi_racuni_stampe.prg
* PUBLIC Get_List 1_KASA_stolovi_screen.prg
* PUBLIC okvirbmp 2_KASA_tach_buttons_gornji_toolbar.prg

// ako je u RAUNU STOLA izvreno prebacivanje rauna na drugi sto OBJECT ooo
// posle zatvaranja RAUNA STOLA otvara se RAUN STOLA tog drugog stola
//---
// if in TABLE ACCOUNT the account has been transferred to another table OBJECT ooo
// after closing the TABLE ACCOUNT, the TABLE ACCOUNT of that other table is opened


   DO WHILE .T.



      IF ooo == NIL
         // nema prebacivanja rauna na drugi sto
         // nije izvrena funkcija RACUN_TO_DRUGISTO(oBrowse5)
         ****
         EXIT
         ****
      ELSE
         // raun je prebaen na drugi sto DCPUSHBUTTON OBJECT ooo
         // izvrena je funkcija RACUN_TO_DRUGISTO(oBrowse5)
         // sada otvori taj drugi sto
         //---
         // no transfer of accounts to another table
         // function CALCULATION_TO_OTHER(oBrowse5) was not executed
         // now open that other table

         *************************************
         racun_na_stolu(ooo,Get_List,okvirbmp)   //  4_KASA_tach_buttons_stolovi_racuni.prg
         *************************************

      ENDIF

   ENDDO

   ooo := NIL // poniti objekat drugog stola | invalidate the second table object


RETURN NIL














* Poziva se iz 1_KASA_stolovi_screen.prg
* [SHIFT]+[F2] POSTAVI OZNAKE R (Raun/Reserve/Radi) NA STOLOVE
*--------------------------------------------------------------
*  DCHOTKEY xbeK_SH_F2 ACTION {|| PROVERI_STOLOVE() } // KASA_tach_buttons_stolovi.prg
*" Poziva se na startu main programa: KASA_stolovi_screen.PRG iz DCGUI READ EVAL{||}


// postavlja kod svih stolova COK_ = .T. ako na raunu stola ima stavki  (zauzet sto)
// postavlja kod svih stolova COK_ = .F. ako na raunu stola nema stavki (slobodan sto)
// a zatim restartuje aplikaciju
//
// sets the code of all tables COK_ = .T. if there are items on the table account (busy table)
// sets the code of all tables COK_ = .F. if there are no items on the table account (free table)
// and then restarts the application
************************************************************************* 11-07-2023
FUNCTION PROVERI_STOLOVE(GetList)
*************************************************************************

LOCAL radno:=SELECT()
LOCAL i:=0, cFile, bbrr, xsto,broj, marka, xrow, xcol
LOCAL brojac1:=0, brojac2:=0


IF C__NEDA("KONTROLA RAUNA NA STOLOVIMA"  +chr(59)+;
           "I REKONSTRUKCIJA OZNAKA"       +chr(59)+;
           "CONTROL OF ACCOUNTS ON TABLES" +chr(59)+;
           "AND RECONSTRUCTION OF MARKINGS"+chr(59)+;
           "","TABLES CONTROL")==.F.
   RETURN NIL
ENDIF

PUBLIC ini    := gde_exe()+"\KASA_RESTORAN.INI"


ec_p()

FOR i=1 TO 100   // proveri u INI da li sto ima svoju ikonu - komandno dugme
                 // check in INI if the table has its own icon - command button

    *** xsto := "X"+alltrim(str(i))+".STO"  // "X1.STO","X2.STO","X3.STO"...
    **********************************
    xsto := "X"+alltrim(str(i))  // "X1","X2","X3"...   T A B L E N A M E
    **********************************


    **********************************
    _xsto := _she_+"."+xsto // TABLE
    **********************************





    broj  := alltrim(str(i)) // -----------"1"
    marka := "X"+broj        // ---------- "X1" do "X100"

    xrow  := INI_READ("N",marka,"row",ini)
    xcol  := INI_READ("N",marka,"col",ini)

    *xhor  := INI_READ("N",marka,"hor",ini)
    *xver  := INI_READ("N",marka,"ver",ini)
    *xhide := INI_READ("L",marka,"hide",ini)
    *xfree := INI_READ("L",marka,"free",ini)
    *xname := INI_READ("C",marka,"name",ini)

    PUBLIC ox := "oX"+broj  // naziv varijable OBJECT svakog dugmeta oX1... oX100
                            // variable name OBJECT of each button oX1... oX100

    bbrr:=0
    IF xrow==153 .and. xcol==150
       // sto nema komandno dugme
       // table has no command button
    ELSE
       // sto ima komandno dugme   - OBJECT = i
       // table has command button - OBJECT = i

          bbrr:=0

         /*
         *------------------------------------
         * USE (xsto) NEW SHARED ALIAS "XX"
         * IF NetErr()==.F.
         *               * --- test
         *               * if i=7  // treba da se prikae kao zauzet - ima raun
         *               *   append blank
         *               *   replace ROBS_ WITH "00000", ROBN_ WITH "TEST"
         *               * endif
         *               * --- test
         *    bbrr:=reccount()
         *    USE
         *    SELECT(radno)
         * ENDIF// IF NetErr()==.F.
         *------------------------------------
         */

          nRows:=0
          cSQL := "SELECT count(*) AS exact_count FROM "+_xsto+";"
          oStmt := DacSqlStatement():fromChar(cSQL)
          oStmt:build():query()
          SELECT QUERY
          nRows:=exact_count
          CLOSE QUERY
          bbrr := nRows



    ENDIF


    IF bbrr==0
       // RESTORANSKI STO nema stavke rauna
       // RESTAURANT TABLE has no bill items
          INI_WRITE("L",marka,"free",.F.,ini)
          INI_WRITE("C",marka,"name","STO JE SLOBODAN",ini)
          * xfree := INI_READ("L",marka,"free",ini)
          * xname := INI_READ("C",marka,"name",ini)
          brojac1:=brojac1+1
    ELSE
       // RESTORANSKI STO ima stavke rauna
       // RESTAURANT TABLE has bill items
          INI_WRITE("L",marka,"free",.T.,ini)
          INI_WRITE("C",marka,"name","STO JE ZAUZET",ini)
          * xfree := INI_READ("L",marka,"free",ini)
          * xname := INI_READ("C",marka,"name",ini)
          brojac2:=brojac2+1
    ENDIF


NEXT i
SELECT(radno)



// RESTART PROGRAM   -> CHANGE EACH TABLE BUTTON ICONS
// RESTARTUJ PROGRAM -> DA PROMENI IKONE NA DUGMETU SVAKOG STOLA

ec_k()
C__PORUKA(;
"STOLOVI BEZ RAUNA     : " + var2char(brojac1) +chr(59)+;
"TABLES WITHOUT ACCOUNTS: " + var2char(brojac1) +chr(59)+;
" "                                             +chr(59)+;
"STOLOVI SA RAUNIMA    : " + var2char(brojac2) +chr(59)+;
"TABLES WITH ACCOUNTS   : " + var2char(brojac2) +chr(59)+;
"","TABLES CONTROL")

RETURN NIL









