//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   4_KASA_tach_buttons_stolovi_racuni.prg
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


/*

 OTVARA SE RAUN STOLA NA ZADATOM STOLU U UGOSTITELJSKOM OBJEKTU
 U FORMI BROWSERA STAVKI ARTIKALA SA KOMANDNIM DUGMADIMA I TASTERIMA
 ZA DODAVANJE ARTIKALA, BRISANJE, OBRADU I TAMPU:

 	FISKALNOG RAUNA,
	KASABLOKA,
	FAKTURE,
	NALOGA ANKU,
	NALOGA KUHINJI

 A TABLE ACCOUNT IS OPENED AT THE DEFINED TABLE IN THE RESTAURANT FACILITY
 IN THE FORM OF BROWSER ITEM ITEMS WITH COMMAND BUTTONS AND BUTTONS
 FOR ADDING ITEMS, DELETING, PROCESSING AND PRINTING:

  FISCAL ACCOUNT,
  KASABLOKA,
  INVOICES,
  ORDER BAR,
  ORDER TO THE KITCHEN



FUNCTION RACUN_NA_STOLU_ZADAJ(oDugme,GetList1,okvirbmp)
FUNCTION RACUN_NA_STOLU(o,GetList1,okvirbmp,akcija)

*/




#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"
#include "xbtsys.ch"
#INCLUDE "DCDIALOG.CH"
#INCLUDE "DCGRA.CH"

#INCLUDE "(KASA-STOLOVI-RESOURCE)\KASA-STOLOVI.CH"



// BLIND FUNCTIONS
*" za potrebe testiranja formiraju se slepe funkcije
*" blind functions are created for testing purposes
* 4_KASA_tach_buttons_stolovi_racuni.prg

static function ZAHTEV_KUHINJI       ; return nil
static function VIDI_RACUN_STOLA1    ; return nil
static function RACUN_TO_SANKKUHINJA ; return nil
static function GOTOVINSKA___UPLATA  ; return nil
static function KARTICA___UPLATA     ; return nil
static function CEKOVNA___UPLATA     ; return nil
static function VIRMAN___UPLATA      ; return nil
static function VAUCER___UPLATA      ; return nil
static function INSTANT___UPLATA     ; return nil
static function BEZGOTOVINE___UPLATA ; return nil
static function KASADELCFG           ; return nil
function RACUN_FORMIRAJ_STAVKU       ; return nil
// BLIND FUNCTIONS





***********************************************************************
FUNCTION RACUN_NA_STOLU_ZADAJ()
***********************************************************************
 * USE INVISIBLE RESTAURANT TABLE
 * Start rauna restoranskog stola kada sto nema ikonu
 * Start restaurant table account when table has no icon
 * Restoranski sto nije upisan u KASA_RESTORAN.INI
 * Restaurant table is not entered in KASA_RESTORAN.INI

* za DCREAD GUI potrebno je: OWNER ooDlg
PRIVATE ooDlg:=setappwindow()  // public iz main programa
PRIVATE bmpico := .F.          // PUBLIC iz main()

PRIVATE oFile, oRacun, akcija
oRacun := alltrim(memoread("brojstola"))
oRacun := padr(oRacun,3)
oRacun := eupis0(oRacun,"BROJ STOLA 1-100")  // TABLENAME X1,X2,X3... X100
IF EMPTY(oRacun)
   RETURN NIL
ENDIF
oRacun:=alltrim(oRacun)
memowrit("brojstola",oRacun) // zapii broj rauna


oFile   := "x"+oRacun     // string
oRacun  := val(oRacun)    // numeric
akcija  := "STEALT-RESTAURANT-TABLE"
o       := o_for_stealt_table // 3_KASA_tach_buttons_stolovi.prg

* o:setcaption(brojstola)
// slobodan_sto(), zauzet_sto(), oznaka na dugmetu stola
// free_table(), busy_table()  , label on table button
******************************************
RACUN_NA_STOLU(o,NIL,NIL,akcija)
******************************************

RETURN NIL









***********************************************************************
FUNCTION RACUN_NA_STOLU(o,GetList1,okvirbmp,akcija)
***********************************************************************
* o = objekat DCPUSHBUTTON
* Getlist1 = GetList glavnog prozora ili PUBLIC Get_List
* PUBLIC okvirbmp = GROUPBOX u kome se prikazuje BMP objekta i stolovi
*    2_KASA_tach_button_gornji_toolbar.prg
*    @ 6.5*20, 0.5*7 ;  // pomereno za dva reda dugmadi na dole
*    DCSTATIC TYPE XBPSTATIC_TYPE_GROUPBOX CAPTION ""; // "STOLOVI";
*                              SIZE 138*7, 34.5*20 ;
*                              OBJECT OkvirBmp FONT fo1 PIXEL


* COMMAND BUTTON STOLOVI: SQL TABLE NAME: X1,X2,X3... do X100
* ===========================================================

LOCAL radno := SELECT()
LOCAL Getlist := {}, GetOptions, oDlg, ToolBar2
LOCAL apos:=setappwindow():currentpos()
LOCAL HOR:=104, VER:=15

LOCAL cKonobar, cRacun, cFile, ccFile


*" tablename se dobija kao kargo iz glavnog programa za objekat
*" komandnog dugmeta: o
*" tablename is obtained as cargo from main program for object
*" of the command button: o


IF akcija=="STEALT-RESTAURANT-TABLE"

 * Start rauna restoranskog stola kada sto nema ikonu
 * Start restaurant table account when table has no icon
 * use private variable from: RACUN_NA_STOLU_ZADAJ()

  cFile   := oFile  //  string
  cRacun  := oRacun //  numeric

ELSE

 * use variable from commandbutton
   cFile   := o:CARGO[3,1]  // X1,X2,X3... X100  // T A B L E
   cRacun  := o:CARGO[3,2]  // ako je cFile=x24, cRacun=24 NUMERIK

ENDIF



   ***************************
   ccFile  := _she_+"."+cFile  // scheme.table 'public.x1'
   PUBLIC _shetab_ := ccFile   // scheme.table 'public.x1'
   ***************************
   * stop("cFile="+cFile,"cRacun="+var2char(cRacun),"ccFile="+ccFile,1)


*" ifra kasira ili konobara
*" cashier or waiter code
   ****************************
   cKonobar := xKONOBARcbroj() // __XKONOBAR_XKASIR.PRG
   ****************************

*================================================================
PRIVATE co0,co1,co2,co3,co4,of1,of2,of3,of4,aCUR,oCUR
PRIVATE of9:= Font_codepage(14,"Verdana",238,.t.)
I2018(@co0,@co1,@co2,@co3,@co4,@of1,@of2,@of3,@of4,@aCUR,@oCUR)
PRIVATE co00:=GraMakeRGBColor({208,82,92})
PRIVATE co11:=GRA_CLR_PALEGRAY
PRIVATE co01:=GraMakeRGBColor({250,2,25})
*================================================================


PUBLIC ToolBar1
PUBLIC oBrowse5
PUBLIC oDlgSto
PUBLIC GetListSto

PUBLIC broj_stola := var2char(cRacun)

// --- ako je otvoren bilo koji STO ne moe se otvoriti drugi sto
// --- if any STO is open no other table can be opened

* OkvirBmp:hide()
for i=1 to 3
    IF alias(i)=="STO"
        C__GRESKA("STO JE U RADU;TABLE IN WORK","STOP",,"A")
        RETURN NIL
    ENDIF
next i

***************************************************** OPEN POSTGRESQL ISAM TABLA

     * --- YES-UPSIZE
     *
     * USE (cFile) NEW EXCLUSIVE ALIAS "STO"
     * IF NETERR()
     *    S_NET(cFile)
     *    RETURN NIL
     * ENDIF
     *
     * *  --- otvori tablu
     * *************
     * SELECT "STO"
     * *************
     * SET DELETED ON *  DELETED STAVKE IZBACI IZ BROWSERA
     * GO TOP
     * U DCREAD GUI je:
     * PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5) }
     * da bi se otvorio ceo spisak - browser
     * ---
     * --- YES-UPSIZE


     * --- NOT-UPSIZE
     *
     cSQL    := "SELECT * FROM "+ccFile+" ORDER BY __record ;"
     oStmt   := DacSqlStatement():fromChar(cSQL)
     cAlias  := oStmt:build():query(,"STO")
     STO:=cAlias        // this is mandatory  !
     *************
     SELECT "STO"       // this is mandatory  !
     *************
     * svega:=reccount()// this works correctly !
     count all to svega // this works correctly !
     GO TOP             // this works correctly !

     * U DCREAD GUI je:
     *   PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5) }
     * da bi se otvorio ceo spisak - browser
     * ---
     * In DCREAD GUI is:
     *   PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5) }
     * to open the entire list - browser
     * ---
     * --- NOT-UPSIZE

***************************************************** OPEN POSTGRESQL ISAM TABLA




// --- napravi Browser

// bIznos := {|| iznos()  }
mas := "999,999,999.99"
BROWSER_COLOR()
*********************
SELECT "STO"
*********************

  @ 0,1 DCSAY "STO-TABLE ( "+broj_stola+ " )" FONT of9 SAYSIZE 0 COLOR GRA_CLR_DARKRED
  @ 0,HOR DCSAY {|| PADL(iznos(),40)  } FONT "16.Consolas Bold" SAYSIZE 0 COLOR GRA_CLR_RED  ALIGNRIGHT OBJECT oIznos

* FONT of9 SAYSIZE 30 COLOR GRA_CLR_RED  ALIGNRIGHT OBJECT oIznos


  @ 1.5,1 DCBROWSE oBrowse5 ALIAS "STO" ;
          SIZE HOR,VER ;
          CURSORMODE XBPBRW_CURSOR_ROW ; // xbeBRW_ItemSelected
          ITEMSELECTED {|a,b,o| SELEKTUJ_STAVKU_RACUNA(oBrowse5),; // DUPLI KLIK
               oBrowse5:refreshCurrent(), dc_getrefresh(oIznos) }; // NA RED
          EVAL {|o| o:setfont(of1) }



// ---
   DCBROWSECOL DATA {|x|x:=STO->COK_,IIF(x,"R"," ")} ;
   PARENT oBrowse5 HEADER "CHK" WIDTH 1 ;
   FONT "16.Wingdings 2" ;  // 16
   TOOLTIP " Enter = Checked = Used  "
// ---
   DCBROWSECOL FIELD STO->ROBS_ ;
   PARENT oBrowse5 ;
   HEADER "CODE " WIDTH 3;
   TOOLTIP "Article code "
// ---
   DCBROWSECOL FIELD STO->ROBN_ ;
   PARENT oBrowse5;
   HEADER "ARTICLE NAME" WIDTH 18 ;
   TOOLTIP "Article name or Description"
// ---
   DCBROWSECOL FIELD STO->MERA_ ;
   PARENT oBrowse5 ;
   HEADER "UOM " WIDTH 3 ;
   TOOLTIP "Unit Of Measurment " // UNIT OF MEASUREMENT -> UOM
// ---
   DCBROWSECOL DATA {|| kolicina__decimali(STO->KOLI_) }  ; // BAZNE.DLL
   PARENT oBrowse5   ;
   HEADER "QUANTITY" WIDTH 4  ;
   TOOLTIP " Article Quantity "
// ---
   DCBROWSECOL FIELD STO->CENA_MPR_ ;
   PARENT oBrowse5 ;
   HEADER "PRICE" WIDTH 7 PICTURE mas ;
   TOOLTIP " Sale price of Article "
// ---
   DCBROWSECOL FIELD STO->VRED_MPR_;
   PARENT oBrowse5 ;
   HEADER "AMOUNT" WIDTH 7 PICTURE mas ;
   TOOLTIP " Sales value "
// ---
   DCBROWSECOL FIELD STO->GRUP_ ;
   PARENT oBrowse5 ;
   HEADER "H-P" WIDTH 2 ;
   TOOLTIP " H-Food, P-Drink "
// ---
   DCBROWSECOL FIELD STO->DOBS_ ;
   PARENT oBrowse5;
   HEADER "GROUP" WIDTH 3 ;
   TOOLTIP " Group Articles from 1 to 16 "
// ---
   DCBROWSECOL FIELD STO->OPST_ ;
   PARENT oBrowse5;
   HEADER "BARMAN"  WIDTH 3;
   TOOLTIP " Barman code "
// ---
   DCBROWSECOL DATA {|| opisplacanja() } ;
   PARENT oBrowse5;
   HEADER "PAID" WIDTH 8 ;
   TOOLTIP " Method of payment "
// ---
   DCBROWSECOL FIELD STO->PPOD_;
   PARENT oBrowse5;
   HEADER "VAT  " WIDTH 7;
   TOOLTIP " VAT amount (PDV iznos) "
// ---
   DCBROWSECOL FIELD STO->PPUP_;
   PARENT oBrowse5;
   HEADER "VAT %" WIDTH 5;
   TOOLTIP " VAT rate (PDV stopa) "
// ---
   DCBROWSECOL FIELD STO->UUID_ ;
   PARENT oBrowse5;
   HEADER "UUID"  WIDTH 25;
   TOOLTIP " Universally Unique Identifier "
// ---
// ---
   DCBROWSECOL DATA{|| var2char(STO->__record) } ;
   PARENT oBrowse5;
   HEADER "Number"  WIDTH 8;
   TOOLTIP " Ordinal number "
// ---
***************************************************************************  START
*
*  T O O L B A R
*
***************************************************************************

* [TAB] PROMENI KOLIINU U STAVCI U RAUNU ZA STO
* [DELETE] OBRII STAVKU IZ RAUNA ZA STO
* [F12] OBRII RAUN ZA STO
* [F11] POALJI RAUN NA DRUGI STO

* PLAANJE
* [1] GOTOVINA
* [2] NALOG
* [3] VAUER
* [4] BEZGOTOVINSKI

* [+] TAMPAJ FISKALNI
* [-] TAMPAJ NEFISKALNI
* [*] TAMPAJ FAKTURU-RAUN

* [Z] TEKST POSEBNOG ZAHTEVA KUHINJI

* [F1] HELP
* [F2] EXIT

* BEZ KOMANDNE DUGMADI
* [R]  VIDI RAUN U TEKST EDITORU
* [CTRL]+[S]  VIDI TEKST NALOGA ANKU
* [CTRL]+[K]  VIDI TEKST NALOGA KUHINJI


bd:=HOR/8

******************
PRIVATE oG:=nil,oV:=nil,oC:=nil   // tri objekta za tri dugmeta GOTOVINA, KARTICA, EK
PRIVATE oN:=NIL,oU:=NIL,oI:=NIL,oB:=NIL
kash_card_check()  // NAIN PLAANJA // command_button_nacin_placanja.prg
******************


//----------------------------------------------------------------------
@ VER+2.5,1 DCTOOLBAR oToolBar1 SIZE HOR,2.5 BUTTONSIZE bd,2.5  FONT of3
//----------------------------------------------------------------------


//----------------------------------------------------------------------
PUBLIC kolicinu_promeni:=.T.

* [TAB] PROMENI KOLIINU U STAVCI U RAUNU ZA STO
DCADDBUTTONXP CAPTION ;
; // "Koliinu;promeni" ACCELKEY xbeK_TAB;
"Quantity;change" ACCELKEY xbeK_TAB;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_promeni_kolicinu(oDlg,oBrowse5,GetList),;
   ; // koristi PUBLIC kolicinu_promeni:=.T.
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [DELETE] OBRII STAVKU IZ RAUNA ZA STO
DCADDBUTTONXP CAPTION ;
; // "Stavku;obrii" ACCELKEY xbeK_DEL;
"Item; delete" ACCELKEY xbeK_DEL;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_obrisi_stavku(ccfile,oBrowse5),;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [F12] OBRII RAUN ZA STO
DCADDBUTTONXP CAPTION ;
; // "Raun;obrii" ACCELKEY xbeK_F12;
"Account; delete" ACCELKEY xbeK_F12;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|a,b,o| bill_obrisi_sve_stavke(ccfile,oBrowse5),;
                  ; // kasa_kash(o,GetList)
                  ; // postavi plaanje na gotovinu
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [F11] POALJI RAUN NA DRUGI STO
DCADDBUTTONXP CAPTION ;
; // "Poalji;na sto" ACCELKEY xbeK_F11;
"Send;to table" ACCELKEY xbeK_F11;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_posalji_na_drugisto(oBrowse5) ,;
   DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
   // ZATVORI SOURCE RAUN STOLA - DA BI SE OTVORIO TARGET RAUN STOLA
//----------------------------------------------------------------------


//----------------------------------------------------------------------
*kasa_kash(o,GetList)
*kasa_card(o,GetList)
*kasa_check(o,GetList)


//----------------------------------------------------------------------
* [4] BEZGOTOVINSKI
DCADDBUTTONXP CAPTION ;
; // "Plaeno bez;gotovinski" ACCELKEY ASC("4");
"Paid Without;Cash" ACCELKEY ASC("4");
   CURSOR aCUR PARENT oToolBar1;  //   ALIGNCAPTION BS_MULTILINE;
   ACTION {|a,b,o| ;
   kasa_bezgotovinski(o,GetList),;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR {|| Bboja }  CLICKCOLOR co3,co4 FONT of2 OBJECT oB
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [3] VAUER
DCADDBUTTONXP CAPTION ;
; //"Plaeno;vauerom" ACCELKEY ASC("3");
"Paid;by voucher" ACCELKEY ASC("3");
   CURSOR aCUR PARENT oToolBar1;  //   ALIGNCAPTION BS_MULTILINE;
   ACTION {|a,b,o| ;
   kasa_vaucer(o,GetList),;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR {|| Uboja }  CLICKCOLOR co3,co4 FONT of2 OBJECT oU
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [2] NALOG - NA RAUN
DCADDBUTTONXP CAPTION ;
; // "Plaeno;na raun" ACCELKEY ASC("2");
"Paid;on account" ACCELKEY ASC("2");
   CURSOR aCUR PARENT oToolBar1; //   ALIGNCAPTION BS_MULTILINE;
   ACTION {|a,b,o| ;
   kasa_nalog(o,GetList),;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR {|| Nboja }  CLICKCOLOR co3,co4 FONT of2 OBJECT oN
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [1] GOTOVINA
DCADDBUTTONXP CAPTION ;
; // "Plaeno;gotovinski" ACCELKEY ASC("1");
"Paid;Cash" ACCELKEY ASC("1");
   CURSOR aCUR PARENT oToolBar1; //   ALIGNCAPTION BS_MULTILINE;
   ACTION {|a,b,o| ;
   kasa_kash(o,GetList) ,;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR {|| Gboja } CLICKCOLOR co3,co4 FONT of2 OBJECT oG
//----------------------------------------------------------------------



//----------------------------------------------------------------------
@ VER+5,1 DCTOOLBAR oToolBar1 SIZE HOR,2.5 BUTTONSIZE bd,2.5  FONT of3
//----------------------------------------------------------------------



//----------------------------------------------------------------------
DCADDBUTTONXP CAPTION ;
; // "VRSTA;RAUNA" ;
"TYPE;ACCOUNT" ;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_type() ,;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR co1,co0   CLICKCOLOR co3,co4 FONT of2  SIZE bd*2
//----------------------------------------------------------------------

//----------------------------------------------------------------------
DCADDBUTTONXP CAPTION ;
; // "KUPAC;VEZA" ;
"BUYER;CONNECTION" ;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_buyer() ,;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR co1,co0   CLICKCOLOR co3,co4 FONT of2  SIZE bd*2
//----------------------------------------------------------------------

//----------------------------------------------------------------------
DCADDBUTTONXP CAPTION ;
; // "UPLATA;NA KASI" ;
"PAYMENT;AT CASHIER" ;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_payment() ,;
   obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR co1,co0   CLICKCOLOR co3,co4 FONT of2  SIZE bd*2
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [+] TAMPAJ FISKALNI
DCADDBUTTONXP CAPTION ;
; //  "FISKALNI RAUN" ACCELKEY asc("+");
"FISCAL BILL" ACCELKEY asc("+");
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_print_fiscal() ,;
   obrowse5:refreshall(),;
   DC_GetRefresh(GetList),;
   SetAppFocus(oBrowse5)} ;
   OUTLINE COLOR co1,co00   CLICKCOLOR co3,co4 FONT of2  SIZE bd*2

//----------------------------------------------------------------------


//----------------------------------------------------------------------
@ VER+7.5,1 DCTOOLBAR oToolBar1 SIZE HOR,2.5 BUTTONSIZE bd,2.5  FONT of3
//----------------------------------------------------------------------

PUBLIC restartujprogram := .f.

//----------------------------------------------------------------------

* [-] TAMPAJ NEFISKALNI
DCADDBUTTONXP CAPTION ;
; // "KASA BLOK" ACCELKEY asc("-");
"CASH BLOCK" ACCELKEY asc("-");
   CURSOR aCUR PARENT oToolBar1      ;
   ACTION {|| bill_print_nofiscal() ,;
              obrowse5:refreshall() ,;
              DC_GetRefresh(GetList),;
              SetAppFocus(oBrowse5)} ;
              FONT of2 SIZE bd*2
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [N] TAMPAJ NALOG KUHINJI - I ANKU ISTOVREMENO
DCADDBUTTONXP CAPTION ;
; // "Nalog kuhinji;Nalog anku" ACCELKEY {asc("N"),asc("n")};
"Kitchen order; Bar order" ACCELKEY {asc("N"),asc("n")};
   CURSOR aCUR PARENT oToolBar1      ;
   ACTION {|| bill_print_order()    ,;
              obrowse5:refreshall() ,;
              DC_GetRefresh(GetList),;
              SetAppFocus(oBrowse5)} ;
              FONT of2 SIZE bd*2

//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [*] TAMPAJ FAKTURU-RAUN
DCADDBUTTONXP CAPTION ;
; // "Faktura;Propratni Raun"  ACCELKEY asc("*");
"Invoice; Accompanying" ACCELKEY asc("*");
   CURSOR aCUR PARENT oToolBar1       ;
   ACTION {|| bill_print_invoice()   ,;
              obrowse5:refreshall()  ,;
              DC_GetRefresh(GetList) ,;
              SetAppFocus(oBrowse5)} SIZE bd*2
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [F1] HELP
DCADDBUTTONXP CAPTION "?"  FONT "14.Verdana Bold";
   ACCELKEY xbeK_F1;
   CURSOR aCUR PARENT oToolBar1      ;
   ACTION {|| bill_help()           ,;
              obrowse5:refreshall() ,;
              DC_GetRefresh(GetList),;
              SetAppFocus(oBrowse5)} // SIZE bd/2
//----------------------------------------------------------------------

//----------------------------------------------------------------------
* [ESC] EXIT
DCADDBUTTONXP CAPTION "X" FONT "14.Verdana Bold" ;
   ACCELKEY xbeK_ESC;
   CURSOR aCUR PARENT oToolBar1;
   ACTION {|| bill_exit(), ;
              ooo:=NIL,;
              DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} // SIZE bd/2
//----------------------------------------------------------------------




****** S T E A L T  B U T T O N S ******



* [Z] TEXT OF SPECIAL KITCHEN REQUEST
* [Z] TEKST POSEBNOG ZAHTEVA KUHINJI
*------------------------------------
 DCHOTKEY {asc("Z"),asc("z")} ;
 ACTION {|| bill_request_kitchen() ,;
            obrowse5:refreshall()  ,;
            DC_GetRefresh(GetList) ,;
            SetAppFocus(oBrowse5)}



* [Q] DESELECT ALL ITEMS ON THE ACCOUNT
* --- ONLY DESELECTED ITEMS ARE PRINTED AND COLLECTED
* [Q]  DESELEKTUJ SVE STAVKE NA RAUNU
* --- TAMPAJU SE I SABIRAJU SE SAMO DESELEKTOVANE STAVKE
*-------------------------------------
  DCHOTKEY {asc("Q"),asc("q")} ;
  ACTION {|| bill_deselect_all(oBrowse5)  ,;
             ; // za sve stavke rauna COK_ postavi na .F.
             obrowse5:refreshall(),;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}

* [ALT]+[Q] SELECT ALL ITEMS ON THE ACCOUNT
* [ALT]+[Q]  SELEKTUJ SVE STAVKE NA RAUNU
*-----------------------------------------
  DCHOTKEY xbeK_ALT_Q ;
  ACTION {|| bill_select_all(oBrowse5)  ,;
             ; // za sve stavke rauna COK_ postavi na .T.
             obrowse5:refreshall(),;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}

* [C] CHANGE ITEM PRICE
* [C]  PROMENI CENU ARTIKLA
*--------------------------------------
  DCHOTKEY {asc("C"),asc("c")} ;
  ACTION {|| bill_price() ,;
             obrowse5:refreshall(),;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}

* [R] SEE ACCOUNT IN TEXT EDITOR
* [R]  VIDI RAUN U TEKST EDITORU
*--------------------------------------
  DCHOTKEY {asc("R"),asc("r")} ; // xbeK_R ;
  ACTION {|| bill_show_account()  ,;
             obrowse5:refreshall(),;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}

* [CTRL]+[S] SEE BAR ORDER TEXT
* [CTRL]+[S]  VIDI TEKST NALOGA ANKU
*------------------------------------
  DCHOTKEY xbeK_CTRL_S ;
  ACTION {|| bill_show_orderbar() ,;
             obrowse5:refreshall(),;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}


* [CTRL]+[K] SEE KITCHEN ORDER TEXT
* [CTRL]+[K]  VIDI TEKST NALOGA KUHINJI
*--------------------------------------
  DCHOTKEY xbeK_CTRL_K ;
  ACTION {|| bill_show_orderkitchen() ,;
             obrowse5:refreshall()    ,;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}


* [S] ENTER ITEM CODE
* [S] ZADAJ IFRU ARTIKLA
* izmenjeno u:
* [SPACE] ZADAJ IFRU ARTIKLA
*--------------------------------------
* DCHOTKEY {asc("S"),asc("s")} ;
* izmenjeno u:
  DCHOTKEY 32 ;
  ACTION {|| bill_article_code(ccfile) ,;
             obrowse5:refreshall()     ,;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}



* [INSERT]
* TEST DODAVANJA ARTIKLA
  DCHOTKEY xbeK_INS ;
  ACTION{|| additem(ccfile,getlist,oBrowse5)   ,;
             obrowse5:refreshall()     ,;
             DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}
***************************************************************************
*
*  T O O L B A R
*
*************************************************************************** END

 PRIVATE oooFocus := NIL
 IF akcija="STEALT-RESTAURANT-TABLE"
    bojab := GraMakeRGBColor({239,228,176})
 ELSE
    bojab := NIL
 ENDIF

 DCGETOPTIONS COLOR bojab ;
 NOESCAPEKEY NOMINBUTTON WINDOWROW 40 WINDOWCOL 10  AUTORESIZE ;
 CLOSEQUERY MSG {|| ooo_postavi_na_nil() }  ;
 TOOLTIPCOLOR GRA_CLR_BLACK,GRA_CLR_YELLOW TOOLTIPFONT "10.Consolas"

 //  ovde // radi prekida programa sa [x]: CLOSEQUERY=.T. kada je ooo:=NIL
 //  kao kod [ESC]: ACTION {|| ooo:=NIL, DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

 DCREAD GUI FIT;
            TITLE {|| "RAUN-ACCOUNT  |  "+broj_stola } ;
            ; // "RAUN NA STOLU BROJ ( "+broj_stola+ " )" ;    // RAC2_
            OPTIONS GetOptions ;
            SETFOCUS @oBrowse5 ;
            OWNER ooDlg  ; // public iz main programa
            PARENT @oDlg ; //            MODAL ;
            EVAL {|orn| oDlgSto := orn,;
                        GetListSto := GetList,;
                        oooFocus := SetAppFocus(),;
                        ; // tehnika: uvek-vidi-ceo_browser-spisak
                        ; // na startu programa je bilo GO TOP
                        PostAppEvent(xbeP_Keyboard,xbeK_CTRL_PGDN,,oBrowse5) } SETAPPWINDOW
                        // tehnika: uvek-vidi-ceo_browser-spisak

*************
SELECT "STO"
*************
* ncount := reccount() // NO !
// Obrisane stavke iz QUERY rauna ostaju kao prazne stavke u QUERY raunu
// sve dok se QUERY raun ponovo ne uita iz table. Iz tog razloga reccount()
// sabira i obrisane stavke kod kojih je ROBS_= "", pa se koristi komanda:
// ---
// Deleted items from the QUERY account remain as empty items in the QUERY account
// until the QUERY account is reloaded from the table. For this reason recount()
// also collect deleted items where ROBS_= "", so the command is used:
count all to ncount for EMPTY(ROBS_)=.F.

IF ncount==0
   * STOP("free",ncount,o,cRacun,cFile,1) // FREE RESTAURANT TABLE
   slobodan_sto(o,cRacun,cFile,getlist1)  // o, 12, "X12.STO"
   xxfree := .F.
ELSE
   * STOP("busy",ncount,o,cRacun,cFile,1) // BUSY RESTAURANT TABLE
   zauzet_sto(o,cRacun,cFile,getlist1)    // o, 12, "X12.STO"
   xxfree:=.T.
ENDIF

*****************
SELECT "STO"; USE
*****************
 SELECT(radno)
*****************

IF restartujprogram = .t.
   //stop(1,1)
   ***********************************
   RACUN_NA_STOLU(o,GetList1,okvirbmp)
   ***********************************
ENDIF

RETURN xxfree
















* STATIC FUNCTION ooo_postavi_na_nil()
* STATIC FUNCTION zauzet_sto(o1,cRacun,cFile)
* STATIC FUNCTION slobodan_sto(o1,cRacun,cFile)
* STATIC FUNCTION KASA_tach_button_stolovi_help()


* STATIC FUNCTION SELEKTUJ_STAVKU_RACUNA(oBrowse5)   // [DBL LCLICK] [ENTER]
* STATIC FUNCTION DESELEKTUJ_STAVKE_RACUNA(oBrowse5) // [Q]
* STATIC FUNCTION SELEKTUJ_STAVKE_RACUNA(oBrowse5)   // [ALT][Q]


* --- OZNAKE ZA NAIN PLAANJA
* FUNCTION opisplacanja()
*
* STATIC FUNCTION kasa_kash(o,GetList)
* STATIC FUNCTION kasa_card(o,GetList)
* STATIC FUNCTION kasa_check(o,GetList)
* STATIC FUNCTION kasa_nalog(o,GetList)
* STATIC FUNCTION kasa_vaucer(o,GetList)
* STATIC FUNCTION kasa_instant(o,GetList)
* STATIC FUNCTION kasa_bezgotovinski(o,GetList)
*
* STATIC FUNCTION kash_card_check(o,GetList)
* --- OZNAKE ZA NAIN PLAANJA


* STATIC FUNCTION brisi()
* STATIC FUNCTION brisisve()
* STATIC FUNCTION xkolicina(oDlg,oBrowse5,GetList)
* STATIC FUNCTION xcena()
* STATIC FUNCTION iznos()




**************************************************************************
STATIC FUNCTION ooo_postavi_na_nil()
**************************************************************************
PUBLIC ooo := NIL
RETURN .T.





* (3) NAIN BEZ CAPTION SLIKE SA PROMENOM BOJE BROJA STOLA --- 3_KASA_tach_button_stolovi.prg
* (2) NAIN SA CAPTION SLIKOM BMP ILI ICO RESURSOM --- 3_KASA_tach_button_stolovi.prg
* (1) NAJPROSTIJI NAIN BEZ CAPTION SLIKE PROMENA BROJA STOLA --- 3_KASA_tach_button_stolovi.prg
* (4) NAIN SA 2 CAPTION SLIKE IZ BMP RESURSA --- 3_KASA_tach_button_stolovi.prg


***************************************************************************
STATIC FUNCTION zauzet_sto(o,cRacun,cFile,GetList1) // setup na izlazu iz RAUNA STOLA
***************************************************************************
* cFile  // X12.STO
* cRacun // 12 numerik
LOCAL marka     := strtran(UPPER(cFile),".STO")
LOCAL brojstola := var2char(cRacun)

* marka     := "X1","X2"... "X100"  // ne sme se menjati !!!
* brojstola := "1" , "2"... "100"   // ne sme se menjati !!!
//------------------------------------------------
  INI_WRITE("L",marka,"free",.T.,ini)
  INI_WRITE("C",marka,"name","STO JE ZAUZET",ini)
  xfree     := INI_READ("L",marka,"free",ini) // sto slobodan/zauzet
  xname     := INI_READ("C",marka,"name",ini) // naziv stola

    IF bmpico==.F.        // PUBLIC iz main()


         * (3) NAIN BEZ CAPTION SLIKE SA PROMENOM BOJE BROJA STOLA --- 3_KASA_tach_button_stolovi.prg
         * ovo nisam uspeo da uradim 27-07-2023

         * (2) NAIN SA CAPTION SLIKOM BMP ILI ICO RESURSOM --- 3_KASA_tach_button_stolovi.prg
         * o:setcaption(II_STO2) // ovo e caption stola (broj i ikonu) zameniti
         *                       // samo sa OBJECT ikonom ICO (nema vie broja)
         * COBA dosetka          // ICO se razvlai kod fullscreen a BMP ne
         * o:setbitmap(II_STO2)  // sto je slobodan ICO
                                 // SetBitMap je METHOD o:setbitmap(oIco)
                                 // iz DCPUSHBUTTONXP
                                 // (menja samo ikonu a ne dira broj)
                                 // ICO se razvlai kod fullscreen a BMP ne
         * (1) NAJPROSTIJI NAIN BEZ CAPTION SLIKE PROMENA BROJA STOLA --- 3_KASA_tach_button_stolovi.prg
         * cap:=o:caption
         o:setcaption("("+brojstola+")") // caption moe da se menja i ako nije u codeblock-u

    ELSE

        * (4) NAIN SA 2 CAPTION SLIKE IZ BMP RESURSA --- 3_KASA_tach_button_stolovi.prg
         o:setcaption(B_STO2) // sto je zauzet BMP 502

    ENDIF
//------------------------------------------------
RETURN NIL
***************************************************************************
STATIC FUNCTION slobodan_sto(o,cRacun,cFile,GetList1) // setup na izlazu iz RAUNA STOLA
***************************************************************************
* cFile  // X12.STO
* cRacun // 12 numerik
LOCAL marka     := strtran(UPPER(cFile),".STO")
LOCAL brojstola := var2char(cRacun)
* marka     := "X1","X2"... "X100"  // ne sme se menjati !!!
* brojstola := "1" , "2"... "100"   // ne sme se menjati !!!
//------------------------------------------------------------------
  INI_WRITE("L",marka,"free",.F.,ini)
  INI_WRITE("C",marka,"name","STO JE SLOBODAN",ini)
  xfree     := INI_READ("L",marka,"free",ini) // sto slobodan/zauzet
  xname     := INI_READ("C",marka,"name",ini) // naziv stola

   IF bmpico==.F.        // PUBLIC iz main()

         * (3) NAIN BEZ CAPTION SLIKE SA PROMENOM BOJE BROJA STOLA --- 3_KASA_tach_button_stolovi.prg
         * ovo nisam uspeo da uradim 27-07-2023

         * (2) NAIN SA CAPTION SLIKOM BMP ILI ICO RESURSOM --- 3_KASA_tach_button_stolovi.prg
         * o:setcaption(II_STO1) // ovo e caption stola (broj i ikonu) zameniti
         *                       // samo sa OBJECT ikonom ICO (nema vie broja)
         * COBA dosetka          // ICO se razvlai kod fullscreen a BMP ne
         * o:setbitmap(II_STO1)  // sto je slobodan ICO
                                 // SetBitMap je METHOD o:setbitmap(oIco)
                                 // iz DCPUSHBUTTONXP
                                 // (menja samo ikonu a ne dira broj)
                                 // ICO se razvlai kod fullscreen a BMP ne
         * cap:=o:caption
         o:setcaption(brojstola)   // caption moe da se menja i ako nije u codeblock-u


   ELSE

    * (4) NAIN SA 2 CAPTION SLIKE IZ BMP RESURSA --- 3_KASA_tach_button_stolovi.prg
      o:setcaption(B_STO1) // sto je slobodan BMP 501

   ENDIF
//------------------------------------------------------------------
RETURN NIL











//** [ENTER] SELEKTUJ JEDNU STAVKU NA RAUNU
//*******************************************
//*FUNCTION SELEKTUJ__STAVKU__RACUNA(oBrowse5)
//*******************************************
//*REPLACE STO->COK_ WITH !STO->COK_ // ne radi sa ENTER
//*RETURN NIL
//* [ENTER]  SELEKTUJ STAVKU NA RAUNU
//* (ako DCBROWSE ima ITEMSELECTED {|| SELEKTUJ__STAVKU__RACUNA(oBrowse5) }
//* tada ne sme postojati taster: DCHOTKEY xbeK_ENTER jer ITEMSELECTED
//* se aktivira sa DBL CLICK i sa ENTER pa se tada dva puta izvrava ENTER:
//* prvo se izvri sa ITEMSELECTED a zatim se poniti sa DCHOTKEY xbeK_ENTER
//*-------------------------------------
//  DCHOTKEY xbeK_ENTER ;
//  ACTION {|| SELEKTUJ__STAVKU__RACUNA(oBrowse5) } // ,; // jednu stavke rauna COK_ postavi na .F./.T.
//          *  obrowse5:refreshall(),DC_GetRefresh(GetList),SetAppFocus(oBrowse5)}
//



* REPLACE TRUE/FALSE
* SELEKTUJ/DESELEKTUJ JEDNU STAVKU BROWSERA
* EKIRAJ/DEEKIRAJ JEDNU STAVKU BROWSERA
* [M_LbDblClick] ili [ENTER]
*************************************************************************
STATIC FUNCTION SELEKTUJ_STAVKU_RACUNA(oBrowse5)
*************************************************************************
* DBF FIELDS COK_=.T. or .F.
* REPLACE STO->COK_ WITH !STO->COK_
* ---
* PgSQL _shetab_ column COK_ = TRUE or FALSE
************
SELECT "STO"
************
ROBS := ROBS_ // moe biti vie stavki sa istom ifrom
              // there can be multiple items with same code
UUID := UUID_ // ne moe biti vie stavki sa istim uuid
              // there can't be multiple items with the same uuid
COK  := COK_
IF COK=.T.
   cCOK:="FALSE"
ELSE
   cCOK:="TRUE"
ENDIF
cSQL := "UPDATE "+_shetab_+" SET COK_ = "+cCOK+" WHERE UUID_ = '"+UUID+"';"
oStmt := DacSqlStatement():fromChar(cSQL)
oStmt:build():execute()
************
SELECT "STO"
************
DBREFRESH()
GO TOP
LOCATE FOR UUID_=UUID
oBrowse5:refreshall()
RETURN NIL


****************************************************************************
STATIC FUNCTION iznos()
****************************************************************************
LOCAL rek,cFlag:="",ctip:=""
SELECT "STO"
rek := RECNO()
           SUM ALL VRED_MPR_ TO iznos FOR COK_=.F.
           GOTO BOTTOM
           ****************************
           * cFlag:=opisplacanja()     // command_buttons_nacin_placanja.prg
             cFlag:=opisplacanja_eng() // command_buttons_nacin_placanja.prg
           ****************************
           GOTO rek
           ctip:=alltrim(RAC2_)

RETURN ctip+" "+cFlag+"  "+alltrim(TRANSFORM(iznos,"999,999,999.99"))













