//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   C-POSTGRESQL-DATABASE.PRG
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

/*

Projekat:
C-POSTGRESQL-DATABASE.BAT
C-POSTGRESQL-DATABASE.XPJ
C-POSTGRESQL-DATABASE.EXE
C-PGDB.INI
KASA.INI

je produkcioni EXE program koji iskljuivo koristi funkcije
iz C_PGDB.DLL/LIB biblioteke
kao i poseban program sa podacima za kreiranje tabli koji
se ugrauje i u konkretnu EXE aplikaciju:

     __tab__create__all.prg -> __tab__create__all()

Program slui kao produkcioni korisniki samostalni konfiguracioni
alat za generisanje postgreSQL UPSIZE baze podataka, ema i tabli
za konkretnu aplikaciju *.EXE ije table se uitavaju iz programa
     __tab__create__all.prg -> __tab__create__all()
Program se linkuje sa __tab__create__all.prg koji je poseban za
svaku EXE aplikaciju, pa je i program poseban za svaku aplikaciju.
Naziv programa je naziv EXE aplikacije na ijem kraju je _ LOWLINE

Program kreira i odrava ini fajl: C-PGDB.INI
u kome su svi potrebni parametri za kreiranje i start postgreSQL
UPSIZE database, ema i tabli te UPSIZE database.

Program proverava postojanje UPSIZE database pa ako ne postoji on
kreira: databazu, eme i table koje koristi EXE aplikacija.
A ako postoji on kontrolie postojanje svih potrebnih tabli te
database i prijavljuje greku ako neka od tabli ne postoji.

Program ima funkcije za generisanje i prikaz listi svih databaza
u postgreSQL serveru, svih ema u konektovanoj databazi i svih
tabli u konektovanoj databazi i zadatoj emi.

Program puni table sa podacima preuzetim iz SQL script fajlova
iz posebne opcije rada (iz menija programa) na zahtev korisnika.
SQL script fajlovi se nalaze u SQL subfolderu EXE aplikacije:
           primer: C:\EXE\SQL\customers.sql
SQL fajlovi naose naziv table koja se putem njih puni podacima
           primer: table name = 'customers'
                   sql file   = 'customers.sql'
Procedure za punjenje tabli podacima iz SQL script fajlova nalaze
se u __tab__create__all.prg -> __tab__create__all()


11.10.2023

*/




/*
13-10-2023
================================================================  START
PROBLEM SA POSEBNIM SERVISNIM PROGRAMOM KOJI KORISTI C_PGDB.DLL:
================================================================
funkcije:
 __tab__create() ->  __tab__create.prg  -> C_PGDB.DLL
 __tab__control() -> __tab__create.prg  -> C_PGDB.DLL
su ugraene u C_PGDB.DLL i obe ove funkcije koriste array listu:
 _aListAppTable_ := __tab__cerate__app() -> __tab__create__app.prg
Funkcija:
 __tab__create__app() -> __tab__create__app.prg -> *.EXE
ne nalazi se u C_PFDB.DLL ve u aplikaciji *.EXE
u koju je ulinkovan C_PGDB.DLL

POSEBAN SERVISNI EXE PROGRAM ZA KONTROLU I KREIRANJE DATABAZE I TABLI
aplikacije CSYSTEMS_PgSQL.EXE koji kreira i kontrolie table
ne moe da izvri kontrolu i kreiranje tabli jer nije aplikacija *.EXE
i nema u sebi ulinkovan program: __tab__create__all.prg sa listom
tabli koje pripadaju bazi podataka te aplikacije.

To e moi samo u sluaju ako je iz aplikacije *.EXE array lista:
 _aListAppTable_ generisana i snimljena u memry varijable fajl XPF
pa je C_PGDB.DLL program odatle preuzme i nastavi rad sa njom.

Iz programa: __tab__create__app() -> *.EXE
generie se array _aListAppTable_ i snimi se u fajl ListTable:
   ListTable := gde_exe()+"\AppListTable.array"
   SAVE ALL LIKE _aListApp* TO (ListTable)

iz programa: __tab__create() i __tab__control() -> C_PGDB.DLL
uita se iz fajla ListTable array _aListAppTable_:
   ListTable := gde_exe()+"\AppListTable.array"
   RESTORE FROM (ListTable)
i koristi se.

Ovo je testirano i funkcionie, ali od ovoga sam odustao jer nema
neke velike potrebe za pravljenjem univerzalnog posebnog servisnogg
programa koji e moi da opsluuje svaku *.EXE aplikaciju sa njenim
specifinim tablama. Posebno i zbog komplikovanog reavanja pitanja
- kako da servisni program zna da fajl ListTable pripada aplikaciji
  koja se eli kontrolisati servisnim programom
- kako uklanjati i da li uklanjati fajl ListTable posle njegove
  upotrebe i slino...


TA JE URAENO:
---------------
Servisni program (inicijalno CSYSTEMS_PgSQL.EXE), ako se uopte pravi
treba praviti posebno za svaku aplikaciju i u njega treba linkovati
program: __tab__create__app.prg eme e ceo posao biti reen jako
jednostavno i razumljivo - sve ostalo je bespotrebno komplikovanje.
Posebno to servisni program ima veliinu manju od 100 Kb.
Servisni program svake aplikacije treba da nosi isti naziv kao i
aplikacija ali sa dodatkom na kraju naziva LOW LINE ili UNDERSTRIKE:
               aplikacija: KASA_STOLOVI.EXE
               servisni  : KASA_STOLOVI_.EXE


================================================================
PROBLEM SA POSEBNIM SERVISNIM PROGRAMOM KOJI KORISTI C_PGDB.DLL:
================================================================  END
*/



 #include "dac.ch"
 #pragma library("dbfupsize.lib") // C:\Program Files (x86)\Alaska Software\xpp20\lib
                                   // potrebno za: oInfo := DacSchema():New(oS)
                                   // =========================================
*-----------------------------------
* Xbase++
#include "Xbp.ch"
#include "AppEvent.ch"
#include "Common.ch"
*-----------------------------------
* XbToolIII++
#include "xbtsys.ch"
*-----------------------------------
* eXpress++
#include "dcdialog.ch"
*-----------------------------------
* Xbase++ PGDBE
#include "pgdbe.ch"
#include "std.ch"
#include "sql.ch"
#pragma library("adac20b.lib")
*-----------------------------------
* Xbase++ APPBROWSE, APPDISPLAY
* for testing the program:
* #include "Appbrow.ch"
* MEMVAR appObject
*-----------------------------------


PROCEDURE APPSYS()

     nOldIcon := DC_ICONDEFAULT(1) // IKONA BROJ 1
     SET CHARSET TO ANSI           // ANSI SLOVA
     SET DATE FORMAT TO "dd.mm.yyyy"
     DC_DotHotKey(180)             // Prebaci DotPrompt sa Alt+D na ...
     SetCancel(.F.)                // turn off Alt+C
 *************
  xRUN_STOP() // BAZNE.DLL
 *************


RETURN
PROCEDURE DBESYS()
  DbeLoad("PGDBE")
RETURN
PROCEDURE MAIN()



LOCAL GetList := {},  GetOptions, oDlg
LOCAL oLogo, oFokus, lButton := .T., oGroup, oMsgBox
LOCAL aSize := Appdesktop():currentsize(), aPos := SetAppWindow():currentpos()
LOCAL oParent := SetAppWindow() // oParent ne sme da bude PRIVATE ili PUBLIC varijabla !
                                // Moze da bude parametar PANEL1(oDlg) LOCAL oParent := oDlg
                                // ako nije zadata (nil) formira je DCREADGUI sa PARENT @oParent

LOCAL Bduz := 34, Bsir := 3.5     // Command Buttons Duzina-Sirina
LOCAL x := 4, y := 1, z := Bsir

PRIVATE aCUR := {"user32.dll",114,XBPWINDOW_POINTERTYPE_POINTER}

SET CHARSET TO ANSI

***********************************************
__pg__ini()  // C_PGDB.DLL

IF __pg__dbinserver() = .F. // C_PGDB.DLL

    ec_k()
    c__greska("NE POSTOJI DATABAZA"+chr(59)+;
              ;//"                 "+chr(59)+;
              PADC(_cdbc_,19)      +chr(59)+;
              "","STOP",,"14.Consolas Bold")

    cTitle:="NO database exists  |  "+_db_
ELSE
    cTitle:="PostgreSQL Database  |  "+_db_
ENDIF
// lRet =.T.,.F.
***********************************************

oConfig1 := ButtonXP_oConfig1()
PUBLIC RESTART:=.F.

* @ 40,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP PIXEL CAPTION 2001 PARENT oGroup

@ 0,0  DCPUSHBUTTONXP BITMAP 2001 ;
       SIZE Bduz+2,Bsir-0.5 WHEN {|| lButton }  ;
       ACTION {|a,b,o| xc_autor1() } ;  // bazne.dll
       CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP "MANUFACTURER"


@ x,y  DCPUSHBUTTONXP CAPTION "PostgreSQL Database;Programa;KASA-STOLOVI.EXE" FONT "13.Consolas Bold" ;
       SIZE Bduz,Bsir WHEN {|| lButton }  ;
       ACTION {|a,b,o| nil } ;
        CURSOR aCUR ;
        ; // CONFIG oConfig1 ;
       TOOLTIP "PG BAZA PODATAKA ZA PROGRAM: [ KASA STOLOVI ZA UGOSTITELJA ]" ;
       MESSAGE "PG DATABASE FOR THE PROGRAM"+chr(13)+"[ KASA STOLOVI ZA UGOSTITELJA ]"



x := x+z
@ x,y  DCPUSHBUTTONXP CAPTION "Parametri baze podataka;"+_cdbc_+";Database Parameters" ;
       SIZE Bduz,Bsir WHEN {|| lButton }  ;
       ACTION {|a,b,o| IIF(fu2()=.T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList),NIL) } ;
        CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP "PG BAZA PODATAKA ZA PROGRAM: [ KASA STOLOVI ZA UGOSTITELJA ]";
        MESSAGE "PG DATABASE FOR THE PROGRAM"+chr(13)+"[ KASA STOLOVI ZA UGOSTITELJA ]"


x := x+z
@ x,y  DCPUSHBUTTONXP CAPTION "Sadraj baze podataka;"+_cdbc_+";Database Contents" ;
       SIZE Bduz,Bsir WHEN {|| lButton }   ;
       ACTION {|a,b,o|  fu1(), SetAppFocus(o) } ;
       CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP "SERVER LISTE: DATABAZE, EME I TABLE"  MESSAGE "SERVER LISTS: DATABASES, SCHEMES AND TABLES"


x := x+z
@ x,y  DCPUSHBUTTONXP CAPTION "Kontrola baze podataka;"+_cdbc_+";Database Control" ;
       SIZE Bduz,Bsir WHEN {|| lButton } ;
       ACTION {|a,b,o| IIF(fu3()=.T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList),NIL) } ;
        CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP "KONTROLA IF EXISTS I KREIRANJE DATABAZE"  MESSAGE "CONTROL IF EXISTS AND CREATE DATABASE"

x := x+z
@ x,y  DCPUSHBUTTONXP CAPTION "Punjenje baze podataka;"+_cdbc_+";Database Filling" ;
       SIZE Bduz,Bsir WHEN {|| lButton } ;
       ACTION {|a,b,o| fu4(), SetAppFocus(o) } ;
        CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP "PRENOS PODATAKA IZ SQL FAJLOVA U TABLE" MESSAGE "DATA TRANSFER FROM SQL FILES TO TABLES"

x := x+z
@ x,y  DCPUSHBUTTONXP CAPTION "Help"  OBJECT o1 ;
       SIZE Bduz/2,Bsir WHEN {|| lButton } ;
       ACTION {|a,b,o| help_programa(), SetAppFocus(o) } ;
        CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP " USER GUIDE " MESSAGE " USER GUIDE "


@ x,y+Bduz/2;
       DCPUSHBUTTONXP CAPTION "Exit" ;
       SIZE Bduz/2,Bsir WHEN {|| lButton } ;
       ACTION {|a,b,o| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
        CURSOR aCUR CONFIG oConfig1 ;
       TOOLTIP " EXIT FROM PROGRAM " MESSAGE " EXIT FROM PROGRAM "


/*
 @ 0,1 DCPUSHBUTTON CAPTION "" SIZE 0,0 ACCELKEY 46;    // . taster taka
       ACTION {|a,b,o| SetAppFocus(o1) }   // STEALT DUGME
*/

 DCHOTKEY 46 ;  // umesto 46 ide asc(".") ili neki od: xbeK_ALT_S ili slino
          ACTION {|a,b,o| SetAppFocus(o1) }  // KEYBOARD DUGME


x:=x+z
   @ x,y  DCMESSAGEBOX OBJECT oMsgBox SIZE Bduz,2 ;
          MOTION ;
          ; // TYPE XBPSTATIC_TYPE_RECESSEDBOX  ;
          TEXTOBJECT MESSAGE OPTIONS XBPSTATIC_TEXT_WORDBREAK;
          COLOR GRA_CLR_DARKGREEN, GRA_CLR_WHITE // FONT "9.Helv Bold"



* "ALT+DEL"
* "brisanje svih redova iz table: alaska-software.isam.tables
* "i ponovni upis naziva svih tabli aplikacije u tu tablu
* "Postoji odreena opasnost u ovome - vidi u: __tab__create.prg
DCHOTKEY xbeK_ALT_DEL ACTION {|| function__tab__control__ISAM__() }   // ovde // __tab__create() // C-PGDB.DLL



DCGETOPTIONS ICON 1 TABSTOP NOMINBUTTON NOMAXBUTTON NORESIZE COLOR GRA_CLR_WHITE ;
FONT "11.Archivo Narrow Bold"

DCREAD GUI TITLE {||ctitle} ;
   FIT ;
   OPTIONS GetOptions ;
   MODAL ;
   SETFOCUS @o1   ;
   OWNER oParent  ; // parent je vlasnik ovog prozora
   PARENT @oDlg   ; // definisanje parenta ovog prozora zbog modalnog sledeceg prozora
   EVAL {|o| SetAppWindow(o)}  // zbog modalnog sledeceg prozora

IF RESTART=.T.
   MAIN()
ENDIF


RETURN


*************************************************************************
FUNCTION fu1()
*************************************************************************
 IF C__NEDA("PREGLED STANJA BAZE PODATAKA" +chr(59)+;
            "OVERVIEW OF DATABASE STATUS"  +chr(59)+;
            "","OVERVIEW POSTGRESQL DATABASE",,"G3")==.F.
    RETURN NIL
 ENDIF


    __pg__lists(2,.T.)
    // 2 = formira PUBLIC array: _databases_, _schemas_, _tables_
    // .T. = prikaz appbrowse listview: databases, schemas, tables


RETURN NIL
*************************************************************************
FUNCTION fu2()
*************************************************************************
    __pg__ini()   // no connect  // __pg__ini__.prg // C_PGDB.DLL
    __pg__see()   // no connect  // __pg__ini__.prg // C_PGDB.DLL

 IF C__NEDA("POSTAVLJANJE PARAMETARA BAZE PODATAKA" +chr(59)+;
            "SETTING PARAMETERS OF THE DATA BASE"   +chr(59)+;
            "","SETTING DATABASE PARAMETERS",,"G3")==.F.
    RETURN .F.
 ENDIF


    __pg__ini__edit()   // no connect // __pg__ini__edit.prg // C_PGDB.DLL
    __pg__ini()   // no connect  // __pg__ini__.prg // C_PGDB.DLL
    __pg__see()   // no connect  // __pg__ini__.prg // C_PGDB.DLL

    RESTART := .T.

RETURN .T.
*************************************************************************
FUNCTION fu3()
*************************************************************************
LOCAL qq

 IF C__NEDA("KONTROLA ISPRAVNOSTI BAZE PODATAKA"     +chr(59)+;
            "CHECKING THE CORRECTNESS OF DATABASE"   +chr(59)+;
            "","DATABASE CONTROL",,"G3")==.F.
    RETURN NIL
 ENDIF

    ************
    __pg__ini()   // no connect  // __pg__ini__.prg // C_PGDB.DLL
    __pg__see()   // no connect  // __pg__ini__.prg // C_PGDB.DLL
    ************


      IF C__NEDA("D A T A B A S E  C O N T R O L"          +chr(59)+;
                 " (PostgreSQL database server) "          +chr(59)+;
                 "                              "          +chr(59)+;
                 "Ako zadata baza podataka ne postoji"     +chr(59)+;
                 "bie startom ove operacije kreirana."    +chr(59)+;
                 "Ako zadata baza podataka postoji"        +chr(59)+;
                 "vri se kontrola njene ispravnosti."     +chr(59)+;
                 "                                   "     +chr(59)+;
                 "If the given database does not exist"    +chr(59)+;
                 "will be created by this operation."      +chr(59)+;
                 "If the given database exists"            +chr(59)+;
                 "its correctness is being checked."       +chr(59)+;
                 "","CHECKING THE CORRECTNESS OF THE DATABASE",3333,"G3")==.F.
         RETURN .F.
      ENDIF

    * __pg__ini()     // no connect  // __pg__ini__.prg // C_PGDB.DLL
    * __pg__lists(1)  // proitaj samo verziju postgresql servera radi prikaza u __pg__see()
    * __pg__see()     // no connect  // __pg__ini__.prg // C_PGDB.DLL



      **************************
      qq := __pg__connect_app()   // connect-work-disconnect // __pg__ini__.prg // C_PGDB.DLL
      **************************



      IF qq==.T.
         c__poruka("BAZA PODATAKA JE ISPRAVNA"               +chr(59)+;
                   "SVE TABLE U BAZI PODATAKA SU NA BROJU"   +chr(59)+;
                   " "                                       +chr(59)+;
                   "DATABASE IS CORRECT"                     +chr(59)+;
                   "ALL TABLES IN DATABASE ARE ON NUMBER"    +chr(59)+;
                   "","OK",,"G3")
      ELSE
         c__greska("BAZA PODATAKA NIJE ISPRAVNA"             +chr(59)+;
                   "NISU NAENE SVE TABLE U BAZI PODATAKA"   +chr(59)+;
                   " "                                       +chr(59)+;
                   "DATABASE IS NOT CORRECT"                 +chr(59)+;
                   "NOT ALL TABLES FOUND IN THE DATABASE"    +chr(59)+;
                   "","STOP",,"G3")
      ENDIF

      RESTART := .T.

RETURN .T.
*************************************************************************
FUNCTION fu4()
*************************************************************************
***********************************************
__pg__ini()  // C_PGDB.DLL
IF __pg__dbinserver() = .F. // C_PGDB.DLL

    ec_k()
    c__greska("NE POSTOJI DATABAZA"+chr(59)+;
              ;//"                 "+chr(59)+;
              PADC(_cdbc_,19)      +chr(59)+;
              "","STOP",,"14.Consolas Bold")

   * cTitle:="NO database exists  |  "+_db_
   RETURN NIL
ELSE
   * cTitle:="PostgreSQL Database  |  "+_db_
ENDIF
// lRet =.T.,.F.
***********************************************




__pg__ini()     // no connect  // __pg__ini__.prg // C_PGDB.DLL
ctab:="kroba_"+_MAG_

IF C__NEDA("PRENOS PODATAKA IZ SQL FAJLOVA U TABLE" +chr(59)+;
           "DATA TRANSFER FROM SQL FILES TO TABLES" +chr(59)+;
           " "                                      +chr(59)+;
           "Tabla kup (kupci) i tabla "+ctab+" (proizvodi)"         +chr(59)+;
           "bie ispranjene i napunjene podacima iz sql fajla"     +chr(59)+;
           "\SQL\kup.sql i \SQL\"+ctab+".sql"                       +chr(59)+;
           " "                                                      +chr(59)+;
           "Table kup (customers) and table "+ctab+" (products)"    +chr(59)+;
           "will be emptied and filled with data from the sql file" +chr(59)+;
           "\SQL\kup.sql and \SQL\"+ctab+".sql"                     +chr(59)+;
           "","FILL POSTGRESQL DATABASE TABLES",,"G3")==.F.
   RETURN NIL
ENDIF

IF c__sifra(1)==.F.
 c__greska("NEMATE OVLAENJE ZA OVO;YOU ARE NOT AUTHORIZED","STOP",,"G3")
 RETURN NIL
ENDIF



* ------------------ punjenje table podacima iz SQL fajla --- start

  * PUBLIC sqlfile_tabledata := gde_exe()+"\SQL\"+ctablename+".SQL"
  * primer: sqlfile_tabledata := "C:\app\SQL\kupci.SQL"
  * ako ne postoji folder user_name() on se kreira kao prazan folder

  c__poruka("PUNJENJE TABLE --- START")

  * pre poziva ove funkcije vri se diskonekcija sa database
  * konekcija i diskonekcija obavljaju se u samoj funkciji.
  * Funkcija koristi PUBLIC _db_ i _she_ iz __pg__ini()
  * Funkcija koristi LOCAL _table_ koja dolazi kao parametar

  _table_ := ctab
  fill__table__all(_table_) // FILL TABLE IN DATABASE
  c__poruka("Tabla kroba_11 je ispranjena pa napunjena")

  _table_ := "kup"
  fill__table__all(_table_) // FILL TABLE IN DATABASE
  c__poruka("Tabla kup je ispranjena pa napunjena")

 c__poruka("PUNJENJE TABLE --- END")

* ------------------ punjenje table podacima iz SQL fajla --- end



RETURN NIL




//
//**************************************************************************
//FUNCTION rezerva()
//**************************************************************************
//
//    __pg__ini__edit()   // no connect // __pg__ini__edit.prg // C_PGDB.DLL
//
//    *__pg__ini()   // no connect  // __pg__ini__.prg // C_PGDB.DLL
//    *__pg__see()   // no connect  // __pg__ini__.prg // C_PGDB.DLL
//
//
//      IF C__NEDA("D A T A B A S E  C O N T R O L"          +chr(59)+;
//                 " (PostgreSQL database server) "          +chr(59)+;
//                 "                              "          +chr(59)+;
//                 "Ako zadata baza podataka ne postoji"     +chr(59)+;
//                 "bie startom ove operacije kreirana."    +chr(59)+;
//                 "Ako zadata baza podataka postoji"        +chr(59)+;
//                 "vri se kontrola njene ispravnosti."     +chr(59)+;
//                 "                                   "     +chr(59)+;
//                 "If the given database does not exist"    +chr(59)+;
//                 "will be created by this operation."      +chr(59)+;
//                 "If the given database exists"            +chr(59)+;
//                 "its correctness is being checked."       +chr(59)+;
//                 "","CHECKING THE CORRECTNESS OF THE DATABASE",,"G3")==.F.
//
//
//               //-------------------------------------------------------------------
//                 IF C__NEDA("PREGLED STANJA BAZE PODATAKA" +chr(59)+;
//                            "OVERVIEW OF DATABASE STATUS"  +chr(59)+;
//                            "","OVERVIEW POSTGRESQL DATABASE",,"G3")==.T.
//
//                    __pg__lists(2,.T.)
//                    // 2 = formira PUBLIC array: _databases_, _schemas_, _tables_
//                    // .T. = prikaz appbrowse listview: databases, schemas, tables
//
//                 ENDIF
//
//
//                 IF C__NEDA("PRENOS PODATAKA IZ SQL FAJLOVA U TABLE" +chr(59)+;
//                            "DATA TRANSFER FROM SQL FILES TO TABLES" +chr(59)+;
//                            "","FILL POSTGRESQL DATABASE TABLES",,"G3")==.T.
//
//                 ENDIF
//               //-------------------------------------------------------------------
//                 QUIT
//       ENDIF
//
//
//
//    __pg__ini()     // no connect  // __pg__ini__.prg // C_PGDB.DLL
//    __pg__lists(1)  // proitaj samo verziju postgresql servera radi prikaza u __pg__see()
//    __pg__see()     // no connect  // __pg__ini__.prg // C_PGDB.DLL
//
//      qq := __pg__connect_app()   // connect-work-disconnect // __pg__ini__.prg // C_PGDB.DLL
//
//      IF qq==.T.
//         c__poruka("BAZA PODATAKA JE ISPRAVNA"               +chr(59)+;
//                   "SVE TABLE U BAZI PODATAKA SU NA BROJU"   +chr(59)+;
//                   " "                                       +chr(59)+;
//                   "DATABASE IS CORRECT"                     +chr(59)+;
//                   "ALL TABLES IN DATABASE ARE ON NUMBER"    +chr(59)+;
//                   "","OK",,"G3")
//      ELSE
//         c__greska("BAZA PODATAKA NIJE ISPRAVNA"             +chr(59)+;
//                   "NISU NAENE SVE TABLE U BAZI PODATAKA"   +chr(59)+;
//                   " "                                       +chr(59)+;
//                   "DATABASE IS NOT CORRECT"                 +chr(59)+;
//                   "NOT ALL TABLES FOUND IN THE DATABASE"    +chr(59)+;
//                   "","STOP",,"G3")
//      ENDIF
//
//
//
//
//               //-------------------------------------------------------------------
//                  IF C__NEDA("PREGLED STANJA BAZE PODATAKA" +chr(59)+;
//                             "OVERVIEW OF DATABASE STATUS"  +chr(59)+;
//                             "","OVERVIEW POSTGRESQL DATABASE",,"G3")==.T.
//
//                     __pg__lists(2,.T.)
//                     // 2 = formira PUBLIC array: _databases_, _schemas_, _tables_
//                     // .T. = prikaz appbrowse listview: databases, schemas, tables
//
//                  ENDIF
//
//
//                  IF C__NEDA("PRENOS PODATAKA IZ SQL FAJLOVA U TABLE" +chr(59)+;
//                             "DATA TRANSFER FROM SQL FILES TO TABLES" +chr(59)+;
//                             "","FILL POSTGRESQL DATABASE TABLES",,"G3")==.T.
//
//                  ENDIF
//               //-------------------------------------------------------------------
//
//RETURN  NIL
//





************************************************************************* 04-12-2020
FUNCTION ButtonXP_oConfig1() // -> oConfig1
*************************************************************************
* PRIVATE oConfig1 := ButtonXP_oConfig1()
* @ 10,10 DCPUSHBUTTONXP CAPTION 'Test' SIZE 10,2 ;
*         CONFIG oConfig1

oConfig1 := DC_XbpPushButtonXPConfig():new()

// default
*oConfig1:bitmapOffset := 5
oConfig1:focusRectStyle  := 1
*oConfig1:focusRectColor  := GraMakeRGBColor({ 200, 30, 70 }) // GRA_CLR_BLACK // GRA_CLR_BLACK // Color of focus rectangle


oConfig1:outline         := .T. // will cause the button to be outlined.
                                // BORDERCOLOR <nBorderColor> defines the color of the outline.
oConfig1:borderColor     := GraMakeRGBColor({ 256, 256, 256 }) // Color of the button border when the :outline is .t.


// dugme
oConfig1:bgColor          := GRA_CLR_DARKGREEN   //  Background color
oConfig1:fgColor          := GRA_CLR_WHITE       //  Foreground color of text
// default za CLICK
oConfig1:fgColorClick     := GRA_CLR_BLACK  //  Foreground color of text when button is clicked.
oConfig1:bgColorClick     := GRA_CLR_GREEN   //  Background color when button is clicked.
// default za SELECT
*oConfig1:enableSelect    := .T.            // RadioButtons - kliknuto je odabrano, a ostala su blokirana u istom PARENT
*oConfig1:fgColorSelected := GRA_CLR_BLACK  // Foreground color of text when button is selected (see :enableSelect)
*oConfig1:bgColorSelected := GRA_CLR_GREEN  // Background color when button is selected (see :enableSelect)
// default za MOUSE MOVE
oConfig1:fgColorMouse     := GRA_CLR_BLACK  // Foreground color of text when mouse is moved over button.
oConfig1:bgColorMouse     := GRA_CLR_CYAN   // Background color when mouse is moved over button.
// GRADIJENTI
//oConfig1:gradientStep := 10
//oConfig1:gradientReverse := .t.
//oConfig1:radius := 10


 oConfig1:disabledBGColor  :=  GraMakeRGBColor({ 92, 170, 92 })    // { 244, 244, 210 } //  Background Color when the button is disabled.
// ovo je blokirano i ne moe se menjati
* oConfig1:disabledFGColor  :=  GraMakeRGBColor({NIL, NIL, NIL })    // { 150, 150, 150 } //  Foreground Color of text when the button is disabled.

* oConfig1:isTransparent := .t.
RETURN oConfig1






***************************************************************************
STATIC FUNCTION help_programa()
***************************************************************************
LOCAL txt := "", cr := chr(13)+chr(10)
exe:=STRTRAN(appname(),"_DATABASE")
prg:=appname()+"  ver."+gde_ver()
TEXT INTO txt WRAP cr //TRIMMED

  &prg


  SERVISNI PROGRAM ZA PostgreSQL DATABAZU PROGRAMA &exe
  SERVICE PROGRAM FOR PostgreSQL DATABASE PROGRAM  &exe



  ---------------------------------------------------------------------

  OPERATION:
  Parametri baze podataka
  Database Parameters
  PG BAZA PODATAKA ZA PROGRAM: [ KASA STOLOVI ZA UGOSTITELJA ]
  PG DATABASE FOR THE PROGRAM: [  KASA STOLOVI ZA UGOSTITELJA ]

  ---------------------------------------------------------------------

   O B A V E Z N I  P A R A M E T R I  P R O G R A M A

   Formiranje parametara aplikacije za rad sa PostgreSQL serverom i
   databazom. Bez ispravnih parametara databazi se ne moe pristupiti.
   Parametre upisuje korisnik programa.

   - Za pristup PostgreSQL serveru na lokalu HostName ili ServerName je
     'Localhost'
     ----------

   - Za pristup PostgreSQL serveru na udaljenom serverskom raunaru
     HostName kao i podeavanje parametara servera dati su u posebnom
     uputstvu:
     'Pristup_remote_postgreSQL_serveru.pdf'
     ---------------------------------------

   Za testiranje rada programa
   postgreSQL databaze server se instalira kao:

   - host name    : 'Localhost'(zadat u instalaciji postgreSQL servera)
   - user name    : 'postgres' (zadat u instalaciji postgreSQL servera)
   - password     : 'postgres' (zadat u instalaciji postgreSQL servera)

   - databasename : 'kasa'     (obavezno ime)
   - schemename   : 'public'   (obavezno ime)

   - Code Shop-magazine  - ifra prodajnog objekta  = '11' (obavezno)
   - Code Casch-register - ifra fiskalne kase ESIR = '22' (obavezno)


     Moraju se upisati svi zadati parametri aplikacije.
     Server moe biti naziv servera ili IP adresa servera.
     U zagradama su dati default parametri koji e raditi
     sa default instaliranim postgreSQL serverom sa njima.

     Sve se upisuje iskljuivo malim slovima.

   - User mod messages - prikaz poruka greke korisniku

   - Test mod messages - prikaz poruka administratoru

   - Database control - na startu programa uvek kontrolie
     ispravnost baze podataka programa. Zbog ubrzanja rada
     programa moe se iskljuiti.





  ---------------------------------------------------------------------

  OPERATION:
  Sadraj baze podataka
  Database Contents
  SERVER LISTE: DATABAZE, EME I TABLE
  SERVER LISTS: DATABASES, SCHEMES AND TABLES

  ---------------------------------------------------------------------

   S A D R  A J  S E R V E R A  I  B A Z E  P O D A T A K A

   DAJE-PRIKAZUJE LISTU SVIH DATABAZA NA POSTGRESQL SERVERU,
   DAJE-PRIKAZUJE LISTU SVIH EMA U AKTIVNOJ DATABAZI,
   DAJE-PRIKAZUJE LISTU SVIH TABLI U ZADATOJ EMI U AKTIVNOJ DATABAZI





  ---------------------------------------------------------------------

  OPERATION:
  Kontrola baze podataka
  Database Control
  KONTROLA IF EXISTS I KREIRANJE DATABAZE
  CONTROL IF EXISTS AND CREATE DATABASE

  ---------------------------------------------------------------------

   K O N T R O L A  I S P R A V N O S T I  B A Z E  P O D A T A K A
   K R E I R A N J E  Z A D A T E  N O V E  B A Z E  P O D A T A K A

   Ova operacija proverava postojanje i ispravnost postgreSQL databaze
   odnosno baze podataka aplikacije.
   Ako zadata databaza - koja je zadata iz operacije:
       Parametri baze podataka
       Database Parameters
   ne postoji na postgreSQL serveru, ova operacija je kreira, ali samo
   ako za kreiranje databaze dozvolu izda korisnik programa.

   Ako zadata databaza postoji, proverava se postojanje zadate eme,
   koja je takoe zadata iz operacije:
       Parametri baze podataka
       Database Parameters

   Ako zadata ema ne postoji kreira se automatski.

   Ako zadata ema postoji, a ako potrebne table u emi ne postoje,
   table se automatski kreiraju.

   Kada sve postoji, program se konektuje na databazu i startuje se
   glavni meni aplikacije bez izdavanja poruka korisniku o tome
   da je databaza kontrolisana i ispravna.

   Na kraju programa, odnosno aplikacije, program se diskonektuje sa
   databaze, ako je korektno zavren - ako nije nasilno prekinut.

   Podrazumeva se da u raunaru mora da prethodno bude instaliran
   postgreSQL server.

   Ovaj softver je pravljen i testiran sa PostgreSQL serverom
   verzija 9.4.4





  ---------------------------------------------------------------------

  OPERATION:
  Punjenje baze podataka
  Database Filling
  PRENOS PODATAKA IZ SQL FAJLOVA U TABLE
  DATA TRANSFER FROM SQL FILES TO TABLES

  ---------------------------------------------------------------------

   P U N J E N J E  B A Z E  P O D A T A K A
   P R E N O S  P O D A T A K A  I Z  S Q L  F A J L A  U  T A B L U

   Tabla se puni podacima iz SQL script fajla koji nosi naziv table.

   SQL script fajl se formira iz posebnog servisnog programa za
   transfer podataka iz DBF fajla u SQL fajl.
   Ili za transfer podataka iz PgSQL table u SQL script fajl, ili
   za transfer podataka iz EXCEL tabele u SQL fajl, ili za transfer
   podataka iz CSV tekst fajla u SQL fajl, ili za transfer podataka
   iz XML i JSON fajla u SQL fajl.

    NEOPHODAN USLOV
    ---------------
    Mora da postoji SQL script fajl.
    Naziv SQL script fajla mora biti = nazivtable.SQL,
    a sadraj mora odgovarati strukturi table.
    SQL fajl mora da ima komandu INSERT INTO nazivtable.

    na primer:
    fajl: KUPCI.SQL ili kupci.sql
    iji je sadraj:

    -- START
    -- upis redova u tablu kupci
    INSERT INTO kupci
    (
    CODE_,
    NAME_,
    STATUS_
    )
      VALUES
    (
    12345,
    'COBA Systems',
    TRUE
    ),
    (
    12346
    'COBA Export'
    FALSE
    ),
    (
    12347
    'COBA Free Software'
    FALSE
    );
    -- ukupno 3 reda
    -- END

    Ako se EXE aplikacija nalazi u folderu C:\EXE tada se sql fajl
    mora nalaziti u folderu C:\EXE\SQL

                primer: C:\EXE\SQL\kupci.SQL

    Note:
    -----

    Kada se zada komanda za punjenje table 'kupci' ona e biti
    izvrena samo ako postoji fajl: C:\EXE\SQL\kupci.SQL

    U primeru prikazana tabla 'kup' je takozvana UPSIZE TABLA
    sa kojom radi Alaska Xbase++ aplikacija koristei ISAM komande
    i funkcije, uz korienje SQL komandi i funkcija, za navigaciju
    sa postgreSQL tablama.

    Ova tabla 'kup', iz datog primera, mora da ima sledeu strukturu:

    CREATE TABLE kup
    (
      CODE_   integer,
      NAME_   character(50),
      STATUS_ boolean,
      __deleted boolean NOT NULL DEFAULT false,
      __record serial NOT NULL,
      __rowversion integer NOT NULL DEFAULT 1,
      __keyversion integer NOT NULL DEFAULT 0,
      __lock_owner integer NOT NULL DEFAULT 0,
      CONSTRAINT kup_pkey PRIMARY KEY (__record)
     )
     WITH (
       OIDS=FALSE,
       autovacuum_enabled=true
     );
     ALTER TABLE kup
       OWNER TO postgres;


  Posebna napomena:
  ------------------

  (A)

  kada se radi sa aplikacijom koja koristi sve tri database engine:
  DBFNTX, FOXCDX, PDDBE tada je potrebno imati punu podrku za ISAM
  mainu koju je u postgreSQL server implementirala Alaska Xbase++.
  U tom sluaju u database tablu:
                   "alaska-software.isam.tables"
  treba upisati sve table koje se koriste od strane aplikacije po
  nazivu table, sa id brojem table i ostalim podacima. To e se kod
  kreiranja nove databaze automatski uraditi od strane C-PGDB.DLL
  programa. Meutim, to se moe uraditi bilo kada na poseban zahtev
  korisnika klikom na ALT+DELETE tastere.
  Tada e tabla "alaska-software.isam.tables" biti ispranjena i
  ponovo napunjena nazivima i id brojevima tabli koje se koriste od
  strane aplikacije.

  Ovaj softver ne koristi DBFNTX i FOXCDX database engine ve samo
  PGDBE engine. Meutim, zadrano je formiranje i auriranje ove
  liste tabli, jer je aplikacija koristi za druge svoje potrebe.

  (B)

  kada se radi sa aplikacijom koja koristi sve tri database engine:
  DBFNTX, FOXCDX, PDDBE tada je potrebno imati punu podrku za ISAM
  mainu koju je u postgreSQL server implementirala Alaska Xbase++.
  U tom sluaju u database tablu:
                  "alaska-software.isam.orders"
  treba upisati sve indeksne NTX i CDX fajlove po njihovom nazivu i
  po extenziji, po DBF polju ili izrazu po kome je indeks formiran,
  po njihovom nazivu u sql tabli i po ostalim parametrima.
  Ovo se kod kreiranje nove baze podataka iz C-PGDB.DLL ne radi,
  a ne radi se ni na poseban zahtev korisnika, jer aplikacija koristi
  samo PGDBE engine. Dakle, aplikacija ne radi istovremeno sa DBF,
  NTX, CDX, DBT, FPT fajlovima ISAM database i sa postgreSQL database
  tablama.

  (C)

  Kako se vri puna implementacija Alaska Xbase++ ISAM maine u
  postgreSQL bazu podataka i ta se kao rezultat dobija u postgreSQL
  bazi podataka detaljno je opisano i moe se testirati iz programa
  DBFUPSIZE.EXE koji se isporuuje u Alaska Xbase++ 2.0 paketu i u
          \Documents\Xbase++\source\samples\apps\mdidemo
          \Documents\Xbase++\source\samples\sql\xbpbrowse
  primeru koji kreira database: 'postgres' emu 'public' i navedene
  table za ISAM mainu kao i table koje koristi aplikacija mdidemo.


  ---------------------------------------------------------------------

  zadnja revizija: 13-10-2023

ENDTEXT
* c__procitaj(txt,naslov,,"H","B")
* CLEAR TYPEAHEAD
  * Kada je txt = string u memoriji
  TxtFile:=cTxt()
  MEMOWRIT(TxtFile,txt)
  *******************************************
  off := Font_codepage(10,"Consolas",238,.f.)
  C_EDIT(TxtFile,"PostgreSQL Database Tools","PostgreSQL Database Tools",,,,,,off) // baznex.dll
  *******************************************
   CLEAR TYPEAHEAD

RETURN NIL





**************************************************************************
FUNCTION function__tab__control__ISAM__()
**************************************************************************


IF c__neda("Proverava se postojanje svake table u postgreSQL databazi:"       + chr(59)+;
           "         "+_db_+"."+_she_                                         + chr(59)+;
           "prema listi tabli upisanoj u aplikaciju. Ako tabla postoji,"      + chr(59)+;
           "naziv i id broj table upisuje se u sistemsku Alaska Xbase++"      + chr(59)+;
           "postgreSQL listu, u tablu:  < alaska-software.isam.tables >"      + chr(59)+;
           "koja se prethodno isprazni. Ovim se formira lista database"       + chr(59)+;
           "tabli aplikacije, koja se koristi od strane ISAM maine kad"      + chr(59)+;
           "aplikacija radi sa ISAM DBFNTX DBE, FOXCDX DBE i PGDBE"           + chr(59)+;
           " "                                                                + chr(59)+;
           "Ova lista u tabli < alaska-software.isam.tables > formirana"      + chr(59)+;
           "je kod prvog kreiranja database aplikacije i ako je imala"        + chr(59)+;
           "90 tabli one su dobile svoje nazive i id brojeve od 1 do 90."     + chr(59)+;
           "Svako izvrenje ove operacije uveae id broj svake table za"     + chr(59)+;
           "broj 90 i resetovae datume i vremena kreiranja i izmene kod"     + chr(59)+;
           "svake table. O ovome treba brinuti ako aplikacija koristi id"     + chr(59)+;
           "brojeve tabli i ostale podatke iz ovih tabli."                    + chr(59)+;
            "","KONTROLA DATABASE TABLI | alaska-software.isam.tables | ") == .F.

    RETURN NIL

ENDIF


__tab__control__ISAM__()   // __tab__control()


RETURN NIL
