//////////////////////////////////////////////////////////////////////////
//                                                                      //
//                                                                      //
//   __tab__create__app.prg
//                                                                      //
//   11-11-2023                                                         //
//                                                                      //
//   www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi Coba  //
//   Open Source Project BAST Business Account Software Technology      //
//   www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503        //
//   www.Donnay-software.com --- eXpress++      version 2.0.268         //
//   Sergej Spirin --- FastReport for Xbase++   version 27.03.2015      //
//                                                                      //
//   Database Server PostgreSQL                 version 9.4.4.          //
//                                                                      //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


* COMMON FUNCTION
* INI_WRITE() // BAZNE.DLL
* INI_READ()  // BAZNE.DLL

* APP FUNCTION
* FUNCTION __tab__create__app()
* FUNCTION __tab__create__app__1()
* FUNCTION SQLstring()
* FUNCTION SQLstring__()



* -----------------------------------------------------------------------
* OVAJ PROGRAM NALAZI SE U SVAKOJ XBASE++ APLIKACIJI KOJA RADI SA PGDBE
* POSEBAN JE ZA SVAKU XBASE++ APLIKACIJU - JER FORMIRA SAMO NJENE TABLE
* -----------------------------------------------------------------------
* Formira array _aListAppTable_ koji sadri n lanova, gde je svaki lan:
*       {tablename, schemename.tablename, sqlstring}
* Nazivi tabli za database _db_ (xdb) i schemas _she_ (xse) u COBA
* Systems aplikaciji i SQL string za kreiranje svake od tabli iz liste.
* Lista naziva tabli koristi se iz biblioteke: C-PGDB.DLL/LIB
* za kreiranje postgreSQL database, baze podataka koju koristi aplikacija.
*
* Funkcija:
* _aListAppTable_ := __tab__cerate__app() -> __tab__create__app.prg
* vri generisanje liste sa nazivima tabli i sql stringovima tabli
* za funkciju: __tab__create() -> C-PGDB.DLL koja kreira te table,
* Ova funkcija je u svakoj EXE aplikaciji koja se linkuje sa C-PGDB.DLL
*------------------------------------------------------------------------

* -----------------------------------------------------------------------
* THIS PROGRAM IS IN EVERY XBASE++ APPLICATION THAT WORKS WITH PGDBE
* IT IS SPECIAL FOR EACH XBASE++ APPLICATION - BECAUSE IT FORM ONLY ITS
* TABLES
* -----------------------------------------------------------------------
* Forms an array _aListAppTable_ containing n members, where each member
* is: {tablename, schemename.tablename, sqlstring}
* Table names for database _db_ (xdb) and schemas _she_ (xse) in the
* COBA Systems application and the SQL string to create each of the
* tables from the list.
* The table name list is used from the library: C-PGDB.DLL/LIB
* to create the postgreSQL database, the database used by the application.
*
* Function:
* _aListAppTable_ := __tab__cerate__app() -> __tab__create__app.prg
* generates a list with table names and table sql strings
* for the function: __tab__create() -> C-PGDB.DLL which creates those
* tables.
* This function is in every EXE application that links with C-PGDB.DLL
*-------------------------------------------------------------------------





*-----------------------------------
#include "Xbp.ch"
#include "AppEvent.ch"
#include "Common.ch"
*-----------------------------------
* XbTools++
#include "xbtsys.ch"
* eXpress++
#include "dcdialog.ch"
*-----------------------------------
* for test
*  #include "Appbrow.ch"
*  MEMVAR appObject



*************************************************************************
FUNCTION __tab__create__app()
*************************************************************************
* Formira array _aListAppTable_ koji sadri n lanova, gde je svaki lan:
*       {tablename, schemename.tablename, sqlstring}
* Nazivi tabli za database _db_ (xdb)i schemas _she_ (xse)
* u COBA Systems aplikaciji
* i SQL string za kreiranje svake od tabli iz liste.
* Lista naziva tabli koristi se iz funkcije:
*
*          __tab__create() -> __tab__create.prg -> C-PGDB.DLL
*
* za kreiranje tabli u bazi podataka _db_
* ----------
* Forms an array _aListAppTable_ containing n members, where each member is:
* {tablename, schemename.tablename, sqlstring}
* Table names for database _db_ (xdb)and schemas _she_ (xse)
* in the COBA Systems application
* and the SQL string to create each of the tables from the list.
* The list of board names is used from the function:
*
*          __tab__create() -> __tab__create.prg -> C-PGDB.DLL
*
* to create tables in the _db_ (xdb)database
* ----------




* -----------------------------------------
* Ovde je procedura za aplikaciju:
*                 KASA_STOLOVI.EXE
* Here is procedure for aplication:
*                 KASA_STOLOVI.EXE
* -----------------------------------------


LOCAL xdb, xse, _MAG_, _KAS_, cObjekat_Kase, cBroj_Kase, i:=0

  xdb := "kasa"     // default database name
  xse := "public"   // default scheme name

 _MAG_ := INI_READ("C","KASA_CFG","cObjekat_Kase",gde_exe()+"\KASA.INI") // broj prodavnice
 _KAS_ := INI_READ("C","KASA_CFG","cBroj_Kase"   ,gde_exe()+"\KASA.INI") // broj kase


  IF EMPTY(_MAG_)
     INI_WRITE("C","KASA_CFG","cObjekat_Kase","11",gde_exe()+"\KASA.INI")  // D E F A U L T
     _MAG_ := INI_READ("C","KASA_CFG","cObjekat_Kase",gde_exe()+"\KASA.INI")
  ENDIF
  IF EMPTY(_KAS_)
     INI_WRITE("C","KASA_CFG","cBroj_Kase","11",gde_exe()+"\KASA.INI")  // D E F A U L T
     _KAS_ := INI_READ("C","KASA_CFG","cBroj_Kase",gde_exe()+"\KASA.INI")
  ENDIF

  _MAG_ := STRZERO( VAL(_MAG_), 2 )   // od '00' do '99'
  _KAS_ := STRZERO( VAL(_KAS_), 2 )   // od '00' do '99'

  cObjekat_Kase := _MAG_   // ifra restorana     | restaurant code             --- '11'
  cBroj_Kase    := _KAS_   // ifra fiskalne kase | code of the fiscal register --- '22'


PUBLIC _aListAppTable_ := {}

* -----------------------------------------
  tablename   := "kup"
  __tab__create__app__1(xdb,xse,tablename)
* -----------------------------------------
  tablename   := "kroba_"+_MAG_
  __tab__create__app__1(xdb,xse,tablename)
* -----------------------------------------
  tablename   := "kasa_"+_KAS_
  __tab__create__app__1(xdb,xse,tablename)
* -----------------------------------------
  tablename   := "kaso_"+_KAS_
  __tab__create__app__1(xdb,xse,tablename)
* -----------------------------------------
  tablename   := "kbon_"+_KAS_
  __tab__create__app__1(xdb,xse,tablename)
* -----------------------------------------
  tablename   := "kblok_"+_KAS_
  __tab__create__app__1(xdb,xse,tablename)
* -----------------------------------------
  FOR i=1 TO 100
    tablename := "x"+var2char(i)
  __tab__create__app__1(xdb,xse,tablename)
  NEXT i
* -----------------------------------------

RETURN _aListAppTable_




**************************************************************************
FUNCTION __tab__create__app__1(xdb,xse,tablename)
**************************************************************************
tableschema := xse+"."+tablename
SQLstring   := SQLstring(xdb,xse,tablename,tableschema)
AADD( _aListAppTable_, { tablename, tableschema, SQLstring } )
RETURN NIL




**************************************************************************
FUNCTION SQLstring(xdb,xse,tablename,tableschema)
**************************************************************************
LOCAL txt := "", cr := chr(13)+chr(10)
LOCAL sqltxt1 := "", sqltxt2 := "", sqltxt := ""

/*
-- **********************************************
-- CREATE TABLE:
-- **********************************************
--  Table kreiraj sa dodatnim kolonama
--  ZA UPSIZE - ZA ISAM MAINU:
--  Create tables with additional columns
--  FOR UPSIZE - FOR THE ISAM MACHINE:
--
--  __deleted boolean NOT NULL DEFAULT false,
--  __record serial NOT NULL,
--  __rowversion integer NOT NULL DEFAULT 1,
--  __keyversion integer NOT NULL DEFAULT 0,
--  __lock_owner integer NOT NULL DEFAULT 0,
--  CONSTRAINT tablename_pkey PRIMARY KEY (__record)
*/


*" (KUPCI_SPISAK) variable for DBF name in application KUP.DBF
*####################################################### START
IF tablename=="kup"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
//     moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
//     special personal code for each of the tables
//     you have to form PRIVATE because of writing variables with & in text into

   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
  (
  KUDS_               character(4)        ,
  KUDO_               character(1)        ,
  VEZA_               character(13)       ,
  BARC_               character(13)       ,
  KUDN_               character(40)       ,
  KUDU_               character(40)       ,
  ADRE_               character(30)       ,
  POST_               character(5)        ,
  MEST_               character(24)       ,
  REPU_               character(30)       ,
  LICE_               character(30)       ,
  TFON_               character(30)       ,
  TFAX_               character(30)       ,
  TLEX_               character(30)       ,
  ZIRO_               character(30)       ,
  MBR_                character(30)       ,
  PIB_                character(9)        ,
  SDEL_               character(5)        ,
  IBAN_               character(30)       ,
  ACOD_               character(30)       ,
  MAIL_               character(40)       ,
  WEBS_               character(40)       ,
  DATO_               date                ,
  DATR_               date                ,
  ROK_                integer             ,
  RABAT_              numeric(6,2)        ,
  GRUPA_              character(4)        ,
  STATU_              character(4)        ,
  NOTES_              character(40)       ,
  KONT_               character(10)       ,
  FLAG_               character(1)        ,
  ZNAK_               character(1)        ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
* "formed SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli
// --- special personal code for each of the tables --- end



// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
//     shared common code for each of the tables
//     get append for string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- shared common code for each of the tables  --- end

// spajanje dva stringa:
// concatenate two strings:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt
*#######################################################
ENDIF // IF tablename=="kup"
*#######################################################  END



*" (ARTIKLI_SPISAK) variable for DBF name in application KROBA_11.DBF
*####################################################### START
IF LEFT(tablename,6)=="kroba_"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
(
  GRUP_               character(2)        ,
  ROBS_               character(5)        ,
  ROBN_               character(25)       ,
  ROBK_               character(25)       ,
  MERA_               character(3)        ,
  TARI_               character(1)        ,
  PPUP_               numeric(5,1)        ,
  PPAP_               numeric(10,2)       ,
  CENA_FAK_           numeric(13,2)       ,
  CENA_NAB_           numeric(13,2)       ,
  CENA_VPR_           numeric(13,2)       ,
  CENA_MPR_           numeric(13,2)       ,
  CENA_DEV_           numeric(13,2)       ,
  ZALI_               numeric(15,3)       ,
  DAT0_               date                ,
  MAGS_               character(2)        ,
  ZNAK_               character(1)        ,
  FLAG_               character(1)        ,
  STAT_               character(1)        ,
  CENA_PRO_           numeric(13,3)       ,
  OSNO_AKC_           numeric(13,3)       ,
  ROK_                integer             ,
  DOBS_               character(4)        ,
  DOBK_               character(25)       ,
  VEZA_               character(15)       ,
  NAME_               character(200)      ,
  OPIS_               text                ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli  --- end


// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- zajedniki common kod za svaku od tabli  --- end
// spajanje dva stringa:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt
*#######################################################
ENDIF // IF LEFT(tablename,6)=="kroba_"
*####################################################### END



*" (KASA_STAV) variable for DBF name in application KASA_22.DBF
*####################################################### START
IF LEFT(tablename,5)=="kasa_"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
  (
  BRJ0_               character(12)       ,
  DAT0_               date                ,
  VRE0_               character(10)       ,
  BRJ1_               character(30)       ,
  DAT1_               character(30)       ,
  BRJ2_               character(30)       ,
  DAT2_               character(30)       ,
  VAL1_               character(30)       ,
  DOBS_               character(4)        ,
  DOBO_               character(1)        ,
  MAGS_               character(2)        ,
  OPST_               character(2)        ,
  KUP1_               character(30)       ,
  KUP2_               character(30)       ,
  RAC1_               character(2)        ,
  RAC2_               character(30)       ,
  KSIR_               character(13)       ,
  ESIR_               character(30)       ,
  ZNAK_               character(1)        ,
  STAT_               character(1)        ,
  GRUP_               character(2)        ,
  ROBS_               character(5)        ,
  ROBK_               character(30)       ,
  DOBK_               character(30)       ,
  ROBN_               character(50)       ,
  MERA_               character(3)        ,
  KOLI_               numeric(16,3)       ,
  CENA_FAK_           numeric(16,2)       ,
  CENA_MPR_           numeric(16,2)       ,
  VRED_MPR_           numeric(16,2)       ,
  TARI_               character(1)        ,
  PPUP_               numeric(5,1)        ,
  PPOD_               numeric(16,2)       ,
  CENA_VPR_           numeric(16,2)       ,
  VRED_VPR_           numeric(16,2)       ,
  RABP_               numeric(6,2)        ,
  RABD_               numeric(16,2)       ,
  FLAG_               character(1)        ,
  FLAG_IME_           character(30)       ,
  UPLATA_             numeric(16,2)       ,
  RACUN_              numeric(16,2)       ,
  KUSUR_              numeric(16,2)       ,
  GOT_                numeric(16,2)       ,
  CEK_                numeric(16,2)       ,
  KAR_                numeric(16,2)       ,
  NAL_                numeric(16,2)       ,
  INS_                numeric(16,2)       ,
  VAU_                numeric(16,2)       ,
  BOT_                numeric(16,2)       ,
  AVA_                numeric(16,2)       ,
  AVP_                numeric(16,2)       ,
  COBA_               integer             ,
  COK_                boolean             ,
  UUID_               character(36)       ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli  --- end


// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- zajedniki common kod za svaku od tabli  --- end
// spajanje dva stringa:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt
*#######################################################
ENDIF // IF LEFT(tablename,5)=="kasa_"
*####################################################### END



*" (KASA_DEL) variable for DBF name in application KASO_22.DBF
*####################################################### START
IF LEFT(tablename,5)=="kaso_"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
  (
  BRJ0_               character(12)       ,
  DAT0_               date                ,
  VRE0_               character(10)       ,
  BRJ1_               character(30)       ,
  DAT1_               character(30)       ,
  BRJ2_               character(30)       ,
  DAT2_               character(30)       ,
  VAL1_               character(30)       ,
  DOBS_               character(4)        ,
  DOBO_               character(1)        ,
  MAGS_               character(2)        ,
  OPST_               character(2)        ,
  KUP1_               character(30)       ,
  KUP2_               character(30)       ,
  RAC1_               character(2)        ,
  RAC2_               character(30)       ,
  KSIR_               character(13)       ,
  ESIR_               character(30)       ,
  ZNAK_               character(1)        ,
  STAT_               character(1)        ,
  GRUP_               character(2)        ,
  ROBS_               character(5)        ,
  ROBK_               character(30)       ,
  DOBK_               character(30)       ,
  ROBN_               character(50)       ,
  MERA_               character(3)        ,
  KOLI_               numeric(16,3)       ,
  CENA_FAK_           numeric(16,2)       ,
  CENA_MPR_           numeric(16,2)       ,
  VRED_MPR_           numeric(16,2)       ,
  TARI_               character(1)        ,
  PPUP_               numeric(5,1)        ,
  PPOD_               numeric(16,2)       ,
  CENA_VPR_           numeric(16,2)       ,
  VRED_VPR_           numeric(16,2)       ,
  RABP_               numeric(6,2)        ,
  RABD_               numeric(16,2)       ,
  FLAG_               character(1)        ,
  FLAG_IME_           character(30)       ,
  UPLATA_             numeric(16,2)       ,
  RACUN_              numeric(16,2)       ,
  KUSUR_              numeric(16,2)       ,
  GOT_                numeric(16,2)       ,
  CEK_                numeric(16,2)       ,
  KAR_                numeric(16,2)       ,
  NAL_                numeric(16,2)       ,
  INS_                numeric(16,2)       ,
  VAU_                numeric(16,2)       ,
  BOT_                numeric(16,2)       ,
  AVA_                numeric(16,2)       ,
  AVP_                numeric(16,2)       ,
  COBA_               integer             ,
  COK_                boolean             ,
  UUID_               character(36)       ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli  --- end


// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- zajedniki common kod za svaku od tabli  --- end
// spajanje dva stringa:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt

*#######################################################
ENDIF // IF LEFT(tablename,5)=="kaso_"
*####################################################### END



*" (KASA_BON) variable for DBF name in application KBON_22.DBF
*####################################################### START
IF LEFT(tablename,5)=="kbon_"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
  (
  BRJ0_               character(12)       ,
  DAT0_               date                ,
  VRE0_               character(10)       ,
  BRJ1_               character(30)       ,
  DAT1_               character(30)       ,
  BRJ2_               character(30)       ,
  DAT2_               character(30)       ,
  VAL1_               character(30)       ,
  DOBS_               character(4)        ,
  DOBO_               character(1)        ,
  MAGS_               character(2)        ,
  OPST_               character(2)        ,
  KUP1_               character(30)       ,
  KUP2_               character(30)       ,
  RAC1_               character(2)        ,
  RAC2_               character(30)       ,
  KSIR_               character(13)       ,
  ESIR_               character(30)       ,
  ZNAK_               character(1)        ,
  STAT_               character(1)        ,
  GRUP_               character(2)        ,
  ROBS_               character(5)        ,
  ROBK_               character(30)       ,
  DOBK_               character(30)       ,
  ROBN_               character(50)       ,
  MERA_               character(3)        ,
  KOLI_               numeric(16,3)       ,
  CENA_FAK_           numeric(16,2)       ,
  CENA_MPR_           numeric(16,2)       ,
  VRED_MPR_           numeric(16,2)       ,
  TARI_               character(1)        ,
  PPUP_               numeric(5,1)        ,
  PPOD_               numeric(16,2)       ,
  CENA_VPR_           numeric(16,2)       ,
  VRED_VPR_           numeric(16,2)       ,
  RABP_               numeric(6,2)        ,
  RABD_               numeric(16,2)       ,
  FLAG_               character(1)        ,
  FLAG_IME_           character(30)       ,
  UPLATA_             numeric(16,2)       ,
  RACUN_              numeric(16,2)       ,
  KUSUR_              numeric(16,2)       ,
  GOT_                numeric(16,2)       ,
  CEK_                numeric(16,2)       ,
  KAR_                numeric(16,2)       ,
  NAL_                numeric(16,2)       ,
  INS_                numeric(16,2)       ,
  VAU_                numeric(16,2)       ,
  BOT_                numeric(16,2)       ,
  AVA_                numeric(16,2)       ,
  AVP_                numeric(16,2)       ,
  COBA_               integer             ,
  COK_                boolean             ,
  UUID_               character(36)       ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli  --- end


// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- zajedniki common kod za svaku od tabli  --- end
// spajanje dva stringa:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt
*#######################################################
ENDIF // IF LEFT(tablename,5)=="kbon_"
*####################################################### END



*" (KASA_BLOK) variable for DBF name in application KBLOK_22.DBF
*####################################################### START
IF LEFT(tablename,6)=="kblok_"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
  (
  BRJ0_               character(12)       ,
  DAT0_               date                ,
  BRJ1_               character(12)       ,
  DAT1_               date                ,
  VAL1_               date                ,
  DOBS_               character(4)        ,
  DOBO_               character(1)        ,
  DOBN_               character(40)       ,
  DOBE_               character(40)       ,
  MBR_                character(30)       ,
  MAGS_               character(2)        ,
  MAGN_               character(25)       ,
  OPST_               character(2)        ,
  ZNAK_               character(1)        ,
  FLAG_               character(1)        ,
  STAT_               character(1)        ,
  DKUR_               numeric(13,2)       ,
  ZBIR_               numeric(15,2)       ,
  ADRESA_             character(30)       ,
  MESTO_              character(30)       ,
  PIB_                character(30)       ,
  OBNAZIV_            character(30)       ,
  OBADRESA_           character(30)       ,
  OBMESTO_            character(30)       ,
  OBPROD1_            character(30)       ,
  OBPROD2_            character(30)       ,
  OBKUP1_             character(30)       ,
  OBKUP2_             character(30)       ,
  DOBI_               character(4)        ,
  DOBM_               character(40)       ,
  DOBU_               character(40)       ,
  DOBMES_             character(40)       ,
  DOBADR_             character(40)       ,
  DOBTEL_             character(40)       ,
  DOBPIB_             character(40)       ,
  DOBMBR_             character(40)       ,
  DOBU__              character(40)       ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli  --- end


// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- zajedniki common kod za svaku od tabli  --- end
// spajanje dva stringa:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt
*#######################################################
ENDIF // IF LEFT(tablename,6)=="kblok_"
*####################################################### END



*" (STO) variable for DBF name in application X1.DBF,X2.DBF... X100.DBF
*####################################################### START
IF LEFT(tablename,1)=="x"
*#######################################################
// --- poseban lini kod za svaku od tabli  --- start
// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"
   PRIVATE caddress  := xdb+"."+xse+"."+tablename

TEXT INTO sqltxt1 WRAP cr // TRIMMED
--
-- Table: &caddress
--
CREATE TABLE &ctable
  (
  BRJ0_               character(12)       ,
  DAT0_               date                ,
  VRE0_               character(10)       ,
  BRJ1_               character(30)       ,
  DAT1_               character(30)       ,
  BRJ2_               character(30)       ,
  DAT2_               character(30)       ,
  VAL1_               character(30)       ,
  DOBS_               character(4)        ,
  DOBO_               character(1)        ,
  MAGS_               character(2)        ,
  OPST_               character(2)        ,
  KUP1_               character(30)       ,
  KUP2_               character(30)       ,
  RAC1_               character(2)        ,
  RAC2_               character(30)       ,
  KSIR_               character(13)       ,
  ESIR_               character(30)       ,
  ZNAK_               character(1)        ,
  STAT_               character(1)        ,
  GRUP_               character(2)        ,
  ROBS_               character(5)        ,
  ROBK_               character(30)       ,
  DOBK_               character(30)       ,
  ROBN_               character(50)       ,
  MERA_               character(3)        ,
  KOLI_               numeric(16,3)       ,
  CENA_FAK_           numeric(16,2)       ,
  CENA_MPR_           numeric(16,2)       ,
  VRED_MPR_           numeric(16,2)       ,
  TARI_               character(1)        ,
  PPUP_               numeric(5,1)        ,
  PPOD_               numeric(16,2)       ,
  CENA_VPR_           numeric(16,2)       ,
  VRED_VPR_           numeric(16,2)       ,
  RABP_               numeric(6,2)        ,
  RABD_               numeric(16,2)       ,
  FLAG_               character(1)        ,
  FLAG_IME_           character(30)       ,
  UPLATA_             numeric(16,2)       ,
  RACUN_              numeric(16,2)       ,
  KUSUR_              numeric(16,2)       ,
  GOT_                numeric(16,2)       ,
  CEK_                numeric(16,2)       ,
  KAR_                numeric(16,2)       ,
  NAL_                numeric(16,2)       ,
  INS_                numeric(16,2)       ,
  VAU_                numeric(16,2)       ,
  BOT_                numeric(16,2)       ,
  AVA_                numeric(16,2)       ,
  AVP_                numeric(16,2)       ,
  COBA_               integer             ,
  COK_                boolean             ,
  UUID_               character(36)       ,
  __deleted boolean NOT NULL DEFAULT false,
  __record serial NOT NULL,
  __rowversion integer NOT NULL DEFAULT 1,
  __keyversion integer NOT NULL DEFAULT 0,
  __lock_owner integer NOT NULL DEFAULT 0,
  CONSTRAINT &ckey PRIMARY KEY (__record)
)
WITH (OIDS=FALSE,autovacuum_enabled=true);

ENDTEXT
* "formiran je SQL string 'sqltxt1'
// --- poseban lini kod za svaku od tabli  --- end


// --- zajedniki common kod za svaku od tabli  --- start
//     dobija se dodatak za string 'sqltxt'
  *****************************************************
  sqltxt2 := SQLstring__(xdb,xse,tablename,tableschema)
  *****************************************************
// --- zajedniki common kod za svaku od tabli  --- end
// spajanje dva stringa:
  sqltxt := sqltxt1 + sqltxt2
RETURN sqltxt
*#######################################################
ENDIF // IF LEFT(tablename,1)=="x"
*####################################################### END


RETURN NIL


*************************************************************************
FUNCTION SQLstring__(xdb,xse,tablename,tableschema)
*************************************************************************
LOCAL txt := "", cr := chr(13)+chr(10), sqltxt2 := ""

// --- zajedniki common kod za svaku od tabli  --- start
// --- shared common code for each of the tables --- start


// moraji se formirati PRIVATE zbog upisa varijabli sa & u text into
// you have to form PRIVATE because of writing variables with & in text into
   PRIVATE ctable := tableschema
   PRIVATE ckey   := tablename + "_pkey"

   PRIVATE ;
   index_deleted          := tablename+"__deleted"        ,;
   index_record           := tablename+"__record"         ,;
   triger_isam_rowversion := tablename+"_isam_rowversion" ,;
   triger_isam_tablemeta  := tablename+"_isam_tablemeta"




TEXT INTO sqltxt2 WRAP cr // TRIMMED
-- **********************************************
-- O W N E R:
-- **********************************************
-- mora se postaviti user na 'postgres' (superuser)
-- morate biti logovani na database kao superuser
-- user must be set to 'postgres' (superuser)
-- you must be logged into the database as superuser

   ALTER TABLE &ctable OWNER TO postgres;



-- **********************************************
-- I N D E K S I
-- **********************************************
-- * index_deleted
-- Index: &index_deleted
-- DROP INDEX &index_deleted;

   CREATE INDEX &index_deleted
   ON &ctable
   USING btree
   (__deleted);

-- * index_record
-- Index: &index_record
-- DROP INDEX &index_record;

   CREATE INDEX &index_record
   ON &ctable
   USING btree
   (__record);


-- **********************************************
-- TRIGGERS AND TRIGER FUNCTIONS:
-- **********************************************

-- * triger_isam_rowversion
-- (uvek obavezno kod upsize tehnologije)
-- Trigger: &triger_isam_rowversion on &ctable
-- DROP TRIGGER &triger_isam_rowversion ON &ctable;

   CREATE TRIGGER &triger_isam_rowversion
   BEFORE UPDATE
   ON &ctable
   FOR EACH ROW
   EXECUTE PROCEDURE isam_rowversion_update();

-- * triger_isam_tablemeta
-- (uvek obavezno kod upsize tehnologije)
-- Trigger: &triger_isam_tablemeta on &ctable
-- DROP TRIGGER &triger_isam_tablemeta ON &ctable;

   CREATE TRIGGER &triger_isam_tablemeta
   AFTER INSERT OR UPDATE OR DELETE
   ON &ctable
   FOR EACH ROW
   EXECUTE PROCEDURE isam_tablemeta_update();

ENDTEXT

// --- shared common code for each of the tables --- end

RETURN sqltxt2
